unit Formate;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs,  StdCtrls;

type
  TEngForm = class(TForm)
    InEdit: TEdit;
    OutEdit: TEdit;
    FormateBut: TButton;
    procedure FormateButClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  EngForm: TEngForm;

implementation

{$R *.DFM}

procedure EngFormat(rr : single; var engrr : string);
{format a variable in the engineering style = ten to multiples of three (E3, E6, etc)
 remove any spaces
 rr     the variable to be formatted
 engrr  the variable rr formatted}
var
  ar  : single;   {abs. value of rr}
  arf : string;   {formatted ar}
  ii  : integer;  {index}
  txt : string;   {temporary}
begin
  ar := abs(rr);  {use abs.value, add the sign later}
  if (ar < 1.0) then begin
    arf := Format('%12.6g',[ar]);
  end else if (ar < 1000.0) then begin
    arf := format('%7.3f',[ar]);
  end else begin
    arf := Format('%12.6g',[ar]);
  end;

end;

procedure TEngForm.FormateButClick(Sender: TObject);
var
  rr  : single;
  txt : string;
begin
  rr := strtofloat(InEdit.text);
  EngFormat(rr,txt);
  OutEdit.text := txt;

end;

end.
