unit Helppas;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls;

type
  THelpForm = class(TForm)
    HelpEdit: TRichEdit;
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  HelpForm: THelpForm;

implementation

{$R *.DFM}

procedure THelpForm.FormResize(Sender: TObject);
var
  ipu : integer;
begin
  ipu := clientHeight-16;
  if (ipu > 32) then HelpEdit.height := ipu
  else HelpEdit.height := 32;
end;

procedure THelpForm.FormCreate(Sender: TObject);
var
  ichar  : integer;  {counts characters}
  ii,jj  : integer;  {index}
  len    : integer;  {length of line}
  line   : string;   {one line}
  nlines : integer;  {no of lines}
begin
  nlines := HelpEdit.lines.count;
  {search for the sigmas, and calculate their positions}
  ichar := 0;
  for ii := 0 to nlines-1 do begin
    line := HelpEdit.lines[ii];   {copy to local}
    len := length(line);
    {search for a space }
    if (len > 3) then begin
      if (line[1] = ' ') and (line[2] = ' ') then begin
        {search for the other two spaces ending the symbol }
        for jj := 3 to len do begin
          if (line[jj] = ' ') and (line[jj+1] = ' ') then begin
            HelpEdit.SelStart := ichar+2;
            HelpEdit.SelLength := jj-3;
            {a S changed to sigma, else use the normal font}
            HelpEdit.SelAttributes.name := 'Courier New';
            if (line[3] = 'S') then begin
              HelpEdit.SelLength := 1;
              HelpEdit.SelAttributes.name := 'symbol'
            end;
            HelpEdit.SelAttributes.style := [fsBold];
            break;
          end;
        end;
      end;
    end;

(*
    {search for  'S}
    if (len > 2) then begin
      line := HelpEdit.lines[ii];   {copy to local}
      if (line[1] = ' ') and (line[2] = '''') and (line[3] = 'S') then begin
        HelpEdit.SelStart := ichar+2;
        HelpEdit.SelLength := 1;
        HelpEdit.SelAttributes.style := [fsBold];
        HelpEdit.SelAttributes.size := 11;
        HelpEdit.SelAttributes.name := 'symbol';
      end;
    end;
*)
    ichar := ichar+len+2;            {lenght of line + LF +CR}
  end;
  HelpEdit.SelStart := 0;
  {add flag that form created}
  Imagoo.ReadyEdit.text := Imagoo.ReadyEdit.text+'H';  
end;

end.
