{Important: ParamTab must be topmost, when compiling!}
{TARKISTA SendTrLineData !!!!!!!; {send parameters to k0-calculator, in skemproc.pas}
{why all lines checked in CheckAmpOfLines??  23.6.08}
unit LineParam;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, ComCtrls, ExtCtrls, StdCtrls, Grids, Skemadef, Utildef, Imagodef,
  Routines,Compdef, perunit;

type
  TTrLineForm = class(TForm)
    ParamPages: TPageControl;
    ParamTab: TTabSheet;
    CurveTab: TTabSheet;
    KmBut: TSpeedButton;
    OhmBut: TSpeedButton;
    PuBut: TSpeedButton;
    KmPanel: TPanel;
    OhmLabel: TLabel;
    LengthEdit: TEdit;
    LengthLabel: TLabel;
    SplitEdit: TEdit;
    splitLabel: TLabel;
    KmImage: TImage;
    KmRectGrid: TStringGrid;
    KmPolarGrid: TStringGrid;
    KmArrowImg: TImage;
    OhmPanel: TPanel;
    OhmImage: TImage;
    OhmArrowImage: TImage;
    OhmRectGrid: TStringGrid;
    OhmPolarGrid: TStringGrid;
    PuPanel: TPanel;
    PuImage: TImage;
    PuArrowImage: TImage;
    PuRectGrid: TStringGrid;
    PuPolarGrid: TStringGrid;
    MVALabel: TLabel;
    MVAEdit: TEdit;
    kVLabel: TLabel;
    kVEdit: TEdit;
    ZLabel: TLabel;
    ZEdit: TEdit;
    AmpPanel: TPanel;
    AmpLabel: TLabel;
    AmpGrid: TStringGrid;
    AmpBut: TSpeedButton;
    ButPanel: TPanel;
    OKBut: TButton;
    CancelBut: TButton;
    HelpBut: TButton;
    puCalcBut: TButton;
    CurveGrid: TStringGrid;
    CurveOKBut: TButton;
    ColorPanel: TPanel;
    ColorImage: TImage;
    CurveApplyBut: TButton;
    CurveCancelBut: TButton;
    DamageCurveBut: TSpeedButton;
    CurveMemo: TMemo;
    CurveHelpBut: TSpeedButton;
    UpdatePanel: TPanel;
    ChangedLabel: TLabel;
    UpdateLabel: TLabel;
    ChangedLabel2: TLabel;
    AVOhmBut: TButton;
    PerUnitBut: TButton;
    CancelUpdateBut: TButton;
    k0Label: TLabel;
    k0PolLabel: TLabel;
    ParalLabel: TLabel;
    ParalEdit: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure KmRectGridKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure KmRectGridSelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure KmPolarGridKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure KmPolarGridSelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure FormHide(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure LengthEditKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure OhmRectGridKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure OhmRectGridSelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure OhmPolarGridSelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure OhmPolarGridKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure PuRectGridSelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure PuPolarGridSelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure PuRectGridKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure PuPolarGridKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure MVAEditKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure kVEditKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure KmButClick(Sender: TObject);
    procedure OhmButClick(Sender: TObject);
    procedure PuButClick(Sender: TObject);
    procedure AmpButClick(Sender: TObject);
    procedure OKButClick(Sender: TObject);
    procedure CancelButClick(Sender: TObject);
    procedure KmRectGridClick(Sender: TObject);
    procedure OhmRectGridClick(Sender: TObject);
    procedure KmRectGridExit(Sender: TObject);
    procedure KmPolarGridExit(Sender: TObject);
    procedure KmPolarGridClick(Sender: TObject);
    procedure OhmRectGridExit(Sender: TObject);
    procedure OhmPolarGridExit(Sender: TObject);
    procedure PuRectGridExit(Sender: TObject);
    procedure PuPolarGridExit(Sender: TObject);
    procedure OhmPolarGridClick(Sender: TObject);
    procedure PuRectGridClick(Sender: TObject);
    procedure PuPolarGridClick(Sender: TObject);
    procedure puCalcButClick(Sender: TObject);
    procedure HelpButClick(Sender: TObject);
    procedure ParamPagesChanging(Sender: TObject;
      var AllowChange: Boolean);
    procedure CurveGridSelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure CurveGridDrawCell(Sender: TObject; Col, Row: Longint;
      Rect: TRect; State: TGridDrawState);
    procedure ColorImageMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CurveOKButClick(Sender: TObject);
    procedure CurveApplyButClick(Sender: TObject);
    procedure DamageCurveButClick(Sender: TObject);
    procedure CurveCancelButClick(Sender: TObject);
    procedure CurveHelpButClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure CancelUpdateButClick(Sender: TObject);
    procedure UpdatePanelMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure AVOhmButClick(Sender: TObject);
    procedure PerUnitButClick(Sender: TObject);
    procedure MVAEditEnter(Sender: TObject);
    procedure kVEditEnter(Sender: TObject);
    procedure ChangedLabelMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure UpdateLabelMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    { Private declarations }
    CRwidth  : integer;       {width (and height) of a small color rectangle}
    CRspace  : integer;       {width of space between color rectangles}
    pComp    : TpComp;        {pointer to the component. Set in TrLineSymbol at start,
                              and in SendTrLineData at mouse down, both in skemproc.pas}
    pSet     : TpCompSet;     {pointer to the common}
    kmr_row  : integer;       {selected row in KmRectGrid}
    kmp_row  : integer;       {selected row in KmPolarGrid}
    ohmr_row : integer;       {selected row in OhmRectGrid}
    ohmp_row : integer;       {selected row in OhmPolarGrid}
    pur_row  : integer;       {selected row in PuRectGrid}
    pup_row  : integer;       {selected row in PuPolarGrid}
  public
    { Public declarations }
    procedure ParamToGrid(pComp: TpComp);
    procedure DefaultLineParameters;
    procedure AllParametersToComp;
    procedure CurveParametersToComp;
    procedure PutpComp(ipComp: longint);
    procedure ImpedancesInGrids;
    procedure DisplayPanels;
    procedure LightGrayGrids;
    procedure CheckAmpOfLines;
    procedure UpdateGraph;
    procedure CurveFormHeight;
    procedure k0;
    procedure GetMainParamToGrid(R1,X1,R0,X0,Ss,len: single);
  end;

var
  TrLineForm: TTrLineForm;

procedure HideTrLineForm(ipComp: longint); far; {hide the parameter form}
procedure ParametersToComp(pCompo: TpComp; line: string; ipar: integer; var par : single);
procedure RecToPolar(textR, textX : string; var textZ,textF : string; var Rr,Xx,Zz,fii: single);
procedure PolarToRec(textZ,textF : string; var textR, textX : string; var Rr,Xx,Zz,fii: single);
procedure ShowBaseZ(baseZ : single; pZEdit: TpEdit);
procedure BaseToGrid(pComp: TpComp; pkVEdit, pMVAEdit, pZEdit: TpEdit; var bkV, bMVA, bZ,IbZ : single);
procedure ChangeOfBase(pEdit, pZEdit : TpEdit; MVAorkV : string; var bkV, bMVA: single; var err : integer);
procedure BaseEditKeyUp(Key: Word; pBEdit, pZEdit : TpEdit; kVorMVA: string;
                        var bkV,bMVA: single; pUDPanel: TpPanel; pAVOBut,pPUBut: TpButton);
procedure LineRectGridKeyUp(pRGrid, pPGrid: TpGrid; var KmrArr, KmpArr: array of single;row : integer);
procedure LinePolarGridKeyUp(pRGrid, pPGrid: TpGrid; var KmrArr, KmpArr: array of single;row : integer);
                        
implementation

uses Imagopas, Elplex, PQRelay, Relcurr, skemproc, emtp;

{$R *.DFM}

const
  {NOTE: these are used for all grids, "km", "ohm" and "pu"}
  R1row = 0;
  X1row = 1;
  R0row = 2;
  X0row = 3;
  Ssrow = 4;
  Z1row = 0;
  F1row = 1;
  Z0row = 2;
  F0row = 3;
  {rows for the damage curve array}
  CurrRow = 0;
  TimeRow = 1;
  MinTRow = 2;
  MaxTRow = 3;
  NameRow = 4;
  ColorRow = 5;
  ThickRow = 6;
  VoltRow = 7;
  InUseRow = 8;
  LightGray = $00E8E8E8{ $00F0F0F0};
  pHelp       : TpMemo = nil;      {pointer to the help-memo}
  pDmgLine    : TpComp = nil;      {pointer to tr.line showing damage curve, for cancel}
  CurveName   : string = '';       {backup of the name-parameter, for cancel}
var
  dec_p       : Char;                   {decimal point - character}
  CurveArr    : array[0..9] of string;  {for saving damage curve parameters}
  KmRectArr   : array[0..4] of single;  {parameters in Ohm/km and S as singles}
  KmPolarArr  : array[0..3] of single;
  OhmRectArr  : array[0..4] of single;  {parameters in Ohm/km and S as singles}
  OhmPolarArr : array[0..3] of single;
  PuRectArr   : array[0..4] of single;  {parameters in Ohm/km and S as singles}
  PuPolarArr  : array[0..3] of single;
  CurvePar    : array[1..10] of single; {for damage parameters. Dim >= CurveGrid.rowcount}
  Lin_Len     : single;                 {length as single}
  Lin_Split   : single;                 {splittin ratio as single}
  baseMVA     : single;                 {base power for pu}
  basekV      : single;                 {pase voltage for pu}
  baseMVA_bu  : single;                 {backup for base power for pu}
  basekV_bu   : single;                 {backup for base voltage for pu}
  baseMVA_txt : string;                 {backup for base power as text}
  basekV_txt  : string;                 {backup for base voltage as text}
  baseZ_txt   : string;                 {backup for base impedance as text}
  cancel      : boolean;                {flag for not saving parameters}

procedure HideTrLineForm(ipComp: longint);
{When deleting component: hide the parameter form, remove pointer if damage curve}
var
  pTL : TpComp;
begin
  TrLineForm.visible := false;
  pTL := TpComp(ipComp);           {pointer to the component to be deleted}
  {if damage curve of this tr.line shown, clear curve}
  if (TrLineForm.pSet^.pTr_Line = pTL) then TrLineForm.pSet^.pTr_Line := nil;
  pTL^.PutPar(gTrLiS_InUse,0);     {reset flag for damage curve, in any case}
  TrLineForm.DamageCurveBut.down := false;
  RelayCurr.TrLineBut.visible := false;
  TrLineForm.UpdateGraph;
end;

procedure TTrLineForm.LightGrayGrids;
{(re)set all grids to light gray}
begin
  KmRectGrid.color := LightGray;
  KmPolarGrid.color := LightGray;
  OhmRectGrid.color := LightGray;
  OhmPolarGrid.color := LightGray;
  PuRectGrid.color := LightGray;
  PuPolarGrid.color := LightGray;
end;

procedure TTrLineForm.FormCreate(Sender: TObject);
begin
  width := ParamPages.width+8;
  DecimalPoint(dec_p);    {determine character for decimal point (. or ,), in Routines.pas}
  {texts to the parameter grids}
  {rectangular impedance/km}
  KmRectGrid.cells[0,R1row] := 'R1';
  KmRectGrid.cells[0,X1row] := 'X1';
  KmRectGrid.cells[0,R0row] := 'R0';
  KmRectGrid.cells[0,X0row] := 'X0';
  KmRectGrid.cells[0,Ssrow] := 'B';
  {polar impedance/km}
  KmPolarGrid.cells[0,Z1row] := '|Z1|';
  KmPolarGrid.cells[0,F1row] := '1()';
  KmPolarGrid.cells[0,Z0row] := '|Z0|';
  KmPolarGrid.cells[0,F0row] := '0()';
  {rectangular impedance, ohms}
  OhmRectGrid.cells[0,R1row] := 'R1';
  OhmRectGrid.cells[0,X1row] := 'X1';
  OhmRectGrid.cells[0,R0row] := 'R0';
  OhmRectGrid.cells[0,X0row] := 'X0';
  OhmRectGrid.cells[0,Ssrow] := 'B';
  {polar impedance, ohms}
  OhmPolarGrid.cells[0,Z1row] := '|Z1|';
  OhmPolarGrid.cells[0,F1row] := '1()';
  OhmPolarGrid.cells[0,Z0row] := '|Z0|';
  OhmPolarGrid.cells[0,F0row] := '0()';
  {rectangular impedance, pu}
  puRectGrid.cells[0,R1row] := 'r1';
  puRectGrid.cells[0,X1row] := 'x1';
  puRectGrid.cells[0,R0row] := 'r0';
  puRectGrid.cells[0,X0row] := 'x0';
  puRectGrid.cells[0,Ssrow] := 'b';
  {polar impedance, ohms}
  puPolarGrid.cells[0,Z1row] := '|z1|';
  puPolarGrid.cells[0,F1row] := '1()';
  puPolarGrid.cells[0,Z0row] := '|z0|';
  puPolarGrid.cells[0,F0row] := '0()';
  {ampacity limits}
  AmpGrid.cells[0,0] := '  A1';
  AmpGrid.cells[1,0] := '  A2';
  AmpGrid.cells[2,0] := '  A3';
  AmpGrid.cells[3,0] := '  A4';
  {pointer}
  pSet := @SetComp;               {pointer to the common}
  top := 0; left := 0;
  {If the color of the nonactive grids must be light gray, there must be one
   extra row in each grid, because the last selected cell seems to stay white.
   Prepare the grids in the following way. In the design time:
   - set the correct number of rows (no extra rows) and the correct height of the grid
   - no scroll bars
   - add the extra row (set RowCount one larger than actually needed)
   Do here ("in run time"):
   - set the height of the last row = 1
   - increase the height of the grid by 2
   When exiting the grid (onExit), set row = the extra row}
  KmRectGrid.RowHeights[5] := 1;
  KmRectGrid.Height := KmRectGrid.Height+2;
  KmPolarGrid.RowHeights[4] := 1;
  KmPolarGrid.Height := KmPolarGrid.Height+2;
  OhmRectGrid.RowHeights[5] := 1;
  OhmRectGrid.Height := OhmRectGrid.Height+2;
  OhmPolarGrid.RowHeights[4] := 1;
  OhmPolarGrid.Height := OhmPolarGrid.Height+2;
  PuRectGrid.RowHeights[5] := 1;
  PuRectGrid.Height := PuRectGrid.Height+2;
  PuPolarGrid.RowHeights[4] := 1;
  PuPolarGrid.Height := PuPolarGrid.Height+2;
  KmRectGrid.row := 5;
  KmPolarGrid.row := 4;
  OhmRectGrid.row := 5;
  OhmPolarGrid.row := 4;
  PuRectGrid.row := 5;
  PuPolarGrid.row := 4;
  {initially light gray color in the grids}
  LightGrayGrids;
  {initialize the grid for the damage curve - - - - - - - -}
  CurveGrid.cells[0,CurrRow] := 'Damage curr.(A)';
  CurveGrid.cells[0,TimeRow] := 'Damage time (s)';
  CurveGrid.cells[0,MinTRow] := 'Min. time (s)';
  CurveGrid.cells[0,MaxTRow] := 'Max. time (s)';
  CurveGrid.cells[0,NameRow] := 'name';
  CurveGrid.cells[0,ColorRow] := 'color';
  CurveGrid.cells[0,ThickRow] := 'line thickness';
  CurveGrid.cells[0,VoltRow] := 'Voltage';
  CurveGrid.cells[0,InUseRow] := 'In Use';
  cancel := false;            {initialize}
  {prepare image for selecting the color of the curve}
  ColorInitialize(@ColorImage);           {in utildef.pas}
  {size and initial position of the color panel}
  GetCRsize(CRwidth,CRspace);             {in utildef.pas}
  ColorPanel.width := ColorImage.width+2*CRspace;
  ColorPanel.height := ColorPanel.width;
  ColorPanel.top := ColorRow*(CurveGrid.DefaultRowHeight+CurveGrid.GridLineWidth)
                    +CurveGrid.top-ColorPanel.width;
  ColorPanel.left := CurveGrid.left+CurveGrid.ColWidths[0];
  {add flag that form created}
  Imagoo.ReadyEdit.text := Imagoo.ReadyEdit.text+'p';
end;

procedure TTrLineForm.PutpComp(ipComp: longint);
{set the pointer in TrLineSymbol to the component when creating the component,
 and in SendTrLineData at mouse down, both in skemproc.pas
 ipComp   pointer to the component, as integer}
var
  ix,iy : integer;
  lbl   : string;
begin
  pComp := TpComp(ipComp);
  pComp^.GetLabel(lbl,ix,iy);
  caption := lbl;             {show label in the caption of the parameter form}
end;

procedure TTrLineForm.CheckAmpOfLines;
{check, does current in some transmission line exceed a ampacity limit}
var
  err   : integer;    {error flag}
  jcomp : integer;    {counts components}
  name  : string;     {name = type of the component}
  pCmp  : TpComp;     {pointer to a component}
begin
  if (AmpCheckIf(pSet)) then begin     {check only for some calculations, in elplex.pas}
    {scan all components, check transmission lines}
    pCmp := nil;                       {initialize pointer to component}
    err := 0;                          {initialize error flag}
    jcomp := 0;
    while(err = 0) do begin                 {scan all components}
      pSet^.NextComp(pCmp,err,jcomp,true);  {get pointer to next component}
      if (err = 0) then begin
        pCmp^.GetName(name);           {name = type of the component}
        if (name = gTrLiS) then begin  {is it a transmission line}
          AmpageLimits(pCmp,true);     {ampage limit exceeded?}
        end;
      end;
    end;
  end;
end;

procedure PolarToRec(textZ,textF : string; var textR, textX : string; var Rr,Xx,Zz,fii: single);
{change complex number from polar form to rectangular
 textZ  abs.value of the number to be changed, as text
 textF  angle in degrees, as text
 textR  real part, as text
 textX  imag.part, as text
 Rr,Xx  real and imag.parts as singles
 Zz,fii magnitude and phase of the impedance}
const
  smallRX = 0.001;
var
  apu,apv,apw : single;  {temporary}
  err1,err2   : integer; {error flags}
  deg{,fii}     : single;  {angle in degrees, in rad}
  ii,jj       : integer; {indices}
  ipu         : integer; {temporary}
  len         : integer; {length of text}
  s1,s2,s3,s4 : string;  {temporary}
  text        : string;  {temporary}
begin
  ValuesFromLine(textZ, 1, false, ipu, Zz , apu, apv, apw, s1,s2,s3,s4,err1); {in routines.pas}
  ValuesFromLine(textF, 1, false, ipu, deg, apu, apv, apw, s1,s2,s3,s4,err2);
  if (err1 = 0) and (err2 = 0) then begin
{   if (Zz >= 0) then begin}
      fii := deg*pi/180;        {change to radians}
      Rr := Zz*cos(fii); if (Rr < SmallRX) then Rr := 0;
      Xx := Zz*sin(fii); if (Xx < SmallRX) then Xx := 0;
      text := ManyChars(Rr,true);  {numerical value to string, in routines.pas}
      TextR := spaceless(text);    {remove spaces}
      text := ManyChars(Xx,true);
      TextX := spaceless(text); {remove spaces}
{   end;}
  end else begin
    TextR := '?';
    TextX := '?';
    Rr := 1;  {just some values}
    Xx := 0;
    Zz := 1;
    fii := 0;
  end;
end;

procedure RecToPolar(textR, textX : string; var textZ,textF : string; var Rr,Xx,Zz,fii: single);
{change complex number from rectangular to polar form
 textZ  abs.value of the number to be changed, as text
 textF  angle in degrees, as text
 textR  real part, as text
 textX  imag.part, as text
 Rr,Xx  real, imag. parts
 Zz, fii  magnitude and phase (in rad) as singles}
var
  apu,apv,apw : single;  {temporary}
  err1,err2   : integer; {error flags}
  ipu         : integer; {temporary}
  deg{,fii}   : single;  {angle in degrees, in rad}
//Rr          : single;  {real part}
  s1,s2,s3,s4 : string;  {temporary}
  text        : string;  {temporary}
//Xx          : single;  {imag.part}
//Zz          : single;  {abs.value of the complex}
begin
  ValuesFromLine(textR, 1, false, ipu, Rr , apu, apv, apw, s1,s2,s3,s4, err1);
  ValuesFromLine(textX, 1, false, ipu, Xx , apu, apv, apw, s1,s2,s3,s4, err2);
  if (err1 = 0) and (err2 = 0) then begin
    Zz := sqrt(Rr*Rr+Xx*Xx);
    fii := Cangle(cplx(Rr,Xx));   {angle in radians}
    deg := fii*180/pi;
    text := ManyChars(Zz,true);   {numerical value to string}
    TextZ := spaceless(text);     {remove spaces}
    text := ManyChars(deg,true);
    TextF := spaceless(text);     {remove spaces}
  end else begin
    TextZ := '?';
    TextF := '?';
    Rr := 1;
    Xx := 0;
    Zz := 1;      {just some values}
    fii := 0;
  end;
end;

procedure OtherGrids(cc: single; pPfrom,pRgrid,pPgrid : TpGrid; Rfrom,Pfrom: array of single;
                   var RTo, PTo : array of single);
{convert variables in one rect. and polar grids and arrays to another by multiplying
 cc       multiplier ( = length of line, 1/length, or coeff for phys units <-> pu
 pPfrom   pointer to input polar grid
 pRgrid   pointer to output grid with rectangular comp. of impedance
 pPgrid   pointer to output grid with polar comp. of impedance
 Rfrom    input array with rect.components
 Pfrom    input array with polar components
 RTo      output array with rect.components
 PTo      output array with rect comp.}
var
  ii  : integer;  {index}
  txt : string;   {temporary}
begin
  {calculate and save numerical parameters in arrays by multiplying (mostly)}
  for ii := 0 to high(KmRectArr) do begin
    RTo[ii] := cc*Rfrom[ii];
  end;
  PTo[Z1row] := cc*Pfrom[Z1row];
  PTo[Z0row] := cc*Pfrom[Z0row];
  PTo[f1row] := Pfrom[f1row];
  PTo[f0row] := Pfrom[f0row];
  {copy to grid as strings (texts) Rectangular impedances first}
  for ii := 0 to high(KmRectArr) do begin
    txt := ManyChars(RTo[ii],true);            {numerical value to string}
    pRGrid^.cells[1,ii] := spaceless(txt);     {remove spaces, put to grid}
  end;
  {then, in polar form}
  txt := ManyChars(PTo[Z1Row],true);                {numerical value to string}
  pPgrid^.cells[1,Z1row] := spaceless(txt);
  txt := ManyChars(PTo[Z0Row],true);                {numerical value to string}
  pPGrid^.cells[1,Z0row] := spaceless(txt);
  pPGrid^.cells[1,f1row] := pPfrom^.cells[1,f1row];  {phases copied as such}
  pPGrid^.cells[1,f0row] := pPfrom^.cells[1,f0row];
//  {calculate k0 of the line}
//  TrLineForm.k0;
end;

procedure ShowBaseZ(baseZ : single; pZEdit: TpEdit);
{show the calculated base impedance
 baseZ  the base impedance
 pZedit pointer to the TEdit, where shown}
var
  txt : string;  {temporary}
begin
  txt := ManyChars(baseZ,false);   {in routines.pas}
  pZEdit^.text := txt+' W';
end;

procedure BaseToGrid(pComp: TpComp; pkVEdit, pMVAEdit, pZEdit: TpEdit;
                     var bkV, bMVA, bZ, IbZ : single);
{read the base values from the component, display in the corresponding edits
 pComp    pointer to the component
 pkVEdit  edit for base voltage
 pMVAEdit edit for base power
 pZEdit   edit for base impedance
 bkV      base voltage
 bMVA     base power
 bZ       base impedance
 IbZ      inverse of base impedance, 1/bZ}
var
  apu,apv : single;   {temporary}
  txt     : string;   {temporary}
begin
  pComp^.GetVPRef(apu,apv);         {base power and voltage BUT MVA and kV, or VA and V??}
  RemoveSpaces(apu,txt);            {format, and remove spaces, in routines.pas}
  pkVEdit^.text := txt;
  bkV := apu;
  RemoveSpaces(apv,txt);            {format, and remove spaces, in routines.pas}
  pMVAEdit^.text := txt;
  bMVA := apv;
  if (bkV > 0) and (bMVA > 0) then begin
    bZ := (bkV*bkV)/bMVA;
    IbZ := 1/bZ;  {1/ base impedance}
    ShowBaseZ(bZ,pZEdit);
  end else begin
    IbZ := 1; {error case}
    if (bMVA <= 0) then pMVAEdit^.color := clYellow;   {warn for zero value}
    if (bkV <= 0) then pkVEdit^.color := clYellow;
  end;
end;

procedure TTrLineForm.ParamToGrid(pComp: TpComp);
{read parameters from the component, put to grid
 Called in SendTrLineData of skemproc.pas
 pComp  pointer to the transmission line}
var
  apu,apv : single;    {temporary}
  baseZ   : single;    {base impedance for pu}
  fii     : single;    {phase angle (rad) of the impedance}
  ii      : integer;   {index}
  pGrid   : TpGrid;    {pointer to the grid for parameters}
  Rr      : single;    {ral part of the impedance}
  txt     : string;    {temporary}
  txx     : string;    {temporary}
  volt    : single;    {voltage}
  Xx      : single;    {imag.part of the impedance}
  Zz      : single;    {magnitude of the impedance}
//par     : array[1..10] of single; {for damage parameters. Dim >= CurveGrid.rowcount}
begin
  pGrid := @KmRectGrid;             {pointer to the grid for the parameters}
  {read parameters one by one}
  pComp^.GetPar(gTrliS_R,apu);      {resistance/km of a transmission line}
  RemoveSpaces(apu,txt);            {format, and remove spaces, in routines.pas}
  pGrid^.Cells[1,R1Row] := txt;
  KmRectArr[R1Row] := apu;          {save also to arrays, for conversion}
  pComp^.GetPar(gTrliS_S,apu);      {susceptance/km  (omega*C)}
  RemoveSpaces(apu,txt);            {format, and remove spaces, in routines.pas}
  pGrid^.Cells[1,SsRow] := txt;
  KmRectArr[SsRow] := apu;          {save also to arrays, for conversion}
  pComp^.GetPar(gTrliS_X,apu);      {reactance/km    (omega*L)}
  RemoveSpaces(apu,txt);            {format, and remove spaces, in routines.pas}
  pGrid^.Cells[1,X1Row] := txt;
  KmRectArr[X1Row] := apu;          {save also to arrays, for conversion}
  pComp^.GetPar(gTrliS_len,apu);    {length (km)}
  RemoveSpaces(apu,txt);            {format, and remove spaces, in routines.pas}
  LengthEdit.text := txt;
  lin_len := apu;
  pComp^.GetPar(gTrliS_R0,apu);     {zero sequence resistance}
  RemoveSpaces(apu,txt);            {format, and remove spaces, in routines.pas}
  pGrid^.Cells[1,R0Row] := txt;
  KmRectArr[R0Row] := apu;          {save also to arrays, for conversion}
  pComp^.GetPar(gTrliS_X0,apu);     {zero sequence reactance}
  RemoveSpaces(apu,txt);            {format, and remove spaces, in routines.pas}
  pGrid^.Cells[1,X0Row] := txt;
  KmRectArr[X0Row] := apu;          {save also to arrays, for conversion}
  pComp^.GetPar(gTrliS_s1,apu);     {relative length of the first section}
  RemoveSpaces(apu,txt);            {format, and remove spaces, in routines.pas}
  SplitEdit.text := txt;
  lin_split := apu;
  pComp^.GetPar(gTrliS_paral,apu);  {number of parallel lines}
  if (apu <= 0) then apu := 1;
  RemoveSpaces(apu,txt);            {format, and remove spaces, in routines.pas}
  ParalEdit.text := txt;
  {display impedances also in polar form}
  RecToPolar(pGrid^.cells[1,R1Row],pGrid^.cells[1,X1Row],txt,txx,Rr,Xx,Zz,fii);
  KmPolarGrid.cells[1,Z1row] := txt;
  KmPolarGrid.cells[1,f1row] := txx;
  KmPolarArr[Z1Row] := Zz;          {save also to arrays, for conversion}
  KmPolarArr[F1Row] := apu;         {save also to arrays, for conversion}
  RecToPolar(pGrid^.cells[1,R0Row],pGrid^.cells[1,X0Row],txt,txx,Rr,Xx,Zz,fii);
  KmPolarGrid.cells[1,Z0row] := txt;
  KmPolarGrid.cells[1,f0row] := txx;
  KmPolarArr[Z0Row] := Zz;          {save also to arrays, for conversion}
  KmPolarArr[F0Row] := apu;         {save also to arrays, for conversion}
  {calculate parameters in ohms and in S, and copy to ohm-arrays}
  OtherGrids(lin_len, @KmPolarGrid,@OhmRectGrid,@OhmPolarGrid, KmRectArr,KmPolarArr,
             OhmRectArr,OhmPolarArr);
  BaseToGrid(pComp, @kVEdit, @MVAEdit, @ZEdit, basekV, baseMVA, baseZ,apu);
  {to pu grid and arrays}
  OtherGrids(apu, @OhmPolarGrid,@PuRectGrid,@PuPolarGrid, OhmRectArr,OhmPolarArr,
             PuRectArr,PuPolarArr);
  {ampacity limits}
  for ii := 0 to 3 do begin
    pComp^.GetPar(gTrliS_A1+ii,apu);  {ampacity limit}
    RemoveSpaces(apu,txt);            {format, and remove spaces, in routines.pas}
    AmpGrid.Cells[ii,1] := txt;
  end;
  {parameters for the damage curve}
  pComp^.GetPar(gTrliS_Curr,CurvePar[1]);    {damage current}
  if (CurvePar[1] <= 0) then CurvePar[1] := 1;
  pComp^.GetPar(gTrliS_Time,CurvePar[2]);    {damage time}
  if (CurvePar[2] <= 0) then CurvePar[2] := 1;
  pComp^.GetPar(gTrliS_MinT,CurvePar[3]);    {minimum time for the curve}
  if (CurvePar[3] <= 0) then CurvePar[3] := 0.01;
  pComp^.GetPar(gTrliS_MaxT,CurvePar[4]);    {max.time for the curve}
  if (CurvePar[4] <= 0) then CurvePar[4] := 10;
//pComp^.GetPar(gTrliS_Name,CurvePar[5]);    {name = title of the curve}
//if (CurvePar[5] <  0) then CurvePar[5] := 0;    {string...not a number...}
CurvePar[5] := 0;                            {temporary}
  pComp^.GetPar(gTrliS_Color,CurvePar[6]);   {color index of the curve}
  if (CurvePar[6] <  1) or (CurvePar[6] > 16) then CurvePar[6] := 1;
  pComp^.GetPar(gTrliS_Thick,CurvePar[7]);   {thickness of the curve}
  if (CurvePar[7] <= 0) or (CurvePar[7] > 4) then CurvePar[7] := 1;
  {voltage level: use calculated value, if available}
  pComp^.GetVoltlev(Volt);              {calculated}
  if (Volt > 0) then CurvePar[8] := volt
  else   pComp^.GetPar(gTrliS_Volt,CurvePar[8]); {voltage as parameter (calculated earlier?)}
  if (CurvePar[8] <= 0) then CurvePar[8] := 1;
  pComp^.GetPar(gTrliS_InUse,CurvePar[9]);   {flag for in use/or not}
  if (CurvePar[9] <>  0) and (CurvePar[9] <> 1) then begin  {error case}
    CurvePar[9] := 0;
    pComp^.PutPar(gTrliS_InUse,0);
  end;
  {numerical parameters to the grid}
  for ii := 1 to 9 do begin
    RemoveSpaces(CurvePar[ii],txt);          {format, and remove spaces, in routines.pas}
    CurveGrid.Cells[1,ii-1] := txt;
  end;
  {name = string parameter}
  pComp^.GetStringPar(txt,0);             {a string.., differently}
  ExtractParam(1,';',txt,CurveName);      {get string parameter, in routines.pas}
  CurveGrid.cells[1,NameRow] := CurveName;
  {state of button for displaying/not the damage curve}
  pComp^.GetPar(gTrliS_InUse,apu);           {flag for displaying damage curve}
  DamageCurveBut.down := (apu <> 0);
  {save pointer present tr.line showing damage curve}
  pDmgLine := pSet^.pTr_Line;
  {calculate and display k0 of the line}
  k0;
end;

procedure LineRectGridKeyUp(pRGrid, pPGrid: TpGrid; var KmrArr, KmpArr: array of single;row : integer);
{update the polar parameters by converting the rectangular parameters to polar
 pRGrid  pointer to the rect.grid
 pPGrid  pointer to the polar grid
 KmrArr  array for impedances as singles, in rect.form
 KmpArr  array for impedances as singles, in polar form
 row     the row where value changed}
var
  apu,apv : single;  {temporary}
  apw,apx : single;  {temporary}
  err1    : integer; {error flag}
  fii     : single;  {phase of the impedance, in rad}
  ipu     : integer; {temporary}
  Rr      : single;  {real part of the impedance}
  Ss      : single;  {susceptance}
  s1,s2   : string;  {temporary}
  s3,s4   : string;  {temporary}
  txt,txx : string;  {temporary}
  Xx      : single;  {imag.part of the impedance}
  Zz      : single;  {magnitude of the impedance}
begin
  if (row = R1Row) or (row = X1Row) then begin            {pos.seq. impedance}
    RecToPolar(pRGrid^.cells[1,R1Row],pRGrid^.cells[1,X1Row],txt,txx,Rr,Xx,Zz,fii);
    if (txt <> '?') and (txx <> '?') then begin           {reasonable values}
      pPGrid^.cells[1,Z1row] := txt;
      pPGrid^.cells[1,f1row] := txx;
      pRGrid^.color := clWhite;
      {save also in arrays as singles (reals)}
      KmrArr[R1Row] := Rr;    {save both, for simplicity}
      KmrArr[X1Row] := Xx;
      KmpArr[Z1Row] := Zz;
      KmpArr[F1Row] := fii;
    end else begin
      pRGrid^.color := clYellow;
    end;
  end else if (row = R0Row) or (row = X0Row) then begin   {zero seq. impedance}
    RecToPolar(pRGrid^.cells[1,R0Row],pRGrid^.cells[1,X0Row],txt,txx,Rr,Xx,Zz,fii);
    if (txt <> '?') and (txx <> '?') then begin           {reasonable values}
      pPGrid^.cells[1,Z0row] := txt;
      pPGrid^.cells[1,f0row] := txx;
      pRGrid^.color := clWhite;
      {save also as singles (reals) into arrays}
      KmrArr[R0Row] := Rr;    {save both, for simplicity}
      KmrArr[X0Row] := Xx;
      KmpArr[Z0Row] := Zz;
      KmpArr[F0Row] := fii;
    end else begin
      pRGrid^.color := clYellow;
    end;
  end else if (row = SsRow) then begin       {admittance = shunt capacitance}
    ValuesFromLine(pRgrid^.cells[1,Ssrow],1,false,ipu,Ss,apu,apv,apw,s1,s2,s3,s4,err1);
    if (err1 = 0) then begin
      KmrArr[Ssrow] := Ss;
      pRGrid^.color := clWhite;
    end else begin
      pRGrid^.color := clYellow;
    end;
  end;
end;

procedure LinePolarGridKeyUp(pRGrid, pPGrid: TpGrid; var KmrArr, KmpArr: array of single;row : integer);
{convert impedances from polar to rectangular form
 pRgrid   pointer to the grid with impedances in rectangular form
 pPGrid   pointer to the grid with impedances in polar form
 KmrArr   array for impedances as singles, in rect.form
 KmpArr   array for impedances as singles, in polar form
 row      the row where value changed}
var
  fii     : single;  {phase of the impedance}
  Rr,Xx   : single;  {rectangular components of the impedances}
  txt,txx : string;  {temporary}
  Zz      : single;  {magnitude of the impedance}
begin
  if (row = Z1Row) or (row = F1Row) then begin    {pos.seq. impedance}
    PolarToRec(pPGrid^.cells[1,Z1Row],pPGrid.cells[1,F1Row],txt,txx,Rr,Xx,Zz,fii);
    if (txt <> '?') and (txx <> '?') then begin           {reasonable values}
      pRGrid^.cells[1,R1row] := txt;
      pRGrid^.cells[1,X1row] := txx;
      pPGrid^.color := clWhite;
      {save values also as reals}
      KmrArr[R1Row] := Rr;
      KmrArr[X1Row] := Xx;
      KmpArr[Z1Row] := Zz;      {save both, for simplicity}
      KmpArr[F1Row] := fii;
    end else begin
      pPGrid^.color := clYellow;
    end;
  end else if (row = Z0Row) or (row = F0Row) then begin {zero seq. impedance}
    PolarToRec(pPGrid^.cells[1,Z0Row],pPGrid^.cells[1,F0Row],txt,txx,Rr,Xx,Zz,fii);
    if (txt <> '?') and (txx <> '?') then begin           {reasonable values}
      pRGrid^.cells[1,R0row] := txt;
      pRGrid^.cells[1,X0row] := txx;
      pPGrid^.color := clWhite;
      {save also as singles (reals) into arrays}
      KmrArr[R0Row] := Rr;
      KmrArr[X0Row] := Xx;
      KmpArr[Z0Row] := Zz;      {save both, for simplicity}
      KmpArr[F0Row] := fii;
    end else begin
      pPGrid^.color := clYellow;
    end;
  end;
end;

procedure TTrLineForm.KmRectGridKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  apu : single;
{update the polar parameters}
begin
  {change to polar form}
  LineRectGridKeyUp(@KmRectGrid,@KmPolarGrid, KmRectArr,KmPolarArr,kmr_row);
  {calculate in ohms (and S) and write in Ohm-grid}
  OtherGrids(lin_len, @KmPolarGrid,@OhmRectGrid,@OhmPolarGrid, KmRectArr,KmPolarArr,
             OhmRectArr,OhmPolarArr);
  {pu grids and arrays}
  if (basekV > 0) and (baseMVA > 0) then begin
    apu := baseMVA/(basekV*basekV);  {1/ base impedance}
  end else begin
    apu := 1; {error case}
    if (baseMVA <= 0) then MVAEdit.color := clYellow;   {warn for zero value}
    if (basekV <= 0) then kVEdit.color := clYellow;
  end;
  {to pu grid and arrays}
  OtherGrids(apu, @OhmPolarGrid,@PuRectGrid,@PuPolarGrid, OhmRectArr,OhmPolarArr,
             PuRectArr,PuPolarArr);
  {calculate and display k0 of the line}
  k0;             
end;

procedure TTrLineForm.KmRectGridSelectCell(Sender: TObject; Col,
  Row: Longint; var CanSelect: Boolean);
{save the row}
begin
  kmr_row := row;
//  LightGrayGrids;              {first,reset all to light gray}
//  KmRectGrid.color := clWhite; {the grid in use is white}
end;

procedure TTrLineForm.FormKeyPress(Sender: TObject; var Key: Char);
{check the decimal point, change if necessary}
begin
  if      (dec_p = ',') and (key = '.') then key := ','
  else if (dec_p = '.') and (key = ',') then key := '.';
end;

procedure TTrLineForm.KmPolarGridKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
{convert impedances to rectangular form}
var
  apu : single;
begin
  LinePolarGridKeyUp(@KmRectGrid,@KmPolarGrid,KmRectArr,KmPolarArr,kmp_row);
  {calculate in ohms (and S) and write in Ohm-grid}
  OtherGrids(lin_len, @KmPolarGrid,@OhmRectGrid,@OhmPolarGrid, KmRectArr,KmPolarArr,
             OhmRectArr,OhmPolarArr);
  {pu grids and arrays}
  if (basekV > 0) and (baseMVA > 0) then begin
    apu := baseMVA/(basekV*basekV);  {1/ base impedance}
  end else begin
    apu := 1; {error case}
    if (baseMVA <= 0) then MVAEdit.color := clYellow;   {warn for zero value}
    if (basekV <= 0) then kVEdit.color := clYellow;
  end;
  {to pu grid and arrays}
  OtherGrids(apu, @OhmPolarGrid,@PuRectGrid,@PuPolarGrid, OhmRectArr,OhmPolarArr,
             PuRectArr,PuPolarArr);
  {calculate and display k0 of the line}
  k0;             
end;

procedure TTrLineForm.DefaultLineParameters;
{initialize the parameters with default values}
var
  apu     : single;  {temporary}
  fii     : single;  {phase angle of the impedance}
  ii      : integer; {index}
  ix,iy   : integer; {coordinates}
  lbl     : string;  {label}
  txt,txx : string;  {temporary}
  Rr,Xx   : single;  {real and imag.parts of the impedance}
  Zz      : single;  {magnitude of the impedance}
begin
  {length and fraction}
  LengthEdit.text := '1';    {Must be 1 !!!!, se below}
  Lin_Len := 1;              {lenght as single, must be same as above}
  SplitEdit.text := '0'+dec_p+'5';
  Lin_Split := 0.5;           {splitting ratio as single, must be same as above}
  ParalEdit.text := '1';
  MVAEdit.text := '1';
  baseMVA      :=  1 ;       {base power, must be the same as text}
  kVEdit.text  := '1';
  basekV       :=  1 ;       {base voltage, must be the same as text}
  apu := basekV*basekV/baseMVA;
  ShowBaseZ(apu,@ZEdit);
  {impedances, in ohm/km}
  KmRectGrid.cells[1,R1row] := '1';
  KmRectGrid.cells[1,X1row] := '1';
  KmRectGrid.cells[1,R0row] := '1';
  KmRectGrid.cells[1,X0row] := '1';
  KmRectGrid.cells[1,Ssrow] := '1e-6'; {these must ...}
  KmRectArr[Ssrow]          :=  1e-6 ; {...be the same}
  OhmRectArr[Ssrow]         :=  1e-6 ;
  puRectArr[Ssrow]          :=  1e-6 ;
  {transfer to polar form. The pos.seq. parameters first}
  RecToPolar(KmRectGrid.cells[1,R1Row],KmRectGrid.cells[1,X1Row],txt,txx,Rr,Xx,Zz,fii);
  KmPolarGrid.cells[1,Z1row] := txt;
  KmPolarGrid.cells[1,f1row] := txx;
  {impedances also to arrays}
  KmRectArr[R1row] := Rr;
  KmRectArr[X1row] := Xx;
  KmPolarArr[Z1row] := Zz;
  KmPolarArr[F1row] := fii;
  {impedances also to Ohm arrays, but length must be 1 !!!!}
  OhmRectArr[R1row] := Rr;
  OhmRectArr[X1row] := Xx;
  OhmPolarArr[Z1row] := Zz;
  OhmPolarArr[F1row] := fii;
  {then the zero seq. param}
  RecToPolar(KmRectGrid.cells[1,R0Row],KmRectGrid.cells[1,X0Row],txt,txx,Rr,Xx,Zz,fii);
  KmPolarGrid.cells[1,Z0row] := txt;
  KmPolarGrid.cells[1,f0row] := txx;
  {impedances also to arrays}
  KmRectArr[R0row] := Rr;
  KmRectArr[X0row] := Xx;
  KmPolarArr[Z0row] := Zz;
  KmPolarArr[F0row] := fii;
  {impedances also to Ohm arrays, but length must be 1 !!!!}
  OhmRectArr[R0row] := Rr;
  OhmRectArr[X0row] := Xx;
  OhmPolarArr[Z0row] := Zz;
  OhmPolarArr[F0row] := fii;
  {impedances in ohm, copy from ohm/km, but length must be 1!!!}
  OhmRectGrid.cells[1,R1row] := KmRectGrid.cells[1,R1row];
  OhmRectGrid.cells[1,X1row] := KmRectGrid.cells[1,X1row];
  OhmRectGrid.cells[1,R0row] := KmRectGrid.cells[1,R0row];
  OhmRectGrid.cells[1,X0row] := KmRectGrid.cells[1,X0row];
  OhmRectGrid.cells[1,Ssrow] := KmRectGrid.cells[1,Ssrow];
  OhmPolarGrid.cells[1,Z1row] := KmPolarGrid.cells[1,Z1row];
  OhmPolarGrid.cells[1,f1row] := KmPolarGrid.cells[1,f1row];
  OhmPolarGrid.cells[1,Z0row] := KmPolarGrid.cells[1,Z0row];
  OhmPolarGrid.cells[1,f0row] := KmPolarGrid.cells[1,f0row];
  {impedances in pu-grids, but length must be 1 and base power and voltage must be 1 !!!}
  puRectGrid.cells[1,R1row] := KmRectGrid.cells[1,R1row];
  puRectGrid.cells[1,X1row] := KmRectGrid.cells[1,X1row];
  puRectGrid.cells[1,R0row] := KmRectGrid.cells[1,R0row];
  puRectGrid.cells[1,X0row] := KmRectGrid.cells[1,X0row];
  puRectGrid.cells[1,Ssrow] := KmRectGrid.cells[1,Ssrow];
  puPolarGrid.cells[1,Z1row] := KmPolarGrid.cells[1,Z1row];
  puPolarGrid.cells[1,f1row] := KmPolarGrid.cells[1,f1row];
  puPolarGrid.cells[1,Z0row] := KmPolarGrid.cells[1,Z0row];
  puPolarGrid.cells[1,f0row] := KmPolarGrid.cells[1,f0row];
  {impedances in pu-arrays, but length = 1, base power = 1, base voltage = 1}
  for ii := 0 to high(KmRectArr) do puRectArr[ii] := KmRectArr[ii];
  for ii := 0 to high(KmPolarArr) do puPolarArr[ii] := KmPolarArr[ii];
  {ampacity limits}
  for ii := 0 to 3 do AmpGrid.cells[ii,1] := '0';
  {default values into the grid for the damage curve (not all known yet?? - - - - - -}
  CurveGrid.cells[1,CurrRow] := '100';
  CurveGrid.cells[1,TimeRow] := '1';
  CurveGrid.cells[1,MinTRow] := '0.01';
  CurveGrid.cells[1,MaxTRow] := '10';
  pComp^.GetLabel(lbl,ix,iy);
  CurveGrid.cells[1,NameRow] := lbl;
  CurveGrid.cells[1,ColorRow] := '1';
  CurveGrid.cells[1,ThickRow] := '1';
  CurveGrid.cells[1,VoltRow] := '100';
  CurveGrid.cells[1,InUseRow] := '0';
end;

procedure TTrLineForm.KmPolarGridSelectCell(Sender: TObject; Col,
  Row: Longint; var CanSelect: Boolean);
{save the row index}
begin
  kmp_row := row;
end;

procedure {TTrLineForm.}ParametersToComp(pCompo: TpComp; line: string; ipar: integer; var par : single);
{copy the parameters from the grid and edits and move to the comp.
 Only rect.parameters in Ohms (and length and split and base values)
 pCompo  pointer to the component
 line    the parameter as a string
 ipar    index of the parameter
 par     value of the parameter}
var
  apu,apv     : single;    {temporary}
  apw,apx     : single;    {temporary}
  errc        : integer;   {error flag}
  ipu         : integer;   {temporary}
  ll          : longint;
  oldval      : single;    {old parameter value}
  pSet        : TpCompSet;
  s1,s2,s3,s4 : string;    {temporary}
begin
  if (not appl_close) then begin       {not when closing}
    pCompo^.GetipSet(ll);
    pSet := TpCompSet(ll);
    pCompo^.getpar(ipar,oldval);        {get the old value, for comparisons}
    ValuesFromLine(line,1,true,ipu, apu,apv,apw,apx,s1,s2,s3,s4,errc); {one parameter a time}
    {set error flag, it is checked and reset in TCompSet.FormMouseDown}
    if (errc <> 0) then begin
      pSet^.err_cs := 1;
      par := oldval;                     {error case, use old value}
    end else begin
      pCompo^.putpar(ipar,apu);           {save the parameter to the component}
      if (oldval <> apu) then pSet^.IsChanged := true; {flag the change}
      par := apu;
    end;
  end;
//cancel := false;
end;

procedure TTrLineForm.AllParametersToComp;
{save all parameters to the component}
var
  apu : single;
  ii  : integer;
begin
  ParametersToComp(pComp,KmRectGrid.cells[1,R1Row],gTrliS_R,apu);  {resistance, ohm/km}
  ParametersToComp(pComp,KmRectGrid.cells[1,X1Row],gTrliS_X,apu);  {reactance/km    (omega*L)}
  ParametersToComp(pComp,KmRectGrid.cells[1,R0Row],gTrliS_R0,apu); {zero sequence resistance}
  ParametersToComp(pComp,KmRectGrid.cells[1,X0Row],gTrliS_X0,apu); {zero sequence reactance}
  ParametersToComp(pComp,KmRectGrid.cells[1,SsRow],gTrliS_S,apu);  {susceptance/km  (omega*C)}
  ParametersToComp(pComp,LengthEdit.text, gTrliS_len,lin_len);     {length (km)}
  ParametersToComp(pComp,SplitEdit.text,  gTrliS_s1,apu);          {relative length of the first section}
  ParametersToComp(pComp,ParalEdit.text,  gTrliS_paral,apu);       {relative length of the first section}
  pComp^.PutVPref(basekV,baseMVA);                           {save base power and voltage}
  {ampacity limits}
  for ii := 0 to 3 do begin
    ParametersToComp(pComp,AmpGrid.cells[ii,1],gTrliS_A1+ii,apu);  {susceptance/km  (omega*C)}
  end;
  {parameters of the damage curve}
  CurveParametersToComp;
  Cancel := false;
end;

procedure TTrLineForm.CurveParametersToComp;
var
  apu : single;
begin
  {parameters of the damage curve}
  ParametersToComp(pComp,CurveGrid.cells[1,CurrRow],gTrliS_Curr,apu);
  ParametersToComp(pComp,CurveGrid.cells[1,TimeRow],gTrliS_Time,apu);
  ParametersToComp(pComp,CurveGrid.cells[1,MinTRow],gTrliS_MinT,apu);
  ParametersToComp(pComp,CurveGrid.cells[1,MaxTRow],gTrliS_MaxT,apu);
  pComp^.PutStringPar(CurveGrid.cells[1,NameRow],0);            {a string.., differently}
  pComp^.PutPar(gTrLiS_name,improbg);                           {flag for string parameter}
  ParametersToComp(pComp,CurveGrid.cells[1,ColorRow],gTrliS_Color,apu);
  ParametersToComp(pComp,CurveGrid.cells[1,ThickRow],gTrliS_Thick,apu);
  ParametersToComp(pComp,CurveGrid.cells[1,VoltRow],gTrliS_Volt,apu);
  ParametersToComp(pComp,CurveGrid.cells[1,InUseRow],gTrliS_InUse,apu);
end;

procedure TTrLineForm.FormHide(Sender: TObject);
{copy parameters to the component
 For impedances: only the rect.impedances in ohm/km}
var
  apu   : single;
  ii    : integer;
  RePro : TCompProc;     {procedure for operations after readings}
begin
  if (not appl_close) and (not cancel) then begin
    AllParametersToComp;
    CheckAmpOfLines;      {check current in tr.lines against limits}
    unmark(longint(pSet));
    {some operation when parameters read}
    pComp^.GetRePro(RePro);              {get the procedure}
    RePro(longint(pComp));               {the operation after reading}
  end;
  cancel := false;
end;

procedure TTrLineForm.FormDeactivate(Sender: TObject);
var
  bpu : boolean;  {temporary}
begin
  {hide the form, but not when Hint-button clicked, or when pu-calculator-button clicked}
  if (pHelp <> nil) then bpu := (not pHelp^.visible)
  else bpu := true;
  if (not puForm.visible) and bpu and (not pSet^.Copy_Click) and {not hide, when copying}
     (not UpdatePanel.visible) then                              {or updating base variables}
    TrLineForm.visible := false;
end;

procedure TTrLineForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  {eventual "delete component" must be handled here, because form (?) has focus}
  if (pComp <> nil) then begin
    if (pSet^.pActComp <> nil) then begin     {some component active}
      if (key = 46) then begin                {delete-key}
        pSet^.FormKeyDown(Key, Shift);        {delete the component}
      end;
    end;
  end;
end;


procedure TTrLineForm.LengthEditKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
{update impedances}
var
  apu,apv : single;  {temporary}
  apw,apx : single;  {temporary}
  err     : integer; {error flag}
  ipu     : integer; {temporary}
  len     : single;  {length of line}
  s1,s2   : string;  {temporary}
  s3,s4   : string;  {temporary}
begin
  {convert string to single}
  ValuesFromLine(LengthEdit.text, 1, false, ipu, len, apu, apv, apw, s1,s2,s3,s4,err);
  if (err = 0) then begin        {no errors}
    if (len >= 0.0001) then      {must not be too short}
      lin_len := len             {save length}
    else lin_len := 0.0001;
    OtherGrids(lin_len, @KmPolarGrid,@OhmRectGrid,@OhmPolarGrid, KmRectArr,KmPolarArr,
               OhmRectArr,OhmPolarArr);
    LengthEdit.color := clWhite;
    {pu grids and arrays}
    if (basekV > 0) and (baseMVA > 0) then begin
      apu := baseMVA/(basekV*basekV);  {1/ base impedance}
    end else begin
      apu := 1; {error case}
      if (baseMVA <= 0) then MVAEdit.color := clYellow;   {warn for zero value}
      if (basekV <= 0) then kVEdit.color := clYellow;
    end;
    {to pu grid and arrays}
    OtherGrids(apu, @OhmPolarGrid,@PuRectGrid,@PuPolarGrid, OhmRectArr,OhmPolarArr,
               PuRectArr,PuPolarArr);
    {calculate and display k0 of the line}
    k0;
  end else begin
    LengthEdit.color := clYellow;
  end;

end;

procedure TTrLineForm.OhmRectGridKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  apu  : single;
  olen : single;  {1/line length}
begin
  {change to polar form}
  LineRectGridKeyUp(@OhmRectGrid,@OhmPolarGrid, OhmRectArr,OhmPolarArr,ohmr_row);
  {calculate in ohms/km (and S/km) and write in Km-grid}
  if (lin_len > 0) then olen := 1/lin_len else olen := 1;
  OtherGrids(olen, @OhmPolarGrid,@KmRectGrid,@KmPolarGrid, OhmRectArr,OhmPolarArr,
             KmRectArr,KmPolarArr);
  {pu grids and arrays}
  if (basekV > 0) and (baseMVA > 0) then begin
    apu := baseMVA/(basekV*basekV);  {1/ base impedance}
  end else begin
    apu := 1; {error case}
    if (baseMVA <= 0) then MVAEdit.color := clYellow;   {warn for zero value}
    if (basekV <= 0) then kVEdit.color := clYellow;
  end;
  {to pu grid and arrays}
  OtherGrids(apu, @OhmPolarGrid,@PuRectGrid,@PuPolarGrid, OhmRectArr,OhmPolarArr,
             PuRectArr,PuPolarArr);
  {calculate and display k0 of the line}
  k0;             
end;

procedure TTrLineForm.OhmRectGridSelectCell(Sender: TObject; Col,
  Row: Longint; var CanSelect: Boolean);
begin
  OhmR_row := row;
end;

procedure TTrLineForm.OhmPolarGridSelectCell(Sender: TObject; Col,
  Row: Longint; var CanSelect: Boolean);
begin
  OhmP_row := row;
end;

procedure TTrLineForm.OhmPolarGridKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
{convert impedances to rectangular form}
var
  apu  : single;
  olen : single; {1/line length}
begin
  LinePolarGridKeyUp(@OhmRectGrid,@OhmPolarGrid,OhmRectArr,OhmPolarArr,Ohmp_row);
  {calculate in ohms/km (and S/km) and write in Km-grid}
  if (lin_len > 0) then olen := 1/lin_len else olen := 1;
  OtherGrids(olen, @OhmPolarGrid,@KmRectGrid,@KmPolarGrid, OhmRectArr,OhmPolarArr,
             KmRectArr,KmPolarArr);
  {pu grids and arrays}
  if (basekV > 0) and (baseMVA > 0) then begin
    apu := baseMVA/(basekV*basekV);  {1/ base impedance}
  end else begin
    apu := 1; {error case}
    if (baseMVA <= 0) then MVAEdit.color := clYellow;   {warn for zero value}
    if (basekV <= 0) then kVEdit.color := clYellow;
  end;
  {to pu grid and arrays}
  OtherGrids(apu, @OhmPolarGrid,@PuRectGrid,@PuPolarGrid, OhmRectArr,OhmPolarArr,
             PuRectArr,PuPolarArr);
  {calculate and display k0 of the line}
  k0;             
end;

procedure TTrLineForm.PuRectGridSelectCell(Sender: TObject; Col,
  Row: Longint; var CanSelect: Boolean);
begin
  pur_row := row;
end;

procedure TTrLineForm.PuPolarGridSelectCell(Sender: TObject; Col,
  Row: Longint; var CanSelect: Boolean);
begin
  pup_row := row;
end;

procedure TTrLineForm.PuRectGridKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  {change to polar form}
  LineRectGridKeyUp(@PuRectGrid,@PuPolarGrid, PuRectArr,PuPolarArr,pur_row);
  ImpedancesInGrids;  {the other impedances, in Ohm and Ohm/km}
end;

procedure TTrLineForm.PuPolarGridKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  {change to rect.form}
  LinePolarGridKeyUp(@PuRectGrid,@PuPolarGrid,PuRectArr,PuPolarArr,Pup_row);
  ImpedancesInGrids;  {the other impedances, in Ohm and Ohm/km}
end;

procedure TTrLineForm.ImpedancesInGrids;
{recalculate impdances in other grids}
var
  apu   :single;
  baseR : single;  {the base impedance}
begin
  if (basekV > 0) and (baseMVA > 0) then begin
    baseR := basekV*basekV/baseMVA;
    {directly in Ohms in OhmGrid}
    OtherGrids(baseR, @PuPolarGrid,@OhmRectGrid,@OhmPolarGrid, PuRectArr,PuPolarArr,
               OhmRectArr,OhmPolarArr);
    {Ohm/km in KmGrid}
    if (lin_len > 0) then apu := baseR/lin_len else apu := baseR;
    OtherGrids(apu, @PuPolarGrid,@KmRectGrid,@KmPolarGrid, PuRectArr,PuPolarArr,
               KmRectArr,KmPolarArr);
    {calculate and display k0 of the line}
    k0;
  end;
end;

procedure ChangeOfBase(pEdit, pZEdit : TpEdit; MVAorkV : string; var bkV, bMVA: single; var err : integer);
{read new base value, recalculate the impdeances
 pEdit      pointer to edit of the base value
 pZEdit     pointer to edit showing base impedance
 MVAorkV    if 'MVA' then base power changed, if 'kV' then base voltage changed
 bkV, bMVA  base voltage, base power
 err        error flag}
var
  apu,apv : single;  {temporary}
  apw,apx : single;  {temporary}
  baseR   : single;  {base impedance}
  baseZ   : single;  {base impedance}
  ipu     : integer; {temporary}
  bvar    : single;  {base variable (power or voltage)}
  s1,s2   : string;  {temporary}
  s3,s4   : string;  {temporary}
begin
  {convert string to single}
  ValuesFromLine(pEdit^.text, 1, false, ipu, bvar, apu, apv, apw, s1,s2,s3,s4,err);
  if (err = 0) then begin        {no errors}
    if (MVAorkV = 'MVA') then begin
      if (bvar >= 0.99e-6) then     {must not be too small}
        bMVA := bvar             {save base power as single}
      else bMVA := 1e-6;
    end else if (MVAorkV = 'kV') then begin
      if (bvar >= 0.99e-3) then     {must not be too small}
        bkV := bvar              {save base power as single}
      else bkV := 1e-3;
    end else begin                  {error case}
      {error, no changes...}
    end;
//  ImpedancesInGrids;  {the other impedances, in Ohm and Ohm/km}  {NOT here!}
    pEdit^.color := clWhite;
    baseZ := bkV*bkV/bMVA;
    ShowBaseZ(baseZ,pZEdit);
  end else begin
    pEdit^.color := clYellow;
  end;
end;

procedure BaseEditKeyUp(Key: Word; pBEdit, pZEdit : TpEdit; kVorMVA: string;
                        var bkV,bMVA: single; pUDPanel: TpPanel;
                        pAVOBut,pPUBut: TpButton);
{When editing base voltage or base power, update base, and ask what parameters
 should be updated
 key       the key pressed (keyboard)
 pBEdit    pointer to edit for base voltage or power
 pZedit    pointer to edit for displaying base impedance
 kVorMVA   flag for the base variable, kV or MVA
 bkV,bMVA  the base variables
 pUDpanel  panel for selectig variables to be updated
 pAVOBut, pPUBut  pointers to buttons for updating parameters}
var
  err : integer;  {error flag}
begin
  if (key < 37) or (key > 40) and (pBEdit^.text <> '') then begin    {not arrow keys}
    PUform.visible := false; {hide PU-calculator to avoid "problems" (=updating)}
    {update impedances, when base power changed}
    ChangeOfBase(pBEdit, pZEdit, kVorMVA, bkV, bMVA, err);
    if (err = 0) then begin
      {ask, what should be updated, but only if no errors}
      if (not pUDPanel.visible) then begin
        pUDPanel^.left := 0;
        pUDPanel^.top := 0;
        pUDPanel^.visible := true;
        pUDPanel^.BringToFront;
      end;
    end else begin
      {}
    end;
    {allow updating only if no errors}
    pAVOBut^.enabled := (err = 0);
    pPUBut^.enabled := (err = 0);
  end;
end;

procedure TTrLineForm.MVAEditKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
{update base impedance, ask for parameters to be updated}
begin
  BaseEditKeyUp(Key, @MVAEdit, @ZEdit, 'MVA', basekV, baseMVA,
                @UpDatePanel, @AVOhmBut, @PerUnitBut);
(* if (key < 37) or (key > 40) and (MVAEdit.text <> '') then begin    {not arrow keys}
    PUform.visible := false; {hide PU-calculator to avoid "problems" (=updating)}
    {update impedances, when base power changed}
    ChangeOfBase(@MVAEdit, @ZEdit, 'MVA', basekV, baseMVA, err);
    if (err = 0) then begin
      {ask, what should be updated, but only if no errors}
      if (not UpdatePanel.visible) then begin
        UpdatePanel.left := 0;
        UpdatePanel.top := 0;
        UpdatePanel.visible := true;
        UpdatePanel.BringToFront;
      end;
    end else begin
      {}
    end;
    {allow updating only if no errors}
    AVOhmBut.enabled := (err = 0);
    PerUnitBut.enabled := (err = 0);
  end;
*)
end;

procedure TTrLineForm.kVEditKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
{update all impedances}
//var
//  err : integer;  {error flag}
begin
  BaseEditKeyUp(Key, @kVEdit, @ZEdit, 'kV', basekV, baseMVA,
                @UpDatePanel, @AVOhmBut, @PerUnitBut);
(*if (key < 37) or (key > 40) and (kVEdit.text <> '') then begin    {not arrow keys}
    PUform.visible := false;    {hide PU-calculator to avoid "problems" (=updating)}
    {update impedances, when base power changed}
    ChangeOfBase(@kVEdit, @ZEdit, 'kV', basekV, baseMVA, err);
    if (err = 0) then begin
      {ask, what should be updated, but only if no errors}
      if (not UpdatePanel.visible) then begin
        UpdatePanel.left := 0;
        UpdatePanel.top := 0;
        UpdatePanel.visible := true;
        UpdatePanel.BringToFront;
      end;
    end else begin
      {}
    end;
    {allow updating only if no errors}
    AVOhmBut.enabled := (err = 0);
    PerUnitBut.enabled := (err = 0);
  end;
*)  
end;

procedure PanelVisible(pBut: TpSpeedBut; pPanel: TpPanel; var yNext: integer);
{display/not a panel, update position of the next panel
 pBut     pointer to the button for show/not
 pPanel   pointer to the panel
 yNext    position of the next panel}
begin
  if (pBut^.down) then begin
    pPanel^.top := ynext;
    pPanel^.visible := true;
    yNext := yNext+pPanel^.height+2; {position of next panel}
  end else begin
    pPanel^.visible := false;
  end;
end;

procedure TTrLineForm.DisplayPanels;
{display the different panels depending on the position of the buttons}
var
  ynext : integer;  {the y-coordinate of the next panel}
begin
  ynext := LengthEdit.top+LengthEdit.height+2;   {position of first panel}
  PanelVisible(@KmBut,@KmPanel, yNext);          {panel for ohm/km}
  PanelVisible(@OhmBut,@OhmPanel, yNext);        {panel for ohm}
  PanelVisible(@PuBut,@PuPanel, yNext);          {panel for pu}
  PanelVisible(@AmpBut,@AmpPanel, yNext);        {panel for ampacity limits}
  ButPanel.top := yNext;
  {heights of the "backgrounds"}
  yNext := yNext+ButPanel.height+2;
  ParamPages.height := ParamTab.top+yNext+4;
  DamageCurveBut.top := ParamPages.height+2;
  TrLineForm.height := DamageCurveBut.top+DamageCurveBut.height+48{36};
end;

procedure TTrLineForm.KmButClick(Sender: TObject);
begin
  DisplayPanels;
end;

procedure TTrLineForm.OhmButClick(Sender: TObject);
begin
  DisplayPanels;
end;

procedure TTrLineForm.PuButClick(Sender: TObject);
begin
  DisplayPanels;
end;

procedure TTrLineForm.AmpButClick(Sender: TObject);
begin
  DisplayPanels;
end;

procedure TTrLineForm.OKButClick(Sender: TObject);
begin
  TrLineForm.visible := false;
  unmark(longint(pSet));       {must do also here, else does not unmark?}
end;

procedure TTrLineForm.CancelButClick(Sender: TObject);
begin
  cancel := true;
  TrLineForm.visible := false;
  unmark(longint(pSet));       {must do also here, else does not unmark?}
end;

procedure TTrLineForm.KmRectGridClick(Sender: TObject);
begin
  LightGrayGrids;               {first,reset all to light gray}
  KmRectGrid.color := clWindow; {the grid in use is white}
end;

procedure TTrLineForm.OhmRectGridClick(Sender: TObject);
begin
  LightGrayGrids;                {first,reset all to light gray}
  OhmRectGrid.color := clWindow; {the grid in use is white}
end;

procedure TTrLineForm.KmRectGridExit(Sender: TObject);
{set the row = the lowermost, very thin row, so that other rows can be grey}
begin
  KmRectGrid.row := 5;
end;

procedure TTrLineForm.KmPolarGridExit(Sender: TObject);
begin
  KmPolarGrid.row := 4;
end;

procedure TTrLineForm.KmPolarGridClick(Sender: TObject);
begin
  LightGrayGrids;                {first,reset all to light gray}
  KmPolarGrid.color := clWindow; {the grid in use is white}
end;

procedure TTrLineForm.OhmRectGridExit(Sender: TObject);
begin
  OhmRectGrid.row := 5;
end;

procedure TTrLineForm.OhmPolarGridExit(Sender: TObject);
begin
  OhmPolarGrid.row := 4;
end;

procedure TTrLineForm.PuRectGridExit(Sender: TObject);
begin
  PuRectGrid.row := 5;
end;

procedure TTrLineForm.PuPolarGridExit(Sender: TObject);
begin
  PuPolarGrid.row := 4;
end;

procedure TTrLineForm.OhmPolarGridClick(Sender: TObject);
begin
  LightGrayGrids;                 {first,reset all to light gray}
  OhmPolarGrid.color := clWindow; {the grid in use is white}
end;

procedure TTrLineForm.PuRectGridClick(Sender: TObject);
begin
  LightGrayGrids;               {first,reset all to light gray}
  PuRectGrid.color := clWindow; {the grid in use is white}
end;

procedure TTrLineForm.PuPolarGridClick(Sender: TObject);
begin
  LightGrayGrids;                {first,reset all to light gray}
  PuPolarGrid.color := clWindow; {the grid in use is white}
end;

procedure TTrLineForm.puCalcButClick(Sender: TObject);
begin
  pSet^.PuValuClick(Sender);
end;

procedure TTrLineForm.HelpButClick(Sender: TObject);
{display the help-memo (hint-memo)}
var
  pMod  : TpElComp;   {pointer to the model component}
begin
  if (pComp <> nil) then begin
    pComp^.GetpMod(pMod);
    pMod^.GetpHelp(pHelp);
    if (pHelp <> nil) then begin
      pHelp.top := 200;
      pHelp.left := 100;
      pHelp.width := 380;
      pHelp.height := 430;
      pHelp.visible := true;
    end;
  end;
end;

procedure TTrLineForm.CurveFormHeight;
{set the normal height of the form, etc, when damage curve parameters visible}
begin
  ParamPages.height := CurveOKBut.top+CurveOKBut.height+32;
  DamageCurveBut.top := ParamPages.height+2;
  TrLineForm.height := DamageCurveBut.top+DamageCurveBut.height+36{28};
end;


procedure TTrLineForm.ParamPagesChanging(Sender: TObject;
  var AllowChange: Boolean);
begin
  {adjust height according to the tab in use}
  if (ParamPages.ActivePage = ParamTab) then begin     {active page before the change!}
    CurveFormHeight;
    DamageCurveBut.visible := true;
  end else begin
    CurveHelpBut.down := false;
    DisplayPanels;
    DamageCurveBut.visible := false;
  end;
end;

procedure TTrLineForm.CurveGridSelectCell(Sender: TObject; Col,
  Row: Longint; var CanSelect: Boolean);
begin
  {show color dialogue}
  if (row = ColorRow) then begin
    ColorPanel.visible := true;
    ColorPanel.BringToFront;
  end else ColorPanel.visible := false;
  {cannot edit color, voltage, or in use-flag}
  if (row = ColorRow) or (row = VoltRow) or (row = InUseRow) then begin
    CurveGrid.options := CurveGrid.options-[goEditing,goAlwaysShowEditor];
  end else begin
    CurveGrid.options := CurveGrid.options+[goEditing,goAlwaysShowEditor];
  end;
end;

procedure TTrLineForm.CurveGridDrawCell(Sender: TObject; Col, Row: Longint;
  Rect: TRect; State: TGridDrawState);
var
  txt : string;  {temporary}
begin
  if (col = 1) then begin
    if (row = ColorRow) then begin
      {draw a square in the selected color}
      ColoredSquare(@CurveGrid, col,row, rect);   {in PQRelay}
    end else if (row = VoltRow) or (row = InUseRow) then begin
      {grey our cells that cannot be edited}
      CurveGrid.canvas.pen.color := clBtnFace;
      CurveGrid.canvas.brush.color := clBtnFace;
      CurveGrid.canvas.rectangle(rect.left,rect.top,rect.left+
                   CurveGrid.DefaultColWidth,rect.top+CurveGrid.DefaultRowHeight);
      {copy voltage and "in use"-flag}
      CurveGrid.canvas.font.name := 'arial';
      CurveGrid.canvas.font.size := 8;
      CurveGrid.canvas.font.style := [];
      if (row = VoltRow) then begin
        txt := CurveGrid.cells[1,VoltRow];
        CurveGrid.canvas.TextOut(4+rect.left,rect.top+2,txt);
      end else begin
        if (CurveGrid.cells[1,InUseRow] = '1') then begin
          txt := 'yes';
          CurveGrid.canvas.font.color := clRed;
        end else begin
          txt := 'no';
          CurveGrid.canvas.font.color := clBlack;
        end;
        CurveGrid.canvas.TextOut(4+rect.left,rect.top+2,txt);
      end;
      CurveGrid.canvas.font.color := clBlack;  {reset the color}
    end;
  end;
end;

procedure TTrLineForm.ColorImageMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
{get color index from X and Y}
var
  ii,jj,kk : integer;
begin
  ii := (X div (CRwidth+CRspace))+1;
  jj := (Y div (CRwidth+CRspace))+1;
  kk := (ii-1)*4+jj;                 {color index}
  CurveGrid.cells[1,ColorRow] := inttostr(kk);
  ColorPanel.visible := false;
end;

procedure TTrLineForm.UpdateGraph;
{show the damage curve of this tr.line in the graph}
var
  ll : longint;
begin
  {update graphics, if visible}
  if (RelayCurr.visible) then begin
    ll := RelayCharact.tag;        {pointer to the relay saved in tag}
    RelayShowIf(ll);               {update graphics, if visible, in Skemproc.pas}
  end;
end;

procedure TTrLineForm.CurveOKButClick(Sender: TObject);
{parameters to the component, hide param.form, update graph}
begin
  TrLineForm.visible := false;
  unmark(longint(pSet));           {must do also here, else does not unmark?}
  UpdateGraph;                     {show the damage curve, if...}
end;

procedure TTrLineForm.CurveApplyButClick(Sender: TObject);
begin
  CurveParametersToComp;
  UpdateGraph;
  cancel := false;
end;

procedure TTrLineForm.DamageCurveButClick(Sender: TObject);
{Display/not the damage curve of this tr.line. In any case, save this tr.line
 as the linw whose damage curve displayed}
var
  apu : single;
begin
  pComp^.GetPar(gTrLiS_InUse,apu);   {flag for displaying}
  if (apu = 0) then begin            {this not displayed}
    if (pSet^.pTr_Line <> nil) then  {unselect the previous tr.line, if any}
      pSet^.pTr_Line^.PutPar(gTrLiS_InUse,0);  {this line not in graph}
    pSet^.pTr_Line := pComp;         {damage curve of this tr.line shown}
    pComp^.PutPar(gTrLiS_InUse,1);   {this line in graph}
    CurveGrid.cells[1,InUseRow] := '1';
    DamageCurveBut.down := true;
  end else begin                     {already displayed, remove}
    pSet^.pTr_Line := nil;
    pComp^.PutPar(gTrLiS_InUse,0);   {this line not in graph}
    CurveGrid.cells[1,InUseRow] := '0';
    DamageCurveBut.down := false;
  end;
  {initialize the position of the label of the curve (in all cases)}
  pComp^.PutPar(gTrliS_nC,-1);
  pComp^.PutPar(gTrliS_nT,-1);
  UpdateGraph;
end;

procedure TTrLineForm.CurveCancelButClick(Sender: TObject);
{cancel changes = return old parameters to the component}
begin
  cancel := true;
  {parameters for the damage curve}
  pComp^.PutPar(gTrliS_Curr,CurvePar[1]);    {damage current}
  pComp^.PutPar(gTrliS_Time,CurvePar[2]);    {damage time}
  pComp^.PutPar(gTrliS_MinT,CurvePar[3]);    {minimum time for the curve}
  pComp^.PutPar(gTrliS_MaxT,CurvePar[4]);    {max.time for the curve}
  pComp^.PutStringPar(CurveName,0);          {restore the name of the curve}
//pComp^.PutPar(gTrliS_Name,CurvePar[5]);    {name = title of the curve}
  pComp^.PutPar(gTrliS_Color,CurvePar[6]);   {color index of the curve}
  pComp^.PutPar(gTrliS_Thick,CurvePar[7]);   {thickness of the curve}
  pComp^.PutPar(gTrliS_Volt,CurvePar[8]);    {voltage as parameter (calculated earlier?)}
  pComp^.PutPar(gTrliS_InUse,CurvePar[9]);   {flag for in use/or not}
  {return the old tr.line showing damage curve}
  pSet^.pTr_Line := pDmgLine;
  if (pDmgLine <> nil) then pDmgLine^.PutPar(gTrLiS_InUse,1);
  UpdateGraph;
  TrLineForm.visible := false;
  unmark(longint(pSet));           {must do also here, else does not unmark?}
end;

procedure TTrLineForm.CurveHelpButClick(Sender: TObject);
{show/hide the help memo}
begin
  if (CurveHelpBut.down) then begin  {button down, show the help}
    CurveMemo.top := CurveOKBut.top+CurveOKBut.height+8;
    ParamPages.height := CurveMemo.top+CurveMemo.height+32;
    DamageCurveBut.top := ParamPages.height+2;
    TrLineForm.height := DamageCurveBut.top+DamageCurveBut.height+36{28};
    CurveMemo.visible := true;
  end else begin                     {button up, set the normal height}
    CurveFormHeight;
  end;
end;

procedure TTrLineForm.FormShow(Sender: TObject);
{the delete-key should:
  - delete the component directly after clicking the comp.
  - delete a character (or parameter) in the table, when editing
 It seems that this is achieved by:
   - handle the delete-key in  FormKeyDown (as is done there)
   - set the ActiveControl of this form nil, when the form appears
     (does not always work in FormShow, See parametr.pas, or TComp.mouse_down in skemadef.pas)
   - keep the KeyPreview = false (but then key preview does not work, of course)
  in addition, the form must be hidden after deleting, either in formkeydown, or
  in DelPro of Skemadef.pas and Imagopas.pas  }
begin
  ActiveControl := nil; {focus to main form, for the case of delete-key pressed}
  {heights etc, depending which tab shown}
  if (ParamPages.ActivePage = ParamTab) then DisplayPanels
  else CurveFormHeight;
end;

procedure TTrLineForm.CancelUpdateButClick(Sender: TObject);
{cancel the change in base values}
begin
  baseMVA := baseMVA_bu;
  MVAEdit.text := baseMVA_txt;
  basekV := basekV_bu;
  kVEdit.text := basekV_txt;
  ZEdit.text := baseZ_txt;
  UpdatePanel.visible := false;
end;

procedure TTrLineForm.UpdatePanelMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
{move the panel with the mouse}
const
  x0  : integer = 0;    {old coordinates}
  y0  : integer = 0;
begin
  if (ssLeft in Shift) then begin        {left button pressed}
    UpdatePanel.left := UpdatePanel.left+X-x0;
    UpdatePanel.top  := UpdatePanel.top +Y-y0;
  end else begin
    x0 := X;
    y0 := Y;
  end;
end;

procedure TTrLineForm.AVOhmButClick(Sender: TObject);
{update impedances in Ohm and Ohm/km}
begin
  ImpedancesInGrids;     {the other impedances, in Ohm and Ohm/km}
  UpdatePanel.visible := false;
end;

procedure TTrLineForm.PerUnitButClick(Sender: TObject);
{update the pu-values}
var
  apu : single;    {temporary}
begin
  apu := baseMVA/(basekV*basekV);
  {to pu grid and arrays}
  OtherGrids(apu, @OhmPolarGrid,@PuRectGrid,@PuPolarGrid, OhmRectArr,OhmPolarArr,
             PuRectArr,PuPolarArr);
  UpdatePanel.visible := false;           
end;

procedure TTrLineForm.MVAEditEnter(Sender: TObject);
begin
  if (not UpdatePanel.visible) then begin
    baseMVA_bu := baseMVA;         {needed in case of cancel}
    baseMVA_txt := MVAEdit.text;
    basekV_bu := basekV;           {needed in case of cancel}
    basekV_txt := kVEdit.text;
    baseZ_txt := ZEdit.text;
  end;
end;

procedure TTrLineForm.kVEditEnter(Sender: TObject);
begin
  if (not UpdatePanel.visible) then begin
    baseMVA_bu := baseMVA;         {needed in case of cancel}
    baseMVA_txt := MVAEdit.text;
    basekV_bu := basekV;           {needed in case of cancel}
    basekV_txt := kVEdit.text;
    baseZ_txt := ZEdit.text;
  end;
end;

procedure TTrLineForm.ChangedLabelMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  UpdatePanelMouseMove(Sender,shift,X+ChangedLabel.left, Y+ChangedLabel.top);
end;

procedure TTrLineForm.UpdateLabelMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  UpdatePanelMouseMove(Sender,shift,X+UpdateLabel.left, Y+UpdateLabel.top);
end;

procedure TTrLineForm.k0;
{calculate the k0 = (Z0 - Z1)/3Z1 for the line}
var
  cpu     : complex;   {temporary}
  k0      : complex;   {the value of k0}
  k0a,k0m : single;  {angle, magnitude of k0}
  txt     : string;    {temporary}
  txx     : string;
  Z1,Z0   : complex;   {pos, zero seq. impedance}
begin
  Z0 := cplx(OhmRectArr[R0row],OhmRectArr[X0row]);
  Z1 := cplx(OhmRectArr[R1row],OhmRectArr[X1row]);
  cpu := Crmult(3,Z1);
  k0 := Cdiv(Csub(Z0,Z1),cpu);
  if (k0.y >= 0) then txx := ' +' else txx := ' ';
  txt := SixSignedChar(k0.x)+txx+SixSignedChar(k0.y)+' j';
  k0Label.caption := 'k0 = '+txt;
  {display also in polar form}
  k0m := Cabs(k0);
  k0a := Cangle(k0)*180/pi;
  txt := SixSignedChar(k0m)+' > '+TwoDecimalsAtMost(k0a)+'';
  k0PolLabel.caption := 'k0 = '+txt;
end;

procedure TTrLineForm.GetMainParamToGrid(R1,X1,R0,X0,Ss,len: single);
{get the main parameters from (somewhere) and put them to the grid
 called in SendTrLineData of Skemproc.pas
 R1,R0  resistance/km
 X1,X0  reactance/km
 len    length of the line}
var
  key : word;
  txt : string;
begin
  EngFormat5(R1,txt,true);               {in routines.pas}
  KmRectGrid.cells[1,R1row] := txt;
  EngFormat5(X1,txt,true);
  KmRectGrid.cells[1,X1row] := txt;
  EngFormat5(R0,txt,true);
  KmRectGrid.cells[1,R0row] := txt;
  EngFormat5(X0,txt,true);
  KmRectGrid.cells[1,X0row] := txt;
  EngFormat5(Ss,txt,true);
  KmRectGrid.cells[1,Ssrow] := txt;
  EngFormat5(len,txt,true);
  LengthEdit.text := txt;
  lin_len := len;
  {update values in other grids}
  key := 0;                       {needed as input, not used}
  kmr_row := R1row;
  KmRectGridKeyUp(nil,key,[]);
  kmr_row := R0row;
  KmRectGridKeyUp(nil,key,[]);
  kmr_row := Ssrow;
  KmRectGridKeyUp(nil,key,[]);
end;

end.
