unit k0calc;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, UAlnEdit, CompDef, Buttons, Menus, ComCtrls;

type          {for receiving line parameters from elplek}
  TSixString = packed record
  x: string[16];
  y: string[16];
  z: string[16];
  u: string[16];
  v: string[16];
  w: string[32];
end;

type
  TK0Form = class(TForm)
    ZL1img: TImage;
    ZL0img: TImage;
    FL1img: TImage;
    FL0img: TImage;
    RL1img: TImage;
    RL0img: TImage;
    XL0img: TImage;
    XL1img: TImage;
    ZL1Edit: TAlignEdit;
    FL1Edit: TAlignEdit;
    RL1Edit: TAlignEdit;
    XL1Edit: TAlignEdit;
    EnableTimer: TTimer;
    ZL0Edit: TAlignEdit;
    FL0Edit: TAlignEdit;
    RL0Edit: TAlignEdit;
    XL0Edit: TAlignEdit;
    ResZedit: TAlignEdit;
    ResFedit: TAlignEdit;
    ResRedit: TAlignEdit;
    ResXedit: TAlignEdit;
    ALabel: TLabel;
    BLabel: TLabel;
    LeftRed: TImage;
    LeftGreen: TImage;
    LeftBlue: TImage;
    ExchBut: TSpeedButton;
    SumMultConjBut: TSpeedButton;
    AddBut: TSpeedButton;
    SubBut: TSpeedButton;
    MultBut: TSpeedButton;
    DivBut: TSpeedButton;
    MultConjBut: TSpeedButton;
    k0But: TSpeedButton;
    ClearBut: TSpeedButton;
    CopyToABut: TSpeedButton;
    CopyToBBut: TSpeedButton;
    CopyToMemBut: TSpeedButton;
    MemToABut: TSpeedButton;
    CopyAtoBBut: TSpeedButton;
    UndoBut: TSpeedButton;
    SumBut: TSpeedButton;
    SignBut: TSpeedButton;
    BsignBut: TSpeedButton;
    AconjBut: TSpeedButton;
    BconjBut: TSpeedButton;
    ClearABut: TSpeedButton;
    ClearBBut: TSpeedButton;
    RSignBut: TSpeedButton;
    sqrtRBut: TSpeedButton;
    TopMenu: TMainMenu;
    TopMenu1: TMenuItem;
    ExitItem: TMenuItem;
    ViewItem: TMenuItem;
    SymbItem: TMenuItem;
    RadiusLabel: TLabel;
    AngleLabel: TLabel;
    RealLabel: TLabel;
    ImagLabel: TLabel;
    Marker: TImage;
    MemToBBut: TSpeedButton;
    LogMemo: TMemo;
    YxEdit: TAlignEdit;
    YrEdit: TAlignEdit;
    YfEdit: TAlignEdit;
    YzEdit: TAlignEdit;
    YtoABut: TSpeedButton;
    YtoBBut: TSpeedButton;
    Rlabel: TLabel;
    Ylabel: TLabel;
    DblArrow: TImage;
    LogItem: TMenuItem;
    AmultEdit: TAlignEdit;
    AmultBut: TSpeedButton;
    AmultLabel: TLabel;
    BmultEdit: TAlignEdit;
    BmultBut: TSpeedButton;
    BmultLabel: TLabel;
    HelpItem: TMenuItem;
    CopyAtoRBut: TSpeedButton;
    CopyBtoYBut: TSpeedButton;
    LabelEdit: TEdit;
    TrLineBut: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure ZL1EditKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FL1EditKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure RL1EditKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure XL1EditKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ZL1EditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure EnableTimerTimer(Sender: TObject);
    procedure FL1EditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ZL0EditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FL0EditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure RL1EditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure XL1EditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure RL0EditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure XL0EditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ZL0EditKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FL0EditKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure RL0EditKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure XL0EditKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ExchButClick(Sender: TObject);
    procedure SumMultConjButClick(Sender: TObject);
    procedure AddButClick(Sender: TObject);
    procedure SubButClick(Sender: TObject);
    procedure MultButClick(Sender: TObject);
    procedure DivButClick(Sender: TObject);
    procedure MultConjButClick(Sender: TObject);
    procedure k0ButClick(Sender: TObject);
    procedure ClearButClick(Sender: TObject);
    procedure CopyToAButClick(Sender: TObject);
    procedure CopyToBButClick(Sender: TObject);
    procedure CopyToMemButClick(Sender: TObject);
    procedure MemToAButClick(Sender: TObject);
    procedure CopyAtoBButClick(Sender: TObject);
    procedure UndoButClick(Sender: TObject);
    procedure SumButClick(Sender: TObject);
    procedure SignButClick(Sender: TObject);
    procedure BsignButClick(Sender: TObject);
    procedure RsignButClick(Sender: TObject);
    procedure AconjButClick(Sender: TObject);
    procedure BconjButClick(Sender: TObject);
    procedure ClearAButClick(Sender: TObject);
    procedure ClearBButClick(Sender: TObject);
    procedure sqrtRButClick(Sender: TObject);
    procedure TopMenu1Click(Sender: TObject);
    procedure ExitItemClick(Sender: TObject);
    procedure SymbItemClick(Sender: TObject);
    procedure MemToBButClick(Sender: TObject);
    procedure XL1EditEnter(Sender: TObject);
    procedure RL1EditEnter(Sender: TObject);
    procedure XL0EditEnter(Sender: TObject);
    procedure RL0EditEnter(Sender: TObject);
    procedure FL1EditEnter(Sender: TObject);
    procedure ZL1EditEnter(Sender: TObject);
    procedure FL0EditEnter(Sender: TObject);
    procedure ZL0EditEnter(Sender: TObject);
    procedure ZL1EditExit(Sender: TObject);
    procedure FL1EditExit(Sender: TObject);
    procedure RL1EditExit(Sender: TObject);
    procedure XL1EditExit(Sender: TObject);
    procedure ZL0EditExit(Sender: TObject);
    procedure FL0EditExit(Sender: TObject);
    procedure RL0EditExit(Sender: TObject);
    procedure XL0EditExit(Sender: TObject);
    procedure YtoAButClick(Sender: TObject);
    procedure YtoBButClick(Sender: TObject);
    procedure LogItemClick(Sender: TObject);
    procedure AmultButClick(Sender: TObject);
    procedure AmultEditEnter(Sender: TObject);
    procedure AmultEditKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure AmultEditExit(Sender: TObject);
    procedure BmultEditEnter(Sender: TObject);
    procedure BmultEditExit(Sender: TObject);
    procedure BmultEditKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure BmultButClick(Sender: TObject);
    procedure AmultEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure BmultEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure HelpItemClick(Sender: TObject);
    procedure CopyAtoRButClick(Sender: TObject);
    procedure CopyBtoYButClick(Sender: TObject);
    procedure TrLineButClick(Sender: TObject);

  private
    { Private declarations }
    Caption_orig : string;           {the original caption}
    procedure WMCopyData(var Msg: TWMCopyData);  message WM_COPYDATA;
    procedure HandleCopyDataRecord(copyDataStruct: PCopyDataStruct);

  public
    { Public declarations }
  end;

const
  pii = 3.141592654;
  MemZ     : string = '0';  {memory}
  MemF     : string = '0';
  MemR     : string = '0';
  MemX     : string = '0';
  LastZL1  : string = '0';  {for backup}
  LastFL1  : string = '0';
  LastRL1  : string = '0';
  LastXL1  : string = '0';
  LastZL0  : string = '0';  {for backup}
  LastFL0  : string = '0';
  LastRL0  : string = '0';
  LastXL0  : string = '0';
  LastZRes : string = '0';  {for backup}
  LastFRes : string = '0';
  LastRRes : string = '0';
  LastXRes : string = '0';
  LastZMem : string = '0';  {for backup}
  LastFMem : string = '0';
  LastRMem : string = '0';
  LastXMem : string = '0';
  LastYz   : string = '0';
  LastYf   : string = '0';
  LastYr   : string = '0';
  LastYx   : string = '0';
  AChanged : boolean = false;
  Bchanged : boolean = false;
  zero     : word = 48;
  LightYellow = $00D0FFFF;     {color for results}
var
  K0Form: TK0Form;
  dec_p     : Char;     {decimal point - character}
  fromLeft  : boolean;  {coming to an edit from left, using the right arrow key}
  fromRight : boolean;
  fromAbove : boolean;
  fromBelow : boolean;
  Contr  : TSpeedButton;
  Contr0 : TSpeedButton;
implementation

uses Helppas;

{$R *.DFM}

procedure FlagDecimalPoint(text: string; var dpflag : integer);  {in routines.pas !!}
{set the flag, if the decimal point is in the text}
var
  len : integer;
  ii  : integer;
begin
  len := length(text);            {length of text}
  dpflag := 0;                    {initialize flag for decimal point}
  if (len > 0) then begin
    for ii := 1 to len do begin
      if (text[ii] = '.') or
         (text[ii] = ',') then begin
          dpflag := 1;            {flag the decimal point}
          break;
      end;
    end;
  end;
end;

procedure DecimalPoint(var decp: Char);    {in unit routines.pas !!}
{determines the character for decimal point, is it a full stop (.),
 or a comma (,), and copies it to dec_p}
var
  apu   : Single;    {temporary}
  i     : Integer;   {counter, or index}
  iapu  : Integer;   {length of line, temporary}
  line  : String;    {apu as string, temporary}
  tx    : Char;      {one character, temporary}
begin
  {determine, is  comma (,) or period (.) used as decimal point}
  apu := 0.5;                   {need a value with decimal point}
  line := floattostr(apu);      {change it to string}
  iapu := length(line);         {length of the string (should be 3 !)}
  tx := ',';                    {default decimal point}
  for i:=1 to iapu do begin
    if (line[i] = '.') or (line[i] = ',') then begin
      tx := line[i];            {pick . or ,}
      break;
    end;
  end;
  decp := tx;                   {copy the decimal point to output}
end;

function ManyChars(rr : single) : string;
{write a positive or negative real using several places, fill with leading spaces (?)
 rr    the real
 text  the outputted text}
const
  small = 1e-8;
var
  aa       : single;     {abs value of rr}
  first    : boolean;
  ii,jj,kk : integer;
  len      : integer;    {length of line}
  line     : string;     {text under construction}
  ss       : string;     {space or minus sign}
  started  : boolean;    {nonzero number found}
  text     : string;
begin
  aa := abs(rr);
  if (aa < small) then begin
    text := ' 0.0      ';
{   k0Form.edit1.text := floattostr(aa);}
  end else if (aa < 0.0001) then
    text := format('%9.7g',[aa])
  else if (aa < 1.0) then begin
    line := format('%10.8f',[aa]);
    {remove trailing zeroes}
    len := length(line);
    if (len > 1) then begin
      text := '';
      for ii := 1 to len do begin
        text := text+' ';          {lengt same as line, but only spaces}
      end;
      started := false;            {not yet found a nonzero number}
      kk := len;                   {last char. in text}
      for ii := 1 to len do begin
        jj := len-ii+1;
        if (line[jj] = '0') and (not started) then begin
          {zeroes not copied}
        end else begin
          text[kk] := line[jj];
          dec(kk);
          started := true;         {a nonzero number found}
        end;
      end;
    end else begin
      text := line;
    end;
  end else if (aa < 1.e5) then begin
    if (aa = round(aa)) then text := format('%7.6g',[aa])+'.0'  {integer}
    else text := format('%9.8g',[aa]);
  end else if (aa < 1.e20) then
    text := format('%9.8g',[aa])
  else
    text := '1.0e20    ';
  len := length(text);
  line := '';
  if (len > 0) then begin
    {add the minus sign for a negative number}
    if (aa >= small) then begin    {no minus sign to zero}
      if (rr < 0) then ss := '-'
      else             ss := ' ';
      first := true;
      for ii := 1 to len do begin
        if (text[ii] <> ' ') and first then begin
          line := line+ss;
          first := false;
        end;
        line := line+text[ii];
      end;
    end else begin
      line := text;      {zero...}
    end;
  end;
  ManyChars := line;
end;

procedure chkfloat(line: String; var ercod: Integer);    {in routines.pas !!}
{checks, whether the line corresponds to a valid floating point
 (or integer) number
 line    the string that should be a number (in)
 ercod   error code,  = 0, if correct number}
var
  dp   : Char;      {decimal point: (,) or (.)}
  epart: string;    {exponential part}
  i    : integer;   {index, or counter}
  nch  : integer;   {number of characters in the string to be studied}
  ph   : integer;   {phases, depending what has been found
                     0 = start
                     1 = only numbers found
                     2 = + or -  found
                     3 = , (or .) found
                     4 = , (r .) and numbers found
                     5 = e or E found
                     6 = + or - after e or E found
                     7 = one number found after e or E or e+,e-,E+E-
                     8 = two numbers found after e ...}
  tx   : char;      { a single character}
  begin
    DecimalPoint(dp);             {get the decimal point character}
    ph := 0;                      {initialize phase}
    ercod := 0;                   {initialize error code}
    epart := '';                  {initialize exponential part}
    nch := length(line);          {number of characters}
    for i:=1 to nch do begin      {scan the whole line}
      tx := line[i];              {copy to local}
      if (ph = 0) then begin      {just starting}
      {first character must be only + - , e E  a number  space}
        if      (tx = ' ')                 then ph := 0
        else if (tx >='0') and (tx <= '9') then ph := 1
        else if (tx ='+') or (tx = '-')    then ph := 2
        else if (tx = dp)                  then ph := 3
        else if (tx = 'e') or (tx = 'E')   then ph := 5
        else begin
          ercod := 1;             {set error code}
          break;                  {errror found, stop}
        end;
      end else if (ph = 1) then begin
      {after a number only  another number  ,  e E allowed}
        if      (tx>='0') and (tx <= '9')  then ph := 1
        else if (tx = dp)                  then ph := 3
        else if (tx = 'e') or (tx = 'E')   then ph := 5
        else  begin
          ercod := 2;
          break;
        end;
      end else if (ph = 2) then begin
      {after + or - only  a number   ,  e E allowed}
        if (tx >='0') and (tx <= '9')      then ph := 1
        else if (tx = dp)                  then ph := 3
        else if (tx = 'e') or (tx = 'E')   then ph := 5
        else begin
          ercod := 3;
          break;
        end;
      end else if (ph = 3) then begin
      {after a comma only a number allowed or e or E}
        if (tx >= '0') and (tx <='9')      then ph := 4
        else if (tx = 'e') or (tx = 'E')   then ph := 5
        else begin
          ercod := 5;
          break;
        end;
       end else if (ph = 4) then begin
       {after a comma and numbers only  nunbers  e   E allowed}
         if (tx >= '0') and (tx <='9')     then ph := 4
         else if (tx = 'e') or (tx = 'E')  then ph := 5
         else begin
           ercod := 5;
           break;
         end;
       end else if (ph = 5) then begin
       {after e or E only + -  numbers allowed}
         if (tx ='+') or (tx = '-')         then ph := 6
         else if (tx >='0') and (tx <= '9') then begin
           epart := tx;
           ph := 7;
         end else begin
           ercod := 6;
           break;
         end;
       end else if (ph = 6) then begin
       {after e+ etc only numbers allowed}
         if (tx >='0') and (tx <= '9')      then begin
           epart := tx;                     {save exp.part}
           ph := 7
         end else begin
           ercod := 7;
           break;
         end;
       end else if (ph = 7) then begin
       {after  e+ only two numbers allowed}
         if (tx >='0') and (tx <= '9')      then begin
           epart := epart+tx;               {complete exponential part}
           if (epart < '37') then           ph := 8
           else begin
             ercod := 11;
             break;
           end;
         end else begin
           ercod := 8;
           break;
         end;
       end else if (ph = 8) then begin
       {after e+$$ only spaces allowed}
         if (tx = ' ')                      then ph := 8
         else begin
           ercod := 9;
           break;
         end;
       end else begin
       {there should not be any other phases}
         ercod := 10;
         break;
      end;
    end;
  end;

procedure ValuesFromLine(line: String; nstrt :Integer; var ipar: Integer;  {in routines.pas}
                         var pa1,pa2,pa3,pa4 : Single;
                         var errc :Integer);
{extracts (numeric) values of parameters from a text line of numbers
          values (words) separated by space(s)
          at most 4 parameters
 line     the text line with the numbers (in)
 nstrt    start copying of parameters from parameter nstrt (at most 4 par.)
 ipar     number of parameters found in the line (out)
 pa1,pa2,pa3,pa4    the numeric values (out)
 errc     error code (defined in chckfloat), = 0, if no errors}
var
  apu   : Single;   {temporary}
  dec_p : Char;     {decimal point}
  err   : integer;  {error flag}
  j     : Integer;  {index, or counter}
  ll    : Integer;  {length of line}
  numb  : boolean;
  tx    : char;     {one character}
  word  : String;   {one word in the line}
  wfnd  : boolean;  {word found}
begin
  {first determine the character used as decimal point}
  DecimalPoint(dec_p);
  {extract the parameter values from the line, separated by spaces etc}
  ll := length(line);             {length of the line}
  {check that there are numbers}
  numb := false;
  if (ll > 0) then begin
    for j := 1 to ll do begin
      if (line[j] >= '0') and (line[j] <= '9') then begin
        numb := true;
        break;
      end;
    end;
  end;
  ipar := 0;                      {initialize parameter count}
  wfnd := false;                  {initialize flag for finding a word}
  word := '';                     {clear the word}
  errc := 0;                      {initialize error flag}
  if (ll > 0) and (numb) then begin {there are numbers on the line}
    for j:=1 to ll do begin         {purpose is to read to end of line}
      tx := line[j];                {copy one character, study it}
      if (tx=' ') or (j=ll) then begin  {a space or end of line => end of word}
        if (j=ll) then begin        {last char. treated separately}
          if (tx <> ' ') then begin {last char. not a space}
            word := word+tx;        {append last character}
            wfnd := true;           {a non-space char. found (number?)}
          end;
        end;
        if (wfnd) then begin        {was constructing a word}
          ipar := ipar+1;           {increment parameter counter}
          wfnd := false;            {for next time}
          chkfloat(word,err);       {check is the word a number}
          errc := errc+err;         {"total" error}
          if (err <> 0) then begin  {not a number}
{            show_message('parameter '+inttostr(ipar)+' is not a number,'
                        +  ' error code '+inttostr(errc)+'   '+word);}
            word := '';
          end else begin            {is a number}
            if (word[1] = 'e') or (word[1] = 'E') then
                 apu := strtofloat('1'+word) {'e' actually not allowed as first}
            else apu := strtofloat(    word);{change to number}
            if      (ipar = nstrt)   then pa1 := apu   {copy to component}
            else if (ipar = nstrt+1) then pa2 := apu
            else if (ipar = nstrt+2) then pa3 := apu
            else if (ipar = nstrt+3) then pa4 := apu;  {at most 4 params.}
            word := '';             {reinitialize the word}
          end;
        end else begin              {not a word, spaces in a row}
          wfnd := false;
          {apu := 0;}
        end;
      end else begin                {not a space, assumed is part of a number}
        wfnd := true;               {found or constructing a word}
        {accept both . and , as decimal point, eventually must change in order
         to correspond to system default}
         if      (dec_p = ',') and (tx = '.') then tx := ','
         else if (dec_p = '.') and (tx = ',') then tx := '.';
         word := word+tx             {append this char. to word}
      end;
    end;
  end else begin                     {no text on line}
    pa1 := 0.0;
    pa2 := 0.0;
    pa3 := 0.0;
    pa4 := 0.0;
    ipar := 0;
    errc := 10;
  end;
end;

function spaceless(text : string): string;
{remove spaces from text}
var
  ii    : integer;
  len   : integer;
  txout : string;
begin
  len := length(text);
  txout := '';
  if (len > 0)  then begin
    for ii := 1 to len do begin
      if (text[ii] <> ' ') then txout := txout+text[ii];
    end;
  end;
  spaceless := txout;
end;

procedure PolarToRec(textZ,textF : string; var textR, textX : string);
{change complex number from polar form to rectangular
 textZ  abs.value of the number to be changed, as text
 textF  angle in degrees, as text
 textR  real part, as text
 textX  imag.part, as text}
var
  apu,apv,apw : single;  {temporary}
  err1,err2   : integer; {error flags}
  deg,fii     : single;  {angle in degrees, in rad}
  ii,jj       : integer; {indices}
  ipu         : integer; {temporary}
  len         : integer; {length of text}
  Rr          : single;  {real part}
  text        : string;  {temporary}
  Xx          : single;  {imag.part}
  Zz          : single;  {abs.value of the complex}
begin
  ValuesFromLine(textZ, 1, ipu, Zz , apu, apv, apw, err1);
  ValuesFromLine(textF, 1, ipu, deg, apu, apv, apw, err2);
  if (err1 = 0) and (err2 = 0) then begin
{   if (Zz >= 0) then begin}
      fii := deg*pii/180;       {change to radians}
      Rr := Zz*cos(fii);
      Xx := Zz*sin(fii);
      text := ManyChars(Rr);      {numerical value to string}
      TextR := spaceless(text); {remove spaces}
      text := ManyChars(Xx);
      TextX := spaceless(text); {remove spaces}
{   end;}
  end else begin
    TextR := '?';
    TextX := '?';
  end;
end;

procedure RecToPolar(textR, textX : string; var textZ,textF : string);
{change complex number from rectangular to polar form
 textZ  abs.value of the number to be changed, as text
 textF  angle in degrees, as text
 textR  real part, as text
 textX  imag.part, as text}
var
  apu,apv,apw : single;  {temporary}
  err1,err2   : integer; {error flags}
  ipu         : integer; {temporary}
  deg,fii     : single;  {angle in degrees, in rad}
  Rr          : single;  {real part}
  text        : string;  {temporary}
  Xx          : single;  {imag.part}
  Zz          : single;  {abs.value of the complex}
begin
  ValuesFromLine(textR, 1, ipu, Rr , apu, apv, apw, err1);
  ValuesFromLine(textX, 1, ipu, Xx , apu, apv, apw, err2);
  if (err1 = 0) and (err2 = 0) then begin
    Zz := sqrt(Rr*Rr+Xx*Xx);
    fii := Cangle(cplx(Rr,Xx));   {angle in radians}
    deg := fii*180/pii;
    text := ManyChars(Zz);        {numerical value to string}
    TextZ := spaceless(text);     {remove spaces}
    text := ManyChars(deg);
    TextF := spaceless(text);     {remove spaces}
  end else begin
    TextZ := '?';
    TextF := '?';
  end;
end;

procedure TK0Form.FormCreate(Sender: TObject);
begin
  DecimalPoint(dec_p);    {determine character for decimal point (. or ,)}
  fromLeft := false;
  fromRight := false;
  fromAbove := false;
  fromBelow := false;
  {draw image for marker}
  Marker.canvas.pen.color := clYellow;
  Marker.canvas.brush.color := clYellow;
  Marker.canvas.brush.style := bsSolid;
  Marker.canvas.rectangle(0,0,Marker.width,Marker.height);
  {a light color for the results}
  ResZedit.color := LightYellow;
  ResFedit.color := LightYellow;
  ResRedit.color := LightYellow;
  ResXedit.color := LightYellow;
  YzEdit.color := LightYellow;
  YfEdit.color := LightYellow;
  YrEdit.color := LightYellow;
  YxEdit.color := LightYellow;
  {initially, do not show the log. Set width accordingly}
  width := LogMemo.left+8;
  Contr0 := nil;
  Caption_orig := caption;    {save the original caption, needed for receiving tr.line data}
end;

procedure TK0Form.FormKeyPress(Sender: TObject; var Key: Char);
{check that only numerals and comma or full stop are accepted at the Edit}
begin
  {only numbers and . or , accepted}
  if not(((key >= '0') and (key <= '9')) or
          (key  = ',') or  (key  = '.')  or
          (key  = 'e') or  (key  = 'E')  or
          (key  = '-') or  (key  = '+')  or
          (key  = #8 ) or
          (key =  #3 ) or (key = #22)) then       {"copy" and "paste"}
           key := #0;                             {neglect other keys }
  {check correct char for decimal point}
  if      (dec_p = ',') and (key = '.') then key := ','
  else if (dec_p = '.') and (key = ',') then key := '.';
  {allow only one decimal point}
  if  ((ZL1Edit.tagB   <> 0) and (activeControl = ZL1Edit)) or
      ((FL1Edit.tagB   <> 0) and (activeControl = FL1Edit)) or
      ((RL1Edit.tagB   <> 0) and (activeControl = RL1Edit)) or
      ((XL1Edit.tagB   <> 0) and (activeControl = XL1Edit)) or
      ((ZL0Edit.tagB   <> 0) and (activeControl = ZL0Edit)) or
      ((FL0Edit.tagB   <> 0) and (activeControl = FL0Edit)) or
      ((RL0Edit.tagB   <> 0) and (activeControl = RL0Edit)) or
      ((XL0Edit.tagB   <> 0) and (activeControl = XL0Edit)) or
      ((AmultEdit.tagB <> 0) and (activeControl = AmultEdit)) or
      ((BmultEdit.tagB <> 0) and (activeControl = BmultEdit)) then begin
    if (key = dec_p) then key := #0;
  end;

end;

procedure TK0Form.ZL1EditKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  ipu       : integer;
  text      : string;
  Rtxt,Xtxt : string; {real, imag.parts as text}
begin
  ipu := 0;
  {first, set flag, if there is a decimal point}
  text := ZL1Edit.text;
  FlagDecimalPoint(text,ipu);
  ZL1Edit.tagB := ipu;
  PolarToRec(ZL1Edit.text, FL1Edit.text,Rtxt,Xtxt); {polar to rectangle}
  if (Rtxt <> '?') and (Xtxt <> '?') then begin   {no errors}
    RL1Edit.text := Rtxt;
    XL1Edit.text := Xtxt;
    FlagDecimalPoint(Rtxt,ipu);
    RL1Edit.tagB := ipu;
    FlagDecimalPoint(Xtxt,ipu);
    XL1Edit.tagB := ipu;
    ZL1Edit.color := clWhite;
    FL1Edit.color := clWhite;
    RL1Edit.color := clWhite;
    XL1Edit.color := clWhite;
  end else begin
    ZL1Edit.color := clYellow;
  end;
  Achanged := true;
end;

procedure TK0Form.FL1EditKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  ipu       : integer;
  text      : string;
  Rtxt,Xtxt : string; {real, imag.parts as text}
begin
  ipu := 0;
  {first, set flag, if there is a decimal point}
  text := FL1Edit.text;
  FlagDecimalPoint(text,ipu);
  FL1Edit.tagB := ipu;
  PolarToRec(ZL1Edit.text, FL1Edit.text,Rtxt,Xtxt); {polar to rectangle}
  if (Rtxt <> '?') and (Xtxt <> '?') then begin   {no errors}
    RL1Edit.text := Rtxt;
    XL1Edit.text := Xtxt;
    FlagDecimalPoint(Rtxt,ipu);
    RL1Edit.tagB := ipu;
    FlagDecimalPoint(Xtxt,ipu);
    XL1Edit.tagB := ipu;
    FL1Edit.color := clWhite;
    ZL1Edit.color := clWhite;
    RL1Edit.color := clWhite;
    XL1Edit.color := clWhite;
  end else begin
    FL1Edit.color := clYellow;
  end;
  Achanged := true;
end;

procedure TK0Form.RL1EditKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  ipu       : integer;
  text      : string;
  Ztxt,Ftxt : string;  {abs.,value, angle as text}
begin
  ipu := 0;
  {first, set flag, if there is a decimal point}
  text := RL1Edit.text;
  FlagDecimalPoint(text,ipu);
  RL1Edit.tagB := ipu;
  RecToPolar(RL1Edit.text, XL1Edit.text, Ztxt,Ftxt);   {rectangle to polar}
  if (Ztxt <> '?') and (Ftxt <> '?') then begin
    ZL1Edit.text := Ztxt;
    FlagDecimalPoint(Ztxt,ipu);
    ZL1Edit.tagB := ipu;
    FL1Edit.text := Ftxt;
    FlagDecimalPoint(Ftxt,ipu);
    FL1Edit.tagB := ipu;
    Achanged := true;
    FL1Edit.color := clWhite;
    ZL1Edit.color := clWhite;
    RL1Edit.color := clWhite;
    XL1Edit.color := clWhite;
  end else begin
    RL1Edit.color := clYellow;
  end;
end;

procedure TK0Form.XL1EditKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  ipu       : integer;
  text      : string;
  Ztxt,Ftxt : string; {abs.value, angle}
begin
  ipu := 0;
  {first, set flag, if there is a decimal point}
  text := XL1Edit.text;
  FlagDecimalPoint(text,ipu);
  XL1Edit.tagB := ipu;
  RecToPolar(RL1Edit.text, XL1Edit.text, Ztxt,Ftxt);   {rectangle to polar}
  if (Ztxt <> '?') and (Ftxt <> '?') then begin
    ZL1Edit.text := Ztxt;
    FlagDecimalPoint(Ztxt,ipu);
    ZL1Edit.tagB := ipu;
    FL1Edit.text := Ftxt;
    FlagDecimalPoint(Ftxt,ipu);
    FL1Edit.tagB := ipu;
    Achanged := true;
    FL1Edit.color := clWhite;
    ZL1Edit.color := clWhite;
    RL1Edit.color := clWhite;
    XL1Edit.color := clWhite;
  end else begin
    XL1Edit.color := clYellow;
  end;
end;

procedure AboveBelow(ThisEdit, AboveEdit, BelowEdit : TAlignEdit; key : word);
{set focus to the Edit above or below this edit, depending on the key}
begin
  if (key = 38) then  begin          {up arrow}
    if (AboveEdit <> nil) then begin
      k0Form.EnableTimer.Enabled := true;
      ThisEdit.enabled := false;       {necessary, to allow the activation}
      AboveEdit.SetFocus;
    end;
  end else if (key = 40) then begin  {down arrow}
    if (BelowEdit <> nil) then begin
      k0Form.EnableTimer.Enabled := true;
      ThisEdit.enabled := false;       {necessary, to allow the activation}
      BelowEdit.SetFocus;
    end;
  end;
end;

procedure ToAbove(ThisEdit, AboveEdit : TAlignEdit);
{set focus to the Edit above this edit}
begin
  if (AboveEdit <> nil) then begin
    k0Form.EnableTimer.Enabled := true;
    ThisEdit.enabled := false;       {necessary, to allow the activation}
    AboveEdit.SetFocus;
    fromBelow := true;
  end;
end;

procedure ToBelow(ThisEdit, BelowEdit : TAlignEdit);
{set focus to the Edit below this edit}
begin
  if (BelowEdit <> nil) then begin
    k0Form.EnableTimer.Enabled := true;
    ThisEdit.enabled := false;       {necessary, to allow the activation}
    BelowEdit.SetFocus;
    fromAbove := true;
  end;
end;

procedure ToRight(ThisEdit, RightEdit : TAlignEdit);
{set focus to the Edit on the right of This edit}
var
  len : integer;   {length of text}
begin
  len := length(ThisEdit.text);
  if (ThisEdit.SelStart = len) then begin  {cursor right to text}
    k0Form.EnableTimer.Enabled := true;
    ThisEdit.enabled := false;       {necessary, to allow the activation}
    RightEdit.SetFocus;
    fromLeft := true;
  end;
end;

procedure ToLeft(ThisEdit, LeftEdit : TAlignEdit);
{set focus to the Edit on the right of This edit}
begin
  if (ThisEdit.SelStart = 0) then begin
    k0Form.EnableTimer.Enabled := true;   {cursor left to text}
    ThisEdit.enabled := false;       {necessary, to allow the activation}
    LeftEdit.SetFocus;
    fromRight := true;
  end;
end;

procedure TK0Form.EnableTimerTimer(Sender: TObject);
{set the edits enabled after moving around with the arrow keys
 actually, only one is not enabled, the one from which moving away}
var
  len : integer;  {length of text}
begin
  ZL1Edit.enabled := true;
  FL1Edit.enabled := true;
  RL1Edit.enabled := true;
  XL1Edit.enabled := true;
  ZL0Edit.enabled := true;
  FL0Edit.enabled := true;
  RL0Edit.enabled := true;
  XL0Edit.enabled := true;
  AmultEdit.enabled := true;
  BmultEdit.enabled := true;
  len := length((ActiveControl as TAlignEdit).text);
  {position of cursor depends on direction from which coming}
  if (fromLeft {or fromAbove or fromBelow}) then
    (ActiveControl as TAlignEdit).SelStart := 0
  else (ActiveControl as TAlignEdit).SelStart := len;
  EnableTimer.enabled := false;
  fromLeft := false;       {reset the direction flags}
  fromRight := false;
  fromAbove := false;
  fromBelow := false;
end;

procedure TK0Form.ZL1EditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if      (key = 40) then ToBelow(ZL1Edit, ZL0Edit)
  else if (key = 39) then ToRight(ZL1Edit, FL1Edit);
end;

procedure TK0Form.FL1EditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if      (key = 40) then ToBelow(FL1Edit,FL0Edit)
  else if (key = 39) then ToRight(FL1Edit,RL1Edit)
  else if (key = 37) then ToLeft (FL1Edit,ZL1Edit);
end;

procedure TK0Form.ZL0EditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if      (key = 38) then ToAbove(ZL0Edit,ZL1Edit)
  else if (key = 39) then ToRight(ZL0Edit,FL0Edit);
end;

procedure TK0Form.FL0EditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if      (key = 38) then ToAbove(FL0Edit,FL1Edit)
  else if (key = 39) then ToRight(FL0Edit,RL0Edit)
  else if (key = 37) then ToLeft (FL0Edit,ZL0Edit);
end;

procedure TK0Form.RL1EditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if      (key = 40) then ToBelow(RL1Edit,RL0Edit)
  else if (key = 39) then ToRight(RL1Edit,XL1Edit)
  else if (key = 37) then ToLeft (RL1Edit,FL1Edit);
end;

procedure TK0Form.XL1EditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if      (key = 40) then ToBelow(XL1Edit,XL0Edit)
  else if (key = 37) then ToLeft (XL1Edit,RL1Edit)
  else if (key = 39) then ToRight(XL1Edit,AmultEdit);
end;

procedure TK0Form.RL0EditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if      (key = 38) then ToAbove(RL0Edit,RL1Edit)
  else if (key = 39) then ToRight(RL0Edit,XL0Edit)
  else if (key = 37) then ToLeft (RL0Edit,FL0Edit);
end;

procedure TK0Form.XL0EditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if      (key = 38) then ToAbove(XL0Edit,XL1Edit)
  else if (key = 39) then ToRight(XL0Edit,BmultEdit)
  else if (key = 37) then ToLeft (XL0Edit,RL0Edit);
end;

procedure TK0Form.ZL0EditKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  ipu       : integer;
  text      : string;
  Rtxt,Xtxt : string; {real, imag.parts as text}
begin
  ipu := 0;
  {first, set flag, if there is a decimal point}
  text := ZL0Edit.text;
  FlagDecimalPoint(text,ipu);
  ZL0Edit.tagB := ipu;
  PolarToRec(ZL0Edit.text, FL0Edit.text,Rtxt,Xtxt); {polar to rectangle}
  if (Rtxt <> '?') and (Xtxt <> '?') then begin   {no errors}
    RL0Edit.text := Rtxt;
    XL0Edit.text := Xtxt;
    FlagDecimalPoint(Rtxt,ipu);
    RL0Edit.tagB := ipu;
    FlagDecimalPoint(Xtxt,ipu);
    XL0Edit.tagB := ipu;
    ZL0Edit.color := clWhite;
    FL0Edit.color := clWhite;
    RL0Edit.color := clWhite;
    XL0Edit.color := clWhite;
  end else begin
    ZL0Edit.color := clYellow;
  end;
  Bchanged := true;
end;

procedure TK0Form.FL0EditKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  ipu       : integer;
  text      : string;
  Rtxt,Xtxt : string; {real, imag.parts as text}
begin
  ipu := 0;
  {first, set flag, if there is a decimal point}
  text := FL0Edit.text;
  FlagDecimalPoint(text,ipu);
  FL0Edit.tagB := ipu;
  PolarToRec(ZL0Edit.text, FL0Edit.text,Rtxt,Xtxt); {polar to rectangle}
  if (Rtxt <> '?') and (Xtxt <> '?') then begin   {no errors}
    RL0Edit.text := Rtxt;
    XL0Edit.text := Xtxt;
    FlagDecimalPoint(Rtxt,ipu);
    RL0Edit.tagB := ipu;
    FlagDecimalPoint(Xtxt,ipu);
    XL0Edit.tagB := ipu;
    FL0Edit.color := clWhite;
    ZL0Edit.color := clWhite;
    RL0Edit.color := clWhite;
    XL0Edit.color := clWhite;
  end else begin
    FL0Edit.color := clYellow;
  end;
  Bchanged := true;
end;

procedure TK0Form.RL0EditKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  ipu       : integer;
  text      : string;
  Ztxt,Ftxt : string;  {abs.,value, angle as text}
begin
  ipu := 0;
  {first, set flag, if there is a decimal point}
  text := RL0Edit.text;
  FlagDecimalPoint(text,ipu);
  RL0Edit.tagB := ipu;
  RecToPolar(RL0Edit.text, XL0Edit.text, Ztxt,Ftxt);   {rectangle to polar}
  if (Ztxt <> '?') and (Ftxt <> '?') then begin   {no errors}
    ZL0Edit.text := Ztxt;
    FL0Edit.text := Ftxt;
    FlagDecimalPoint(Ztxt,ipu);
    ZL0Edit.tagB := ipu;
    FlagDecimalPoint(Ftxt,ipu);
    FL0Edit.tagB := ipu;
    Bchanged := true;
    FL0Edit.color := clWhite;
    ZL0Edit.color := clWhite;
    RL0Edit.color := clWhite;
    XL0Edit.color := clWhite;
  end else begin
    RL0Edit.color := clYellow;
  end;
end;

procedure TK0Form.XL0EditKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  ipu       : integer;
  text      : string;
  Ztxt,Ftxt : string; {abs.value, angle}
begin
  ipu := 0;
  {first, set flag, if there is a decimal point}
  text := XL0Edit.text;
  FlagDecimalPoint(text,ipu);
  XL0Edit.tagB := ipu;
  RecToPolar(RL0Edit.text, XL0Edit.text, Ztxt,Ftxt);   {rectangle to polar}
  if (Ztxt <> '?') and (Ftxt <> '?') then begin   {no errors}
    ZL0Edit.text := Ztxt;
    FL0Edit.text := Ftxt;
    FlagDecimalPoint(Ztxt,ipu);
    ZL0Edit.tagB := ipu;
    FlagDecimalPoint(Ftxt,ipu);
    FL0Edit.tagB := ipu;
    Bchanged := true;
    FL0Edit.color := clWhite;
    ZL0Edit.color := clWhite;
    RL0Edit.color := clWhite;
    XL0Edit.color := clWhite;
  end else begin
    XL0Edit.color := clYellow;
  end;
end;

procedure Backup;
{save all variables}
begin
  LastZL1  := k0Form.ZL1Edit.text;
  LastFL1  := k0Form.FL1Edit.text;
  LastRL1  := k0Form.RL1Edit.text;
  LastXL1  := k0Form.XL1Edit.text;
  LastZL0  := k0Form.ZL0Edit.text;
  LastFL0  := k0Form.FL0Edit.text;
  LastRL0  := k0Form.RL0Edit.text;
  LastXL0  := k0Form.XL0Edit.text;
  LastZRes := k0Form.ResZEdit.text;
  LastFRes := k0Form.ResFEdit.text;
  LastRRes := k0Form.ResREdit.text;
  LastXRes := k0Form.ResXEdit.text;
  LastYz   := k0Form.YzEdit.text;
  LastYf   := k0Form.YfEdit.text;
  LastYr   := k0Form.YrEdit.text;
  LastYx   := k0Form.YxEdit.text;
  LastZMem := MemZ;
  LastFMem := MemF;
  LastRMem := MemR;
  LastXMem := MemX;
end;

procedure calculate(oper : string);
{calculate: add, subtract, etc}
var
  ampl        : single;  {amplitude of result}
  apu,apv,apw : single;  {teporary}
  btw         : string;  {between real and imag.parts}
  cpu,cpv,cpw : complex; {temporary}
  cpx,cpy     : complex; {temporary}
  err1,err2   : integer; {error flag}
  err3,err4   : integer; {error flag}
  err5,err6   : integer; {error flag}
  err7,err8   : integer; {error flag}
  er11,er12   : integer; {error flag}
  er13,er14   : integer; {error flag}
  ipu         : integer; {temporary}
  line        : string;  {temporary}
  phas        : single;  {phase of result}
  text        : string;  {temporary}
  textR,textX : string;  {result as text}
  textZ,textF : string;  {abs.value and phase of results}
  ZL1,ZL0     : complex; {impedances}
begin
  backup;
  {move old results to Y}
  k0Form.YzEdit.text := k0Form.ResZedit.text;
  k0Form.YfEdit.text := k0Form.ResFedit.text;
  k0Form.YrEdit.text := k0Form.ResRedit.text;
  k0Form.YxEdit.text := k0Form.ResXedit.text;
  {for checks only, read also abs.value and phase}
  ValuesFromLine(k0Form.ZL1Edit.text, 1, ipu, cpu.x , apu, apv, apw, err5);
  ValuesFromLine(k0Form.FL1Edit.text, 1, ipu, cpu.y , apu, apv, apw, err6);
  ValuesFromLine(k0Form.ZL0Edit.text, 1, ipu, cpv.x , apu, apv, apw, err7);
  ValuesFromLine(k0Form.FL0Edit.text, 1, ipu, cpv.y , apu, apv, apw, err8);
  {read also the result, it may be needed}
  ValuesFromLine(k0Form.resREdit.text, 1, ipu, cpx.x , apu, apv, apw, er11);
  ValuesFromLine(k0Form.resXEdit.text, 1, ipu, cpx.y , apu, apv, apw, er12);
  ValuesFromLine(k0Form.resZedit.text, 1, ipu, ampl  , apu, apv, apw, er13);
  ValuesFromLine(k0Form.resFedit.text, 1, ipu, phas  , apu, apv, apw, er14);
  {now the actual input}
  ValuesFromLine(k0Form.RL1Edit.text, 1, ipu, cpu.x , apu, apv, apw, err1);
  ValuesFromLine(k0Form.XL1Edit.text, 1, ipu, cpu.y , apu, apv, apw, err2);
  ValuesFromLine(k0Form.RL0Edit.text, 1, ipu, cpv.x , apu, apv, apw, err3);
  ValuesFromLine(k0Form.XL0Edit.text, 1, ipu, cpv.y , apu, apv, apw, err4);
  if (err1 = 0) and (err2 = 0) and (err3 = 0) and (err4 = 0) and
     (err5 = 0) and (err6 = 0) and (err7 = 0) and (err8 = 0)then begin
    if      (oper = 'add'  ) then cpw := Cadd(cpu,cpv)
    else if (oper = 'sub'  ) then cpw := Csub(cpu,cpv)
    else if (oper = 'mult' ) then cpw := Cmult(cpu,cpv)
    else if (oper = 'div'  ) then cpw := Cdiv(cpu,cpv)
    else if (oper = 'AxB*' ) then cpw := Cmult(cpu,Conj(cpv))
    else if (oper = 'A*xB' ) then cpw := Cmult(Conj(cpu),cpv)
    else if (oper = 'power') then cpw := cplx(cpu.x*cpv.x+cpu.y*cpv.y,0)
    else if (oper = 'k0'   ) then begin  {calculate  k0 = ( ZL0  - ZL1) / ( 3* ZL1) }
      ZL1 := cpu;
      ZL0 := cpv;
      cpw := CDiv(Csub(ZL0,ZL1),CrMult(3,ZL1));
    end else if (oper = 'R+AxB*') then begin
      if (er11 = 0) and (er12 = 0) then begin
        cpw := Cadd(cpx,CMult(cpu,Conj(cpv))); { Result + A x B* }
      end else begin
        cpv := cplx(0,0);
      end;
    end else if (oper = 'R+A+B') then begin
      if (er11 = 0) and (er12 = 0) then begin
        cpw := Cadd(cpx,Cadd(cpu,cpv));        { Result + A + B }
      end else begin
        cpv := cplx(0,0);
      end;
    end else if (oper = 'sqrtR') then begin    {square root of result}
{      if (err11 = 0) and (err12 = 0) and (err13 = 0) and (err14 = 0) then begin
        if (ampl >= 0) then begin
          apu := sqrt(ampl);
          if (phas > 0) then apv := phas/2 else apv := (360+phas)/2;
        end else begin
          apu := sqrt(-ampl);}
      cpw := Csqrt(cpx);
    end;
    text := ManyChars(cpw.x);      {result to text}
    TextR := spaceless(text);      {remove spaces}
    text := ManyChars(cpw.y);      {result to text}
    TextX := spaceless(text);      {remove spaces}
    k0Form.ResRedit.text := textR; {display real part}
    k0Form.ResXedit.text := textX; {display imag.part}
    {display also in polar form}
    RecToPolar(textR, textX, textZ, textF);   {rectangle to polar}
    k0Form.ResZedit.text := textZ; {display}
    k0Form.ResFedit.text := textF;
{   k0Form.ResRedit.color := clWhite;}   {indicate normal state}
{   k0Form.ResXedit.color := clWhite;}
{   k0Form.ResZedit.color := clWhite;}
{   k0Form.ResFedit.color := clWhite;}
  end else begin
{   k0Form.ResRedit.color := clYellow;}   {indicate that something wrong}
{   k0Form.ResXedit.color := clYellow;}
{   k0Form.ResZedit.color := clYellow;}
{   k0Form.ResFedit.color := clYellow;}
  end;
  {write result to log}
  text := k0Form.ResXEdit.text;
  if (length(text) > 0) then begin
    if (text[1] = '-') then btw := '' else btw := '+';
  end;
  line := 'R='+k0Form.ResRedit.text+btw+k0Form.ResXedit.text+'i';
  k0Form.LogMemo.lines.add(line);
end;

procedure ShowMarker(sender : TObject);
begin
  k0Form.marker.top := (sender as TControl).top-4;
  k0Form.marker.left := (sender as TControl).left-4;
  k0Form.marker.width := (sender as TControl).width+8;
  k0Form.marker.height := (sender as TControl).height+8;
  k0Form.marker.SendToBack;
  k0Form.marker.visible := true;

  if (Sender <> Contr0) then begin
    Contr0 := Contr;
    Contr := sender as TSpeedButton;  {save operation}
  end else begin
    Contr := Contr0;
  end;

end;

procedure WriteABif;
{write A or/and B to log, if changed}
var
  line,text : string;
  btw       : string;
begin
  if (Achanged) then begin
    {if negative imag.part, no '+' needed}
    text := k0Form.XL1Edit.text;
    if (length(text) > 0) then begin
      if (text[1] = '-') then btw := '' else btw := '+';
    end;
    line := 'A='+k0Form.RL1Edit.text+btw+k0Form.XL1Edit.text+'i';
    k0Form.LogMemo.lines.add(line);
    Achanged := false;
  end;
  if (Bchanged) then begin
    text := k0Form.XL0Edit.text;
    if (length(text) > 0) then begin
      if (text[1] = '-') then btw := '' else btw := '+';
    end;
    line := 'B='+k0Form.RL0Edit.text+btw+k0Form.XL0Edit.text+'i';
    k0Form.LogMemo.lines.add(line);
    Bchanged := false;
  end;
end;

procedure TK0Form.ExchButClick(Sender: TObject);
{exchange the texts of A and B }
var
Ztext,Ftext,Rtext,Xtext : string;
begin
  backup;
  ShowMarker(sender);
  WriteABif;
  LogMemo.lines.add('A<->B');
  Ztext := ZL1Edit.text;
  Ftext := FL1Edit.text;
  Rtext := RL1Edit.text;
  Xtext := XL1Edit.text;
  ZL1Edit.text := ZL0Edit.text;
  FL1Edit.text := FL0Edit.text;
  RL1Edit.text := RL0Edit.text;
  XL1Edit.text := XL0Edit.text;
  ZL0Edit.text := Ztext;
  FL0Edit.text := Ftext;
  RL0Edit.text := Rtext;
  XL0Edit.text := Xtext;
end;

procedure TK0Form.SumMultConjButClick(Sender: TObject);
begin
  ShowMarker(sender);
  WriteABif;
  LogMemo.lines.add('x*+R');
  calculate('R+AxB*');  {A x Conj(B) added to result}
end;

procedure TK0Form.AddButClick(Sender: TObject);
begin
  ShowMarker(sender);
  WriteABif;
  LogMemo.lines.add('+');
  calculate('add');
end;

procedure TK0Form.SubButClick(Sender: TObject);
begin
  ShowMarker(sender);
  WriteABif;
  LogMemo.lines.add('-');
  calculate('sub');
end;

procedure TK0Form.MultButClick(Sender: TObject);
begin
  ShowMarker(sender);
  WriteABif;
  LogMemo.lines.add('x');
  calculate('mult');
end;

procedure TK0Form.DivButClick(Sender: TObject);
begin
  ShowMarker(sender);
  WriteABif;
  LogMemo.lines.add(':');
  calculate('div');
end;

procedure TK0Form.MultConjButClick(Sender: TObject);
begin
  ShowMarker(sender);
  WriteABif;
  LogMemo.lines.add('x*');
  calculate('AxB*');
end;

procedure TK0Form.k0ButClick(Sender: TObject);
begin
  ShowMarker(sender);
  WriteABif;
  LogMemo.lines.add('k0');
  calculate('k0');
end;

procedure TK0Form.ClearButClick(Sender: TObject);
begin
  ShowMarker(sender);
  LogMemo.lines.add('CR');
  backup;
  ResRedit.text := '0';
  ResXedit.text := '0';
  ResZedit.text := '0';
  ResFedit.text := '0';
end;

procedure TK0Form.CopyToAButClick(Sender: TObject);
begin
  ShowMarker(sender);
  LogMemo.lines.add('R->A');
  Achanged := true;
  backup;
  ZL1Edit.text := resZedit.text;
  FL1Edit.text := resFedit.text;
  RL1Edit.text := resRedit.text;
  XL1Edit.text := resXedit.text;
end;

procedure TK0Form.CopyToBButClick(Sender: TObject);
begin
  ShowMarker(sender);
  LogMemo.lines.add('R->B');
  Bchanged := true;
  backup;
  ZL0Edit.text := resZedit.text;
  FL0Edit.text := resFedit.text;
  RL0Edit.text := resRedit.text;
  XL0Edit.text := resXedit.text;
end;

procedure TK0Form.CopyToMemButClick(Sender: TObject);
begin
{ ShowMarker(sender);}
  LogMemo.lines.add('->M');
  backup;
  MemZ := ResZEdit.text;
  MemF := ResFEdit.text;
  MemR := ResREdit.text;
  MemX := ResXEdit.text;
end;

procedure TK0Form.MemToAButClick(Sender: TObject);
begin
  ShowMarker(sender);
  Achanged := true;
  LogMemo.lines.add('M->A');
  backup;
  ZL1Edit.text := MemZ;
  FL1Edit.text := MemF;
  RL1Edit.text := MemR;
  XL1Edit.text := MemX;
end;

procedure TK0Form.CopyAtoBButClick(Sender: TObject);
begin
  ShowMarker(sender);
  Bchanged := true;
  LogMemo.lines.add('A->B');
  backup;
  ZL0Edit.text := ZL1Edit.text;
  FL0Edit.text := FL1Edit.text;
  RL0Edit.text := RL1Edit.text;
  XL0Edit.text := XL1Edit.text;
end;

procedure TK0Form.UndoButClick(Sender: TObject);
begin
  if (Contr0 <> nil) then ShowMarker(Contr0)
  else marker.visible := false;
  Achanged := true;
  Bchanged := true;
  LogMemo.lines.add('undo');
{  Contr := Contr0;}
  k0Form.ZL1Edit.text := LastZL1;
  k0Form.FL1Edit.text := LastFL1;
  k0Form.RL1Edit.text := LastRL1;
  k0Form.XL1Edit.text := LastXL1;
  k0Form.ZL0Edit.text := LastZL0;
  k0Form.FL0Edit.text := LastFL0;
  k0Form.RL0Edit.text := LastRL0;
  k0Form.XL0Edit.text := LastXL0;
  k0Form.ResZEdit.text := LastZRes;
  k0Form.ResFEdit.text := LastFRes;
  k0Form.ResREdit.text := LastRRes;
  k0Form.ResXEdit.text := LastXRes;
  k0Form.YzEdit.text := LastYz;
  k0Form.YfEdit.text := LastYf;
  k0Form.YrEdit.text := LastYr;
  k0Form.YxEdit.text := LastYx;
  MemZ := LastZMem;
  MemF := LastFMem;
  MemR := LastRMem;
  MemX := LastXMem;
end;

procedure TK0Form.SumButClick(Sender: TObject);
begin
  backup;
  WriteABif;
  LogMemo.lines.add('+R');
  ShowMarker(sender);
  calculate('R+A+B');
end;

procedure ChangeSign(var text : string);
{change the sign of text}
var
  ii   : integer;
  line : string;
  len  : integer; {length of text}
begin
  len := length(text);
  if (len > 0) then begin
    if (text[1] = '+') then begin
      text[1] := '-';
    end else if (text[1] = '-') then begin
      text[1] := '+';
    end else if (text[1] >= '0') and (text[1] <= '9') then begin
      line := '-';
      for ii := 1 to len do line := line+text[ii];
      text := line;
    end;
  end;
end;

procedure TK0Form.SignButClick(Sender: TObject);
{change sign}
var
  text,Ztxt,Ftxt : string;  {temporary}
begin
  ShowMarker(sender);
  LogMemo.lines.add('+-A');
  Achanged := true;
  backup;
  text := RL1Edit.text;
  ChangeSign(text);
  RL1Edit.text := text;
  text := XL1Edit.text;
  ChangeSign(text);
  XL1Edit.text := text;
  RecToPolar(RL1Edit.text, XL1Edit.text, Ztxt,Ftxt);   {rectangle to polar}
  ZL1Edit.text := Ztxt;
  FL1Edit.text := Ftxt;
end;

procedure TK0Form.BsignButClick(Sender: TObject);
{change sign}
var
  text,Ztxt,Ftxt : string;  {temporary}
begin
  ShowMarker(sender);
  Bchanged := true;
  LogMemo.lines.add('+-B');
  backup;
  text := RL0Edit.text;
  ChangeSign(text);
  RL0Edit.text := text;
  text := XL0Edit.text;
  ChangeSign(text);
  XL0Edit.text := text;
  RecToPolar(RL0Edit.text, XL0Edit.text, Ztxt,Ftxt);   {rectangle to polar}
  ZL0Edit.text := Ztxt;
  FL0Edit.text := Ftxt;
end;

procedure TK0Form.AconjButClick(Sender: TObject);
{complex conjugate}
var
  text,Ztxt,Ftxt : string;  {temporary}
begin
  ShowMarker(sender);
  WriteABif;
  LogMemo.lines.add('A*');
  Achanged := true;
  backup;
  text := XL1Edit.text;
  ChangeSign(text);
  XL1Edit.text := text;
  RecToPolar(RL1Edit.text, XL1Edit.text, Ztxt,Ftxt);   {rectangle to polar}
  ZL1Edit.text := Ztxt;
  FL1Edit.text := Ftxt;
end;

procedure TK0Form.BconjButClick(Sender: TObject);
{complex conjugate}
var
  text,Ztxt,Ftxt : string;  {temporary}
begin
  ShowMarker(sender);
  WriteABif;
  LogMemo.lines.add('B*');
  Bchanged := true;
  backup;
  text := XL0Edit.text;
  ChangeSign(text);
  XL0Edit.text := text;
  RecToPolar(RL0Edit.text, XL0Edit.text, Ztxt,Ftxt);   {rectangle to polar}
  ZL0Edit.text := Ztxt;
  FL0Edit.text := Ftxt;
end;

procedure TK0Form.ClearAButClick(Sender: TObject);
{clear A}
begin
  ShowMarker(sender);
  LogMemo.lines.add('CA');
  Achanged := true;
  backup;
  RL1Edit.text := '0';
  XL1Edit.text := '0';
  ZL1Edit.text := '0';
  FL1Edit.text := '0';
end;

procedure TK0Form.ClearBButClick(Sender: TObject);
begin
  ShowMarker(sender);
  Bchanged := true;
  LogMemo.lines.add('CB');
  backup;
  RL0Edit.text := '0';
  XL0Edit.text := '0';
  ZL0Edit.text := '0';
  FL0Edit.text := '0';
end;

procedure TK0Form.RsignButClick(Sender: TObject);
{change sign}
var
  text,Ztxt,Ftxt : string;  {temporary}
begin
  ShowMarker(sender);
  LogMemo.lines.add('+-R');
  backup;
  text := ResREdit.text;
  ChangeSign(text);
  ResREdit.text := text;
  text := ResXEdit.text;
  ChangeSign(text);
  ResXEdit.text := text;
  RecToPolar(ResREdit.text, ResXEdit.text, Ztxt,Ftxt);   {rectangle to polar}
  ResZEdit.text := Ztxt;
  ResFEdit.text := Ftxt;
end;

procedure TK0Form.sqrtRButClick(Sender: TObject);
{square root of result}
begin
  ShowMarker(sender);
  LogMemo.lines.add('sqrt');
  calculate('sqrtR');
end;

procedure TK0Form.TopMenu1Click(Sender: TObject);
begin
  Application.terminate;
end;

procedure TK0Form.ExitItemClick(Sender: TObject);
begin
  Application.terminate;
end;

procedure TK0Form.SymbItemClick(Sender: TObject);
var
  check : boolean;
begin
  check := not SymbItem.checked;
  SymbItem.checked := check;
  ZL1img.visible := check;
  FL1img.visible := check;
  RL1img.visible := check;
  XL1img.visible := check;
  ZL0img.visible := check;
  FL0img.visible := check;
  RL0img.visible := check;
  XL0img.visible := check;
  RadiusLabel.visible := not check;
  AngleLabel.visible := not check;
  RealLabel.visible := not check;
  ImagLabel.visible := not check;
end;

procedure TK0Form.MemToBButClick(Sender: TObject);
begin
  ShowMarker(sender);
  Bchanged := true;
  LogMemo.lines.add('M->B');
  backup;
  ZL0Edit.text := MemZ;
  FL0Edit.text := MemF;
  RL0Edit.text := MemR;
  XL0Edit.text := MemX;
end;

procedure TK0Form.XL1EditEnter(Sender: TObject);
begin
  if (XL1Edit.text = '0') or (XL1Edit.text = '0.0') then XL1Edit.text := '';
end;



procedure TK0Form.RL1EditEnter(Sender: TObject);
begin
  if (RL1Edit.text = '0') or (RL1Edit.text = '0.0') then RL1Edit.text := '';
end;

procedure TK0Form.XL0EditEnter(Sender: TObject);
begin
  if (XL0Edit.text = '0') or (XL0Edit.text = '0.0') then XL0Edit.text := '';
end;

procedure TK0Form.RL0EditEnter(Sender: TObject);
begin
  if (RL0Edit.text = '0') or (RL0Edit.text = '0.0') then RL0Edit.text := '';
end;

procedure TK0Form.FL1EditEnter(Sender: TObject);
begin
  if (FL1Edit.text = '0') or (FL1Edit.text = '0.0') then FL1Edit.text := '';
end;

procedure TK0Form.ZL1EditEnter(Sender: TObject);
begin
  if (ZL1Edit.text = '0') or (ZL1Edit.text = '0.0') then ZL1Edit.text := '';
end;

procedure TK0Form.FL0EditEnter(Sender: TObject);
begin
  if (FL0Edit.text = '0') or (FL0Edit.text = '0.0') then FL0Edit.text := '';
end;

procedure TK0Form.ZL0EditEnter(Sender: TObject);
begin
  if (ZL0Edit.text = '0') or (ZL0Edit.text = '0.0') then ZL0Edit.text := '';
end;

procedure TK0Form.ZL1EditExit(Sender: TObject);
begin
  if (ZL1Edit.text = '') then begin
    ZL1Edit.text := '0';
    ZL1EditKeyUp(Sender, zero,[]);
  end;
end;

procedure TK0Form.FL1EditExit(Sender: TObject);
begin
  if (FL1Edit.text = '') then begin
    FL1Edit.text := '0';
    FL1EditKeyUp(Sender, zero,[]);
  end;
end;

procedure TK0Form.RL1EditExit(Sender: TObject);
begin
  if (RL1Edit.text = '') then begin
    RL1Edit.text := '0';
    RL1EditKeyUp(Sender, zero,[]);
  end;
end;

procedure TK0Form.XL1EditExit(Sender: TObject);
begin
  if (XL1Edit.text = '') then begin
    XL1Edit.text := '0';
    XL1EditKeyUp(Sender, zero,[]);
  end;
end;

procedure TK0Form.ZL0EditExit(Sender: TObject);
begin
  if (ZL0Edit.text = '') then begin
    ZL0Edit.text := '0';
    ZL0EditKeyUp(Sender, zero,[]);
  end;
end;

procedure TK0Form.FL0EditExit(Sender: TObject);
begin
  if (FL0Edit.text = '') then begin
    FL0Edit.text := '0';
    FL0EditKeyUp(Sender, zero,[]);
  end;
end;

procedure TK0Form.RL0EditExit(Sender: TObject);
begin
  if (RL0Edit.text = '') then begin
    RL0Edit.text := '0';
    RL0EditKeyUp(Sender, zero,[]);
  end;
end;

procedure TK0Form.XL0EditExit(Sender: TObject);
begin
  if (XL0Edit.text = '') then begin
    XL0Edit.text := '0';
    XL0EditKeyUp(Sender, zero,[]);
  end;
end;

procedure TK0Form.YtoAButClick(Sender: TObject);
{copy old result to A}
begin
  ShowMarker(sender);
  LogMemo.lines.add('Y->A');
  Achanged := true;
  backup;
  ZL1Edit.text := YzEdit.text;
  FL1Edit.text := YfEdit.text;
  RL1Edit.text := YrEdit.text;
  XL1Edit.text := YxEdit.text;
end;

procedure TK0Form.YtoBButClick(Sender: TObject);
{copy old result to B}
begin
  ShowMarker(sender);
  LogMemo.lines.add('Y->B');
  Bchanged := true;
  backup;
  ZL0Edit.text := YzEdit.text;
  FL0Edit.text := YfEdit.text;
  RL0Edit.text := YrEdit.text;
  XL0Edit.text := YxEdit.text;
end;

procedure TK0Form.LogItemClick(Sender: TObject);
begin
  LogItem.checked := not LogItem.checked;
  if (LogItem.checked) then begin  {show the log}
    LogMemo.visible := true;
    k0Form.width := LogMemo.left+LogMemo.width+16;
  end else begin
    LogMemo.visible := false;
    k0Form.width := LogMemo.left+8;
  end;
end;

procedure TK0Form.AmultButClick(Sender: TObject);
{multiply A, result to A}
var
  apu,apv,apw : single;   {temporary}
  btw         : string;   {char between real and imag.parts}
  cpu,cpw     : complex;  {temporary}
  er1,er2,er3 : integer;  {error flags}
  ipu         : integer;  {temporary}
  line        : string;   {temporary}
  rr          : single;   {multiplier}
  text        : string;   {temporary}
  textR,textX : string;   {real, imag.parts}
  textZ,textF : string;   {magnitude, angle}
begin
  ShowMarker(sender);
  backup;
  {entries to numericals}
  ValuesFromLine(k0Form.RL1Edit.text, 1, ipu, cpu.x , apu, apv, apw, er1);
  ValuesFromLine(k0Form.XL1Edit.text, 1, ipu, cpu.y , apu, apv, apw, er2);
  ValuesFromLine(k0Form.AmultEdit.text, 1, ipu, rr  , apu, apv, apw, er3);
  {multiply, if entries correct}
  if (er1 = 0) and (er2 = 0) and (er3 = 0) then begin
    {write original A to log}
    {write result to log}
    text := k0Form.RL1Edit.text;
    if (length(text) > 0) then begin
      if (text[1] = '-') then btw := '' else btw := '+';
    end;
    line := 'A='+k0Form.RL1Edit.text+btw+k0Form.XL1Edit.text+'i';
    k0Form.LogMemo.lines.add(line);
    {calculate}
    cpw := Crmult(rr,cpu);
    {result back to A}
    text := ManyChars(cpw.x);      {result to text}
    TextR := spaceless(text);      {remove spaces}
    text := ManyChars(cpw.y);      {result to text}
    TextX := spaceless(text);      {remove spaces}
    k0Form.RL1Edit.text := textR;      {display real part}
    k0Form.XL1Edit.text := textX;      {display imag.part}
    {display also in polar form}
    RecToPolar(textR, textX, textZ, textF);   {rectangle to polar}
    k0Form.ZL1Edit.text := textZ; {display}
    k0Form.FL1Edit.text := textF;
    {write multiplier to log}
    line := AmultEdit.text+' * A';
    k0Form.LogMemo.lines.add(line);
    {write result to log}
    text := k0Form.RL1Edit.text;
    if (length(text) > 0) then begin
      if (text[1] = '-') then btw := '' else btw := '+';
    end;
    line := 'A='+k0Form.RL1Edit.text+btw+k0Form.XL1Edit.text+'i';
    k0Form.LogMemo.lines.add(line);
  end else begin

  end;
end;

procedure TK0Form.AmultEditEnter(Sender: TObject);
begin
  if (AmultEdit.text = '0') or (AmultEdit.text = '0.0') then AmultEdit.text := '';
end;

procedure TK0Form.AmultEditKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  ipu       : integer;
  text      : string;
begin
  ipu := 0;
  { set flag, if there is a decimal point}
  text := AmultEdit.text;
  FlagDecimalPoint(text,ipu);
  AmultEdit.tagB := ipu;
end;

procedure TK0Form.AmultEditExit(Sender: TObject);
begin
  if (AmultEdit.text = '') then begin
    AmultEdit.text := '0';
    AmultEditKeyUp(Sender, zero,[]);
  end;
end;

procedure TK0Form.BmultEditEnter(Sender: TObject);
begin
  if (BmultEdit.text = '0') or (BmultEdit.text = '0.0') then BmultEdit.text := '';
end;

procedure TK0Form.BmultEditExit(Sender: TObject);
begin
  if (BmultEdit.text = '') then begin
    BmultEdit.text := '0';
    BmultEditKeyUp(Sender, zero,[]);
  end;
end;

procedure TK0Form.BmultEditKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  ipu       : integer;
  text      : string;
begin
  ipu := 0;
  { set flag, if there is a decimal point}
  text := BmultEdit.text;
  FlagDecimalPoint(text,ipu);
  BmultEdit.tagB := ipu;
end;

procedure TK0Form.BmultButClick(Sender: TObject);
{multiply B, result to B}
var
  apu,apv,apw : single;   {temporary}
  btw         : string;   {char between real and imag.parts}
  cpu,cpw     : complex;  {temporary}
  er1,er2,er3 : integer;  {error flags}
  ipu         : integer;  {temporary}
  line        : string;   {temporary}
  rr          : single;   {multiplier}
  text        : string;   {temporary}
  textR,textX : string;   {real, imag.parts}
  textZ,textF : string;   {magnitude, angle}
begin
  ShowMarker(sender);
  backup;
  {entries to numericals}
  ValuesFromLine(k0Form.RL0Edit.text, 1, ipu, cpu.x , apu, apv, apw, er1);
  ValuesFromLine(k0Form.XL0Edit.text, 1, ipu, cpu.y , apu, apv, apw, er2);
  ValuesFromLine(k0Form.BmultEdit.text, 1, ipu, rr  , apu, apv, apw, er3);
  {multiply, if entries correct}
  if (er1 = 0) and (er2 = 0) and (er3 = 0) then begin
    {write original B to log}
    text := k0Form.RL0Edit.text;
    if (length(text) > 0) then begin
      if (text[1] = '-') then btw := '' else btw := '+';
    end;
    line := 'B='+k0Form.RL0Edit.text+btw+k0Form.XL0Edit.text+'i';
    k0Form.LogMemo.lines.add(line);
    {calculate}
    cpw := Crmult(rr,cpu);
    {result back to B}
    text := ManyChars(cpw.x);      {result to text}
    TextR := spaceless(text);      {remove spaces}
    text := ManyChars(cpw.y);      {result to text}
    TextX := spaceless(text);      {remove spaces}
    k0Form.RL0Edit.text := textR;      {display real part}
    k0Form.XL0Edit.text := textX;      {display imag.part}
    {display also in polar form}
    RecToPolar(textR, textX, textZ, textF);   {rectangle to polar}
    k0Form.ZL0Edit.text := textZ; {display}
    k0Form.FL0Edit.text := textF;
    {write multiplier to log}
    line := BmultEdit.text+' * B';
    k0Form.LogMemo.lines.add(line);
    {write result to log}
    text := k0Form.RL0Edit.text;
    if (length(text) > 0) then begin
      if (text[1] = '-') then btw := '' else btw := '+';
    end;
    line := 'B='+k0Form.RL0Edit.text+btw+k0Form.XL0Edit.text+'i';
    k0Form.LogMemo.lines.add(line);
  end else begin

  end;
end;

procedure TK0Form.AmultEditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if      (key = 40) then ToBelow(AmultEdit,BmultEdit)
  else if (key = 37) then ToLeft (AmultEdit,XL1Edit);
end;

procedure TK0Form.BmultEditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if      (key = 38) then ToAbove(BmultEdit,AmultEdit)
  else if (key = 37) then ToLeft (BmultEdit,XL0Edit);
end;

procedure TK0Form.HelpItemClick(Sender: TObject);
begin
  HelpForm.visible := true;
end;

procedure TK0Form.CopyAtoRButClick(Sender: TObject);
begin
  ShowMarker(sender);
  LogMemo.lines.add('A->R');
  backup;
  ResZEdit.text := ZL1Edit.text;
  ResFEdit.text := FL1Edit.text;
  ResREdit.text := RL1Edit.text;
  ResXEdit.text := XL1Edit.text;
end;

procedure TK0Form.CopyBtoYButClick(Sender: TObject);
begin
  ShowMarker(sender);
  LogMemo.lines.add('B->Y');
  backup;
  YZEdit.text := ZL0Edit.text;
  YFEdit.text := FL0Edit.text;
  YREdit.text := RL0Edit.text;
  YXEdit.text := XL0Edit.text;
end;

procedure TK0Form.WMCopyData(var Msg: TWMCopyData);
{receive line data from elplek}
begin
  {Handle of the Sender}
  HandleCopyDataRecord(Msg.CopyDataStruct);
  {Send something back}
  msg.Result := 1;
  BringToFront;
end;

procedure TK0Form.HandleCopyDataRecord(copyDataStruct: PCopyDataStruct);
{receive line parameters from elplek}
var
  key: word;
begin
  key := 0;
  RL1Edit.text   := TSixString(copyDataStruct.lpData^).x;   {resistance}
  XL1Edit.text   := TSixString(copyDataStruct.lpData^).y;   {reactance}
  XL1EditKeyUp(K0Form,key,[]);                              {to polar form}
  RL0Edit.text   := TSixString(copyDataStruct.lpData^).z;   {zero seq. resistance}
  XL0Edit.text   := TSixString(copyDataStruct.lpData^).u;   {zero seq. reactance}
  XL0EditKeyUp(K0Form,key,[]);                              {to polar form}
  AmultEdit.text := TSixString(copyDataStruct.lpData^).v;   {length of line}
  BmultEdit.text := TSixString(copyDataStruct.lpData^).v;   {length of line}
  LabelEdit.text := TSixString(copyDataStruct.lpData^).w;   {label of the line in Elplek}
end;

procedure TK0Form.TrLineButClick(Sender: TObject);
begin
  {add a space to the caption, as a flag showing that transmission line
   data can be received from Elplek, see procedure SendLinedata in Imagopas.pas}
  if (TrLineBut.down) then caption := caption_orig+' '
  else caption := caption_orig;
end;

end.
