{!!! IF number of parameters is changed, check dimensions in paramrep.pas !!!!}
{... and array spare[ ] in distance.pas}
{!!! and indices in BothImpedanceZones of eplex.pas,  in imagodef.pas gPoly_alf, etc}
unit polygon;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, ExtCtrls, skemadef, Utildef, Distance, StdCtrls, Drawcomp, Menus,
  Buttons, routines, Clipbrd, Imagodef, lineparam;

type
  TPolyRel = class(TForm)
    PolyGrid: TStringGrid;
    PolyChar: TImage;
    MarkImage: TImage;
    ImpedEdit: TEdit;
    FirstMenu: TMainMenu;
    FileMenu: TMenuItem;
    ExportItem: TMenuItem;
    ExitItem: TMenuItem;
    ExportDialog: TSaveDialog;
    TitleEdit: TEdit;
    NotesMemo: TMemo;
    DummyImage: TImage;
    ViewMenu: TMenuItem;
    NotesItem: TMenuItem;
    MarkerMenu: TMenuItem;
    Zone1Item: TMenuItem;
    Zone2Item: TMenuItem;
    Zone3Item: TMenuItem;
    Zone4Item: TMenuItem;
    LineItem: TMenuItem;
    OptionsMenu: TMenuItem;
    ShowItem: TMenuItem;
    ColorItem: TMenuItem;
    GridColor: TImage;
    GridItem: TMenuItem;
    IDImage: TImage;
    PointMarker: TMenuItem;
    LineMarker: TMenuItem;
    IncBut: TSpeedButton;
    DecBut: TSpeedButton;
    ResetBut: TSpeedButton;
    OKBut: TSpeedButton;
    CancelBut: TSpeedButton;
    ApplyBut: TSpeedButton;
    HintBut: TSpeedButton;
    ImagePanel: TPanel;
    ColorImage: TImage;
    ThicknessPanel: TPanel;
    ThicknessImage: TImage;
    LoadZoneItem: TMenuItem;
    LoadItem: TMenuItem;
    OutZoneItem: TMenuItem;
    StepItem: TMenuItem;
    UnitsItem: TMenuItem;
    ParamItem: TMenuItem;
    SymbolItem: TMenuItem;
    TitleItem: TMenuItem;
    ImpedanceItem: TMenuItem;
    DecMenu: TMenuItem;
    GroupMenu: TMenuItem;
    IncMenu: TMenuItem;
    CopyItem: TMenuItem;
    AutoManMenu: TMenuItem;
    CondItem1: TMenuItem;
    CondItem2: TMenuItem;
    CondItem3: TMenuItem;
    CondItem4: TMenuItem;
    CondItem5: TMenuItem;
    CondItem6: TMenuItem;
    AllItem: TMenuItem;
    Warnedit: TEdit;
    CopyToCItem: TMenuItem;
    ScaleItem: TMenuItem;
    OrigImg: TImage;
    CompBut: TSpeedButton;
    ClearCompBut: TButton;
    ImpedImg0: TImage;
    ImpedImg1: TImage;
    ImpedImg2: TImage;
    ImpedImg3: TImage;
    ImpedImg4: TImage;
    ImpedImg5: TImage;
    ImpedImg6: TImage;
    CancelRelayBut: TButton;
    OhmImg0: TImage;
    OhmImg1: TImage;
    OhmImg2: TImage;
    OhmImg3: TImage;
    OhmImg4: TImage;
    OhmImg5: TImage;
    OhmImg6: TImage;
    InfoBut: TButton;
    RelBut: TButton;
    ButtonBox: TGroupBox;
    HideBut: TSpeedButton;
    CancelBoxBut: TButton;
    RemoveBut: TButton;
    SavePanel: TPanel;
    TargetLabel: TLabel;
    RelayBox: TListBox;
    SaveBut: TButton;
    RecallBut: TButton;
    DeleteBut: TButton;
    CancelActionBut: TButton;
    NewEdit: TEdit;
    SRDItem: TMenuItem;
    ImpedMarkerItem: TMenuItem;
    RelBut2: TButton;
    TestPanel: TPanel;
    GroundLabel: TLabel;
    PhaseLabel: TLabel;
    RectGrid: TStringGrid;
    PolarGrid: TStringGrid;
    TestBut: TButton;
    GroundEdit: TEdit;
    PhaseEdit: TEdit;
    CloseBut: TButton;
    ActivationItem: TMenuItem;
    ResetTestBut: TButton;
    HideColorBut: TButton;
    ImpedLinePanel: TPanel;
    ImpedLineImg: TImage;
    HideThBut: TButton;
    RevBut: TSpeedButton;
    ParamImg: TImage;
    ParamBut: TSpeedButton;
    Zone5Item: TMenuItem;
    PhasePanel: TPanel;
    PhaseGrid: TStringGrid;
    ZBut: TSpeedButton;
    GroundPanel: TPanel;
    GroundGrid: TStringGrid;
    FlagEdit: TEdit;
    HelpItem: TMenuItem;
    MultiRelBut: TSpeedButton;
    NoteBut: TBitBtn;
    RelayLabel: TLabel;
    HenryPanel: TPanel;
    HenryEdit: TEdit;
    Label1: TLabel;
    CopyMemo: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure PolyGridSelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure FormDeactivate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure OKButClick(Sender: TObject);
    procedure CancelButClick(Sender: TObject);
    procedure ApplyButClick(Sender: TObject);
    procedure HintButClick(Sender: TObject);
    procedure IncButClick(Sender: TObject);
    procedure DecButClick(Sender: TObject);
    procedure ResetButClick(Sender: TObject);
    procedure PolyCharMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ExportItemClick(Sender: TObject);
    procedure ExitItemClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure TitleEditKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure NotesItemClick(Sender: TObject);
//  procedure NotesMemoKeyUp(Sender: TObject; var Key: Word;
//    Shift: TShiftState);
    procedure MarkerMenuClick(Sender: TObject);
    procedure Zone1ItemClick(Sender: TObject);
    procedure Zone2ItemClick(Sender: TObject);
    procedure Zone3ItemClick(Sender: TObject);
    procedure Zone4ItemClick(Sender: TObject);
    procedure LineItemClick(Sender: TObject);
    procedure ShowItemClick(Sender: TObject);
    procedure ColorItemClick(Sender: TObject);
    procedure GridColorMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure GridItemClick(Sender: TObject);
    procedure PolyCharMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PolyCharMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PointMarkerClick(Sender: TObject);
    procedure LineMarkerClick(Sender: TObject);
    procedure TitleEditClick(Sender: TObject);
    procedure ImpedEditClick(Sender: TObject);
//  procedure NotesMemoClick(Sender: TObject);
    procedure PolyGridMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PolyGridMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PolyGridDrawCell(Sender: TObject; Col, Row: Longint;
      Rect: TRect; State: TGridDrawState);
    procedure ColorImageMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PolyGridKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure PolyGridKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ThicknessImageMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure LoadZoneItemClick(Sender: TObject);
    procedure LoadItemClick(Sender: TObject);
    procedure OutZoneItemClick(Sender: TObject);
    procedure StepItemClick(Sender: TObject);
    procedure UnitsItemClick(Sender: TObject);
    procedure ParamItemClick(Sender: TObject);
    procedure SymbolItemClick(Sender: TObject);
    procedure TitleItemClick(Sender: TObject);
    procedure ImpedanceItemClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure CopyItemClick(Sender: TObject);
    procedure DecMenuClick(Sender: TObject);
    procedure IncMenuClick(Sender: TObject);
    procedure AutoManMenuClick(Sender: TObject);
    procedure CondItem1Click(Sender: TObject);
    procedure CondItem2Click(Sender: TObject);
    procedure CondItem3Click(Sender: TObject);
    procedure CondItem4Click(Sender: TObject);
    procedure CondItem5Click(Sender: TObject);
    procedure CondItem6Click(Sender: TObject);
    procedure AllItemClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure WarneditClick(Sender: TObject);
    procedure CopyToCItemClick(Sender: TObject);
    procedure ScaleItemClick(Sender: TObject);
    procedure ImpedImg0Click(Sender: TObject);
    procedure ImpedImg1Click(Sender: TObject);
    procedure ImpedImg2Click(Sender: TObject);
    procedure ImpedImg3Click(Sender: TObject);
    procedure ImpedImg4Click(Sender: TObject);
    procedure ImpedImg5Click(Sender: TObject);
    procedure ImpedImg6Click(Sender: TObject);
    procedure OhmImg0Click(Sender: TObject);
    procedure OhmImg1Click(Sender: TObject);
    procedure OhmImg2Click(Sender: TObject);
    procedure OhmImg3Click(Sender: TObject);
    procedure OhmImg4Click(Sender: TObject);
    procedure OhmImg5Click(Sender: TObject);
    procedure OhmImg6Click(Sender: TObject);
    procedure CancelRelayButClick(Sender: TObject);
    procedure RelButClick(Sender: TObject);
    procedure CancelBoxButClick(Sender: TObject);
    procedure HideButClick(Sender: TObject);
    procedure ClearCompButClick(Sender: TObject);
    procedure RemoveButClick(Sender: TObject);
    procedure SRDItemClick(Sender: TObject);
    procedure NewEditClick(Sender: TObject);
    procedure NewEditEnter(Sender: TObject);
    procedure SaveButClick(Sender: TObject);
    procedure RecallButClick(Sender: TObject);
    procedure CancelActionButClick(Sender: TObject);
    procedure DeleteButClick(Sender: TObject);
    procedure ImpedMarkerItemClick(Sender: TObject);
    procedure RelBut2Click(Sender: TObject);
    procedure InfoButClick(Sender: TObject);
    procedure ActivationItemClick(Sender: TObject);
    procedure CloseButClick(Sender: TObject);
    procedure TestPanelMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PolarGridSelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure RectGridSelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure RectGridKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure PolarGridKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure TestButClick(Sender: TObject);
    procedure ResetTestButClick(Sender: TObject);
    procedure HideColorButClick(Sender: TObject);
    procedure ImpedLineImgMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure HideThButClick(Sender: TObject);
    procedure RevButClick(Sender: TObject);
    procedure GetZrow(var Zrow,frow: integer);
    procedure ParamButClick(Sender: TObject);
    procedure ZButClick(Sender: TObject);
    procedure PhaseGridKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure PhaseGridSelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure PhaseGridKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure GroundGridKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure GroundGridKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure GroundGridSelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure FlagEditChange(Sender: TObject);
    procedure RelayBoxKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure RelayBoxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure HelpItemClick(Sender: TObject);
    procedure Zone5ItemClick(Sender: TObject);
    procedure MultiRelButClick(Sender: TObject);
    procedure NoteButClick(Sender: TObject);
    procedure HenryEditKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure CopyMemoKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure CopyMemoMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
{    width_old : integer;               {old width of form}
{    spare   : array[0..29] of string;  {for saving parameters, for apply-cancel}
//  procedure ToPolarGrid(GorP: string);
    procedure LinePhaseAngle(var fii: single; var err: integer);
    procedure AlphaAngle(var fii: single; var err: integer);
    procedure ToZRGrid(GorP: string);
//  procedure FromPolarToMainGrid(GorP: string);
    procedure FromZRToMainGrid(GorP: string);
    procedure PrepareImpedanceGrid(pGrid: TpGrid; pPanel: TpPanel; row1: integer);
    procedure SetGridTop;
    procedure UpdateImpedanceGrids;
    procedure UpdateXinMainGrid(pGrid: TpGrid; row, row1 : integer);
    procedure InductanceToReactance;    
  end;

procedure DrawAllPolyChar(pComp : TpComp; toile: TCanvas; called: string);
procedure PolygonRelayShow;
function  PolyHiddenRow(irow : integer): boolean;
procedure corners(pComp: TpComp; RR,XX,tana,tanb,tang,tanc,flineD,Zline,RpR: single;
                  var x1,y1,x2,y2,x3,y3,x4,y4: single; var eq14,eq23: boolean);
procedure DrawOnePolyChar(pComp: TpComp; toile: TCanvas);
function  GetDeltarow: integer;
function  GetBetarow: integer;

var
  Poly   : TDist;
  PolyRel: TPolyRel;

implementation

uses
  Imagopas, Impmark, RXLines, PQRelay, CopyGroup, Condition, Skemproc,
  PolyHelp;

const
  CRwidth = 16;              {width (and height) of a small color rectangle}
  CRspace = 4;               {width of space between color rectangles}
  scroll_pos : integer = 0;  {position of vertical scroll bar}
  nBasicPar     = 37;        {number of basic parameters}
  K0magnRow     = 0;
  K0angRow      = 1;
  alphaRow      = 2;
  betaRow       = 3;
  gammarow      = 4;
  deltarow      = 5;
  RpRrow        = 6;
  R1row         = 7;
  X1row         = 8;
  R2row         = 9;
  X2row         = 10;
  R3row         = 11;
  X3row         = 12;
  R4row         = 13;
  X4row         = 14;
  R5row         = 15;
  X5row         = 16;
  T1row         = 17;
  T2row         = 18;
  T3row         = 19;
  T4row         = 20;
  T5row         = 21;
  R1Nrow        = 22;
  X1Nrow        = 23;
  R2Nrow        = 24;
  X2Nrow        = 25;
  R3Nrow        = 26;
  X3Nrow        = 27;
  R4Nrow        = 28;
  X4Nrow        = 29;
  R5Nrow        = 30;
  X5Nrow        = 31;
  T1Nrow        = 32;
  T2Nrow        = 33;
  T3Nrow        = 34;
  T4Nrow        = 35;
  T5Nrow        = 36;
  Zlinerow      = 37;
  Filinerow     = 38;
  phThicknRow   = 39;        {row for thickness of phase circles}
  ForwardRow    = 40;        {row with the text 'forward'}
  fwNameRow     = 41;        {name of the forward load zone}
  fwMVARow      = 42;        {forward apparent power row}
  fwPosAngleRow = 43;        {forward positive load angle row}
  fwNegAngleRow = 44;        {forward negative load angle row}
  fwColorRow    = 45;        {row for selecting the color of forward line}
  fwThicknRow   = 46;        {forward line thickness row}
  ReverseRow    = 47;        {row with the text 'reverse'}
  rvNameRow     = 48;        {name of the reverse load zone}
  rvMVARow      = 49;        {reverse apparent power row}
  rvPosAngleRow = 50;        {reverse positive load angle row}
  rvNegAngleRow = 51;        {reverse negative load angle row}
  rvColorRow    = 52;        {color row of reverse line}
  rvThicknRow   = 53;        {reverse line thickness row}
  Zone6Row      = 54;        {title row for zone 6}
  z6NameRow     = 55;        {row for name (identifier)}
  z6TopRow      = 56;        {top reactance}
  z6BotRow      = 57;        {bottom reactance}
  z6RightRow    = 58;        {right resistance}
  z6LeftRow     = 59;        {left resistance}
  z6ColorRow    = 60;        {color of the line}
  z6ThicknRow   = 61;        {line thickness}
  Zone5Row      = 62;        {title row for zone 6}
  z5NameRow     = 63;        {row for name (identifier)}
  z5TopRow      = 64;        {top reactance}
  z5BotRow      = 65;        {bottom reactance}
  z5RightRow    = 66;        {right resistance}
  z5LeftRow     = 67;        {left resistance}
  z5ColorRow    = 68;        {color of the line}
  z5ThicknRow   = 69;        {line thickness}
  OptiRow       = 70;        {if <> 0, charact. drawn reversed; impedance as Z+R}
  parGroupRow   = 71;        {for parameter group index}
  {for y-coordinate, not available for the user}
  fwIDyRow      = 72;        {row for saving y of forward ID}
  rvIDyRow      = 73;        {row for saving y of reverse ID}
  z6IDyRow      = 74;        {row for saving y of zone 6 ID}
  z5IDyRow      = 75;        {row for saving y of zone 5 ID}
  grThicknRow   = 76;        {row for thickness of ground circles}
  {rows in the Z-grids}
  Z1row         =  0;        {magnitude of impedance}
  F1row         =  1;        {phase of impedance}
  Z2row         =  2;        {magnitude of impedance}
  F2row         =  3;        {phase of impedance}
  Z3row         =  4;        {magnitude of impedance}
  F3row         =  5;        {phase of impedance}
  Z4row         =  6;        {magnitude of impedance}
  F4row         =  7;        {phase of impedance}
  Z5row         =  8;        {magnitude of impedance}
  F5row         =  9;        {phase of impedance}
  {others}
  xxc = 80;                  {size of the corner with symbols}
  TestPanelOldTop : integer = 408;
  phase_row     : integer = 0;  {selected row in PhaseGrid}
  ground_row    : integer = 0;  {selected row in GroundGrid}
{$R *.DFM}

function  GetDeltarow: integer;
begin
  GetDeltarow := deltarow;
end;

function GetBetarow: integer;
begin
  GetBetarow := betarow;
end;  

function PolyHiddenRow(irow : integer): boolean;
{checks is the given index a row of hidden parameters, not to be shown
 NOTE  index irow starts at zero}
var
  bpu : boolean;  {temporary}
begin
{ ForwardRow
 fwNameRow
 ReverseRow
rvNameRow
Zone6Row
z6NameRow
Zone5Row
z5NameRow
z5ThicknRow}
  bpu := (irow = fwNameRow)  or
         (irow = rvNameRow)  or
         (irow = ForwardRow) or
         (irow = ReverseRow) or
         (irow = Zone6Row)   or
         (irow = z6NameRow)  or
         (irow = Zone5Row)   or
         (irow = z5NameRow)  or
         (irow > z5ThicknRow);
  PolyHiddenRow := bpu;
end;

procedure TPolyRel.GetZrow(var Zrow,frow: integer);
begin
  Zrow := Zlinerow;
  frow := Filinerow;
end;

procedure TPolyRel.PrepareImpedanceGrid(pGrid: TpGrid; pPanel: TpPanel; row1: integer);
{prepare grid for entering impedances in polar form (magnitude and phase
 pGrid  pointer to the grid for impedance as magnitude and phase
 pPanel pointer to the panel, where grid is
 row1   row of resistance of first zone in main grid}
begin
  pGrid^.top := 1;
  pGrid^.left := 1;
  pGrid^.ColWidths[1] := 61;
  pGrid^.width := pGrid^.ColWidths[0]+pGrid^.ColWidths[1]+3;
  pGrid^.height := pGrid^.RowCount*(pGrid^.DefaultRowHeight+1)+1;
  pPanel^.width := pGrid^.width+2;
  pPanel^.height := pGrid^.height+2;
  pPanel^.top := PolyGrid.top+row1*(PolyGrid.DefaultRowHeight+1)-1;
  pPanel^.left := PolyGrid.left-1;
end;

procedure TPolyRel.FormCreate(Sender: TObject);
var
  ii    : integer;
  y0,y1 : integer;
begin
  Poly := TDist.create;              {object for diverse procedures}
  Poly.name_d := name{'Polyg.distance relay'}; {same name as the form, needed in in FromGridToParam}
  Poly.Initialize(@ApplyBut,@CancelBut, @HintBut, @OKBut, @PolyGrid,@PolyRel,
                  @PolyChar,@ImpedEdit,@TitleEdit,@WarnEdit,@FlagEdit,@Imagoo.PolyMemo,@CopyMemo,
                  @DummyImage,@IDImage,@MarkImage,
                  @ImagePanel,@ThicknessPanel,@ImpedLinePanel,@ThicknessImage,
                  @ImpedLineImg,@OrigImg,@ParamImg, @AutoManMenu);
  Poly.MorePointers(@InfoBut, @RelBut, @RelBut2, @RemoveBut,@CompBut, @ClearCompBut,
                    @HideBut, @RevBut, @ParamBut, @ZBut, @MultiRelBut, @ButtonBox, @ImpedMarkerItem,@NotesItem);
  Poly.More2Pointers(@RectGrid,@PolarGrid,@PhaseEdit,@GroundEdit,@HenryEdit,@PhaseLabel,@GroundLabel,
                     @RelayLabel, @TestPanel, @HenryPanel, @NoteBut);
  Poly.PutpOther(@Distance.Dist,@Distrel);     {pointer to the other distance relays}
  Poly.PutOldWidth(PolyRel.width);             {save original width}
  {parameter names}
  with PolyGrid do begin
    height := DefaultRowHeight*RowCount+GridLineWidth*(RowCount+3);
    width := ColCount*DefaultColWidth;
    cells[0, K0magnRow] := 'K0 magn';
    cells[0, K0angrow]  := 'K0 ang';
    cells[0, alpharow]  := 'alpha';
    cells[0, betarow]   := 'beta';
    cells[0, gammarow]  := 'gamma';
    cells[0, deltarow]  := 'delta';
    cells[0, RpRrow]    := 'R-/R+';
    cells[0, R1row]     := 'R1(21)';
    cells[0, X1row]     := 'X1(21)';
    cells[0, R2row]     := 'R2(21)';
    cells[0, X2row]     := 'X2(21)';
    cells[0, R3row]     := 'R3(21)';
    cells[0, X3row]     := 'X3(21)';
    cells[0, R4row]     := 'R4(21)';
    cells[0, X4row]     := 'X4(21)';
    cells[0, R5row]     := 'R5(21)';
    cells[0, X5row]     := 'X5(21)';
    cells[0, T1row]     := 'T1(21)';
    cells[0, T2row]     := 'T2(21)';
    cells[0, T3row]     := 'T3(21)';
    cells[0, T4row]     := 'T4(21)';
    cells[0, T5row]     := 'T5(21)';
    cells[0, R1Nrow]    := 'R1(21N)';
    cells[0, X1Nrow]    := 'X1(21N)';
    cells[0, R2Nrow]    := 'R2(21N)';
    cells[0, X2Nrow]    := 'X2(21N)';
    cells[0, R3Nrow]    := 'R3(21N)';
    cells[0, X3Nrow]    := 'X3(21N)';
    cells[0, R4Nrow]    := 'R4(21N)';
    cells[0, X4Nrow]    := 'X4(21N)';
    cells[0, R5Nrow]    := 'R5(21N)';
    cells[0, X5Nrow]    := 'X5(21N)';
    cells[0, T1Nrow]    := 'T1(21N)';
    cells[0, T2Nrow]    := 'T2(21N)';
    cells[0, T3Nrow]    := 'T3(21N)';
    cells[0, T4Nrow]    := 'T4(21N)';
    cells[0, T5Nrow]    := 'T5(21N)';
    cells[0, Zlinerow]  := '|Z line|';
    cells[0, Filinerow] := ' line';
    cells[0, phThicknRow] := ' thickness';
  end;
  {texts to the grids for impedance in polar form}
  with PhaseGrid do begin
    cells[0, 0]     := 'R1(21)';
    cells[0, 1]     := 'Z1(21)';
    cells[0, 2]     := 'R2(21)';
    cells[0, 3]     := 'Z2(21)';
    cells[0, 4]     := 'R3(21)';
    cells[0, 5]     := 'Z3(21)';
    cells[0, 6]     := 'R4(21)';
    cells[0, 7]     := 'Z4(21)';
    cells[0, 8]     := 'R5(21)';
    cells[0, 9]     := 'Z5(21)';
  end;
  with GroundGrid do begin
    cells[0, 0]     := 'R1(21N)';
    cells[0, 1]     := 'Z1(21N)';
    cells[0, 2]     := 'R2(21N)';
    cells[0, 3]     := 'Z2(21N)';
    cells[0, 4]     := 'R3(21N)';
    cells[0, 5]     := 'Z3(21N)';
    cells[0, 6]     := 'R4(21N)';
    cells[0, 7]     := 'Z4(21N)';
    cells[0, 8]     := 'R5(21N)';
    cells[0, 9]     := 'Z5(21N)';
  end;
  Poly.GridTotHeight := PolyGrid.height;
  Poly.CharNomTop := PolyChar.top;
  Poly.ButNomTop := OKBut.top;
  Poly.FormNomHeight := height; {onko oikein?}
  Poly.GridNomHeight := PolyGrid.DefaultRowHeight*nBasicPar+
                        PolyGrid.GridLineWidth*(nBasicPar+3);
  Poly.PutZrows(Zlinerow,Filinerow);
  Poly.PutImpedZoneRows(phThicknRow,grThicknRow); {rows for impedance zones}
  Poly.PutNameRows(fwNameRow,rvNameRow);          {rows for the names of the load zones}
  Poly.PutParGroupRow(parGroupRow);               {index for the parameter group}
  Poly.PutfwIDRows(forwardRow,fwIDyRow);          {rows for the coordinates of the ID}
  Poly.PutrvIDRows(reverseRow,rvIDyRow);
  Poly.PutLineRows(fwColorRow,rvColorRow,fwThicknRow,rvThicknRow);
  Poly.PutLoadZoneRows(fwMVARow,fwPosAngleRow,fwNegAngleRow,
                       rvMVARow,rvPosAngleRow,rvNegAngleRow);
  Poly.Putz6Rows(z6NameRow,z6TopRow,z6BotRow,z6RightRow,z6LeftRow,
                 z6ColorRow,z6ThicknRow,Zone6Row,z6IDyRow);
  Poly.Putz5Rows(z5NameRow,z5TopRow,z5BotRow,z5RightRow,z5LeftRow,
                 z5ColorRow,z5ThicknRow,Zone5Row,z5IDyRow);
  Poly.PutZRrows(R1row,R1Nrow);
  Poly.PutOptiRow(OptiRow);
  Poly.ParameterTexts;     {texts to the grid for the load zones and out of step zones}
  Poly.PutParGroupMenus(@GroupMenu,@IncMenu,@DecMenu);
  {initialize parameter values }
  for ii := 0 to PolyGrid.RowCount-1 do begin
    PolyGrid.cells[1,ii] := '0';
  end;
{  height := PolyGrid.height+height-ClientHeight+30;  {set form height}
  {set height of form}
  height := PolyGrid.DefaultRowHeight*nBasicPar+
            PolyGrid.GridLineWidth*(nBasicPar+3)+height-ClientHeight+46;
  {put the picture to the right of the parameters}
  PolyChar.left := PolyGrid.left+PolyGrid.width+8;
  {initially, no picture}
  PolyChar.picture := nil;
  PolyChar.width := 1;
  PolyChar.height := 1;
(*{buttons for the scale}  moved to FormPaint
  IncBut.left := PolyChar.left+8;
  DecBut.left := IncBut.left+IncBut.width;
  ResetBut.left := DecBut.left+DecBut.width;
  ImpedEdit.left := PolyChar.left;
*)
//NotesMemo.left := PolyChar.left;
//NotesMemo.height := 1;
  {initialize the marker image}
//  MarkImage.top := PolyGrid.top+6*PolyGrid.DefaultRowHeight+6*PolyGrid.GridLineWidth+1;
      {move the marker to the rows for ground relay}
  MarkImage.top := Poly.MarkImageTop(R1row,R1Nrow);
  MarkImage.height := 15*(PolyGrid.DefaultRowHeight+PolyGrid.GridLineWidth);
  MarkImage.left := PolyGrid.left+2*PolyGrid.DefaultColWidth;
  y0 := 0;
  y1 := PolyGrid.DefaultRowHeight+PolyGrid.GridLineWidth;
  MarkImage.canvas.pen.width := 1;
  for ii := 1 to 15 do begin
    {use zone colors for each row. Colors defined in Utildef.pas}
    if      (ii = 1) or (ii = 2) or (ii = 11) then MarkImage.canvas.pen.color := Zone1Color
    else if (ii = 3) or (ii = 4) or (ii = 12) then MarkImage.canvas.pen.color := Zone2Color
    else if (ii = 5) or (ii = 6) or (ii = 13) then MarkImage.canvas.pen.color := Zone3Color
    else if (ii = 7) or (ii = 8) or (ii = 14) then MarkImage.canvas.pen.color := Zone4Color
    else if (ii = 9) or (ii =10) or (ii = 15) then MarkImage.canvas.pen.color := Zone5Color;
    if (ii <= 10) then begin
      MarkImage.canvas.brush.color := MarkImage.canvas.pen.color;
      MarkImage.canvas.brush.style := bsSolid;
    end else begin
      MarkImage.canvas.brush.style := bsClear;
    end;
    MarkImage.canvas.rectangle(0,y0,MarkImage.width,y1);
    y0 := y1;
    y1 := y1+PolyGrid.DefaultRowHeight+PolyGrid.GridLineWidth;
  end;
  MarkImage.BringToFront;
  {pointers to form and components as integers}
  Poly.pointeg[1] := longint(@PolyRel);          {form}
  Poly.pointeg[2] := longint(@PolyRel.PolyGrid);  {parameter grid}
  Poly.pointeg[3] := longint(@PolyRel.PolyChar); {picture of characteristic}
  {initial directory for saving the graphics}
  if (SetComp.Poly_Dir <> '') then ExportDialog.InitialDir := SetComp.Poly_Dir;
  {initialize the edit for the title (or caption)}
  TitleEdit.top := PolyChar.top;
  TitleEdit.left := PolyChar.left+64;
  TitleEdit.tag := 0;       {distance from top of DistChar}
  TitleEdit.BringToFront;
  {initialize dummy image. needed for determining the size of the title}
  DummyImage.canvas.font.name := TitleEdit.font.name;
  DummyImage.canvas.font.size := TitleEdit.font.size;
  {prepare image for selecting the colors}
  {PQForm.}ColorInitialize(@ColorImage);
  {size and initial position of the color panel}
  HideColorBut.left := ColorImage.left+ColorImage.width+2;
  ImagePanel.width := ColorImage.width+2*CRspace+HideColorBut.width;
  ImagePanel.height := ColorImage.width+2*CRspace;
  ImagePanel.left := PolyGrid.left+PolyGrid.width;
  HenryPanel.left := PolyGrid.left+PolyGrid.width;
  {prepare image for selecting the line thicknesses}
  Poly.PrepareThicknessPanel;
  Poly.PrepareImpedLinePanel;          {for impedance lines}
  HideThBut.left := ImpedLineImg.left+ImpedLineImg.width+2;
  {add flag that form created}
  Imagoo.ReadyEdit.text := Imagoo.ReadyEdit.text+'P';
  {prepare images for showing endpoints of impedance lines, for drawing lines}
  Poly.InitImpedImages(@ImpedImg0,@ImpedImg1,@ImpedImg2,@ImpedImg3,@ImpedImg4,
                       @ImpedImg5,@ImpedImg6,@CancelRelayBut);
  {prepare images for showing endpoints of impedance lines, for drawing char.of relays}
  Poly.InitOhmImages(@OhmImg0,@OhmImg1,@OhmImg2,@OhmImg3,@OhmImg4,@OhmImg5,@OhmImg6);
  {texts to the grids for activation tests}
  Poly.InitTestGrids;
  {prepare grids for entering impedances in polar form (magnitude and phase}
  PrepareImpedanceGrid(@PhaseGrid, @PhasePanel, R1row);
  PrepareImpedanceGrid(@GroundGrid, @GroundPanel, R1Nrow);
  NoteBut.top := PolyChar.top+2;
  NoteBut.left := PolyChar.left;
end;

procedure TPolyRel.FormDestroy(Sender: TObject);
begin
  Poly.FreeCompList;
  Poly.free;
end;

procedure TPolyRel.FormHide(Sender: TObject);
{this is needed to unmark the relay, when the Distance Relay form is minimized
 but are there any side-effects?  Oct 1  2004}
var
  ipset : longint;   {pointer  to the common, as integer}
begin
  if (not {SetComp.}appl_close) and (not SetComp.shut_down) then begin
    if (Poly.GetActRel <> nil) then begin
      Poly.GetActRel.Getipset(ipset);            {pointer to the common, as iteger}
      unmark(ipset);
    end;
    {clear, hide the memo for the notes}
    Poly.pDistNotes^.clear;
    Poly.pDistNotes^.visible := false;
    CopyGroupForm.visible := false;   {hide, if it happens to be visible}
    CompBut.down := false;            {cannot add impedances to an unvisible graph}
    HenryPanel.visible := false;
  end;
end;

procedure TPolyRel.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  {eventual "delete component" must be handled here, because PolyRel form has focus}
  if (SetComp.pActComp <> nil) then begin     {some component active}
    if (key = 46) then begin                  {delete-key}
      SetComp.FormKeyDown(Key, Shift);        {delete the component}
    end;
  end;
end;

procedure TPolyRel.PolyGridSelectCell(Sender: TObject; Col, Row: Longint;
  var CanSelect: Boolean);
var
  options : TGridOptions;  {for temporary saving options}
begin
{mark (color) the selected cell, or not}
  if not (ColorItem.checked) then begin
    {send an "enter"-key press, to select the cell (remove the color)}
    keybd_event(VK_SHIFT, 0, 0, 0);
    keybd_event(13, 0, 0, 0);
    keybd_event(VK_SHIFT, 0, KEYEVENTF_KEYUP, 0);
  end;
  {no editing in local captions or color cells}
  Poly.SelectCell(col,row);
  options := PolyGrid.options;       {save, needed for restoring, below}
  {no editing of R or X, if grid for Z, R visible}
  if (row >= R1row) and (row <= X5row) and PhasePanel.visible then
    polyGrid.options := polyGrid.options-[goEditing,goAlwaysShowEditor]
  else
    PolyGrid.options := options;
//{disable temporarily the gamma row}
//if (row = gammarow) then
//  polyGrid.options := polyGrid.options-[goEditing,goAlwaysShowEditor];
end;

procedure PolygonRelayShow;
{show the relay char and values of impedances}
begin
  Poly.DrawRelays(Poly.pDistChar^.Canvas,'PolygonRelayShow' );
//DrawAllPolyChar(Poly.GetActRel,Poly.pDistChar^.Canvas,'PolygonRelayShow' );
end;

procedure TPolyRel.FormDeactivate(Sender: TObject);
begin
  if not NotesItem.checked then
    Poly.FormDeactivate(Sender);
end;

procedure TPolyRel.FormPaint(Sender: TObject);
begin
  Poly.PutpList(@RXLineForm.LineList);
  Poly.FormPaint;
  ResetBut.top := PolyChar.top+xxc{-12};  {under the explanations}
  DecBut.top := ResetBut.top;
  IncBut.top := ResetBut.top;
  IncBut.left := PolyChar.left+8;
  DecBut.left := IncBut.left+IncBut.width;
  ResetBut.left := DecBut.left+DecBut.width;
  ImpedEdit.left := PolyChar.left;
  TestPanel.top := TestPanelOldTop;
  CompBut.top := ResetBut.top+DecBut.height;
  CompBut.left := PolyChar.left+8;
  MultiRelBut.left := CompBut.left;
  MultiRelBut.top := CompBut.top+CompBut.height;
  ClearCompBut.top := CompBut.top;
  ClearCompBut.left := CompBut.left+CompBut.width;
  ParamBut.top := ClearCompBut.top+ClearCompBut.height;
  ParamBut.left := ClearCompBut.left;
  RevBut.top := CompBut.top;
  RevBut.left := ClearCompBut.left+ClearCompBut.width;
  ZBut.left := ParamBut.left+ParamBut.width;
  ZBut.top := ParamBut.top;
end;

procedure TPolyRel.FormResize(Sender: TObject);
begin
  if (not appl_close) then begin
    if (SetComp.appl_op = 6 ) or (SetComp.appl_op = 7 )
    or (SetComp.appl_op = 8 ) or (SetComp.appl_op = 11) then begin
//    Polyrel.ViewMenu.visible := true;
      Polyrel.MarkerMenu.visible := true;
//    Polyrel.notesmemo.visible := Polyrel.NotesItem.checked;
    end else begin
//    Polyrel.ViewMenu.visible := false;
      Polyrel.MarkerMenu.visible := false;
//    Polyrel.notesmemo.visible := false;
    end;
    Poly.FormResize;
    {buttons for adding/clearing impedance lines}
    if (PolyGrid.visible) then
      CompBut.left := PolyGrid.left+PolyGrid.width
    else CompBut.left := 0;
    ClearCompBut.left := CompBut.left;
    CompBut.visible := (width > PolyGrid.width+32) and (ShowItem.checked);
    ClearCompBut.visible := CompBut.visible;
    {show the notes in graph, if graph large}
    Poly.ShowNotesIf('resize');    
  end;
end;

procedure TPolyRel.OKButClick(Sender: TObject);
var
  ipSet : longint;
begin
  if (Poly.GetActRel <> nil) then
    Poly.GetActRel.var2_s := 1;     {flag for the button}
  FormDeactivate(sender);           {save the parameters, recalculate impedances, etc}
  ipSet := longint(@SetComp);
  unmark(ipSet);
  {if polygon-curves displayed in graph for Mho-char, update also Mho-graph}
  Distrel.FormDeactivate(sender);   {some condition needed ???}
  if (TestPanel.visible) then Poly.TestButClick;    
end;

procedure TPolyRel.CancelButClick(Sender: TObject);
var
  ipSet : longint;
begin
  if (Poly.GetActRel <> nil) then
    Poly.GetActRel.var2_s := 2;     {flag for the button}
  FormDeactivate(sender);           {discard changes, restore impedances etc.}
  ipSet := longint(@SetComp);
  unmark(ipSet);
  {if polygon-curves displayed in graph for Mho-char, update also Mho-graph}
  Distrel.FormDeactivate(sender);   {some condition needed ???}
  {cancel also any changes done in impedances as magnitude and phase}
  ToZRGrid('P');
  ToZRGrid('G');
end;

procedure TPolyRel.ApplyButClick(Sender: TObject);
begin
  if (Poly.GetActRel <> nil) then
    Poly.GetActRel.var2_s := 3; {flag for the button}
  FormDeactivate(sender);       {preliminaily save and show the effect of the changes}
  {if polygon-curves displayed in graph for Mho-char, update also Mho-graph}
  Distrel.FormDeactivate(sender);   {some condition needed ???}
  if (TestPanel.visible) then Poly.TestButClick;
end;

procedure TPolyRel.HintButClick(Sender: TObject);
var
  pHelp : TpMemo;     {poointer to the help-memo}
  pMod  : TpElComp;   {pointer to the model component}
begin
  if (Poly.GetActRel <> nil) then begin
    Poly.GetActRel.GetpMod(pMod);
    pMod^.GetpHelp(pHelp);
    if (pHelp <> nil) then begin
      pHelp.top := 200;
      pHelp.left := 100;
      pHelp.width := 480;
      pHelp.height := 550;
      pHelp.visible := true;
    end;
  end;
end;
(*
procedure TPolyRel.ToPolarGrid(GorP: string);
{copy and transform the impedances from the main grid to the polar grid
 GorP  'G' = ground impedances, to ground grid, 'P' = phase impedances to phase grid}
var
  Erow,Frow  : integer;  {endrow, first (start) row in the main grid}
  fii        : single;   {phase angle}
  ii,jj,kk   : integer;  {index}
  nz         : integer;  {number of impedances}
  pGrid      : TpGrid;   {pointer to the polar grid, phase or ground}
  Rr         : single;   {resistance}
  txt,txx    : string;   {temporary}
  Xx         : single;   {reactance}
  Zz         : single;   {impedance (magnitude)}
begin
  {select grid}  {so far only phase...}
  if (GorP = 'P') or (GorP = 'p') then begin
    pGrid := @PhaseGrid;
    {starting point depends on ground or phase grid}
    Frow := R1row;                          {start here..}
    Erow := X5row;                          {..end here}
  end else begin
    pGrid := @GroundGrid;                   {ground impedance}
    Frow := R1Nrow;
    Erow := X5Nrow;
  end;
  {read from main grid, transform, write to polar grid}
  nz := (Erow-Frow+1) div 2;                {number of impedances}
  for ii := 1 to nz do begin                {all impedances (phase or ground)}
    jj := Frow+2*(ii-1);                    {row of resistance in main grid}
    kk := 2*(ii-1);                         {row of Z in polar grid}
    {transform to polar form, in Lineparam.pas}
    RecToPolar(PolyGrid.cells[1,jj],PolyGrid.cells[1,jj+1],txt,txx,Rr,Xx,Zz,fii);
//    if (txt <> '?') and (txx <> '?') then begin
      pGrid^.cells[1,kk] := txt;           {impedance}
      pGrid^.cells[1,kk+1] := txx;         {phase}
//    end;
  end;
end;
*)
procedure RecToZR(textR, textX : string; var txtZ,txtR : string; var Rr,Xx,Zz: single);
{change complex number from rectangular (R,X) to magnitude and resistance (Z, R)
 textR  real part, as text
 textX  imag.part, as text
 txtZ   abs.value of the impedance, as text
 txtR   real part (resistance), same as textR, but checked
 Rr,Xx  real, imag. parts
 Zz     magnitude single}
var
  apu,apv,apw : single;  {temporary}
  err1,err2   : integer; {error flags}
  ipu         : integer; {temporary}
  s1,s2,s3,s4 : string;  {temporary}
  text        : string;  {temporary}
begin
  ValuesFromLine(textR, 1, false, ipu, Rr , apu, apv, apw, s1,s2,s3,s4, err1);
  ValuesFromLine(textX, 1, false, ipu, Xx , apu, apv, apw, s1,s2,s3,s4, err2);
  {copy resistance, if correct}
  if (err1 = 0) then begin
    txtR := textR;
  end else begin
    Rr := 1;                      {just some value}
    txtR := '?'
  end;
  {flag for X, if in error}
  if (err2 <> 0) then Xx := 0;
  {calculate impedance if R and X correct}
  if (err1 = 0) and (err2 = 0) then begin
    Zz := sqrt(Rr*Rr+Xx*Xx);
    text := ManyChars(Zz,true);   {numerical value to string}
    TxtZ := spaceless(text);     {remove spaces}
  end else begin
    TxtZ := '?';
    Zz := 1;      {just some values}
  end;
end;

procedure TPolyRel.LinePhaseAngle(var fii: single; var err: integer);
{get the phase angle (arc tan(X/R)) of the transmission line
 fii  the angle in radians
 err  error flag,  0 = no errors}
var
  apu        : single;   {temporary}
  kstrt,kend : integer;  {start, end indices}
  st1        : string;   {temporary}
  txt        : string;   {temporary}
begin
  {phase angle of the impedance line}
  txt := PolyGrid.cells[1,Filinerow];   {angle as text from the grid}
  kstrt := 1;
  NextValueFromLine(txt, kstrt, kend, apu, st1, err);  {phase of impedance, in routines.pas}
  if (err = 0) then fii := apu*pi/180
  else fii := 0.45*pi;                  {error case, just some value}
end;

procedure TPolyRel.AlphaAngle(var fii: single; var err: integer);
{get the phase angle (arc tan(X/R)) of the transmission line
 fii  the angle in radians
 err  error flag,  0 = no errors}
var
  apu        : single;   {temporary}
  kstrt,kend : integer;  {start, end indices}
  st1        : string;   {temporary}
  txt        : string;   {temporary}
begin
  {phase angle of the impedance line}
  txt := PolyGrid.cells[1,AlphaRow];    {angle as text from the grid}
  kstrt := 1;
  NextValueFromLine(txt, kstrt, kend, apu, st1, err);  {phase of impedance, in routines.pas}
  if (err = 0) then fii := apu*pi/180
  else fii := 0.45*pi;                  {error case, just some value}
end;

procedure TPolyRel.ToZRGrid(GorP: string);
{copy and transform the impedances as R,X from the main grid to the small grid as Z and R
 NOTE: R is copied as such, X = Z sin(fii), where fii is the phase angle of the line
       (NOT the impedance R+jX !)
 GorP  'G' = ground impedances, to ground grid, 'P' = phase impedances to phase grid}
var
  apu        : single;   {temporary}
  Erow,Frow  : integer;  {endrow, first (start) row in the main grid}
  err        : integer;  {error flag}
  fii        : single;   {phase angle of the impedance}
  ii,jj,kk   : integer;  {index}
  kstrt,kend : integer;  {start, end indices}
  nz         : integer;  {number of impedances}
  pGrid      : TpGrid;   {pointer to the polar grid, phase or ground}
  Rr         : single;   {resistance}
  st1        : string;   {temporary}
  txt,txx    : string;   {temporary}
  txz        : string;   {temporary}
  Xx         : single;   {reactance}
  Zz         : single;   {impedance (magnitude)}
begin
  {select grid}
  if (GorP = 'P') or (GorP = 'p') then begin
    pGrid := @PhaseGrid;
    {starting point depends on ground or phase grid}
    Frow := R1row;                          {start here..}
    Erow := X5row;                          {..end here}
  end else begin
    pGrid := @GroundGrid;                   {ground impedance}
    Frow := R1Nrow;
    Erow := X5Nrow;
  end;
  {phase angle of the impedance line}
//  txt := PolyGrid.cells[1,Filinerow];
//  kstrt := 1;
//  NextValueFromLine(txt, kstrt, kend, apu, st1, err);  {phase of impedance, in routines.pas}
  AlphaAngle(fii, err);                   {phase of impedance}
  if (err = 0) then begin
//  fii := apu*pi/180;                        {angle in degrees}
    {read from main grid, transform, write to ZR grid}
    nz := (Erow-Frow+1) div 2;                {number of impedances}
    for ii := 1 to nz do begin                {all impedances (phase or ground)}
      jj := Frow+2*(ii-1);                    {row of resistance in main grid}
//    kk := 2*(ii-1);                         {row of Z in polar grid}
      kk := 2*ii-1;                           {row of Z in R,Z grid}
      {reactance from the grid}
      txt := PolyGrid.cells[1,jj+1];
      kstrt := 1;
      NextValueFromLine(txt, kstrt, kend, Xx, st1, err);  {reactance, in routines.pas}
      {transform to Z and R form}
      if (err = 0) then begin
//    RecToZR(PolyGrid.cells[1,jj],PolyGrid.cells[1,jj+1], txt,txx, Rr,Xx,Zz);
      if (fii <> 0) then begin
        apu := Xx/sin(fii);
        txt := ManyChars(apu,true);          {in LineParam.pas}
        txx := spaceless(txt);               {remove spaces}
      end else begin
        txz := '0';
      end;
      {negative X is flagged with a negative Z}
//      if (Xx < 0) then txz := '-'+txx else txz := txx;
        txz := txx;
        pGrid^.cells[1,kk] := txz;                      {impedance}
        pGrid^.cells[1,kk-1] := PolyGrid.cells[1,jj];   {resistance copied as such}
      end else begin                         {some error in reading reactance}

      end;
    end;
  end else begin                           {some error in reading fii}

  end;
end;

function RoundToInt(apu: single): integer;
{change a floating (single) variable to integer of 16 bits (<= 32000)}
var
  ipu : integer;
begin
  if (abs(apu) < 32000) then begin
    ipu := round(apu);
  end else begin
    if (apu > 0) then ipu := 32000 else ipu := -32000;
  end;
  RoundToInt:= ipu;
end;

procedure DrawBetaLine(pComp: TpComp; tanb, tanc : single; toile: TCanvas);
{draw the oblique line across the image
 pComp pointer to relay whose beta line drawn
 tanb  tan of the angle (beta) of the line, NOTE beta > 0, slope is to the right
 tanc  tan(90-delta) = "beta" on the left side
 toile canvas, on which drawn}
var
  apu         : single;  {temporary}
  dx,dy       : integer; {char. moved by}
  dx1,dy1     : integer; {origo moved by}
  exname      : string;  {flag, which button/item clicked for metafile}
  ipu         : integer; {temporary}
  lx,ly,mx,my : integer; {coordinates of the endpoints of the line}
  ox,oy       : integer; {origo}
  pGraph      : TpImage; {pointer to the image}
  zx,zy       : integer; {char.moved by, "local origo"}
begin
  {if drawing on "own" graph (polygonal) use own origo, if drawing on the
   other graph (Mho), then use the other origo}
   if (toile = Poly.pDistChar.canvas) then begin
     Poly.GetOrig(ox,oy);
   end else if (toile = Dist.pDistChar^.canvas) then begin
     Dist.GetOrig(ox,oy);
   end else begin         {neither, drawing on metafile}
     Dist.GetExportName(exname);             {flag for metafile: poly or dist}
     if (exname = 'dist') then begin         {drawing circular char in metafile}
       Dist.GetOrig(ox,oy);
     end else begin
       Poly.GetOrig(ox,oy);
     end;
   end;
  {if drawing on "own" graph (polygonal) use own shift of origo, if drawing on the
   other graph (Mho), then use the other delta origo}
  GraphShifts(toile, dx1,dy1,zx,zy, pGraph);           {in distance.pas}
  {at the end of an impedance line}
  dx := dx1+zx;
  dy := dy1-zy;
  {start drawing}
  if (tanc >= 0) then begin                  {beta line pointing to upper left}
    apu := (pGraph^.width/2+dx)*tanc{tanb};
    mx := 0;
    ipu := RoundToInt(apu);
    my := (pGraph^.height div 2)-ipu
  end else begin
    if ( not(Poly.NegativeDelta(pComp))) then begin  {beta line pointing to lower left}
      apu := (pGraph^.width/2+dx)*tanc{tanb};
      mx := 0;
      ipu := RoundToInt(apu);
      my := (pGraph^.height div 2)-ipu
    end else begin                              {beta line pointing to upper right}
      mx := pGraph^.width;
      apu := (pGraph^.width/2-dx)*tanc;
      ipu := RoundToInt(apu);
      my := (pGraph^.height div 2)+ipu;
    end;
  end;
  lx := pGraph^.width;
  apu := (pGraph^.width/2-dx)*tanb;
  ipu := RoundToInt(apu);
  ly := (pGraph^.height div 2)+ipu;
  toile.pen.color := clBlack;
  toile.pen.width := 1;
  toile.pen.style := psSolid;
  toile.moveto(mx,my+dy);    {move to left border}
  toile.lineto(ox+zx,oy-zy); {line to (local) origo}
  toile.lineto(lx,ly+dy);    {draw to right border}
end;

procedure DrawPolyChar(scale,x1,y1,x2,y2,x3,y3,x4,y4 : single; ZoneColor: TColor;
                       thc : integer; toile: TCanvas);
{draw one polygonal characteristic
 scale       the scaling factor
 x1,y1 etc.  the corners, as impedances
 ZoneColor   the color of the polygon
 thc         line size, if 0 => dotted
 toile       canvas on which drawn}
var
  apu,apv : single;   {temporary}
  dx,dy   : integer;  {char. moved}
  dx1,dy1 : integer;  {origo moved}
  iwidth  : integer;  {width of the image}
  lx,ly   : integer;  {coordinates}
  mx,my   : integer;  {coordinates}
  ox,oy   : integer;  {origo}
  pRchar  : TpImage; {the relay graph (image)}
  zx,zy   : integer;  {"local origo"}
begin
  {if drawing on "own" graph (polygonal) use own shift of origo, if drawing on the
   other graph (Mho), then use the other delta origo}
  GraphShifts(toile, dx1,dy1,zx,zy, pRchar);         {in distance.pas}
  iwidth := pRchar^.width;
(*
  if (toile = Poly.pDistChar^.canvas) then begin
    Poly.DeltaOrigo(dx1,dy1);
    Poly.CharMovedBy(Poly.RelayDrawIndex, zx,zy);
    iwidth := PolyRel.PolyChar.width;
  end else begin
    Dist.DeltaOrigo(dx1,dy1);
    {find starting point ("local origo"), at the end of some impedance}
    Dist.CharMovedBy(Dist.RelayDrawIndex, zx,zy);
    iwidth := DistRel.DistChar.width;
  end;
*)
  {at the end of an impedance line}
  dx := dx1+zx;
  dy := dy1-zy;
  {line type, dotted or continuous}
  if (thc = 0) then begin
    toile.pen.width := 1;
    toile.pen.style := psDot;  {dotted line}
  end else begin
    toile.pen.width := thc;
    toile.pen.style := psSolid;
  end;
  toile.pen.color := ZoneColor;
  toile.Brush.style := bsClear;
  {midpoint of the image = origo}
  ox := ({PolyRel.PolyChar.}iwidth div 2);
  oy := ox;
  {starting point of first line}
  apu := {PolyRel.PolyChar.}iwidth*x4/(2*scale);
  apv := {PolyRel.PolyChar.}iwidth*y4/(2*scale);
  mx := ox+RoundToInt(apu);                  {starting point}
  my := oy-RoundToInt(apv);
  apu := {PolyRel.PolyChar.}iwidth*x1/(2*scale);
  apv := {PolyRel.PolyChar.}iwidth*y1/(2*scale);
  lx := ox+roundToInt(apu);                  {end point}
  ly := oy-roundToInt(apv);
  {draw first line}
  toile.moveto(mx+dx,my+dy);
  toile.lineto(lx+dx,ly+dy);
  {second line}
  apu := {PolyRel.PolyChar.}iwidth*x2/(2*scale);
  apv := {PolyRel.PolyChar.}iwidth*y2/(2*scale);
  lx := ox+roundToInt(apu);                  {end point}
  ly := oy-roundToInt(apv);
  toile.lineto(lx+dx,ly+dy);
  {third line}
  apu := {PolyRel.PolyChar.}iwidth*x3/(2*scale);
  apv := {PolyRel.PolyChar.}iwidth*y3/(2*scale);
  lx := ox+roundToInt(apu);                  {end point}
  ly := oy-roundToInt(apv);
  toile.lineto(lx+dx,ly+dy);
end;

procedure corners(pComp: TpComp; RR,XX,tana,tanb,tang,tanc,flineD,Zline,RpR: single;
                   var x1,y1,x2,y2,x3,y3,x4,y4: single; var eq14,eq23: boolean);
{find the corners of the polygonal (quadrilateral) char. The corners are:
 1 = top right, 2 = top left, 3 = bottom left, 4 = bottom right, when XX > 0
 (and mirrored when XX < 0)
 pComp  pointer to the relay
 RR,XX  resistance, reactance
 tana,tanb,tang,tandc  tan(alpha), tan(beta), tan(gamma), tan(90-delta) when
   alpha is the angle of the sides, i.e. the (almost) vertical line
   beta is the angle of the bottom = the line through origo, positive clockwise!
   gam  is the angle of the top line = the (almost) horizontal line
   delta is the angle between the vertical (reactance) axis, and the bottom line
            of the left part of the polygonal
 (top and bottom, when XX > 0)
 flineD   phase angle of the transmission line, in degrees
 Zline    impedance of the transmission line
 RpR      R-/R+ = ratio of left resistance and right resistance
 x1,y1,.. the coordinates of the corners, in terms of resistance and reactance
 eq14     true, when corners 1 and 4 are equal
 eq23     true, when corners 2 and 3 are equal}
var
  apu      : single;  {temporary}
  cRpR     : single;  {checked ratio of left and right resistances}
  dx,dy    : single;  {shift of corner 1, when top line is tilted}
  eq12     : boolean; {corners 1 and 2 are the same}
  fline    : single;  {phase angle of transmission line, in rad}
  tanch    : single;  {checked tanc = tan(90-delta)}
  tanf     : single;  {tan(fline)}
  xh1,yh1  : single;  {preliminary first corner, when gamma = 0}
  xh2,yh2  : single;  {preliminary second corner, when gamma = 0}
  xl,yl    : single;  {coordinates of the point, where the line impedance intersects..}
  {}                  {..the reactance line}
  xt1,yt1  : single;  {coordinates, when top (bottom) line tilted = gamma <> 0}
  xt2,yt2  : single;  {coordinates, when top (bottom) line tilted = gamma <> 0}
begin
  fline := flineD*pi/180;
  {if line impedance (actually the angle) not defined, use alpha (midpoint of the line 1-2)}
  if (fline > 0) then tanf := tan(fline)
  else tanf := tana;
  if (RpR > 0) then cRpR := RpR else cRpR := 1;         {checked ratio of resistances}
  {first (right) corner - - - - - - - - - - - - - - - }
  if (RR > 0) then begin
    {calculate first, as if top (bottom) line horizontal = gamma = 0}
    xh1 := XX/tana+RR;                    {first corner}
    yh1 := XX;
    {if gamma <>0 = top (or bottom) line tilted, intersection is moved}
    {is the top (or bottom) line tilted?, can it be}
    if (tanf > 0) {(fline > 0) and (Zline > 0)} then  begin
      {intersection of the line impedance and the reactance}
      if (flineD <> 90) then xl := XX/tanf else xl := 0;
      {calculate how much the corner moves, when the line is tilted}
      if (tana <> tang) then begin
        dx := (xh1-xl)*tang/(tana-tang);
        dy := dx*tana;
      end else begin   {equal angles , corner moves to infinity}
        dx := 1e5;
        dy := dx*tana
      end;
    end else begin     {horizontal line, use the calculated values as such}
      dx := 0;
      dy := 0;
      xl := 0;
    end;
    {new position of the corner}
    xt1 := xh1+dx;
    yt1 := yh1+dy;
    {second corner - - - - - - - - - - - - - - -}
    xh2 := XX/tana-RR*cRpR;
    yh2 := XX;
    {if top line tilted, corner moves}
    if (tanf > 0) {(fline > 0) and (Zline > 0)} then  begin
      if (xh1 <> xl) then apu := (xl-xh2)/(xh1-xl) else apu := 0;
    end else begin
      apu := 0;
    end;
    xt2 := xh2-dx*apu;
    yt2 := yh2-dy*apu;
    {Check: must not be on the wrong side of the oblique line, determined by beta}
    {first (right) corner }
    if (xt1 > 0) then begin                            {cannot be on wrong side, if < 0, unless..}
      if (not Poly.NegativeDelta(pComp)) then begin
        if ((yt1/xt1 >= -tanb) and (XX < 0)) or          {wrong side of then line..}
           ((yt1/xt1 <= -tanb) and (XX > 0)) then  begin {..note: tanb > 0, by definition)}
          {must calculate intersection with beta-line}
          apu := tanb+tang;
          if (apu <> 0) then begin
            x1 := (xt2*tang-yt2)/apu;
            y1 := -x1*tanb;
          end else begin                 {error case...}
            x1 := 1000;
            y1 := -x1*tanb;
          end;
          eq14 := true;
        end else begin
          x1 := xt1;
          y1 := yt1;
          eq14 := false;
        end;
        eq12 := false;
      end else begin               {corners 1 and 2 may be the same, if negative delta}
        {corners 1 and 4 may be the same, if beta < 0, and..}
        if (xt1 > 0) then begin
          {beta < 0, and to the left of corner 1}
          if (yt1/xt1 < -tanb) and (tanb < 0) then begin
            apu := tanb+tang;
            if (apu <> 0) then begin
              x1 := (xt2*tang-yt2)/apu;
              y1 := -x1*tanb;
            end else begin                 {error case...}
              x1 := 1000;
              y1 := -x1*tanb;
            end;
            eq14 := true;
          end else begin
            eq14 := false;
          end;
        end else begin             {1 and 4 cannot be the same, if x1 < 0, I think..}
          eq14 := false;
          {x1 and y1 below, after checking corners 1 and 2}
        end;
        {check corners 1 and 2}
        if ((yt1/xt1 >= -tanc) and (XX > 0)) {or
           ((yt1/xt1 <= -tanc) and (XX < 0))} then begin
          apu := tana+tanc;
          if (apu <> 0) then begin
            x1 := RR*tana/apu;
            y1 := -x1*tanc;
          end else begin
            x1 := 1000;
            y1 := -x1*tanc;
          end;
          eq12 := true;
        end else begin
//        x1 := xt1;
//        y1 := yt1;
          eq12 := false;
        end;
//      eq14 := false;
        if (not eq14) and (not eq12) then begin
          x1 := xt1;
          y1 := yt1;
        end;
      end;
    end else if (xt1 < 0) then begin       {may be on the wrong side, if X < 0}
      if (XX < 0) and (Poly.BluntDelta(pComp)) then begin
        if (yt1 < 0) and (yt1/xt1 < -tanc) then begin
{check!!}
          apu := tana+tanc;
          if (apu <> 0) then begin
            x1 := RR*tana/apu;
            y1 := -x1*tanc;
          end else begin
            x1 := -1000;
            y1 := -x1*tanc;
          end;
          eq12 := true;
        end else begin
          x1 := xt1;
          y1 := yt1;
          eq12 := false;
        end;
      end else begin
        x1 := xt1;
        y1 := yt1;
        eq12 := false;
      end;
      eq14 := false;
    end else begin                 {zero x (and y?), not reasonable}
      x1 := xt1;
      y1 := yt1;
      eq14 := false;
      eq12 := false;
    end;
    {second (left) corner }
//  if {(xt2 < 0)}(true) then begin
    if (not eq12) and (xt2 < 0) then begin                      {corners 1 and 2 not the same}
      if (not Poly.BluntDelta(pComp)) then begin                {only possible if delta < 90}
        if ((yt2/xt2 >= -tanc{-tanb}) and (XX > 0)) or          {wrong side of then line..}
           ((tanc < 0) and (XX > 0)) or
           {(Poly.NegativeDelta(pComp)) or} {??}
           ((yt2/xt2 <= -tanc{-tanb}) and (XX < 0) and (not Poly.NegativeDelta(pComp))) then  begin {..note: tanb > 0, by definition)}
          {must calculate intersection with beta-line}
          apu := {tanb}tanc+tang;
          if (apu <> 0) then begin
            x2 := (xt1*tang-yt1)/apu;
            y2 := -x2*tanc{tanb};
          end else begin                 {error case...}
            x2 := -1000;
            y2 := -x2*tanc{tanb};
          end;
          eq23 := true;
        end else begin
          if (Poly.NegativeDelta(pComp)) and (XX < 0) then begin
            x2 := xt2;      {check...}
            y2 := yt2;
            eq23 := false;
          end else begin
            x2 := xt2;
            y2 := yt2;
            eq23 := false;
          end;
        end;
      end else begin                 {delta > 90 degrees, 2 and 3 can be the same, if X < 0}
        if (XX < 0) then begin
          if (yt2/xt2 < -tanc) then begin
            apu := tanc+tang;
            if (apu <> 0) then begin
              x2 := (xt1*tang-yt1)/apu;
              y2 := -x2*tanc;
            end else begin                 {error case...}
              x2 := -1000;
              y2 := -x2*tanc;
            end;
            eq23 := true;
          end else begin
            x2 := xt2;
            y2 := yt2;
            eq23 := false;
          end;
        end else begin
          x2 := xt2;
          y2 := yt2;
          eq23 := false; {or true?}
        end;
      end;
    end else begin  {either corner 1 = corner 2, or x-coord of corner 2 > 0}
      if (eq12) then begin            {corners 1 and 2 are the same (negative delta, etc)}
        x2 := x1;
        y2 := y1;
        eq23 := true;
      end else begin    {positive x, corners 2 and 3 cannot be the same}
        x2 := xt2;
        y2 := yt2;
        eq23 := false;
      end;
    end;
    {third corner - - - - - - - - - - - - - -}
    if (not eq23) then begin
      if (XX < 0) and (Poly.NegativeDelta(pComp)) then begin  {rather special case ?}
        {the sides of the polygon and delta-line do not intersect}
//      if (tana >= -tanc) then begin
        if ((tana >= 0) and (tana >= -tanc)) or
           ((tana <  0) and (tana <= -tanc)) then begin

          if (tana > 0) then x3 := x2+10 else x3 := x2-10;
          y3 := (x3+cRpR*RR)*tana;
//eq34?
        end else begin
          apu := tana+tanc;
//          if (apu <> 0) then begin
          if (apu < -0.01) or (apu > 0.01) then begin
            x3 := -cRpR*RR*tana/apu;
            y3 := -x3*tanc;
          end else begin
            if (tana > 0) then x3 := x2+10 else x3 := x2-10;
            y3 := (x3+cRpR*RR)*tana;
          end;
//eq34?
        end;
      end else begin
        if (XX > 0) then begin
          if (tana+tanc <> 0) then begin
            x3 := -RR*cRpR*tana/(tana+tanc);
            y3 := -x3*tanc;
          end else begin
            x3 := x2-10;                            {third corner}
            y3 := (x3+cRpR*RR)*tana;
          end;
        end else begin    {?}
          if (tana < 0) and (tana > -tanc) then begin  {no intersection}
            x3 := x2-10;
            y3 := (x3+cRpR*RR)*tana;
          end else begin                          {left side intersects delta-line}
            if (tana+tanc < -0.01) or (tana+tanc > 0.01) then
              x3 := -RR*cRpR*tana/(tana+tanc)
            else
              x3 := x2-10;
//            y3 := -x3*tanc;
            y3 := (x3+cRpR*RR)*tana;
          end;
        end;
      end;
    end else begin                              {only the part above the line drawn}
      x3 := x2;
      y3 := y2;
    end;
    {fourth corner - - - - - - - - - - -}
    if (not eq14) then begin                    {not same points = not on the wrong side}
      {no solution, if alpha-90 > 90-beta}
      if (tana < 0) and (-tana <= tanb) then begin
        x4 := x1+10;
        y4 := (x4-RR)*tana;
      end else begin                            {solution exists}
//      if (tana+tanb <> 0) then
        if (tana+tanb < -0.01) or (tana+tanb > 0.01) then begin
          x4 :=  RR*tana/(tana+tanb);
          y4 := -x4*tanb;
        end else begin
          x4 := x1+10;
          y4 := (x4-RR)*tana;
        end;
      end;
    end else begin
      x4 := x1;
      y4 := y1;
    end;
  end else begin
    x1 := 0;
    y1 := 0;
    x2 := 0;
    y2 := 0;
    x3 := 0;
    y3 := 0;
    x4 := 0;
    y4 := 0;
  end;
//showmessage(floattostr(x1)+'  '+floattostr(y1)+'  '+floattostr(x2)+'  '+floattostr(y2)+'  '+
//            floattostr(x3)+'  '+floattostr(y3)+'  '+floattostr(x4)+'  '+floattostr(y4));
end;

procedure GetDrawParam(pComp: TpComp; var tana,tanb,tang,tanc,RpR: single; var ground: boolean;
                                      var RR,XX : array of single; var err : integer);
{get the parameters needed for drawing the characteristics
 pComp     pointer to the relay
 tana,tanb,tang,tanc  tan of the angles alpha, beta, gamma,90-delta  (defined in corners(.))
 RpR       ratio of left and right resistance
 ground    true, if ground distance relay
 RR   intersection on resistance-axis (array 1..4, for the four zones)
 XX   intersection on reactance-axis
 err  error flag}
var
  AltState    : boolean;   {true, if the alt-key has been pressed}
  alpha,beta  : single;    {angles of the sides and the bottom of the polygon, in radians}
  alphD,betD  : single;    {angles of the sides and the bottom of the polygon, in degrees}
  apu         : single;    {temporary}
  deltD       : single;    {angle of the left bottom with vertical axis}
  ea,eb,eg,ed : integer;   {error flags}
  flineD      : single;    {angle of line impedance, in degrees}
  fline       : single;    {angle of the line-impedance, in radians}
  gamD        : single;    {angle of topmost line, in degrees}
  gamma       : single;    {angle of the topmost line, in radians}
  ipSet       : longint;   {pointer to the "common" as integer}
  pSet        : TpCompSet; {pointer to the "common"}

begin
  pComp^.GetipSet(ipSet);         {get pointer to the set, as integer}
  pSet := TpCompSet(ipSet);       {pointer to the set, from integer}
  AltState := pComp^.GetAltState; {true, if alt-key pressed}
  pComp^.GetPar(alpharow+1{3},alphD);         {in degrees}
  pComp^.GetPar(betarow+1{4},betD);
  pComp^.GetPar(gammarow+1{5},gamD);
  pComp^.GetPar(deltarow+1,deltD);
  pComp^.GetPar(RpRrow+1{5},RpR);
  {check angle alpha, set error flag if not correct}
  if (alphD <= 10) then begin
    alpha := 10*pi/180;
    ea := 1;
  end else if (alphD < 170) then begin
    alpha := alphD*pi/180;
    ea := 0;
  end else begin
    alpha := 170*pi/180;
    ea := 1;
  end;
  tana := tan(alpha);
  {check angle beta, set error flag if not correct}
  if (betD <= -90) then begin
    beta := -80*pi/180;
    eb := 1;
  end else if (betD < 90) then begin
    beta := betD*pi/180;
    eb := 0;
  end else begin
    beta := 80*pi/180;
    eb := 1;
  end;
  tanb := tan(beta);
  {check angle gamma, set error flag if not correct}
  if (gamD < -80) then begin
    gamma := -80*pi/180;
    eg := 1;
  end else if (gamD <= 60) then begin
    gamma := gamD*pi/180;
    eg := 0;
  end else begin
    gamma := 60*pi/180;
    eg := 1;
  end;
  tang := tan(gamma);
  {instead of angle delta, use 90-delta, delta < 0 not accepted, use beta (must change!)}
  if (deltD = 0) then begin
//  tanc := 1e5;
    tanc:= tanb;            {zero is a special case}
    ed := 0;
  end else begin
    if (deltD < {0}-10) then begin
      apu := 100*pi/180;
      ed := 1;
    end else if (deltD <= 100) then begin
      apu := (90-deltD)*pi/180;
      ed := 0;
    end else begin
      apu := -10*pi/180;
      ed := 1;
    end;
    tanc := tan(apu);                {tan(90-delta)}
  end;
  err := ea+2*eb+4*eg+8*ed;          {coded error flag}
  {normally, show the impedance and char according to the fault type, but
  if alt-key is pressed, show the other way around}
  {ground distance relay}
  if ((Imagoo.DistRelBut.caption = gAuto  {'auto' })and((pSet^.Grnd_dist)and(not AltState))) or
     ((Imagoo.DistRelBut.caption = gAuto  {'auto' })and((not pSet^.Grnd_dist)and(AltState))) or
     ((Imagoo.DistRelBut.caption = gGround{'grnd' })and(not AltState)) or
     ((Imagoo.DistRelBut.caption = gPhase {'phase'})and(    AltState)) then begin
    pComp^.GetPar(R1Nrow+1,RR[0]);
    pComp^.GetPar(X1Nrow+1,XX[0]);
    pComp^.GetPar(R2Nrow+1,RR[1]);
    pComp^.GetPar(X2Nrow+1,XX[1]);
    pComp^.GetPar(R3Nrow+1,RR[2]);
    pComp^.GetPar(X3Nrow+1,XX[2]);
    pComp^.GetPar(R4Nrow+1,RR[3]);
    pComp^.GetPar(X4Nrow+1,XX[3]);
    pComp^.GetPar(R5Nrow+1    ,RR[4]);
    pComp^.GetPar(X5Nrow+1    ,XX[4]);
    ground := true;
  end else begin                    {some other fault}
    pComp^.GetPar(R1row+1,RR[0]);
    pComp^.GetPar(X1row+1,XX[0]);
    pComp^.GetPar(R2row+1,RR[1]);
    pComp^.GetPar(X2row+1,XX[1]);
    pComp^.GetPar(R3row+1,RR[2]);
    pComp^.GetPar(X3row+1,XX[2]);
    pComp^.GetPar(R4row+1,RR[3]);
    pComp^.GetPar(X4row+1,XX[3]);
    pComp^.GetPar(R5row+1,RR[4]);
    pComp^.GetPar(X5row+1,XX[4]);
    ground := false;
  end;
end;

procedure CornersOfAll(pComp: TpComp; RR,XX : array of single; tana,tanb,tang,tanc,flineD,Zline,RpR : single;
                     var x1,y1,x2,y2,x3,y3,x4,y4: array of single; from: string);
{find the corners of all (0..4) polygonal (quadrilateral) characters The corners are:
 1 = top right, 2 = top left, 3 = bottom left, 4 = bottom right, when XX > 0
 (and mirrored when XX < 0)
 pComp  pointer to the relay
 RR,XX  resistance, reactance
 tana,tanb,tang,tanc  tan(alpha), tan(beta), tan(gamma), tan(90-delta) when
   alpha is the angle of the sides, i.e. the (almost) vertical line
   beta is the angle of the bottom = the line through origo, positive clockwise!
   gam  is the angle of the top line = the (almost) horizontal line
   delta is the angle between the vertical axis and the left bottom
 (top and bottom, when XX > 0)
 flineD   phase angle of the transmission line, in degrees
 Zline    impedance of the transmission line
 RpR      ratio of left resistance / right resistance
 x1,y1,.. the coordinates of the corners, in terms of resistance and reactance
 from     calling routine}
var
 eq14 : boolean;   {true, when corners 1 and 4 are equal}
 eq23 : boolean;   {true, when corners 2 and 3 are equal}
 ii   : integer;   {index}
begin
//showmessage(from);
  for ii := 0 to 4 do begin                         {all five polygons}
    {positions of the corners}
    corners(pComp, RR[ii],XX[ii],tana,tanb,tang,tanc,flineD,Zline,RpR,
      x1[ii],y1[ii],x2[ii],y2[ii],x3[ii],y3[ii],x4[ii],y4[ii], eq14,eq23);
  end;
end;

procedure FindMaxImpedances(x1,y1,x2,y2,x3,y3,x4,y4: array of single;
                            var zm: array of single);
{find the maximum impedance sqrt(R*R+X*X) of the corners of the polygon,
 for each of the four polygons of a relay
 x1,y1,...  the resistance, reactance of the corners
 zm         the max impedance}
var
  ii : integer;   {index of the polygons of a relay}
  z1,z2,z3,z4 : array[0..4] of single;  {impedances of the corners}
begin
  {find max.impedance}
  for ii := 0 to 4 do begin
    {impedances of the corners}
    z1[ii] := sqrt(x1[ii]*x1[ii]+y1[ii]*y1[ii]);  {impedance of the 1st corner}
    z2[ii] := sqrt(x2[ii]*x2[ii]+y2[ii]*y2[ii]);  {impedance of the 2nd corner}
    z3[ii] := sqrt(x3[ii]*x3[ii]+y3[ii]*y3[ii]);  {impedance of the 3rd corner}
    z4[ii] := sqrt(x4[ii]*x4[ii]+y4[ii]*y4[ii]);  {impedance of the 4th corner}
    {find max impedance}
    zm[ii] := 0;
    if (z1[ii] > zm[ii]) then zm[ii] := z1[ii];
    if (z2[ii] > zm[ii]) then zm[ii] := z2[ii];
    if (z3[ii] > zm[ii]) then zm[ii] := z3[ii];
    if (z4[ii] > zm[ii]) then zm[ii] := z4[ii];
  end;
end;


procedure DrawThePolyChar(pComp: TpComp; toile: TCanvas; tanb, tanc : single;
                          x1,y1,x2,y2,x3,y3,x4,y4: array of single);
{carry out the actual drawing of the char. of one polygonal distance relay
 pComp   pointer to the relay
 toile   canvas on which drawn
 tanb    tan of beta = the angle of the (long) line through origo
 tanc    tan(90-delta) = tan("beta" of left side)
 x1,y1.. coordinates of the corners (array = all four polygons of one relay)
 }
var
  exname    : string;  {flag, which button/item clicked for metafile}
  ii        : integer;
  scale     : single;                   {scale of the graph = max.value on the axes}
  thc       : array[0..5] of integer;   {line thickness (size)}
  Zcol      : array[0..4] of TColor;    {colors of the characteristics}
  zm        : array[0..4] of single;    {max.impedance of the corners}
begin
//scale := Poly.scale;   {BUT... if in the graph of Mho-relay ???}
  {if drawing on "own" graph (polygonal) use own scale, but if drawing on the
   other graph (Mho), then use the other scale}
  FindScale(toile, scale);
  {draw characteristics. Colors defined in Utildef.pas}
  Zcol[0] := Zone1Color; Zcol[1] := Zone2Color;   {copy colors to an array}
  Zcol[2] := Zone3Color; Zcol[3] := Zone4Color;
  Zcol[4] := Zone5Color;
  Poly.GetAndDecodeThickness(pComp,thc[0],thc[1],thc[2],thc[3],thc[4],thc[5]); {get line size (thickness)}
  {find max. impedance of the corners, for checking the parameters}
  FindMaxImpedances(x1,y1,x2,y2,x3,y3,x4,y4,zm);
  {draw the polygons}
  for ii := 0 to 4 do begin
    {draw only if allowed}
    if ((ii = 0) and (PolyRel.Zone1Item.checked)) or
       ((ii = 1) and (PolyRel.Zone2Item.checked)) or
       ((ii = 2) and (PolyRel.Zone3Item.checked)) or
       ((ii = 3) and (PolyRel.Zone4Item.checked)) or
       ((ii = 4) and (PolyRel.Zone5Item.checked)) then begin
      if (zm[ii] > 0) then  {polygon defined = parameters reasonable}
        DrawPolyChar(scale,x1[ii],y1[ii],x2[ii],y2[ii],
                           x3[ii],y3[ii],x4[ii],y4[ii],ZCol[ii],thc[ii],toile);
    end;
  end;
  DrawBetaLine(pComp,tanb,tanc,toile);     {draw the oblique line across the image}
end;

procedure DrawOnePolyChar(pComp: TpComp; toile: TCanvas);
{draw the char. of one polygonal relay
 pComp  pointer to the relay
 toile  canvas on which drawn}
var
  err         : integer;   {error flag}
  flineD      : single;    {angle of line impedance, in degrees}
  ground      : boolean;   {true, if ground distance relay}
  ii          : integer;
  RpR         : single;    {ratio of left and right resistance}
  tana,tanb   : single;    {tan(alpha), tan(beta)}
  tanc        : single;    {tan(90-delta)}
  tang        : single;    {tan(gamma)}
  Zline       : single;    {impedance of the line}
  RR          : array[1..5] of single;    {intersection at R-axis (resistance-axis)}
  XX          : array[1..5] of single;    {intersection of X-axis (reactance-axis)}
  x1,x2,x3,x4 : array[1..5] of single;    {x-coordinate of the corners}
  y1,y2,y3,y4 : array[1..5] of single;    {y-coordinate of the corners}
begin
  {get the parameters needed for drawing the characteristics}
  pComp^.GetPar(Zlinerow+1{30},Zline);                {line impedance}
  pComp^.GetPar(Filinerow+1{31},flineD);              {(phase) angle of line impedance}
  GetDrawParam(pComp, tana,tanb,tang,tanc, RpR, ground, RR,XX, err);
  {upside-down?}
  if (Poly.IsReverse(pComp)) then begin
    for ii := 1 to 5 do XX[ii] := -XX[ii];
  end;
  {find the corners of all polygons}
  CornersOfAll(pComp,RR,XX,tana,tanb,tang,tanc,flineD,Zline,RpR,x1,y1,x2,y2,x3,y3,x4,y4,'dopc');
  {draw characteristics. Colors defined in Utildef.pas}
  DrawThePolyChar(pComp,toile, tanb, tanc, x1,y1,x2,y2,x3,y3,x4,y4);
end;

procedure DrawAllPolyChar(pComp : TpComp; toile: TCanvas; called: string);
{draw the four polygonal-characteristics of a distance relay
 pComp  pointer to the distance relay}
const
  scale : single = 10;     {scale of the graph = max.value on the axes}
  zmax  : single = 1.;
var
  AltState    : boolean;   {true, if the alt-key has been pressed}
  alpha,beta  : single;    {angles of the sides and the bottom of the polygon, in radians}
  alphD,betD  : single;    {angles of the sides and the bottom of the polygon, in degrees}
  apu,apv     : single;    {temporary}
  dix,diy     : integer;   {change in x,y for color code}
  dx,dy       : single;    {movement of corner 1, when top line is tilted}
  eq14,eq23   : boolean;   {points equal, if one point in the "wrong" side}
  err         : integer;   {error flag}
  flineD      : single;    {angle of line impedance, in degrees}
  fline       : single;    {angle of the line-impedance, in radians}
  gamD        : single;    {angle of topmost line, in degrees}
  gamma       : single;    {angle of the topmost line, in radians}
  GrColor     : TColor;    {color of the grid}
  ground      : boolean;   {true, if ground distance relay}
  ii          : integer;   {index}
  ipSet       : longint;   {pointer to the "common" as integer}
  ipu,ipv     : integer;   {temporary}
  ix,iy       : integer;   {coordinates}
  lbl         : string;    {label of the relay}
  pSet        : TpCompSet; {pointer to the "common"}
  RpR         : single;    {ratio of left and right resistance}
  step        : single;    {interval between markingsd (grid)}
  tana,tanb   : single;    {tan(alpha), tan(beta)}
  tang,tanf   : single;    {tan(gamma), tan(fline)}
  tanc        : single;    {tan(90-delta)}
  xh1,yh1     : single;    {preliminary first corner, when gamma = 0}
  xh2,yh2     : single;    {preliminary second corner, when gamma = 0}
  xl,yl       : single;    {coordinates of the point, where the line impedance intersects..}
  {}                       {..the reactance line}
  xt1,yt1     : single;    {coordinates, when top (bottom) line tilted = gamma <> 0}
  xt2,yt2     : single;    {coordinates, when top (bottom) line tilted = gamma <> 0}
  Zline       : single;    {impedance of the line}
  RR          : array[1..5] of single;    {intersection at R-axis (resistance-axis)}
  XX          : array[1..5] of single;    {intersection of X-axis (reactance-axis)}
  thc         : array[1..5] of integer;   {line thickness (size)}
  x1,x2,x3,x4 : array[1..5] of single;    {x-coordinate of the corners}
  y1,y2,y3,y4 : array[1..5] of single;    {y-coordinate of the corners}
  zm          : array[1..5] of single;    {max.impedance of the corners}
  Zcol        : array[1..5] of TColor;    {colors of the characteristics}
begin
  if (pComp <> nil) then begin
{1} Poly.ClearDistChar(toile);      {clear first}
{1} {pComp^}Poly.GetThisRel^.GetLabel(lbl,ix,iy);     {label of the component}
{a} pComp^.GetPar(Zlinerow+1{30},Zline);        {line impedance}
{a} pComp^.GetPar(Filinerow+1{31},flineD);
{1} fline := flineD*pi/180;         {phase of line impedance}
{1} tanf := tan(fline);
    {get the parameters needed for drawing the characteristics}
{a} GetDrawParam(pComp, tana,tanb,tang,tanc, RpR, ground, RR,XX, err);
    {upside-down?}
    if (Poly.IsReverse(pComp)) then begin
      for ii := 1 to 5 do XX[ii] := -XX[ii];
    end;
{what if err <>0 ?? . . . . . . . .  ??}
    {save the relay or calculation type}
{1} Poly.SetPhaseGround(not ground);
    {find the corners of all polygons}
{a} CornersOfAll(pComp,RR,XX,tana,tanb,tang,tanc,flineD,Zline,RpR,x1,y1,x2,y2,x3,y3,x4,y4,'dapc');
    {find max. impedance of the corners, for scale}
    FindMaxImpedances(x1,y1,x2,y2,x3,y3,x4,y4,zm);
    {find scale with the help of the max.impedance, but not if constant scale}
{1.}if (not PolyRel.ScaleItem.checked) then begin
      zmax := 0;
      for ii := 1 to 5 do begin
        if (zm[ii] > zmax) then zmax := zm[ii];
      end;
    end;
//  if (not PolyRel.ScaleItem.checked) then
    if (zmax > 0) then
{.1}  Poly.CalculateScale( (exp(Poly.modscale*0.25))*zmax )
    else
      Poly.CalculateScale( (exp(Poly.modscale*0.25))*5); {no curves, error?}
    {change scale, if not told otherwise}
{a} scale := Poly.scale;
{1.}if (Poly.ColorChanged) then begin
      GrColor := Poly.NewColor;                 {lines of selected color}
      Poly.SaveLineColor(GrColor);              {save to current trafo}
    end else begin
      GrColor := Poly.GetLineColor;             {color from current trafo}
    end;
    Poly.DrawGrid(toile,GrColor);
{.1}if (PolyRel.UnitsItem.checked) then Poly.DrawOhms(toile);  {draw the units: "Ohms"}
{a.}{draw characteristics, if allowed. Colors defined in Utildef.pas}
    if (Poly.DrawIndex(pComp) >= 0) then
      DrawThePolyChar(pComp,toile, tanb, tanc, x1,y1,x2,y2,x3,y3,x4,y4);
{!} if (PolyRel.TestPanel.visible) and (Polyrel.RectGrid.color = clWhite) and
       (Polyrel.PolarGrid.color = clWhite) and (Polyrel.RectGrid.cells[1,0] <> '') then
{!}   Poly.DrawTestMarker(Toile, scale);
{1.}{mark the impedances}
    if (not PolyRel.ImpedanceItem.checked) then Poly.DrawImpedances(pComp,toile);
//  if (PolyRel.LineItem.checked) and (not Imagoo.DistRelayBut.down) then
    if (PolyRel.LineItem.checked) and (not Polyrel.MultiRelBut.down) then
      Poly.DrawLineImpedance(Zline,fline,toile);
    Poly.DrawColors(toile); {show the colors of the zones}
    if (not Polyrel.LoadZoneItem.checked) then
      Poly.DrawLoadZones(toile,not PolyRel.LoadItem.checked);     {draw load zones}
    if (not Polyrel.OutZoneItem.checked)
      then Poly.DrawOutOfStepChar(toile,not PolyRel.StepItem.checked); {draw out of step characteristics}
    {draw also text for the type of the relay}
    if (ground) then begin
      {do not change the caption when adding relays}
{?}   if (not Polyrel.OhmImg0.visible) then
{?}     Polyrel.caption := lbl+'    Residual plane (21N)';  {ERIKSEEN !?}
      {draw the relay symbol, if not hidden}
      if (not Polyrel.SymbolItem.checked) then PogoGroundRight(toile,13,1,1);  {draw the relay symbol}
      {move the marker to the rows for ground relay}
      Polyrel.MarkImage.top := Poly.MarkImageTop(R1row,R1Nrow);
//      Polyrel.MarkImage.top := Polyrel.PolyGrid.top+
//        {16}{17}21*Polyrel.PolyGrid.DefaultRowHeight+{17}{18}22*Polyrel.PolyGrid.GridLineWidth;
    end else begin
      {do not change the caption when adding relays}
{?}   if (not Polyrel.OhmImg0.visible) then
        Polyrel.caption := lbl+'    Phase plane(21)';
      {draw the relay symbol, if not hidden}
      if (not Polyrel.SymbolItem.checked) then PogoPhaseRight(toile,13,1,1);
      {move the marker to the rows for phase relay}
      Polyrel.MarkImage.top := Poly.MarkImageTop(R1row,R1Nrow);
//    Polyrel.MarkImage.top := Polyrel.PolyGrid.top+
//      {4}{5}6*Polyrel.PolyGrid.DefaultRowHeight+{5}6*Polyrel.PolyGrid.GridLineWidth;
    end;
    Poly.DrawImpedMarkers(pComp,toile, scale,ground);
{.1}PolyRel.WarnEdit.visible := false;
//  end else begin            {parameters not correct}
{?} {warning, but only for gamma}
//    if (gamD < -80) or (gamD > 60) then begin
//      Poly.SetParWarning('gamma','-80','+60');
//    end else begin          {clear graph, if other param. wrong}
{?? . . . .??}
//      Poly.ClearDistChar(toile);
//    end;
//  end;
//Poly.DrawImpedanceLines(true); {To Be Moved..., see dist.drawmho..} {draw also the lines of the selected impedances}

  end;
end;

procedure TPolyRel.IncButClick(Sender: TObject);
begin
  if (Poly.modscale < 36) then begin
    inc(Poly.modscale);                   {increase the scale}
//  DrawAllPolyChar(Poly.GetActRel,PolyChar.canvas,'IncButClic');
    Poly.DrawRelays(PolyChar.canvas,'IncButClic');
    Poly.MarkParameterRelay;
  end;
end;

procedure TPolyRel.DecButClick(Sender: TObject);
begin
  if (not Poly.TooSmall) then begin
    dec(Poly.modscale);                   {decrease the scale}
//  DrawAllPolyChar(Poly.GetActRel,PolyChar.canvas,'DecButClick');
    Poly.DrawRelays(PolyChar.canvas,'DecButClic');
    Poly.MarkParameterRelay;
  end;
end;

procedure TPolyRel.ResetButClick(Sender: TObject);
begin
  Poly.modscale := 0;                   {reset the scale}
//DrawAllPolyChar(Poly.GetActRel,PolyChar.canvas,'ResetButClick');
  Poly.DrawRelays(PolyChar.canvas,'ResetButClic');
  Poly.MarkParameterRelay;
end;

procedure TPolyRel.PolyCharMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
{show the cursor position in terms of impedance}
var
  res,rea   : single;   {resistance, reactance}
  txt       : string;   {temporary}
begin
  Poly.MouseImpedance(x,y,txt,res,rea);
  ImpedEdit.text := txt;
  {is the mouse pointing to the end of some impedance line?}
  Poly.ShowImpedAndRelay(x,y);
  {move the rectangle around ID-number, if shown}
  if (IDimage.visible) then begin
    IDimage.left := PolyChar.left+x-6;
    IDimage.top := PolyChar.top+y-6;
  end else begin
    {move origo-marker, in preparation of moving the whole image}
    Poly.MoveOrigMarker(Shift, x,y);
  end;
end;


procedure TPolyRel.ExportItemClick(Sender: TObject);
{export the relay diagram (characteristics, impedances}
var
  DirName   : string;  {name of directory where saved}
  FormImage : TBitmap; {for saving the whole form as a bitmap}
begin
  ExportDialog.FileName := '';                    {clear initially}
  if (ExportDialog.execute) then begin
    Poly.PutExportName('poly');                {set flag, needed for wmf }
    Dist.PutExportName('poly');
    if (ExportDialog.FilterIndex = 1) then begin  {save as a wmf-file}
      Poly.DrawDiagram(ExportDialog.FileName);
    end else begin                                {save as a bitmap or as a jpeg}
      FormImage := Polyrel.getFormImage;
      if (ExportDialog.FilterIndex = 2) then begin {save as abitmap}
        FormImage.savetofile(ExportDialog.Filename);
      end else begin                               {save as a jpeg}
        SaveJpegImage(@Polyrel, FormImage, ExportDialog.FileName);  {..in routines.pas}
      end;
      FormImage.free;
    end;
    DirName := ExtractFilePath(ExportDialog.FileName);
    ExportDialog.InitialDir := DirName;    {save the directory}
  end;
end;

procedure TPolyRel.ExitItemClick(Sender: TObject);
begin
  PolyRel.visible := false;
end;

procedure TPolyRel.FormKeyPress(Sender: TObject; var Key: Char);
{ semicolon ';' not allowed because it is used as a separator when saving to file
  pound '' not allowed, because it is used as line separator}
begin
  if (key = ';') or (key = '') then key := #0;
end;

procedure TPolyRel.TitleEditKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  ipu     : integer; {temporary}
  pActRel : TpComp;  {pointer to the active relay}
begin
  if (not {SetComp.}appl_close) then begin
    {check the length with help of the dummy image, with same font}
    ipu := DummyImage.canvas.textwidth(TitleEdit.text)+16;
    TitleEdit.width := ipu;
    pActRel := Poly.GetActRel;
    if (pActRel <> nil) then begin
      {save title}
      pActRel^.PutDescrG(1,TitleEdit.text,'','');  {save title as a description}
    end;
  end;
end;

procedure TPolyRel.NotesItemClick(Sender: TObject);
const
 NomHeight = 48;
 HidHeight = 1;
begin
  NotesItem.checked := not NotesItem.checked;
  if (NotesItem.checked) then begin                        {display the memo}
//  NotesMemo.height := NomHeight;
//  NotesMemo.visible := true;;
//  Height := height+NomHeight-HidHeight;                   {increase height of form}
  end else begin
//  NotesMemo.height := HidHeight;
//  NotesMemo.visible := false;
//  height := height-NomHeight+HidHeight;                   {decrease height of form}
  end;
  {hide/show the memo for the notes}
  Poly.ShowNotesIf('');
(*
  Poly.pDistNotes^.visible := NotesItem.checked;
  if (Poly.pDistNotes^.visible) then Poly.pDistNotes^.BringToFront;
  {if hidden by the graph, move}
  if (Poly.pDistNotes^.left > PolyRel.left-32) and
     (Poly.pDistNotes^.left+Poly.pDistNotes^.width < PolyRel.left+PolyRel.width+32) then begin
    if (PolyRel.left > 32) then Poly.pDistNotes^.left := 16
    else Poly.pDistNotes^.left := PolyRel.left+PolyRel.width;
  end;
*)  
end;

//procedure TPolyRel.NotesMemoKeyUp(Sender: TObject; var Key: Word;
//  Shift: TShiftState);
//begin
//  {save the notes}
//  Poly.NotesMemoKeyUp(Sender,Key,Shift);
//end;

procedure TPolyRel.MarkerMenuClick(Sender: TObject);
begin
(*
  ImpedanceForm.tag := longint(Poly.GetActRel);  {save pointer to relay as integer}
  ImpedanceForm.visible := true;
*)
end;

procedure TPolyRel.Zone1ItemClick(Sender: TObject);
begin
  Zone1Item.checked := not Zone1Item.checked;
  PolygonRelayShow;
end;

procedure TPolyRel.Zone2ItemClick(Sender: TObject);
begin
  Zone2Item.checked := not Zone2Item.checked;
  PolygonRelayShow;
end;

procedure TPolyRel.Zone3ItemClick(Sender: TObject);
begin
  Zone3Item.checked := not Zone3Item.checked;
  PolygonRelayShow;
end;

procedure TPolyRel.Zone4ItemClick(Sender: TObject);
begin
  Zone4Item.checked := not Zone4Item.checked;
  PolygonRelayShow;
end;

procedure TPolyRel.LineItemClick(Sender: TObject);
begin
  LineItem.checked := not LineItem.checked;
  PolygonRelayShow;
end;

procedure TPolyRel.ShowItemClick(Sender: TObject);
var
  bpu : boolean;
begin
  ShowItem.checked := not ShowItem.checked;
  IncBut.visible := ShowItem.checked;
  DecBut.visible := ShowItem.checked;
  ResetBut.visible := ShowItem.checked;
  CompBut.visible := ShowItem.checked;
  MultiRelBut.visible := ShowItem.checked;
  ClearCompBut.visible := ShowItem.checked;
  RevBut.visible := ShowItem.checked;
  ParamBut.visible := ShowItem.checked;
  ZBut.visible := ShowItem.checked;
(*  moved to ParamItemClick
  OKBut.visible := ShowItem.checked;
  CancelBut.visible := ShowItem.checked;
  ApplyBut.visible := ShowItem.checked;
  HintBut.visible := ShowItem.checked;
  MarkImage.visible := ShowItem.checked;
*)  
  bpu := (SetComp.appl_op = 6 ) or (SetComp.appl_op = 7 ) or
         (SetComp.appl_op = 8 ) or (SetComp.appl_op = 11);
  ImpedEdit.visible := ShowItem.checked and bpu;
end;

procedure TPolyRel.ColorItemClick(Sender: TObject);
begin
  ColorItem.checked := not ColorItem.checked;
end;

procedure TPolyRel.GridColorMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
{change the color of the grid}
var
  GridCol : TColor;
  ll      : longint;
  pComp   : TpComp;
  xcol    : TColor;
begin
  GridCol := GetPixel(GridColor.canvas.handle,x,y);  {get color from the menu}
  GridColor.visible := false;
  Poly.PutNewColor(GridCol);              {new color to grid}
  Poly.SetClrChange;                      {flag for "color changed"}
  PolygonRelayShow;
  Poly.ResetClrChange;                    {reset flag}
end;

procedure TPolyRel.GridItemClick(Sender: TObject);
begin
  GridColor.top := PolyChar.top+64;
  GridColor.visible := true;
  GridColor.BringToFront;
end;

procedure TPolyRel.PolyCharMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  {mouse pressed at ID of a marker?}
  Poly.MouseDownAtID(x,y);
  Poly.MarkerToOrigo;              {marker to origo, for possible moving of origo}
  {if not at ID of a marker, prepare to move the origo-marker}
  if not (Poly.pMarkerID^.visible) then begin
    {save mouse position, to move the picture}
    Poly.PutMouseXY(x,y);
    {put the origo-marker to origo}
  end;
end;

procedure TPolyRel.PolyCharMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  {ID of a marker moving? }
  Poly.MouseUpAtID(x, y);
  {moving the origo?}
  OrigImg.visible := false;
  {marker for origo moved?}
  Poly.MoveOrigo;
end;

procedure TPolyRel.PointMarkerClick(Sender: TObject);
begin
  ImpedanceForm.tag := longint(Poly.GetActRel);  {save pointer to relay as integer}
  ImpedanceForm.visible := true;
  ImpedanceForm.BringToFront;
end;

procedure TPolyRel.LineMarkerClick(Sender: TObject);
begin
  RXLineForm.tag := longint(Poly.GetActRel);  {save pointer to relay as integer}
  RXLineForm.visible := true;
  RXLineForm.BringToFront;
end;

procedure TPolyRel.TitleEditClick(Sender: TObject);
begin
  {try to prevent in advance the reset of the scroll-position}
  Poly.ClickNonData;
end;

procedure TPolyRel.ImpedEditClick(Sender: TObject);
begin
  {try to prevent in advance the reset of the scroll-position}
  Poly.ClickNonData;
end;

//procedure TPolyRel.NotesMemoClick(Sender: TObject);
//begin
//  {try to prevent in advance the reset of the scroll-position}
//  Poly.ClickNonData;
//end;

procedure TPolyRel.PolyGridMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
{save position of scroll bar, so that it can be returned when grid is clicked
 after some component that can have focus}
const
  xo : integer = 0;
  yo : integer = 0;
var
  arow, acol : longint;
begin
  if (x <> xo) and ( y <> yo) then begin  {to prevent taking mouse click as mouse move}
    scroll_pos := vertscrollbar.position;
    xo := x;
    yo := y;
  end;
end;

procedure TPolyRel.PolyGridMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  VertScrollBar.position := scroll_pos;
end;

procedure TPolyRel.PolyGridDrawCell(Sender: TObject; Col, Row: Longint;
  Rect: TRect; State: TGridDrawState);
begin
  Poly.DrawCell(Col, Row, Rect);
(*if (col = 1) then begin
    if ((row = R1row) or (row = X1row)) and (not Poly.IsGround) then begin
      PolyGrid.canvas.pen.color := clRed;
      PolyGrid.canvas.brush.color := clRed;
      PolyGrid.canvas.rectangle(rect.left+60,rect.top,rect.left+PolyGrid.defaultcolwidth-8,rect.bottom);
    end else if ((row = R1Nrow) or (row = X1Nrow)) and (Poly.IsGround) then begin
      PolyGrid.canvas.pen.color := clRed;
      PolyGrid.canvas.brush.color := clRed;
      PolyGrid.canvas.rectangle(rect.left+60,rect.top,rect.left+PolyGrid.defaultcolwidth-8,rect.bottom);
    end;
  end;
*)  
end;

procedure TPolyRel.ColorImageMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  ii,jj,kk : integer;
begin
  ii := (X div (CRwidth+CRspace))+1;
  jj := (Y div (CRwidth+CRspace))+1;
  kk := (ii-1)*4+jj;                 {color index}
  {set color of impedance lines, if called from InfoButClick..}
  if (ImagePanel.hint = gImpedHint) then begin
    Poly.SetColorIndex(kk);
  end else begin
    {..else set color of ..some.. lines in the graph}
    PolyGrid.cells[PolyGrid.Col,PolyGrid.Row] := inttostr(kk);
  end;  
  ImagePanel.visible := false;
end;

procedure TPolyRel.SetGridTop;
{set the top coordinate of phase and ground grids}
begin
  if (PhasePanel.visible) then
    PhasePanel.top := PolyGrid.top+(R1row-PolyGrid.toprow)*(PolyGrid.DefaultRowHeight+1)-1;
  if (GroundPanel.visible) then
    GroundPanel.top := PolyGrid.top+(R1Nrow-PolyGrid.toprow)*(PolyGrid.DefaultRowHeight+1)-1;
end;

procedure TPolyRel.InductanceToReactance;
{read the inductance (in H) from the edit, convert to reactance in Ohms,
 and write to the grid for parameters
 The row is saved in the tag of the edit in ReactToInductance of distance.pas}
var
  apu        : single;      {temporary}
  err        : integer;     {error flag}
  kstrt,kend : integer;     {parameter starts, ends at}
  ll         : longint;     {temporary}
  pSet       : TpCompSet;   {pointer to the common}
  react      : single;      {reactance}
  st1        : string;      {temporary}
  txt        : string;      {temporary text}
begin
  {get impedance}
  txt := HenryEdit.text;
  kstrt := 1;
  NextValueFromLine(txt, kstrt, kend, apu, st1, err);  {reactance, in routines.pas}
  react := apu*(2*pi*SetComp.appl_Hz);                 {Ohms from impedance in Henry}
  RemoveSpaces(react,txt);                             {to string, withoud spaces}
  PolyGrid.cells[1,HenryEdit.tag] := txt;              {move to grid}
end;

procedure TPolyRel.PolyGridKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
{ '' is not accepted as input, because it is used as a separator}
var
  arow    : integer;
  ii,jj   : integer;
  len     : integer;   {length of string}
  row     : integer;   {row index in phase or ground grid}
  txa     : string;
begin
  if (key = 18) then begin             {altGR (or alt)-key}
    arow := PolyGrid.row;               {active row}
    txa := PolyGrid.cells[1,arow];      {copy to local}
    len := length(txa);
    if (len > 0) then begin
      for ii := 1 to len do begin
        jj := len-ii+1;
        if (txa[jj] = '') then begin  {if '' then delete it by a backspace}
          keybd_event(VK_SHIFT, 0, 0, 0);
          keybd_event(VK_BACK, 0, 0, 0);                    {backspace}
          keybd_event(VK_SHIFT, 0, KEYEVENTF_KEYUP, 0);
        end else begin
          break;
        end;
      end;
    end;
  end;
  {keep the impedance grids in place relative to the main grid, if "scrolling" with the arrow
   keys on the top or bottom of the grid (the same must be in KeyUp ?)}
  if (key = 38) or (key = 40) then begin
    SetGridTop;
(*  if (PhasePanel.visible) then
      PhasePanel.top := PolyGrid.top+(R1row-PolyGrid.toprow)*(PolyGrid.DefaultRowHeight+1)-1;
    if (GroundPanel.visible) then
      GroundPanel.top := PolyGrid.top+(R1Nrow-PolyGrid.toprow)*(PolyGrid.DefaultRowHeight+1)-1;
*)
    {image marking the impedances, ground or phase also in place}
    Polyrel.MarkImage.top := Poly.MarkImageTop(R1row,R1Nrow);
  end;
  {must update X, if editing phase angle of the line, and if Z-R grid visible}
  if (PolyGrid.row = {Filinerow}alpharow) and (PhasePanel.visible) then begin
    {phase grid first, all reactances}
    for ii := 0 to 4 do begin
      row := 2*ii+1;                      {row of impedance in phase grid}
      UpdateXinMainGrid(@PhaseGrid, row, R1row);
    end;
    {next, the same for the ground grid}
    for ii := 0 to 4 do begin
      row := 2*ii+1;                      {row of impedance Z}
      UpdateXinMainGrid(@GroundGrid, row, R1Nrow);
    end;
  end;
  {update reactance as impedance in Henry}
  if (PolyGrid.cells[0,PolyGrid.row][1] = 'X') then begin   {X identifies reactance}
    Poly.ReactToInductance(PolyGrid.row);
  end;
end;

procedure TPolyRel.PolyGridKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
{ ';' and '' are not allowed as input, because they are used as data separators.
  If ';', it is deleted by a backspace}
begin
  if (((key = 188) or (key = 52))and (ssShift in Shift)) then begin  { ';' is not allowed}
    keybd_event(VK_SHIFT, 0, 0, 0);
    keybd_event(VK_BACK, 0, 0, 0);                    {backspace}
    keybd_event(VK_SHIFT, 0, KEYEVENTF_KEYUP, 0);
  end;
  {move focus to phase or ground grid, if arrow key, and moving to these grids}
  {down arrow}
  if (key = 40) and (PolyGrid.row = RpRrow) and (PhasePanel.visible) then begin
    ActiveControl := PhaseGrid;
    PhaseGrid.row := 0;
    PhaseGrid.col := 1;
  end;
  {up-arrow}
  if (key = 38) and (PolyGrid.row = T1Row) and (PhasePanel.visible) then begin
    ActiveControl := PhaseGrid;
    PhaseGrid.row := PhaseGrid.rowcount-1;
    PhaseGrid.col := 1;
  end;
  {ground grid similarly}
  {down arrow}
  if (key = 40) and (PolyGrid.row = T5row) and (GroundPanel.visible) then begin
    ActiveControl := GroundGrid;
    GroundGrid.row := 0;
    GroundGrid.col := 1;
  end;
  {up-arrow}
  if (key = 38) and (PolyGrid.row = T1NRow) and (GroundPanel.visible) then begin
    ActiveControl := GroundGrid;
    GroundGrid.row := GroundGrid.rowcount-1;
    GroundGrid.col := 1;
  end;
  {keep the impedance grids in place relative to the main grid, if "scrolling" with the arrow
   keys on the top or bottom of the grid (the same must be in KeyUp ?)}
(**)
  if (key = 38) or (key = 40) then begin
    SetGridTop;
(*  if (PhasePanel.visible) then
      PhasePanel.top := PolyGrid.top+(R1row-PolyGrid.toprow)*(PolyGrid.DefaultRowHeight+1)-1;
    if (GroundPanel.visible) then
      GroundPanel.top := PolyGrid.top+(R1Nrow-PolyGrid.toprow)*(PolyGrid.DefaultRowHeight+1)-1;
*)      
  end;

(**)
end;

procedure TPolyRel.ThicknessImageMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  Poly.ThicknessImageMouseUp(X,Y);
  ThicknessPanel.visible := false;
end;

procedure TPolyRel.LoadZoneItemClick(Sender: TObject);
begin
  LoadZoneItem.checked := not LoadZoneItem.checked;
//DrawAllPolyChar(Poly.GetActRel,Poly.pDistChar^.canvas,'LoadZoneItemClick');
  Poly.DrawRelays(PolyChar.canvas,'LoadZoneItemClic');
end;

procedure TPolyRel.LoadItemClick(Sender: TObject);
begin
  LoadItem.checked := not LoadItem.checked;
//DrawAllPolyChar(Poly.GetActRel,Poly.pDistChar^.canvas,'LoadItemClick');
  Poly.DrawRelays(PolyChar.canvas,'LoadItemClic');
end;

procedure TPolyRel.OutZoneItemClick(Sender: TObject);
begin
  OutZoneItem.checked := not OutZoneItem.checked;
//DrawAllPolyChar(Poly.GetActRel,Poly.pDistChar^.canvas,'OutZoneItemClick');
  Poly.DrawRelays(PolyChar.canvas,'OutZoneItemClic');
end;

procedure TPolyRel.StepItemClick(Sender: TObject);
{show or hide the names (identifiers) of the out of step zones}
begin
  StepItem.checked := not StepItem.checked;
//DrawAllPolyChar(Poly.GetActRel,Poly.pDistChar^.canvas,'StepItemClick');
  Poly.DrawRelays(PolyChar.canvas,'StepItemClic');
end;

procedure TPolyRel.UnitsItemClick(Sender: TObject);
{show / not the "Ohm" (omega) on the axes}
begin
  UnitsItem.checked := not UnitsItem.checked;
//DrawAllPolyChar(Poly.GetActRel,Poly.pDistChar^.canvas,'UnitsItemClick');
  Poly.DrawRelays(PolyChar.canvas,'UnitsItemClic');
end;

procedure TPolyRel.ParamItemClick(Sender: TObject);
begin
  ParamItem.checked := not ParamItem.checked;
  PolyGrid.visible := not ParamItem.checked;
  VertScrollBar.visible := not ParamItem.checked;
  OKBut.visible := not ParamItem.checked;
  CancelBut.visible := not ParamItem.checked;
  ApplyBut.visible := not ParamItem.checked;
  HintBut.visible := not ParamItem.checked;
  MarkImage.visible := not ParamItem.checked;
end;

procedure TPolyRel.SymbolItemClick(Sender: TObject);
begin
  SymbolItem.checked := not SymbolItem.checked;
//DrawAllPolyChar(Poly.GetActRel,Poly.pDistChar^.canvas,'SymbolItemClick');
  Poly.DrawRelays(PolyChar.canvas,'SymbolItemClic');
end;

procedure TPolyRel.TitleItemClick(Sender: TObject);
begin
  TitleItem.checked := not TitleItem.checked;
  TitleEdit.visible := not TitleItem.checked;
end;

procedure TPolyRel.ImpedanceItemClick(Sender: TObject);
begin
  ImpedanceItem.checked := not ImpedanceItem.checked;
//DrawAllPolyChar(Poly.GetActRel,Poly.pDistChar^.canvas,'ImpedanceItemClick');
  Poly.DrawRelays(PolyChar.canvas,'ImpedanceItemClic');
end;

procedure TPolyRel.FormActivate(Sender: TObject);
begin
  if (NotesItem.checked) then Poly.pDistNotes^.visible := true;
end;

procedure TPolyRel.CopyItemClick(Sender: TObject);
begin
  CopyGroupForm.ParamBox.visible := false;
  CopyGroupForm.TextBox.visible := false;
  CopyGroupForm.WhatLabel.visible := false;
  CopyGroupForm.visible := true;
  {copy pointer to the relay to the tag of the form}
  CopyGroupForm.tag := longint(Poly.GetActRel);
end;

procedure TPolyRel.DecMenuClick(Sender: TObject);
begin
  Poly.ChangeParamGroup('dec');
  Poly.SetWarning; {warning, if auto mode}
  ToZRGrid('P');
  ToZRGrid('G');
end;

procedure TPolyRel.IncMenuClick(Sender: TObject);
begin
  Poly.ChangeParamGroup('inc');
  Poly.SetWarning; {warning, if auto mode}
  ToZRGrid('P');
  ToZRGrid('G');
end;

procedure TPolyRel.AutoManMenuClick(Sender: TObject);
var
  ll   : longint;   {temporary }
  pSet : TpCompSet;
begin
  Poly.GetActRel^.getAdpar(ll);
  if (ll <> 2) then begin          {in manual mode}
    AutoManMenu.caption := 'A';    {set in automatic mode}
    Poly.GetActRel^.putAdpar(2);   {must use 2, because 1 was earlier in other use}
    {change the parameter group, if allowed and conditions satisfied}
    ChangeParamGroupIf(Poly.GetActRel);
  end else begin                   {in auto-mode, set in manual}
    AutoManMenu.caption := 'M';
    Poly.GetActRel^.putAdPar(0);
    WarnEdit.visible := false;
  end;
  {show auto/man in the symbol (actually in the symbol of the CT)}
  Poly.GetActRel.GetipSet(ll);
  pSet := TpCompSet(ll);
  pSet^.WriteGroupIndex(Poly.GetActRel);       {in skemadef.pas}
end;

procedure TPolyRel.CondItem1Click(Sender: TObject);
begin
  ConditionForm.GroupItemsClick(1);
end;

procedure TPolyRel.CondItem2Click(Sender: TObject);
begin
  ConditionForm.GroupItemsClick(2);
end;

procedure TPolyRel.CondItem3Click(Sender: TObject);
begin
  ConditionForm.GroupItemsClick(3);
end;

procedure TPolyRel.CondItem4Click(Sender: TObject);
begin
  ConditionForm.GroupItemsClick(4);
end;

procedure TPolyRel.CondItem5Click(Sender: TObject);
begin
  ConditionForm.GroupItemsClick(5);
end;

procedure TPolyRel.CondItem6Click(Sender: TObject);
begin
  ConditionForm.GroupItemsClick(6);
end;

procedure TPolyRel.AllItemClick(Sender: TObject);
begin
  ConditionForm.AllGroupItemsClick;
end;

procedure TPolyRel.FormShow(Sender: TObject);
begin
  Poly.SaveParSetIndex;
end;

procedure TPolyRel.WarneditClick(Sender: TObject);
begin
  WarnEdit.visible := false;
end;

procedure TPolyRel.CopyToCItemClick(Sender: TObject);
begin
  Clipboard.assign(PolyChar.picture);
end;

procedure TPolyRel.ScaleItemClick(Sender: TObject);
begin
  ScaleItem.checked := not ScaleItem.checked;
end;

procedure TPolyRel.ImpedImg0Click(Sender: TObject);
begin
  Poly.ImpedImgClick(0,PolyChar.Canvas);
end;

procedure TPolyRel.ImpedImg1Click(Sender: TObject);
begin
  Poly.ImpedImgClick(1,PolyChar.Canvas);
end;

procedure TPolyRel.ImpedImg2Click(Sender: TObject);
begin
  Poly.ImpedImgClick(2,PolyChar.Canvas);
end;

procedure TPolyRel.ImpedImg3Click(Sender: TObject);
begin
  Poly.ImpedImgClick(3,PolyChar.Canvas);
end;

procedure TPolyRel.ImpedImg4Click(Sender: TObject);
begin
  Poly.ImpedImgClick(4,PolyChar.Canvas);
end;

procedure TPolyRel.ImpedImg5Click(Sender: TObject);
begin
  Poly.ImpedImgClick(5,PolyChar.Canvas);
end;

procedure TPolyRel.ImpedImg6Click(Sender: TObject);
begin
  Poly.ImpedImgClick(6,PolyChar.Canvas);
end;

procedure TPolyRel.OhmImg0Click(Sender: TObject);
begin
  Poly.AddNextToRelayList(0);
end;

procedure TPolyRel.OhmImg1Click(Sender: TObject);
begin
  Poly.AddNextToRelayList(1);
end;

procedure TPolyRel.OhmImg2Click(Sender: TObject);
begin
  Poly.AddNextToRelayList(2);
end;

procedure TPolyRel.OhmImg3Click(Sender: TObject);
begin
  Poly.AddNextToRelayList(3);
end;

procedure TPolyRel.OhmImg4Click(Sender: TObject);
begin
  Poly.AddNextToRelayList(4);
end;

procedure TPolyRel.OhmImg5Click(Sender: TObject);
begin
  Poly.AddNextToRelayList(5);
end;

procedure TPolyRel.OhmImg6Click(Sender: TObject);
begin
  Poly.AddNextToRelayList(6);
end;

procedure TPolyRel.CancelRelayButClick(Sender: TObject);
{hide the markers at the ends of the impedance lines, do some "cleaning"}
begin
  Poly.CancelRelayButClick(Sender);
end;

(*
procedure TPolyRel.RelButClick(Sender: TObject);
var
  pComp : TpComp;   {pointer to the relay}
begin
  {show parameters, pointer saved to tag in DistCharMouseMove}
  ParameterShow(RelBut.tag);       {works also with polygonal relays, should it?}
  pComp := TpComp(RelBut.tag);
  {show box with additional buttons}
  ButtonBox.left := PolyChar.left;
  ButtonBox.top := PolyChar.top;
  ButtonBox.Caption := RelBut.caption;
  ButtonBox.visible := true;
  {read the flag: draw/not = pointer to relay in drawlist}
  HideBut.down := (Poly.DrawIndex(pComp) < 0);
end;
*)
procedure TPolyRel.RelButClick(Sender: TObject);
begin
  Poly.RelButClick(@RelBut,name);
end;

procedure TPolyRel.RelBut2Click(Sender: TObject);
begin
  Poly.RelButClick(@RelBut2,name);
end;

procedure TPolyRel.CancelBoxButClick(Sender: TObject);
begin
  ButtonBox.visible := false;
end;

procedure TPolyRel.HideButClick(Sender: TObject);
{hide/show the char. of the relay. Pointer to the relay in RelBut.tag,
 saved in TDistrel.DistCharMouseMove}
begin
  Poly.HideButClick;
  {update graph}
  FormResize(sender);
end;

procedure TPolyRel.ClearCompButClick(Sender: TObject);
{clear the impedance lines}
{called also in DeleteButClick of Imagopas, when deleting the diagram}
var
  answer : word;   {answer to the question of deleting}
begin
  if (sender <> nil) then
    answer := MessageDlg('Really clear impedance lines?',mtWarning, [mbCancel, mbYes], 0)
  else answer := mrYes;  
  if (answer = mrYes) then begin
    Poly.ClearImpedances;
    Poly.HideImpedImages;
    FormResize(nil);    {redraw = wipe impedance lines}
    CancelRelayBut.visible := false;
  end;
end;

procedure TPolyRel.RemoveButClick(Sender: TObject);
{remove the relay from the graph = remove from the list}
var
  pBut  : TpButton;  {pointer to relay button in graph}
  pComp : TpComp;    {pointer to the relay}
begin
  {get pointer to the relay. Saved in ShowImpedAndRelay, called from PolyCharMouseMove}
  pBut := TpButton(ButtonBox.tag);       {saved in TDist.RelButClick}
  pComp := TpComp(pBut^.Tag);
  Poly.RelayFromList(pComp);             {remove the graph = remove the relay from the list}
  ButtonBox.visible := false;
  FormResize(sender);
end;

procedure TPolyRel.SRDItemClick(Sender: TObject);
{display the panel etc. for saving/recalling/deleting relay lists}
begin
  Dist.SavRecDelItemClick(@RelayBox, @SetComp.Poly_List, @SavePanel, @NewEdit);
  NewEditClick(nil);          {position the target-pointer to Newedit}
end;

procedure TPolyRel.NewEditClick(Sender: TObject);
begin
  RelayBox.ItemIndex := -1;
  TargetLabel.top := NewEdit.top;
end;

procedure TPolyRel.NewEditEnter(Sender: TObject);
begin
  RelayBox.ItemIndex := -1;
  TargetLabel.top := NewEdit.top;
end;

procedure TPolyRel.SaveButClick(Sender: TObject);
{save the coordination diagram (list of relays, impedances, etc) to local list}
begin
  Poly.SaveButClick(@TargetLabel, @NewEdit, @SetComp.Poly_List, @RelayBox, @SavePanel);
end;

procedure TPolyRel.RecallButClick(Sender: TObject);
{recall the coordination diagram (list of relays, impedances, etc) from local list}
begin
  Poly.RecallButClick(@RelayBox, @SetComp.Poly_List, @SavePanel);
end;

procedure TPolyRel.CancelActionButClick(Sender: TObject);
begin
  SavePanel.visible := false;
end;

procedure TPolyRel.DeleteButClick(Sender: TObject);
begin
  Poly.DeleteButClick(@RelayBox, @SetComp.Poly_List, @SavePanel);
end;

procedure TPolyRel.ImpedMarkerItemClick(Sender: TObject);
begin
  ImpedMarkerItem.checked := not ImpedMarkerItem.checked;
  FormResize(sender);
end;


procedure TPolyRel.InfoButClick(Sender: TObject);
{display the menu for the color of the line}
begin
  Poly.InfoButClick(sender);
end;

procedure TPolyRel.ActivationItemClick(Sender: TObject);
{display the panel for activation tests}
begin
  ActivationItem.checked := not ActivationItem.checked;
  TestPanel.visible := ActivationItem.checked;
  RelayLabel.caption := 'Test';
end;

procedure TPolyRel.CloseButClick(Sender: TObject);
begin
  TestPanel.visible := false;
  ActivationItem.checked := false;
end;

procedure TPolyRel.TestPanelMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
{move the test panel with the mouse}
const
  x0  : integer = 0;    {old coordinates}
  y0  : integer = 0;
var
  ix,iy : integer;
begin
  if (ssLeft in Shift) then begin        {left button pressed}
    ix := TestPanel.left+X-x0;
    {must stay within the form}
    if (ix <= 0) then TestPanel.left := 0
    else if (ix < width-TestPanel.width) then TestPanel.left := ix
    else TestPanel.left := width-TestPanel.width;
    {the same for the top-coordinate}
    iy := TestPanel.top +Y-y0;
    if (iy <= 0) then TestPanel.top := 0
    else if (iy < height-TestPanel.height) then TestPanel.top := iy
    else TestPanel.top := height-TestPanel.height;
  end else begin
    x0 := X;
    y0 := Y;
  end;
  TestPanelOldTop := TestPanel.top;
end;

procedure TPolyRel.PolarGridSelectCell(Sender: TObject; Col, Row: Longint;
  var CanSelect: Boolean);
begin
  Poly.PutPolaRow(row);
end;

procedure TPolyRel.RectGridSelectCell(Sender: TObject; Col, Row: Longint;
  var CanSelect: Boolean);
begin
  Poly.PutRectRow(row);
end;

procedure TPolyRel.RectGridKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  Poly.RectGridKeyUp;
  Poly.TestButClick;
end;

procedure TPolyRel.PolarGridKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  Poly.PolarGridKeyUp;
  Poly.TestButClick;
end;

procedure TPolyRel.TestButClick(Sender: TObject);
begin
  Poly.TestButClick;
end;

procedure TPolyRel.ResetTestButClick(Sender: TObject);
begin
  RectGrid.cells[1,0] := '';
  RectGrid.cells[1,1] := '';
  PolarGrid.cells[1,0] := '';
  PolarGrid.cells[1,1] := '';
  PhaseEdit.text := '';
  GroundEdit.text := '';
  Poly.FormResize;  
end;

procedure TPolyRel.HideColorButClick(Sender: TObject);
begin
  ImagePanel.visible := false;
end;

procedure TPolyRel.ImpedLineImgMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  kk : integer;  {thickness parameter}
begin
  Poly.ImpedLineImageMouseUp(x,kk);
  Poly.SetThickness(kk);
  ImpedLinePanel.visible := false;
end;

procedure TPolyRel.HideThButClick(Sender: TObject);
begin
  ImpedLinePanel.visible := false;
end;

procedure TPolyRel.RevButClick(Sender: TObject);
{set "polarized in reverse direction"-parameter, update graph}
begin
  Poly.PolarizedButtonClick;
  ApplyButClick(sender);
end;

procedure TPolyRel.ParamButClick(Sender: TObject);
begin
  Poly.MarkParameterRelay;
end;

procedure TPolyRel.UpdateImpedanceGrids;
{update the state of the phase and ground grids to correspond to the state of
 the impedance button (Zbut)}
begin
  {convert R,X to Z, R}
  ToZRGrid('P');
  ToZRGrid('G');
  {show the grids for Z and R}
  PhasePanel.visible := ZBut.down;
  GroundPanel.visible := ZBut.down;
  {reset possible error messages = colors}
  PhaseGrid.color := clWindow;
  GroundGrid.color := clWindow;
end;

procedure TPolyRel.ZButClick(Sender: TObject);
begin
  {change the "impedance with Z and R"-bit in the options parameter = bit 2}
  Poly.PutOptionBit(2, ZBut.down);   {set bit 2 if button down, else reset}
  UpdateImpedanceGrids;              {update the state of ground and phase grids}
(*
  {convert R,X to Z, fii}
  ToPolarGrid('P');
  ToPolarGrid('G');
  {show the grids for Z and fii}
  PhasePanel.visible := ZBut.down;
  GroundPanel.visible := ZBut.down;
  {reset possible error messages = colors}
  PhaseGrid.color := clWindow;
  GroundGrid.color := clWindow;
*)
  {grids to correct location}
  SetGridTop;
end;

procedure TPolyRel.PhaseGridKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   {move to the main grid, if arrow key, and on top or bottom. Up arrow first}
   if (key = 38) and (PhaseGrid.row = 0) and (PhasePanel.visible) then begin
    ActiveControl := PolyGrid;
    PolyGrid.row := RpRrow;
    PolyGrid.col := 1;
  end;
  {down-arrow}
  if (key = 40) and (PhaseGrid.row = PhaseGrid.RowCount-1) and (PhasePanel.visible) then begin
    ActiveControl := PolyGrid;
    PolyGrid.row := T1row;
    PolyGrid.col := 1;
  end;
  {set the top coordinate of the additional grids}
  if (key = 38) or (key = 40) then
    SetGridTop;
//  PhasePanel.top := PolyGrid.top+(R1row-PolyGrid.toprow)*(PolyGrid.DefaultRowHeight+1)-1;
end;

procedure TPolyRel.PhaseGridSelectCell(Sender: TObject; Col, Row: Longint;
  var CanSelect: Boolean);
begin
  phase_row := row;
end;
(*
procedure TPolyRel.FromPolarToMainGrid(GorP: string);
{convert and copy impedance from polar grid to main grid in rectangular form (R and X)
 GorP  if 'G' then ground grid, if 'P' then phase grid
 row   row being edited}
var
  apu,apv   : single;
  fii       : single;    {phase angle of impedance}
  pGrid     : TpGrid;    {pointer to the grid, phase or ground}
  row       : integer;   {row being edited}
  row1      : integer;   {row of first resistance in main grid}
  Rr,Xx     : single;    {resistance, reactance}
  Rrow,Xrow : integer;   {row for resistance, reactance in the main grid}
  txtF      : string;    {phase angle of impedance, in degrees, as text}
  txtR      : string;    {resistance as text}
  txtX      : string;    {reactance as text}
  txtZ      : string;    {impedance (magnitude)as text}
  Zz        : single;    {impedance}
begin
  {phase grid, or ground grid?}
  if (GorP = 'P') or (GorP = 'p') then begin  {phase grid}
    row := phase_row;             {row being edited}
    row1 := R1row;                {row of first resistance in main grid}
    pGrid := @PhaseGrid;          {grid with polar impedance}
  end else begin
    row := ground_row;
    row1 := R1Nrow;
    pGrid := @GroundGrid;
  end;
  {editing magnitude or phase of impedance? Even = magnitude}
  apu := row;
  apv := apu/2.;
  if (row div 2) = apv then begin            {even = editing magnitude}
    txtZ := pGrid^.cells[1,row];             {magnitude}
    txtF := pGrid^.cells[1,row+1];           {phase}
    Rrow := row1+row;                        {resistance row in main grid}
    Xrow := Rrow+1;
  end else begin                             {odd = editing phase}
    txtZ := pGrid^.cells[1,row-1];           {magnitude}
    txtF := pGrid^.cells[1,row];             {phase}
    Xrow := row1+row;
    Rrow := Xrow-1;
  end;
  {convert to polar form, in LineParam.pas}
  PolarToRec(txtZ, txtF, txtR, txtX, Rr,Xx,Zz,fii);
  {update main grid = R and X, if no errors}
  if (txtR <> '?') and (txtX <> '?') then begin
    PolyGrid.cells[1,Rrow] := txtR;
    PolyGrid.cells[1,Xrow] := txtX;
    pGrid^.color := clWindow;
  end else begin                    {some error in the entered values}
    pGrid^.color := clYellow;
  end;
end;
*)
procedure ZRToRec(textZ,textR : string; var txtR, txtX : string; var Rr,Xx,Zz: single);
{change complex number from magnitude and real part (Z,R) to rectangular (R,X)
 textZ  abs.value of the number to be changed, as text
 textR  resistance as text (input)
 txtR   real part, as text (output, same as textR)
 txtX   imag.part, as text
 Rr,Xx  real and imag.parts as singles
 Zz     magnitude the impedance}
const
  smallX2 = 0.0001;
var
  apu,apv,apw : single;  {temporary}
  err1,err2   : integer; {error flags}
  ii,jj       : integer; {indices}
  ipu         : integer; {temporary}
  len         : integer; {length of text}
  s1,s2,s3,s4 : string;  {temporary}
  text        : string;  {temporary}
begin
  ValuesFromLine(textZ, 1, false, ipu, Zz , apu, apv, apw, s1,s2,s3,s4,err1); {in routines.pas}
  ValuesFromLine(textR, 1, false, ipu, Rr, apu, apv, apw, s1,s2,s3,s4,err2);
  if (err1 = 0) and (err2 = 0) then begin
    apu := Zz*Zz-Rr*Rr;
    if (apu >= 0) then begin
      Xx := sqrt(apu);
      text := ManyChars(Xx,true);
      TxtX := spaceless(text);     {remove spaces}
    end else if (apu > -smallX2) then begin
      Xx := 0;
      TxtX := '0';
    end else begin
      Xx := 0;
      TxtX := '?';
    end;
    txtR := textR;
  end else begin
    TxtR := '?';
    TxtX := '?';
    Rr := 1;  {just some values}
    Xx := 0;
    Zz := 1;
  end;
end;

procedure TPolyRel.UpdateXinMainGrid(pGrid: TpGrid; row, row1 : integer);
{update X in the main grid, when Z in one of the small grids (GroundGrid or
 PhaseGrid has been edited
 pGrid  pointer to the small grid
 row    row index in the small grid being edited
 row1   row of first resistance}
var
  erf,erz    : integer;   {error flags}
  fii        : single;    {phase of impedance of line (radians)}
  kstrt,kend : integer;   {start, end of parameter}
  st1        : string;    {temporary}
  txt        : string;    {temporary}
  txtX       : string;    {reactance as text}
  txtZ       : string;    {impedance (magnitude)as text}
  Xrow       : integer;   {row for resistance, reactance in the main grid}
  Xx         : single;    {reactance}
  Zz         : single;    {impedance}
begin
  AlphaAngle(fii, erf);                {phase of impedance}
  txtZ := pGrid^.cells[1,row];             {magnitude}
  kstrt := 1;
  NextValueFromLine(txtZ, kstrt, kend, Zz, st1, erz); {impedance to numbers}
  if (erf = 0) and (erz = 0) then begin    {no errors in fii,Z}
    Xx := Zz*sin(fii);                       {reactance}
    txt := ManyChars(Xx,true);               {in LineParam.pas}
    txtX := spaceless(txt);                  {remove spaces}
    {Note: negative Z is interpreted as negative X}
    Xrow := row1+row;                        {row of reactance}
    PolyGrid.cells[1,Xrow] := txtX;
    pGrid^.color := clWindow;
  end else begin                             {some error}
    pGrid^.color := clYellow;
  end;
end;

procedure TPolyRel.FromZRToMainGrid(GorP: string);
{convert and copy impedance from Z-R grid to main grid in rectangular form
 NOTE: R is copied as such, X = Z sin(fi), where fi is the phase angle of the line
 GorP  if 'G' then ground grid, if 'P' then phase grid
 row   row being edited}
var
  apu,apv    : single;
  err        : integer;   {error flags}
  kstrt,kend : integer;   {start, end of parameter}
  pGrid      : TpGrid;    {pointer to the grid, phase or ground}
  row        : integer;   {row being edited}
  row1       : integer;   {row of first resistance in main grid}
  Rr         : single;    {resistance, reactance}
  Rrow       : integer;   {row for resistance, reactance in the main grid}
  st1        : string;    {temporary}
  textR      : string;    {ressitance in local grid, as text}
  txt        : string;    {temporary}
  txtR       : string;    {resistance as text}
begin
  {phase grid, or ground grid?}
  if (GorP = 'P') or (GorP = 'p') then begin  {phase grid}
    row := phase_row;             {row being edited}
    row1 := R1row;                {row of first resistance in main grid}
    pGrid := @PhaseGrid;          {grid with polar impedance}
  end else begin
    row := ground_row;
    row1 := R1Nrow;
    pGrid := @GroundGrid;
  end;
  {editing magnitude or resistance of impedance? Even = resistance}
  apu := row;
  apv := apu/2.;
  if (row div 2) = apv then begin            {even = editing resistance R}
    {resistance copied as such, if no errors}
    textR := pGrid^.cells[1,row];            {resistance}
    kstrt := 1;
    NextValueFromLine(textR, kstrt, kend, apu, st1, err); {resistance to numbers}
    if (err = 0) then begin
      Rrow := row1+row;
      PolyGrid.cells[1,Rrow] := textR;       {copy R as such, if no errors}
      pGrid^.color := clWindow;
    end else begin
      pGrid^.color := clYellow;
    end;
  end else begin                             {odd = magnitude (impedance Z)}
    UpdateXinMainGrid(pGrid, row, row1);
  end;
end;

procedure TPolyRel.PhaseGridKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
{convert and copy impedance from polar in "local" grid to rectangular R and X in main grid }
begin
  FromZRToMainGrid('P');
  if (key = 38) then begin             {up-arrow }
    if (PhasePanel.top < PolyGrid.top) then begin
      PolyGrid.toprow := PolyGrid.toprow-1;
    end;
    {set top coordinate of additional grids}
    SetGridTop;
  end;
  MarkImage.top := Poly.MarkImageTop(R1row,R1Nrow);
end;

procedure TPolyRel.GroundGridKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   {move to the main grid, if arrow key, and on top or bottom. Up arrow first}
   if (key = 38) and (GroundGrid.row = 0) and (GroundPanel.visible) then begin
    ActiveControl := PolyGrid;
    PolyGrid.row := T5row;
    PolyGrid.col := 1;
  end;
  {down-arrow}
  if (key = 40) and (GroundGrid.row = GroundGrid.RowCount-1) and (GroundPanel.visible) then begin
    ActiveControl := PolyGrid;
    PolyGrid.row := T1Nrow;
    PolyGrid.col := 1;
  end;
end;

procedure TPolyRel.GroundGridKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  FromZRToMainGrid('G');
  if (key = 38) then begin             {up-arrow }
    if (PhasePanel.top < PolyGrid.top) then begin
      PolyGrid.toprow := PolyGrid.toprow-1;
    end;
    {set top coordinate of additional grids}
    SetGridTop;
  end;
  {set top coordinate of additional grids}
  SetGridTop;
end;

procedure TPolyRel.GroundGridSelectCell(Sender: TObject; Col, Row: Longint;
  var CanSelect: Boolean);
begin
  ground_row := row;
end;

procedure TPolyRel.FlagEditChange(Sender: TObject);
{this edit is used to flag (possible) changes in the state of the Z-button (Zbut)
 The state may change in TDist.FromCompToGrid and TDist.FromParamGroupToGrid.
 The flag is set by changing the text of this edit component (Flagedit).
 If the state changes, the phase or ground grids are shown/are hidden}
begin
  UpdateImpedanceGrids;
end;

procedure TPolyRel.RelayBoxKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  TargetLabel.top := RelayBox.top+RelayBox.ItemIndex*RelayBox.ItemHeight;
end;

procedure TPolyRel.RelayBoxMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  TargetLabel.top := RelayBox.top+RelayBox.ItemIndex*RelayBox.ItemHeight;
end;

procedure TPolyRel.HelpItemClick(Sender: TObject);
begin
  PolyHintForm.visible := true;
end;

procedure TPolyRel.Zone5ItemClick(Sender: TObject);
begin
  Zone5Item.checked := not Zone5Item.checked;
  PolygonRelayShow;
end;

procedure TPolyRel.MultiRelButClick(Sender: TObject);
begin
  {no activetion test, if char. of several relays displayed}
//ActivationItem.enabled := not MultiRelBut.down;
  {hide the activation test, if several characteristics}
  if (MultiRelBut.down) then begin
    CloseButClick(sender);
    {reset flag "cancel-button clicked", see AddToRelayList, in distance.pas}
    CancelRelayBut.tag := 0;
  end else begin
    {clear additional relays from the graph, if button pushed up}
    Poly.RelaysFromList;
  end;
end;

procedure TPolyRel.NoteButClick(Sender: TObject);
begin
  NoteBut.visible := false;
end;

procedure TPolyRel.HenryEditKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  InductanceToReactance;
end;

procedure TPolyRel.CopyMemoKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
{copy the text to the component (relay)}
var
  line : string;  {the whole text in the memo}
  mlen : integer;
begin
  Poly.NotesMemoKeyUp(Sender, Key, Shift, line);
  ShowNotes(Poly.pDistNotes, line, mlen);     {copy to the "main" memo for notes, in skemproc.pas}

end;

procedure TPolyRel.CopyMemoMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
{move the memo with the mouse}
const
  h0  : integer = 0;    {old height}
  x0  : integer = 0;    {old coordinates}
  y0  : integer = 0;
  w0  : integer = 0;
begin
  MeMouseMove(CopyMemo, Shift, X, Y, h0,x0,y0,w0);
end;

end.


