{
- nyt kytetn annettua X2:a, ei lasketa kolmatta harmonista !
- ainakin short-komponentille tulokset kaksi kertaa oliolle:
    restocomp ja erikseen pTwoshort^...
- tulosten indeksi parametrilla, ei numerolla (putvar...)
- AmatOper  voisi tehd vain kun on synch.moottoreita}
{ changes - - - - - - - - - - - - - - - - - - - - - }
{10.12.2002  when adding fault current to solution vector, change sign, because
             pos. injected current is in, but pos.direction for the current of the
             fault component is out}

unit Twoshort;

interface

uses
SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
Forms, Dialogs, ExtCtrls, StdCtrls,Compdef,Cmatmul,Skemadef,Utildef,
Imagodef,Elplex,RelCurr,Skemproc,matmul,Shortcir,Shortcmp,distance, polygon;

procedure PhaseToPhaseShort(ipSet : longint; IsInitState : boolean);
procedure FindShort(pSet : TpCompSet; var pTwosc : TpComp);
procedure copyrhs(pRhs,pWs : pComplex; nnod : integer);
{procedure PhaseToSeq(Pa,Pb,Pc : complex; var Ps,Ns,Zs : complex);}
procedure SeqToPhase(Ps,Ns,Zs : complex; var Pa,Pb,Pc : complex);
procedure InjSCcurr(pComp: TpComp; pbb: pComplex; nn: integer; Isc : complex);
procedure clearrhs(pWs : pComplex; nnod : integer);
procedure AllVarSeqToPhase(pSet : TpCompSet);
procedure PosToNegMat(pSet : TpCompSet; paa,pzz : pComplex; nn : integer;fmult: single);
procedure SolveFaultCurrent(pVrhs,pWrk : pComplex; pTwosc : TpComp; pGM: TpGenMot;
                            nnod : integer;  var Ishort,Jp,Jn: complex);
procedure PosSeqNet(pTwosc : TpComp; nnod : integer; Jp : complex;
                    pVrh,pWrk : pComplex);
function Znegseq(R1,R2,X1,X2,X3,slip : single): complex;
procedure PerUnitVolt(pComp : TpComp);
(*procedure NegSeqNet(pTwosc : TpComp; pGM: TpGenMot; nnod : integer;
                     Jn : complex; pWrk : pComplex); *)
(*procedure PosSeq3rdNet(pTwosc : TpComp; nnod : integer; Jp : complex;
                       pVrh,pWrk : pComplex);*)
(*procedure AdditionalVoltageSource(pWrk: pComplex; pGM : TpGenMot;
                                 nnod, frqid : integer);*)
(*const
  iflag : integer = 0;  {for tests} *)
(**)
var
  pNmat   : pComplex;    {pointer to the zero sequence matrix}
  pIndexN : pInteger;    {pointer to array keeping track on row exchanges}
(*
  p3mat   : pComplex;    {pointer to the matrix for third harmonics}
  pIndex3 : pInteger;    {pointer to array keeping track on row exchanges}
  p3matN  : pComplex;    {pointer to the neg.seq. matrix for third harmonics}
  pIndex3N: pInteger;    {pointer to array keeping track on row exchanges}
*)
implementation

uses
 Imagopas, earthflt;

const
  czero : complex = (x : 0.0 ; y : 0.0);       {complex zero}
(*
var
  pNmat   : pComplex;    {pointer to the zero sequence matrix}
  pIndexN : pInteger;    {pointer to array keeping track on row exchanges}
  p3mat   : pComplex;    {pointer to the matrix for third harmonics}
  pIndex3 : pInteger;    {pointer to array keeping track on row exchanges}
  p3matN  : pComplex;    {pointer to the neg.seq. matrix for third harmonics}
  pIndex3N: pInteger;    {pointer to array keeping track on row exchanges}
*)
var
  pCT : TpComp; {temporary}
procedure FindShort(pSet : TpCompSet; var pTwosc : TpComp);
{find the short circuit(s)
 pSet    pointer to the set of components, etc.
 NOTE, only one accepted
 }
var
  errc    : integer;     {error flag}
  jcomp   : integer;     {counts components}
  ModNam  : string;      {name (type) of the component}
  n2sc    : integer;     {number of short circuits}
  pComp   : TpComp;      {pointer to components}
begin
  pComp := nil;                              {initialize pointer to components}
  errc  := 0;                                {initialize error flag}
  jcomp := 0;
  n2sc := 0;                                 {initialize number of short circuits}
  while (errc = 0) do begin                  {scan all components}
    pSet^.NextComp(pComp,errc,jcomp,true);   {get pointer to next component}
    if (errc = 0) then begin                 {component found}
      pComp^.GetModName(ModNam);             {get the name (type) of the component}
      if (ModNam = gshort) then begin        {is it a short}
        pComp^.var1_s := 0;                  {initialize guess for short circ. current}
{       pComp^.var2_s := 0;}
        inc(n2sc);                           {increment count of short circ.s}
        if (n2sc = 1) then begin             {first short}
          pTwosc := pComp;
        end else begin
          show_message('too many short circuits');
        end;
      end;
    end;
  end;
end;
(*  moved to Compdef.pas
procedure PhaseToSeq(Pa,Pb,Pc : complex; var Ps,Ns,Zs : complex);
{converts the phase variables to symmetrical components
 Ps   pos. seq. component
 Ns   neg. seq. component
 Zs   zero seq. component
 Pa,Pb,Pc  the phase variables
}
const
  eifii  : complex = (x : -0.5; y: 0.8660254); {exp(i fii), phase difference}
  emifii : complex = (x : -0.5; y:-0.8660254); {exp(-i fii) phase difference}
  one3rd = 0.3333333;
var
  cpu  : complex;  {temporary}
begin
  cpu := Cadd(Pa,Cadd(Pb,Pc));
  Zs  := Crmult(one3rd,cpu);
  cpu := Cadd(Cmult(eifii,Pb),Cmult(emifii,Pc));
  Ps  := Crmult(one3rd,Cadd(cpu,Pa));
  cpu := Cadd(Cmult(emifii,Pb),Cmult(eifii,Pc));
  Ns  := Crmult(one3rd,Cadd(cpu,Pa));
end;
*)
procedure SeqToPhase(Ps,Ns,Zs : complex; var Pa,Pb,Pc : complex);
{converts the symmetrical components to phase variables
 Ps   pos. seq. component
 Ns   neg. seq. component
 Zs   zero seq. component
 Pa,Pb,Pc  the phase variables
}
const
  eifii : complex = (x : -0.5; y: 0.8660254); {exp(i fii), phase difference}
  emifii: complex = (x : -0.5; y:-0.8660254); {exp(-i fii) phase difference}
var
  cpu  : complex;  {temporary}
begin
  Pa  := Cadd(Cadd(Ps,Ns),Zs);
  cpu := Cadd(Cmult(emifii,Ps),Cmult(eifii,Ns));
  Pb  := Cadd(cpu,Zs);
  cpu := Cadd(Cmult(eifii,Ps),Cmult(emifii,Ns));
  Pc  := Cadd(cpu,Zs);
end;

procedure PerUnitVolt(pComp : TpComp);
{save the bus voltage in volts, or calculate and save
 the per-unit voltage of bus or voltmeter: either as phase-phase voltage
 or phase neutral voltage, depending on the state of the voltBut in the main form
 pComp    pointer to the bus or voltmeter
 Called in Skemproc (2 times), Shortcir, Twoshort, Earthflt,...}
var
  apu,apv,apw : single;     {temporary}
  coef        : single;     {coefficient}
  ll          : longint;    {temporary}
  pSet        : TpCompSet;  {pointer to the common}
  Va,Vb,Vc    : complex;    {phase-neutral voltages}
  Vn          : single;     {nominal phase-phase voltage}
  Vab,Vbc,Vca : complex;    {phase-phase voltages}
begin
  pComp^.GetipSet(ll);      {pointer to common as integer}
  pSet := TpCompSet(ll);
  {get phase-neutral voltages}
  pComp^.GetVar(1,Va.x);
  pComp^.GetVar(2,Va.y);
  pComp^.GetVar(4,Vb.x);
  pComp^.GetVar(5,Vb.y);
  pComp^.GetVar(7,Vc.x);
  pComp^.GetVar(8,Vc.y);
  pComp^.GetPar(gBus_Vn,Vn);                     {nominal phase-phase voltage}
  if (pSet^.Volt_Form = PhasePhase_g) then begin {displaying phase-phase voltages}
    {calculate phase-phase voltages}
    Vab := Csub(Va,Vb);
    Vbc := Csub(Vb,Vc);
    Vca := Csub(Vc,Va);
    if (Vn > 0) then begin
      {per-unit phase-phase voltages}
      apu := Cabs(Vab)/Vn;
      apv := Cabs(Vbc)/Vn;
      apw := Cabs(Vca)/Vn;
    end else begin           {not reasonable nominal voltage}
      apu := 1;
      apv := 1;
      apw := 1;
    end;
  end else begin            {phase-neutral or sqrt3*phase-neutral voltage}
    if (Vn > 0) then begin
      {note Vn is nominal phase-phase voltage}
//      if (pSet^.Volt_Form = PhaseNeutral_g) then coef := sqrt3 else coef := 1;
      coef := sqrt3;
      {per unit phase-neutral voltages*sqrt(3)}
      apu := coef*Cabs(Va)/Vn;
      apv := coef*Cabs(Vb)/Vn;
      apw := coef*Cabs(Vc)/Vn;
    end else begin
      apu := 1;
      apv := 1;
      apw := 1;
    end;
  end;
  {save the per unit voltages to the component}
  pComp^.PutVar(3,apu,'PerUnitVolt');
  pComp^.PutVar(6,apv,'PerUnitVolt');
  pComp^.PutVar(9,apw,'PerUnitVolt');
end;

procedure VarSeqToPhase(pComp: TpComp);
{change the sequence variables of one component to phase variables
 pComp   pointer to the component
}
var
  apu,apv,apw : single;    {temporary}
  cpu,cpv,cpw : complex;   {temporary}
  cpa,cpb,cpc : complex;   {temporary}
  ii          : integer;   {index}
  ix1,iy1     : integer;   {indices for the components of complex var. }
  ix2,iy2     : integer;
  ix0,iy0     : integer;
  name        : string;    {name = type of the component}
  nvar        : integer;   {number of variables}
  mult        : integer;   {the multiplicity of the set of variables}
  Vn          : single;    {nominal phase-phase voltage}
begin
  try
    if (pComp <> nil) then begin
      pComp^.GetName(name);
      pComp^.GetMult(mult);                    {get the multiplicity of the set of variables}
      pComp^.GetNvar(nvar);
      if (mult >= 3) and (nvar > 1) then begin {three phases, at least, and some variable(s)}
        for ii:=1 to (nvar div 2)  do begin    {all variables}
          iy1 := 2*ii;                {imag.part of pos.seq}
          ix1 := iy1-1;               {real part of pos.seq}
          iy2 := nvar+iy1;            {imag.part of neg.seq.}
          ix2 := iy2-1;               {real part of neg.seq.}
          iy0 := 2*nvar+iy1;          {imag.part of zero seq.}
          ix0 := iy0-1;               {real part of zero seq.}
          {read the sequence variables}
          pComp^.GetVar(ix1,cpu.x);   {read real part of pos.seq}
          pComp^.GetVar(iy1,cpu.y);   {read imag part of pos.seq}
          pComp^.GetVar(ix2,cpv.x);   {read real part of neg.seq}
          pComp^.GetVar(iy2,cpv.y);   {read imag part of neg.seq}
          pComp^.GetVar(ix0,cpw.x);   {read real part of zero.seq}
          pComp^.GetVar(iy0,cpw.y);   {read imag part of zero.seq}
          {change to phase variables}
          SeqToPhase(cpu,cpv,cpw,cpa,cpb,cpc);
          {write the phase variables to the component}
          pComp^.PutVar(ix1,cpa.x,'VarSeqToPhase');   {write real part of phase a}
          pComp^.PutVar(iy1,cpa.y,'VarSeqToPhase');   {write imag part of phase a}
          pComp^.PutVar(ix2,cpb.x,'VarSeqToPhase');   {write real part of phase b}
          pComp^.PutVar(iy2,cpb.y,'VarSeqToPhase');   {write imag part of phase b}
          pComp^.PutVar(ix0,cpc.x,'VarSeqToPhase');   {write real part of phase c}
          pComp^.PutVar(iy0,cpc.y,'VarSeqToPhase');   {write imag part of phase c}
        end;
        {check for a "leftover", so far only Load-component and bus should have one}
        if ((nvar div 2) <> nvar/2) then begin
          if (name = gBus) or (name = 'Voltmeter') then begin {bus, or voltmeter}
            PerUnitVolt(pComp);       {per unit voltage in the bus}
          end else begin              {load, or ?}
            {sum the leftover for all phases = total power, and put the sum back}
            pComp^.GetVar(nvar,apu);
            pComp^.GetVar(2*nvar,apv);
            pComp^.GetVar(3*nvar,apw);
            apu := apu+apv+apw;
            pComp^.PutVar(nvar,apu,'VarSeqToPhase');
            pComp^.PutVar(2*nvar,apu,'VarSeqToPhase');
            pComp^.PutVar(3*nvar,apu,'VarSeqToPhase');
          end;
        end;
      end;
if (mult = 6) then pCT := pComp;
    end;
  finally
  end;
end;

procedure AllVarSeqToPhase(pSet : TpCompSet);
{change all variables of all components from seq. var. to phase variables
 pSet   pointer to the set of components etc
}
var
  cpa,cpb : complex;
  cpc     : complex;
  cpu,cpv : complex;
  cpw     : complex;
  jcomp   : integer;   {counts components}
  pComp   : TpComp;    {pointer to a component}
  err_c   : integer;   {error flag}
begin
  pComp := nil;                  {initialize pointer to component}
  err_c := 0;                    {initialize error flag}
  jcomp := 0;
  while(err_c = 0) do begin      {scan all components}
    pSet^.NextComp(pComp,err_c,jcomp,true); {get pointer to next component}
    if (err_c = 0) then begin
//    if (pComp^.hint <> gSumCT) then begin  {not sum current transformer}
        VarSeqToPhase(pComp);        {this comp from seq. to phase}
(*    end else begin                 {sum current trafo}
        pComp^.GetVar(1,cpu.x);      {read real part of pos.seq}
        pComp^.GetVar(2,cpu.y);      {read imag part of pos.seq}
        pComp^.GetVar(3,cpv.x);      {read real part of neg.seq}
        pComp^.GetVar(4,cpv.y);      {read imag part of neg.seq}
        pComp^.GetVar(5,cpw.x);      {read real part of zero.seq}
        pComp^.GetVar(6,cpw.y);      {read imag part of zero.seq}
        {change to phase variables}
        SeqToPhase(cpu,cpv,cpw,cpa,cpb,cpc);
        cpu := Cadd(cpa,Cadd(cpb,cpc));
        {write the phase variables to the component}
        pComp^.PutVar(1,cpu.x);
        pComp^.PutVar(2,cpu.y);      {same sum to all phases}
        pComp^.PutVar(3,cpu.x);
        pComp^.PutVar(4,cpu.y);
        pComp^.PutVar(5,cpu.x);
        pComp^.PutVar(6,cpu.y);
      end;*)
    end;
  end;
end;

procedure InjSCcurr(pComp: TpComp; pbb: pComplex; nn: integer; Isc : complex);
{adds the contribution of a two phase short circuit to the right hand side
 of the set of equations for solving the voltages (and some currents)
 The contribution = the injected short circuit current
 ......
 pComp  = pointer to the component (fault)
 pbb    = pointer to the rhs
 nn     = dimension
 Isc    = the injected short circuit current
}
var
  cpu     : complex;   {temporary}
  er      : integer;   {error sum}
  ju      : integer;   {upstream node}
begin
  try                                {try to protect from (pointer) errors}
    pComp^.GetNode(1,ju,er);         {get node}
    if (ju > 0) and (ju <= nn) and   {reasonable upstream node}
       (er = 0) then begin           {and no errors}
      {inject current = update rhs }
      getCvec(pbb,ju,nn,cpu);        {get present value of rhs}
      cpu := Cadd(cpu,Isc);          {add injected current}
      putCvec(pbb,ju,nn,cpu);        {put new value back to rhs}
    end;
  finally
  end;
end;

procedure copyrhs(pRhs,pWs : pComplex; nnod : integer);
{copy the rhs to working space
 pRhs   pointer to the rhs
 pWs    pointer to the workingspace
 nnod   number of elements (nodes)
 }
var
  ii  : integer;  {index}
  cpu : complex;  {temporary}
begin
  for ii:=1 to nnod do begin
    getCvec(pRhs,ii,nnod,cpu);             {get rhs of eq. i}
    putCvec(pWs,ii,nnod,cpu);              {put it to working space}
  end;
end;

procedure clearrhs(pWs : pComplex; nnod : integer);
{fill the rhs with (complex) zeroes
 pWs   pointer to the rhs
 nnod  number of elements (nodes)}
var
  cpu  : complex;  {temporary}
  ii   : integer;  {index}
begin
  cpu.x := 0; cpu.y := 0;                  {complex zero}
  for ii:=1 to nnod do begin
    putCvec(pWs,ii,nnod,cpu);              {fill rhs with zeroes}
  end;
end;

procedure TrafoYDNeg(pComp: TpComp; paa,pbb: pComplex; nn: integer; par: single;
          short: integer; fmult: single);
{For a Y-D transformator,
 updates AN EXISTING, extended admittance matrix to the matrix
 of the neg. sequence.
 pComp    pointer to the component (trafo)
 paa      pointer to the coefficient matrix
 pbb      pointer to the right hand side (not used ?)
 nn       dimension = number of nodes (excluding earth)
 par      a parameter (usually frequency, not used ?)
 short    flag for a short circuit (not used ?)
 fmult    frequency multiplier (not used ?)}
var
  apu     : single;    {temporary}
  cpu     : complex;   {temporary}
  jcp,jcs : integer;   {"nodes" for prim, sec. current}
  jup,jus : integer;   {nodes for prim, sec. voltage}
  jcc     : integer;   {node for current in D-coli}
  er1,er2 : integer;   {error flag}
  er3,er4 : integer;   {error flag}
  er5     : integer;   {error flag}
begin
{ cs.x := 0.5; cs.y := -0.5*sqrt(3.0); {... shift term divided by the other }
  pComp^.GetNode(1,jup,er3);           {get upstr.  node on primary side}
  pComp^.GetNode(2,jus,er4);           {get upstr.  node on sec. side}
  pComp^.GetNode(3,jcp,er1);           {get "node" for primary current}
  pComp^.GetNode(4,jcs,er2);           {get "node" for sec. current}
  pComp^.GetNode(6,jcc,er5);           {get "node" for sec.current (in D)}
  {relation between current into D side, and current in D-coil}
  if (jcs > 0) and (jcs <= nn) and (jcc > 0) and (jcc <= nn) then begin
    pComp^.GetPar(gYD_phase,apu);
    getCmat(paa,jcs,jcc,nn,nn,cpu);
    cpu.y := -cpu.y;
    putCmat(paa,jcs,jcc,nn,nn,cpu);
  end;
  {differently for ideal trafo}
  if (imagoo.IdealTrBut.down) then  begin
    {voltage ratio}
    if (jus > 0) and (jus <= nn) then begin
      getCmat(paa,jcp,jus,nn,nn,cpu);
      cpu.y := -cpu.y;
      putCmat(paa,jcp,jus,nn,nn,cpu);
    end;
  end else begin                           {normal, nonideal trafo}
    {combined trafo equation}
    if (jcc > 0) and (jcc <= nn) and (jus > 0) and (jus <= nn) then begin
      getCmat(paa,jcc,jus,nn,nn,cpu);
      cpu.y := -cpu.y;   {this should be more correct 9.2.01}
      putCmat(paa,jcc,jus,nn,nn,cpu);
    end;
  end;
end;

procedure AutoTrafoYDNeg(pComp: TpComp; paa,pbb: pComplex; nn: integer; par: single;
          short: integer; fmult: single);
{For a Y-D autotrasformer,
 updates AN EXISTING, extended admittance matrix to the matrix
 of the neg. sequence.
 pComp    pointer to the component (trafo)
 paa      pointer to the coefficient matrix
 pbb      pointer to the right hand side (not used ?)
 nn       dimension = number of nodes (excluding earth)
 par      a parameter (usually frequency, not used ?)
 short    flag for a short circuit (not used ?)
 fmult    frequency multiplier (not used ?)}
var
  cpu     : complex;   {temporary}
  Dflag   : single;    {delta connected tertiary}
  jcp,jcs : integer;   {"nodes" for prim, sec. current}
  jup,jus : integer;   {nodes for prim, sec. voltage}
  jcc     : integer;   {node for current in D-coli}
  jtw,jut : integer;
  er1,er2 : integer;   {error flag}
  er3,er4 : integer;   {error flag}
  er5     : integer;   {error flag}
  jvs,jct : integer;
begin
  pComp^.GetPar(gATrafo_D,Dflag);     {flag for D-tertiary}
  if (Dflag <> 0) then begin
    {AUTOTRAFO (YYD) with D tertiary}
    {pos. to neg. circulation}
    pComp^.GetNode(10,jtw,er3);
    pComp^.GetNode(9,jct,er2);
    pComp^.GetNode(3,jut,er5);
    if (jct > 0) and (jct <= nn) then begin
      if (jut > 0) and (jut <= nn) then begin
        getCmat(paa,jct,jut,nn,nn,cpu);
        cpu.y := -cpu.y;
        putCmat(paa,jct,jut,nn,nn,cpu);
      end;
    end;
    if (jtw > 0) and (jtw <= nn) then begin
      getCmat(paa,jtw,jtw,nn,nn,cpu);
      cpu.y := -cpu.y;
      putCmat(paa,jtw,jtw ,nn,nn,cpu);
    end;



  end;  
end;

procedure IdealYDNeg(pComp: TpComp; paa,pbb: pComplex; nn: integer; par: single;
          short: integer; fmult: single);
{For an ideal Y-D transformator,
 updates AN EXISTING, extended admittance matrix to the matrix
 of the neg. sequence.
 pComp    pointer to the component (trafo)
 paa      pointer to the coefficient matrix
 pbb      pointer to the right hand side (not used ?)
 nn       dimension = number of nodes (excluding earth)
 par      a parameter (usually frequency, not used ?)
 short    flag for a short circuit (not used ?)
 fmult    frequency multiplier (not used ?)}
var
//apu     : single;    {temporary}
  cpu     : complex;   {temporary}
  jcp,jcs : integer;   {"nodes" for prim, sec. current}
  jup,jus : integer;   {nodes for prim, sec. voltage}
  jcc     : integer;   {node for current in D-coli}
  er1,er2 : integer;   {error flag}
  er3,er4 : integer;   {error flag}
  er5     : integer;   {error flag}
begin
  pComp^.GetNode(1,jup,er3);           {get upstr.  node on primary side}
  pComp^.GetNode(2,jus,er4);           {get upstr.  node on sec. side}
  pComp^.GetNode(3,jcp,er1);           {get "node" for primary current}
  pComp^.GetNode(4,jcs,er2);           {get "node" for sec. current}
  pComp^.GetNode(6,jcc,er5);           {get "node" for sec.current (in D)}
  {relation between current into D side, and current in D-coil}
  if (jcs > 0) and (jcs <= nn) and (jcc > 0) and (jcc <= nn) then begin
//  pComp^.GetPar(gYD_phase,apu);
    getCmat(paa,jcs,jcc,nn,nn,cpu);
    cpu.y := -cpu.y;
    putCmat(paa,jcs,jcc,nn,nn,cpu);
  end;
  {simply for an ideal trafo}
  if (jus > 0) and (jus <= nn) then begin
    getCmat(paa,jcp,jus,nn,nn,cpu);
    cpu.y := -cpu.y;
    putCmat(paa,jcp,jus,nn,nn,cpu);
  end;
end;

procedure TrafoDYNeg(pComp: TpComp; paa,pbb: pComplex; nn: integer; par: single;
                     short: integer; fmult: single);
{For a D-Y transformator,
 updates AN EXISTING, extended admittance matrix to the matrix
 of the neg. sequence.
 pComp    pointer to the component (trafo)
 paa      pointer to the coefficient matrix
 pbb      pointer to the right hand side (not used ?)
 nn       dimension = number of nodes (excluding earth)
 par      a parameter (usually frequency, not used ?)
 short    flag for a short circuit (not used ?)
 fmult    frequency multiplier (not used ?)}
var
  cpu     : complex;   {temporary}
{ cs      : complex;   {correction coefficient}
  jcp,jcs : integer;   {"nodes" for prim, sec. current}
  jup,jus : integer;   {nodes for prim, sec. voltage}
  jcc     : integer;   {node for current in D-coli}
  er1,er2 : integer;   {error flag}
  er3,er4 : integer;   {error flag}
  er5     : integer;   {error flag}
begin
{ cs.x := 0.5; cs.y := -0.5*sqrt(3.0); {... shift term divided by the other }
  pComp^.GetNode(1,jup,er3);           {get upstr.  node on primary side}
  pComp^.GetNode(2,jus,er4);           {get upstr.  node on sec. side}
  pComp^.GetNode(3,jcp,er1);           {get "node" for primary current}
  pComp^.GetNode(4,jcs,er2);           {get "node" for sec. current}
  pComp^.GetNode(6,jcc,er5);           {get "node" for sec.current (in D)}
  {relation between current into D side, and current in D-coil}
  if (jcp > 0) and (jcp <= nn) and (jcc > 0) and (jcc <= nn) then begin
    getCmat(paa,jcp,jcc,nn,nn,cpu);
    cpu.y := -cpu.y;
    putCmat(paa,jcp,jcc,nn,nn,cpu);
  end;
  {differently for ideal trafo}
  if (imagoo.IdealTrBut.down) then  begin
    {voltage ratio}
    if (jup > 0) and (jup <= nn) then begin
      getCmat(paa,jcs,jup,nn,nn,cpu);
      cpu.y := -cpu.y;
      putCmat(paa,jcs,jup,nn,nn,cpu);
    end;
  end else begin
    {combined trafo equation}
    if (jcc > 0) and (jcc <= nn) and (jup > 0) and (jup <= nn) then begin
      getCmat(paa,jcc,jup,nn,nn,cpu);
      cpu.y := -cpu.y;   {this should be more correct 9.2.01}
      putCmat(paa,jcc,jup,nn,nn,cpu);
    end;
  end;
end;

procedure TrafoDDNeg(pComp: TpComp; paa,pbb: pComplex; nn: integer; par: single;
                     short: integer; fmult: single);
{For a D-D transformator,
 updates AN EXISTING, extended admittance matrix to the matrix
 of the neg. sequence.
 pComp    pointer to the component (trafo)
 paa      pointer to the coefficient matrix
 pbb      pointer to the right hand side (not used ?)
 nn       dimension = number of nodes (excluding earth)
 par      a parameter (usually frequency, not used ?)
 short    flag for a short circuit (not used ?)
 fmult    frequency muliplier (not used ?)}
var
  cpu     : complex;   {temporary}
  cs      : complex;   {correction coefficient}
  jcp,jcs : integer;   {"nodes" for prim, sec. current}
  jup,jus : integer;   {nodes for prim, sec. voltage}
  jcc     : integer;   {"node" for current in prim D-coil}
  jss     : integer;   {"node" for current in sec. D-coil}
  er1,er2 : integer;   {error flag}
  er3,er4 : integer;   {error flag}
  er5,er6 : integer;   {error flag}
begin
  cs.x := 0.5; cs.y := -0.5*sqrt(3.0); {... shift term divided by the other }
  pComp^.GetNode(1,jup,er3);           {get upstr.  node on primary side}
  pComp^.GetNode(2,jus,er4);           {get upstr.  node on sec. side}
  pComp^.GetNode(3,jcp,er1);           {get "node" for primary current}
  pComp^.GetNode(4,jcs,er2);           {get "node" for sec. current}
  pComp^.GetNode(5,jcc,er5);           {get "node" for prim.current (in D)}
  pComp^.GetNode(6,jss,er6);           {get "node" for sec.current (in D)}
  {differently for an ideal transformer}
  if (imagoo.IdealTrBut.down) then  begin
    {current ratio: prim.current <-> prim. winding current}
    cpu := cplx(-0.5,{-}sqrt3/6);
    putCmat(paa,jcc,jcp ,nn,nn,cpu);
    {current ratio: secondary winding current <-> secondary current}
    cpu := cplx(-0.5,{-}sqrt3/6);
    putCmat(paa,jcs,jcs,nn,nn,cpu);
  end else begin                       {normal, nonideal trafo}
    {relation between current into D side, and current in D-coil}
    if (jcp > 0) and (jcp <= nn) and (jcc > 0) and (jcc <= nn) then begin
      cpu.x := -1.5; cpu.y := -0.5*sqrt(3.0);
      putCmat(paa,jcp,jcc,nn,nn,cpu);
    end;
    if (jcs > 0) and (jcs <= nn) and (jss > 0) and (jss <= nn) then begin
      cpu.x := -1.5; cpu.y := -0.5*sqrt(3.0);
      putCmat(paa,jcs,jss,nn,nn,cpu);
    end;
    {eq. for prim.side}
    if (jcc > 0) and (jcc <= nn) and (jup > 0) and (jup <= nn) then begin
      getCmat(paa,jcc,jup,nn,nn,cpu);
      {cpu := Cmult(cpu,cs);}
      cpu.y := -cpu.y;         {more correct ? 9.2.01}
      putCmat(paa,jcc,jup,nn,nn,cpu);
    end;
    {combined trafo equation}
    if (jss > 0) and (jss <= nn) then begin
      if (jus > 0) and (jus <= nn) then begin
        getCmat(paa,jss,jus,nn,nn,cpu);
        cpu := Cmult(cpu,cs);
        putCmat(paa,jss,jus,nn,nn,cpu);
      end;
      if (jup > 0) and (jup <= nn) then begin
        getCmat(paa,jss,jup,nn,nn,cpu);
        {cpu := Cmult(cpu,cs);}
        cpu.y := -cpu.y;        {more correct ?, 9.2.01}
        putCmat(paa,jss,jup,nn,nn,cpu);
      end;
    end;
  end;
end;
(**)
procedure TrafoYYDNeg(pComp: TpComp; paa,pbb: pComplex; nn: integer; par: single;
          short: integer; fmult: single);
{For a Y-Y-D transformator,
 updates AN EXISTING, extended admittance matrix to the matrix
 of the neg. sequence.
 pComp    pointer to the component (trafo)
 paa      pointer to the coefficient matrix
 pbb      pointer to the right hand side (not used ?)
 nn       dimension = number of nodes (excluding earth)
 par      a parameter (usually frequency, not used ?)
 short    flag for a short circuit (not used ?)
 fmult    frequency multiplier (not used ?)}
var
  cpu     : complex;
  er      : integer;    {error flag}
  jc2,jc3 : integer;    {"node" for input current}
  jn3     : integer;    {"node" for winding current}
  ju3     : integer;    {voltage node}
begin
  pComp^.GetNode(3,ju3,er);
  pComp^.GetNode(5,jc2,er);
  pComp^.GetNode(6,jc3,er);
  pComp^.GetNode(9,jn3,er);
  {ideal transformer ?}
  if (imagoo.IdealTrBut.down) then begin
    {voltage ratio}
    if (ju3 > 0) and (ju3 <= nn) then begin
      getCmat(paa,jc2,ju3,nn,nn,cpu);
      cpu.y := -cpu.y;
      putCmat(paa,jc2,ju3,nn,nn,cpu);
    end;
    {current ratio: winding <-> tertiary}
    getCmat(paa,jn3,jn3,nn,nn,cpu);
    cpu.y := -cpu.y;
    putCmat(paa,jn3,jn3,nn,nn,cpu);
  end else begin                         {nonideal trafo}
    {relation between input current and winding current}
    getCmat(paa,jc3,jn3,nn,nn,cpu);
    cpu.y := -cpu.y;
    putCmat(paa,jc3,jn3,nn,nn,cpu);
    {...}
    getCmat(paa,jc2,ju3,nn,nn,cpu);
    cpu.x := -cpu.x;
    putCmat(paa,jc2,ju3,nn,nn,cpu);
    {current-voltage equation for the D-winding}
    getCmat(paa,jn3,ju3,nn,nn,cpu);
    cpu.y := -cpu.y;
    putCmat(paa,jn3,ju3,nn,nn,cpu{cplx(-1.5,0.5*sqrt3)});
  end;
end;
(**)
(*
procedure TrafoYYDNeg(pComp: TpComp; paa,pbb: pComplex; nn: integer; par: single;
          short: integer; fmult: single);
{For a Y-Y-D transformator,
 updates AN EXISTING, extended admittance matrix to the matrix
 of the neg. sequence.
 pComp    pointer to the component (trafo)
 paa      pointer to the coefficient matrix
 pbb      pointer to the right hand side (not used ?)
 nn       dimension = number of nodes (excluding earth)
 par      a parameter (usually frequency, not used ?)
 short    flag for a short circuit (not used ?)
 fmult    frequency multiplier (not used ?)}
const
  ckx = 0.5;
  cky = sqrt3/6;
  crx = 1.5;
  cry = 0.5*sqrt3;
var
  cknp        : complex;   {ratio of neg/pos seq. coefficients}
  cpu,cpv     : complex;   {temporary}
  crnp        : complex;   {ratio of neg/pos seq. coefficients}
  er1,er2     : integer;   {error flag}
  er3,er4     : integer;   {error flag}
  ersum       : integer;   {sum of error flags}
  jc1,jc2,jc3 : integer;   {current "nodes"}
  ju3         : integer;   {voltage node of winding 3 }
begin
  cknp := Cdiv(cplx(ckx,-cky),cplx(ckx,cky));
  crnp := Cdiv(cplx(crx,-cry),cplx(crx,cry));
  pComp^.GetNode(4,jc1,er1);      {current node of winding 1}
  pComp^.GetNode(5,jc2,er2);
  pComp^.GetNode(6,jc3,er3);
  pComp^.GetNode(3,ju3,er4);      {voltage node of winding 3 (the D-winding)}
  ersum := er1+er2+er3+er4;
  if (ersum = 0) then begin
    if (jc1 > 0) and (jc1 <= nn) and (jc3 > 0) and (jc3 <= nn) then begin
      getCmat(paa,jc1,jc3,nn,nn,cpu);
      cpu := Cmult(cknp,cpu);
      putCmat(paa,jc1,jc3,nn,nn,cpu);
    end;
    if (jc2 > 0) and (jc2 <= nn) and (ju3 > 0) and (ju3 <= nn) then begin
      getCmat(paa,jc2,ju3,nn,nn,cpu);
      cpu := Cmult(crnp,cpu);
      putCmat(paa,jc2,ju3,nn,nn,cpu);
    end;
    if (jc2 > 0) and (jc2 <= nn) and (jc3 > 0) and (jc3 <= nn) then begin
      getCmat(paa,jc2,jc3,nn,nn,cpu);
      cpu := Cmult(crnp,cpu);
      putCmat(paa,jc2,jc3,nn,nn,cpu);
    end;
    if (jc3 > 0) and (jc3 <= nn) and (ju3 > 0) and (ju3 <= nn) then begin
      putCmat(paa,jc3,ju3,nn,nn,cplx(-crx,cry));
    end;
    if (jc3 > 0) and (jc3 <= nn) then begin
      getCmat(paa,jc3,jc3,nn,nn,cpu);
      cpu := Cmult(cknp,cpu);
      putCmat(paa,jc3,jc3,nn,nn,cpu);
    end;
  end;
end;
*)
procedure Trafo3wNeg(pComp: TpComp; paa,pbb: pComplex; nn: integer; par: single;
          short: integer; fmult: single);
{For different three-winding transformers
 updates AN EXISTING, extended admittance matrix to the matrix
 of the neg. sequence.
 pComp    pointer to the component (trafo)
 paa      pointer to the coefficient matrix
 pbb      pointer to the right hand side (not used ?)
 nn       dimension = number of nodes (excluding earth)
 par      a parameter (usually frequency, not used ?)
 short    flag for a short circuit (not used ?)
 fmult    frequency multiplier (not used ?)}
var
  apu      : single;   {temporary}
  TrafoTyp : integer;  {type of the trafo , YYY, YYD, etc}
begin
  pComp^.GetPar(g3W_type,apu);    {type of the trafo}
  TrafoTyp := round(apu);
  if (TrafoTyp = 1) then begin    {YYY-trafo}
    {for a YYY-trafo neg.seq equations = pos.seq. eq, => do nothing}
  end else begin                  {YYD-transformer}
    TrafoYYDNeg(pComp, paa,pbb, nn, par, short, fmult);
  end;
end;

procedure GeneratNeg(pComp: TpComp; paa,pbb: pComplex; nn: integer; par: single;
                     short: integer; fmult: single);
{For a generator,
 updates AN EXISTING, extended admittance matrix to the matrix
 of the neg. sequence.
 pComp    pointer to the component (trafo)
 paa      pointer to the coefficient matrix
 pbb      pointer to the right hand side (not used ?)
 nn       dimension = number of nodes (excluding earth)
 par      a parameter (frequency)
 short    flag for a short circuit (not used ?)
 fmult    frequency muliplier }
var
  apu     : single;    {temporary}
  cpu     : complex;   {temporary}
  er      : integer;   {error flag}
  jc      : integer;   {"node" for current}
  Xd,Xdd  : single;    {reactances}
  Xd2d    : single;    {subtransient reactance}
begin
  pComp^.getNode(2,jc,er);                         {get "node" for current}
  ReadGenReact(pComp, Xd, Xdd, Xd2d);              {read reactances}
(*if (fmult <= 1) then apu := 0.5*(Xd-Xdd)         {0.75*w*Mf**2/Lff}
  { is this (else) correct, because 3rd pos. seq already has a "feedback"}
  else                 apu := 0.5*(Xd-Xdd)*fmult;  {for (3rd) harmonic} *)
  if (fmult <= 1) then apu := 0.5*(Xd-Xd2d)        {when X'' included}
  {Remember: 3rd.pos. seq arleady has a "feedback" !}
  else                 apu := 0;                   {nothing more for (3rd) harmonic}
  {"feedback" through 3rd harmonics, but differently for first and third harm.}
  GetCmat(paa,jc,jc,nn,nn,cpu);             {old coefficient}
(*  if (fmult <= 1) then begin*)
    {onko vaihe-ero otettu oikein huomioon ?? cos(wt+alpha)}
    cpu.y := cpu.y-apu;                       {contribution for neg.seq}
    PutCmat(paa,jc,jc,nn,nn,cpu);             {put coefficient back}
(*  end;  {3rd.harm. later....}*)
end;

procedure FeedNeg(pComp: TpComp; paa,pbb: pComplex; nn: integer; par: single;
                  short: integer; fmult: single);
{ For a feeder,
 updates AN EXISTING, extended admittance matrix to the matrix
 of the neg. sequence.
 pComp    pointer to the component
 paa      pointer to the coefficient matrix
 pbb      pointer to the right hand side (not used ?)
 nn       dimension = number of nodes (excluding earth)
 par      a parameter (frequency)
 short    flag for a short circuit (not used ?)
 fmult    frequency muliplier }
var
  cpu     : complex;   {temporary}
  er      : integer;   {error flag}
  jc      : integer;   {"node" for current}
  ll      : longint;
  pSet    : TpCompSet; {pointer to the common}
  R2      : single;    {neg.seq. resistance}
  X2      : single;    {neg.seq. reactance}
  zc      : complex;   {neg.seq. impedance}
begin
  pComp^.GetipSet(ll);
  pSet := TpCompSet(ll);
  pComp^.getNode(2,jc,er);                  {get "node" for current}
  pComp^.getPar(gFeed_R2,R2);
  pComp^.getPar(gFeed_X2,X2);
  {if open line fault, the impedance must not be too small}
  if (pSet^.appl_op = 16) or (pSet^.appl_op = 17) then begin
    if (sqrt(R2*R2+X2*X2) < 0.001) then zc := cplx(0.001,0)
    else zc := cplx(R2,X2);
  end else begin
    zc := cplx(R2,X2);
  end;
  {IEC-multiplier, if IEC-calculation}
  cpu := Crmult(ImpedMult(pComp),zc);       {in earthflt.pas}
  PutCmat(paa,jc,jc,nn,nn,cpu);             {replace pos.seq. impedance}
end;

procedure GeneratNeg2(pComp: TpComp; paa,pbb: pComplex; nn: integer; par: single;
                     short: integer; fmult: single);
{A test version, using X2, no harmonics
 For a generator,
 updates AN EXISTING, extended admittance matrix to the matrix
 of the neg. sequence.

 pComp    pointer to the component (trafo)
 paa      pointer to the coefficient matrix
 pbb      pointer to the right hand side (not used ?)
 nn       dimension = number of nodes (excluding earth)
 par      a parameter (frequency)
 short    flag for a short circuit (not used ?)
 fmult    frequency muliplier }
var
  cpu     : complex;   {temporary}
  er      : integer;   {error flag}
  ipSet   : longint;   {pointer to the common, as integer}
  jc      : integer;   {"node" for current}
  ngp     : single;    {number of parallel generators}
  pSet    : TpCompSet; {pointer to the common}
  X2      : single;    {neg.seq. reactance}
  Xd,Xdd  : single;    {reactances}
  Xd2d    : single;    {subtransient reactance}
begin
  pComp^.getipSet(ipSet);
  pSet := TpCompSet(ipSet);
  pComp^.getNode(2,jc,er);                  {get "node" for current}
  ngp := nGenP(pComp);                      {number of parallel generators, in elplex.pas}
  pComp^.getPar(gGen_X2,X2);
  X2 := X2/ngp;
  ReadGenReact(pComp, Xd, Xdd, Xd2d);       {read reactances}
  GetCmat(paa,jc,jc,nn,nn,cpu);             {old coefficient}
  {check that reasonable}
  if (X2 >= 0) then
    cpu.y := X2
  else
    cpu.y := Xd2d;                          {change reactance to X2 = X''}
  {if IEC-calculation, multiply with the correction factor..
   but not when calculating sequence impedances}
  if ((Imagoo.IECBut.down) and not(pSet^.appl_but = 15)) or
     (pSet^.appl_op = 14) then
    cpu := Crmult(pComp^.var1_s,cpu);
  PutCmat(paa,jc,jc,nn,nn,cpu);             {put coefficient back}
end;

procedure SMotNeg(pComp: TpComp; paa,pbb: pComplex; nn: integer; par: single;
                     short: integer; fmult: single);
{For a synchronous motor
 updates AN EXISTING, extended admittance matrix to the matrix
(almost like a generator)
 pComp    pointer to the component (motor)
 paa      pointer to the coefficient matrix
 pbb      pointer to the right hand side (not used ?)
 nn       dimension = number of nodes (excluding earth)
 par      a parameter (frequency)
 short    flag for a short circuit (not used ?)
 fmult    frequency muliplier }
var
  apu     : single;    {temporary}
  cpu     : complex;   {temporary}
  er      : integer;   {error flag}
  jc      : integer;   {"node" for current}
{ omega   : single;    {angular frequency}
  Xd,Xdd  : single;    {reactance, transient reactance}
  Xd2d    : single;    {subtransient reactance}
begin
{ omega := 2.0*3.141593*par;                {angular frequency}
  pComp^.getNode(2,jc,er);                  {get "node" for current}
  ReadSMotReact(pComp, Xd, Xdd, Xd2d);      {read reactances from component}
(* if (fmult <= 1) then apu := 0.5*(Xd-Xdd)  {0.75*w*Mf**2/Lff}
  { is this (else) correct, because 3rd pos. seq already has a "feedback"}
  else                 apu := 0.5*(Xd-Xdd)*fmult; {for (3rd) harmonic}*)
  if (fmult <= 1) then apu := 0.5*(Xd-Xd2d)
  else                 apu := 0;            {3rd, pos seq, already has beedback}
  {"feedback" through 3rd harmonics, but differently for first and third harm.}
  GetCmat(paa,jc,jc,nn,nn,cpu);             {old coefficient}
(*if (fmult <= 1) then begin*)
  {onko vaihe-ero otettu oikein huomioon ?? cos(wt+alpha)}
  cpu.y := cpu.y-apu;                     {contribution for neg.seq}
  PutCmat(paa,jc,jc,nn,nn,cpu);           {put coefficient back}
(*end;*)
end;

procedure SMotNeg2(pComp: TpComp; paa,pbb: pComplex; nn: integer; par: single;
                     short: integer; fmult: single);
{A test version, uses X2 = X'', no harmonics
 For a synchronous motor
 updates AN EXISTING, extended admittance matrix to the matrix
 (almost like a generator)
 pComp    pointer to the component (trafo)
 paa      pointer to the coefficient matrix
 pbb      pointer to the right hand side (not used ?)
 nn       dimension = number of nodes (excluding earth)
 par      a parameter (frequency)
 short    flag for a short circuit (not used ?)
 fmult    frequency muliplier }
var
  cpu      : complex;   {temporary}
  er       : integer;   {error flag}
  ipSet    : longint;   {pointer to the common, as integer}
  jc       : integer;   {"node" for current}
  pSet     : TpCompSet; {pointer to the common}
  Xd,Xdd   : single;    {reactances}
  Xd2d     : single;    {subtransient reactance}
  Xqd,Xq2d : single;    {q-axis reactances, only Xq2d needed}
  Tqd,Tq2d : single;    {q-axis time constants, not needed}
  Tdd      : single;    {d-axis time constant, actually not needed}
begin
  pComp^.getipSet(ipSet);
  pSet := TpCompSet(ipSet);
  pComp^.getNode(2,jc,er);                        {get "node" for current}
  ReadSMotReact(pComp, Xd, Xdd, Xd2d);            {read reactances}
  Tdd := 1.0;                                     {just some value}
  ReadSMotqPar(pComp, Xd,Tdd, Xqd,Xq2d,Tqd,Tq2d); {read q-axis parameters}
  GetCmat(paa,jc,jc,nn,nn,cpu);                   {old coefficient}
  cpu.y := 0.5*(Xd2d+Xq2d);                       {set X2 = 0.5*(Xd"+Xq")}
  if ((Imagoo.IECBut.down) and not(pSet^.appl_but = 15)) or
     (pSet^.appl_op = 14) then
    cpu := Crmult(pComp^.var1_s,cpu);
  PutCmat(paa,jc,jc,nn,nn,cpu);                   {put coefficient back}
end;

function Znegseq(R1,R2,X1,X2,X3,slip : single): complex;
{calculate the neg.seq. impedance}
var
  apu,apv,apw,apx : single;
begin
  apu := (2-slip)*(2-slip)*(X2+X3)*(X2+X3)+R2*R2;
  apv := (2-slip)*X3*X3;
  apw := apv*R2/apu+R1;                      {the resistance}
  apx := -(2-slip)*apv*(X2+X3)/apu+(X1+X3);  {the reactance}
  Znegseq := cplx(apw,apx);                     {neg.seq. impedance}
end;

procedure ASMotNeg(pComp: TpComp; paa,pbb: pComplex; nn: integer; par: single;
                     short: integer; fmult: single);
{For an asynchronous motor
 updates AN EXISTING, extended admittance matrix to the neg.seq.matrix
 pComp    pointer to the component (motor)
 paa      pointer to the coefficient matrix
 pbb      pointer to the right hand side (not used ?)
 nn       dimension = number of nodes (excluding earth)
 par      a parameter (frequency)
 short    flag for a short circuit (not used ?)
 fmult    frequency muliplier }
var
  apu,apv     : single;    {temporary}
  apw,apx     : single;
  cpu,cpv     : complex;   {temporary}
  er1,er2,er3 : integer;   {error flags}
  err         : integer;   {error flag}
  errMess     : string;    {error message}
  ipSet       : longint;   {pointer to the common, as integer}
  jc,jn,ju    : integer;   {current "node", neutral node, upstream node}
  Pow         : single;    {actual power}
  pSet        : TpCompSet; {pointer to the common}
  R1,R2       : single;    {resistances of the equivalent circuit}
  RL          : single;    {resistance corresponding to the load}
  slip        : single;    {actual slip}
  sn          : single;    {nominal slip}
  Vn          : single;    {nominal phase to neutral voltage}
  X1,X2,X3    : single;    {reactances of the equivalent circuit}
  Z1,Z2,Z3    : complex;   {impedances of the equivalent circuit}
  zneg        : complex;   {negative, positive sequence impedance}
begin
  pComp^.GetipSet(ipSet);
  pSet := TpCompSet(ipSet);
  {in IEC-calculation pos.seq.impedance = neg.seq impedance (is it?)
   and when calculating sequence impedances}
  if ((Imagoo.IECbut.down) and not (pSet^.appl_but = 15)) or
     ((pSet^.Appl_Op = 14) and not (pSet^.appl_type = AllSup))  then begin {fault in all buses, in allshort.pas}
    {do nothing}
  end else begin
    {as.motors not included when calculating transient theven impedance}
    if not (pSet^.fcalc_phase = TransientTheven) then begin
      {get all nodes}
      pComp^.GetNode(3,jn,er2);             {get neutral node}
      pComp^.GetNode(1,ju,er1);             {upstream (voltage) node}
      pComp^.GetNode(2,jc,er3);             {"node" for current}
      {get parameters}
      AsMotPar(pComp, R1, R2, X1, X2, X3, Vn, Pow,apu,apv,apw,apx,errMess);
      {do not care, if error message not empty, it has been announced earlier}
      {calculate the resistance R2(1-s)/s corresponding to the actual power
      {impecances of the equivalent circuit, without the load}
      Z1 := cplx(R1,X1);
      Z2 := cplx(R2,X2);
      Z3 := cplx(0.0,X3);
      {calculate the resistance corresponding to the load}
      pComp^.GetPar(gASmot_sn,sn);           {nominal slip}
      AsMotLoad(Vn,Pow,sn,Z1,Z2,Z3, RL,slip, err);
      {calculate the neg.seq. impedance}
      zneg := Znegseq(R1,R2,X1,X2,X3,slip);
      {put all coefficients for the voltage eq., to be sure, use the neg seq. impedance}
      cpu := cplx(+1,0);
      cpv := cplx(-1,0);
      if (ju > 0) and (ju <= nn) and (jc > 0) and (jc <= nn) and
         (jn > 0) and (jn <= nn) then begin
        putCmat(paa,jc,ju,nn,nn,cpu);  {voltage-current eq.}
        putCmat(paa,jc,jn,nn,nn,cpv);
        putCmat(paa,jc,jc,nn,nn,Crmult(-1.0,zneg));
      end;
    end;
  end;
end;

procedure Z012Neg(pComp: TpComp; paa,pbb: pComplex; nn: integer; par: single;
                  short: integer; fmult: single);
{ For a sequence impedance (with different values in different seq.nets),
 updates AN EXISTING, extended admittance matrix to the matrix
 of the neg. sequence.
 pComp    pointer to the component
 paa      pointer to the coefficient matrix
 pbb      pointer to the right hand side (not used ?)
 nn       dimension = number of nodes (excluding earth)
 par      a parameter (frequency)
 short    flag for a short circuit (not used ?)
 fmult    frequency muliplier }
var
  e3       : integer;   {error flag}
  jc       : integer;   {"node" for current}
  R2       : single;    {neg.seq. resistance}
  X2       : single;    {neg.seq. reactance}
  zc       : complex;   {-neg.seq. impedance}
begin
  pComp^.getNode(3,jc,e3);                  {get "node" for current}
  pComp^.getPar(3,R2);
  pComp^.getPar(4,X2);
  zc := cplx(-R2,-X2);
  if (e3 = 0) then
    PutCmat(paa,jc,jc,nn,nn,zc);            {replace pos.seq. impedance}
end;


procedure PosToNegMat(pSet : TpCompSet; paa,pzz : pComplex; nn : integer; fmult: single);
{copies and converts the extended matrix for pos. seq. to matrix for neg. seq.
 pSet    pointer to the set of components etc
 paa     pointer to the matrix for pos.seq.
 pzz     pointer to the matrix for neg seq.
 nn      dimension = number of nodes
 fmult   frequency multiplier
}
var
  errc   : integer;     {error flag}
  jcomp  : integer;     {counts components}
  ModNam : string;      {component name}
  pComp  : TpComp;      {pointer to a component}
  prh    : pComplex;    {pointer to the right hand side, not used}
  par    : single;      {parameter (not used ?)}
  short  : integer;     {flag for short circuit (not used ?)}
begin
  if (pSet <> nil) and (nn > 0) then begin  {network defined ?}
    {start with copying the pos.seq.matrix to zero seq. matrix}
    copyCmat(paa,pzz,nn);         {copy aa to zz}
    prh := nil;                   {right hand side not in use}
    par := pSet^.appl_Hz;;        {initialize parameter = frequency}
    short := 0;                   {initialize short circuit flag, not used ?}
    pComp := nil;                 {initialize pointer to component}
    errc := 0;                    {initialize error flag}
    jcomp := 0;
    while(errc = 0) do begin                    {scan all components}
      pSet^.NextComp(pComp,errc,jcomp,true);    {get pointer to next component}
      if (errc = 0) then begin
        pComp^.GetModName(ModNam);              {name of the component}
        {check those components that can have zero sequence components}
        if      (ModNam = gTrafoYD) then        {Y-D transformer ?}
          TrafoYDNeg(pComp, pzz,prh,nn,par,short,fmult)
        else if (ModNam = gTrafoDY) then        {D-Y transformer ?}
          TrafoDYNeg(pComp, pzz,prh,nn,par,short,fmult)
        else if (ModNam = gTrafoDD) then        {D-D transformer ?}
          TrafoDDNeg(pComp, pzz,prh,nn,par,short,fmult)
        else if (ModNam = gIdealYD) then        {ideal Y-D transformer ?}
          IdealYDNeg(pComp, pzz,prh,nn,par,short,fmult)
        else if (ModNam = gTrafo3W) then        {3-winding transformer ? }
          Trafo3wNeg(pComp, pzz,prh,nn,par,short,fmult)
        else if (ModNam = gGen) then            {generator ?}
        { GeneratNeg(pComp, pzz,prh,nn,par,short,fmult)}
          GeneratNeg2(pComp, pzz,prh,nn,par,short,fmult) {test, X2 in use}
        else if (ModNam = gSMot) then           {synchronous motor ?}
          SMotNeg2(pComp, pzz,prh,nn,par,short,fmult)
        else if (ModNam = gASMot) then          {asynchronous motor ?}
          ASMotNeg(pComp, pzz,prh,nn,par,short,fmult)
        else if (ModNam = gFeed) then           {feeder ?}
          FeedNeg(pComp, pzz,prh,nn,par,short,fmult)
        else if (ModNam = gZ012) then
          Z012Neg(pComp, pzz,prh,nn,par,short,fmult)
        else if (ModNam = gAtrafo) then
          AutoTrafoYDNeg(pComp, pzz,prh,nn,par,short,fmult);
        {others do not (yet?) have neg. seq. component}
      end;
    end;
  end;
end;

procedure PosSeqNet(pTwosc : TpComp; nnod : integer; Jp : complex;
                    pVrh,pWrk : pComplex);
{inject a current to the location of the fault, and solve the
 positive seq. net
 pTwosc   pointer to the short, as a component
 nnod     number of nodes = dimension
 Jp       the pos. seq. injected short circuit current
 pVrh     pointer to the right hand side (ext. voltages)
 pWrk     pointer to a working space, result is written here
 The solution is written to the array that pWrk is pointing to
 }
begin
  {copy rhs to working space, rhs must not change !}
  copyrhs(pVrh,pWrk,nnod);
  {add the short circuit current = modify the rhs}
  InjSCcurr(pTwosc,pWrk,nnod,Jp);           {modify the rhs for the injected pos.seq current}
  CLUbacksub(pAdmat,nnod,pIndex,pWrk);      {backsubstitute = solve}
(*showmessage('psn  '+comptostr(pAdmat^));*)
end;

procedure NegSeqNet1(pTwosc : TpComp; nnod : integer; Jn : complex;
                    pWrk : pComplex);
{NOTE  earthflt:ssa ON MYS NEGSEQNET!!!
 inject a current to the location of the fault, and solve the
 negative seq. net
 pTwosc   pointer to the short, as a component
 nnod     number of nodes = dimension
 Jn       the neg. seq. injected short circuit current
 pWrk     pointer to a working space, result is written here
 The solution is written to the array that pWrk is pointing to
 }
begin
  {for neg.seq. must clear rhs = no sources, other than the injected current}
  clearrhs(pWrk, nnod);
  {add the short circuit current = modify the rhs}
  InjSCcurr(pTwosc,pWrk,nnod,Jn);           {modify the rhs for the injected pos.seq current}
  CLUbacksub(pNmat,nnod,pIndexN,pWrk);      {backsubstitute = solve}
end;
(*
procedure PosSeq3rdNet(pTwosc : TpComp; nnod : integer; Jp : complex;
                       pVrh,pWrk : pComplex);
{inject a current to the location of the fault, and solve the
 positive seq. net for 3rd harmonic
 pTwosc   pointer to the short, as a component
 nnod     number of nodes = dimension
 Jp       the pos. seq. injected short circuit current
 pVrh     pointer to the right hand side (ext. voltages)
 pWrk     pointer to a working space, result is written here
 The solution is written to the array that pWrk is pointing to
 }
begin
  {copy rhs to working space, rhs must not change !}
  copyrhs(pVrh,pWrk,nnod);
  {add the short circuit current = modify the rhs}
  InjSCcurr(pTwosc,pWrk,nnod,Jp);          {modify the rhs for the injected pos.seq current}
  CLUbacksub(p3mat,nnod,pIndex3,pWrk);      {backsubstitute = solve}
end;
*)
(*
procedure Solve3rdCurrent(pTwosc: TpComp; pVrh,pWrk : pComplex;
                       nnod :integer; Vsp1 : complex; var Ishort : complex);
{solves the 3rd harmonic current at short,
 when the no-fault voltage at the short is given
 pTwosc    pointer to the short (as a component)
 pVrh      pointer to the right hand side (of pos.seq. net)
 pWrk      pointer to a working space
 nnod      number of nodes = dimension
 Vsp1      voltage at the short at no fault
 Ishort    the short circuit current}
var
  cpu,cpv   : complex;     {temporary}
  cpw,cpx   : complex;     {temporary}
  Ish1,Ish2 : complex;     {two defined short circuit currents}
  Jp,Jn     : complex;     {pos./neg. seq. injected fault current}
  Us1a,Us1b : Complex;     {phase voltages at fault}
  Us2a,Us2b : Complex;     {phase voltages at fault}
  Vsp2      : complex;     {pos seq. voltage at short}
  Vsn1,Vsn2 : complex;     {neg seq. voltage at short}
begin
  {first point = no fault => no short circuit current,
   neg.seq. voltage at fault = 0}
  Ish1.x := 0; Ish1.y := 0;                {no short circuit current, to start with}
  Vsn1.x := 0; Vsn1.y := 0;                {neg.seq. voltage at short is zero now !}
  {second point: define some short circuit current}
  Ish2 := Crmult(0.25,Vsp1);               {define some short circuit current}
  {calculate pos. and neg. sequence currents, from Ish2, -Ish2, 0 }
  cpu := Crmult(-1.0,Ish2);                {negative injected current, to phase b}
  PhaseToSeq(Ish2,cpu,czero,Jp,Jn,cpv);
  PosSeq3rdNet(pTwosc,nnod,Jp,pVrh,pWrk);  {solution to pWrk^}
  GetVolt(pTwosc,pWrk,1,nnod,Vsp2);        {get pos.seq voltage at short}

  {for neg.seq voltages must set external voltages to zero (check!!!)}
  clearrhs(pWrk, nnod);
  {inject current to fault}
  InjSCcurr(pTwosc,pWrk,nnod,Jn);          {modify rhs for the injected neg.seq. current}
  CLUbacksub(p3matN,nnod,pIndex3N,pWrk);   {backsubstitute = solve}

  GetVolt(pTwosc,pWrk,1,nnod,Vsn2);        {get neg.seq voltage at short}
  {solve the fault current using condition that voltages at faulted phases must be equal}
  {convert to corresponding phase voltages, first at no fault current}
  SeqToPhase(Vsp1,Vsn1,czero,Us1a,Us1b,cpu);
  {phase voltages at short, when injecting a fault current}
  SeqToPhase(Vsp2,Vsn2,czero,Us2a,Us2b,cpu);
  {find short circuit current, at which voltages at phases a and b are equal}
  cpu := Csub(Us2b,Us2a);
  cpv := Csub(Us1a,Us1b);
  cpw := Cadd(Cmult(Ish1,cpu),Cmult(Ish2,cpv));
  cpx := Cadd(cpu,cpv);
  Ishort := Cdiv(cpw,cpx);                 {steady state fault current}
end;
*)
(*
procedure Solve3rdFaultCurrent(pVrhs,pWrk : pComplex; pTwosc : TpComp; nnod : integer;
                        var Ishort,Jp,Jn: complex);
{calculates the (steady state) 3rd harmonic short circuit current
 at the location of the fault,
 and decomposes it to pos and neg.seq currents
 when the voltages, i.e. the right hand side is given
 The result is in pWrk^
 ------
 pVrhs   pointer to the  right hand side = source voltages
 pWrk    pointer to a working space, the result is written here
 pWw     pointer to another working space
 pTwosc  pointer to the short, as a component
 nnod    number of nodes = dimension
 Ishort  the current at the location of the fault
 Jp,Jn   pos,neg seq. component of Ishort
}
var
  cpu,cpv : complex;    {temporary}
  Vsp1    : complex;    {prefault voltage at the location of fault}
begin
  {copy the rhs to working space, it must not be destroyed}
  copyrhs(pVrhs,pWrk,nnod);
  {solve with zero fault current}
  CLUbacksub(p3mat,nnod,pIndex3,pWrk);       {backsubstitute = solve}
  {start to calculate sc currents; first, get the nonfault voltages}
  GetVolt(pTwosc,pWrk,1,nnod,Vsp1);         {get pos.seq voltage at short}
  {next, set some fault current, solve pos, and neg. seq voltages,
   and, using the voltages, solve the current at short }
  {solve the (steady state) current at the short circuit}
  Solve3rdCurrent(pTwosc, pVrhs, pWrk, nnod, Vsp1,Ishort);
  {use this to calculate the positive seq. net. The pos.seq
   currents are needed for the initial generator/motor voltages}
  cpu := Crmult(-1.0,Ishort);             {negative injected current, to phase b}
  PhaseToSeq(Ishort,cpu,czero,Jp,Jn,cpv);
end;
*)
(*
procedure AdditionalVoltageSource(pWrk: pComplex; pGM : TpGenMot;
                                 nnod, frqid : integer);
{calculate to pGM^.p3rh the additional voltage source caused by the
 neg.seq. current through the generator or motor.
 The fundamental freq. causes a 3rd harmonic source, and the
 3rd harmonic current causes a fundamental freq. source.
 Both seem to use the same equation (not the same constant)!!
 pWrk  pointer to the array with the solution for the neq.seq.net
 pGM   pointer to the object for generators and motors
       additional voltage source to pGM^.p3rh
 nnod  number of nodes
 frqid identifier for frequency (of additional voltage source:
       1=fundamental, 3 = 3rd harmonic)
 }
var
  apu     : single;   {temporary}
  cNode   : integer;  {node ID-number for the current through the generator}
  cpu,cpv : Complex;  {temporary}
  fii     : single;   {voltage phase (not used)}
  igm     : integer;  {index for generators and motors}
  Icx     : Complex;  {current}
  Par     : GMset;    {set of generator and motor parameters (Rs, Xd,Xdd etc)}
  Rs,Rr   : single;   {stator, rotor resistance (not used)}
  Vi      : single;   {generator voltage (not used)}
  Xd,Xdd  : single;   {reactance, transient reactance}
  Xd2d    : single;   {subtransient reactance}
begin
  clearrhs(pGM^.p3rh, nnod);
  for igm := 1 to pGM^.number do begin
    pGM^.GetGMnode(igm,cNode);              {get current node for this gen.}
    getCvec(pWrk ,cNode,nnod,Icx);          {get current}
    pGM^.getGMset(igm,Par);                 {get the set of parameters}
    if (frqid = 1) then               {differently, when X'' included }
      apu := 0.5*(Par.Xd-Par.Xd2d)         {voltage at fundam.freq}
    else                                    {voltage at third harm.}
      apu := 1.5*(Par.Xd-Par.Xd2d);
    cpu := Crmult(apu,Icx);
    {if current is sin(wt+..), then voltage is cos(3wt+..)}
    cpv.x := -cpu.y;
    cpv.y := +cpu.x;   {+ is correct, I think, not -}
    {update rhs for 3rd harmonic}
    putCvec(pGM^.p3rh,cNode,nnod,cpv);
  end;
end;
*)
(*
procedure NegSeqNet(pTwosc : TpComp; pGM: TpGenMot; nnod : integer;
                     Jn : complex; pWrk : pComplex; var test : single);
{NOTE  earthflt:ssa ON MYS NegSeqNet!!!
 inject a current to the location of the fault, and solve the
 negative seq. net
 pTwosc   pointer to the short, as a component
 pGM      pointer to the object for (set of) generators and motors
 nnod     number of nodes = dimension
 Jn       the neg. seq. injected short circuit current
 pWrk     pointer to a working space, result is written here
 test     some test output
 The solution is written to the array that pWrk is pointing to
 }
var
  itr     : integer;      {iteration index}
  I3short : complex;      {current at the short}
  J3p,J3n : complex;      {3rd phase pos, neg. seq. currents at the short}
begin
  {for neg.seq voltages must set external voltages to zero}
  clearrhs(pWrk, nnod);
  {inject current to fault}
  InjSCcurr(pTwosc,pWrk,nnod,Jn);           {modify rhs for the injected neg.seq. current}
  {for greater accuracy, check third harmonic}
  {first, find currents in generators (and motors ?), if there are any}
  if (pGM <> nil) then begin
    CLUbacksub(pNmat,nnod,pIndexN,pWrk);      {backsubstitute = solve neg.seq fundam. current}
    {neq. seq. current "induces" a 3rd harmonic pos.seq. voltage in the generators
       voltage to pGM^.p3rh}
    AdditionalVoltageSource(pWrk, pGM, nnod, 3);

    {solve 3rd harmonic short circuit current}
    Solve3rdFaultCurrent(pGM^.p3rh,pWrk, pTwosc, nnod, I3short,J3p,J3n);
    test := Cabs(I3short);                    {return 3rd harm. current}
    {solve 3rd harmonic pos.seq. net (not neg.seq?!) }
    {first, for neg.seq voltages must set external voltages to zero (check!!!) NO !!}
    clearrhs(pWrk, nnod);
    {test..., must retain the additional voltage source}
    CopyCvec(pGm^.p3rh,pWrk,nnod);
    {inject current to fault}
{CHECK THIS !!!}
    InjSCcurr(pTwosc,pWrk,nnod,J3p{J3n});     {modify rhs for the injected neg.seq. current}
    CLUbacksub(p3mat,nnod,pIndex3{N},pWrk);     {backsubstitute = solve}
    {3rd harmonic current "induces" a neg.seq. fundam. voltage source in the generators}
    clearrhs(pGM^.p3rh,nnod);                 {clear first (check!)}
    AdditionalVoltageSource(pWrk, pGM, nnod, 1);
    {modify the rhs still, by injecting current to fault}
    InjSCcurr(pTwosc,pGM^.p3rh,nnod,Jn);      {modify rhs for the injected neg.seq. current}
    {solve the neq. seq. net again}
    CLUbacksub(pNmat,nnod,pIndexN,pGM^.p3rh); {backsubstitute = solve}
    CopyCvec(pGm^.p3rh,pWrk,nnod);            {result must be in pWrk}
  end else begin                              {no generators or motors}
    CLUbacksub(pNmat,nnod,pIndexN,pWrk);      {backsubstitute = solve}
  end;
end;
*)
procedure SolveCurrent(pTwosc: TpComp; pGM: TpGenMot; pVrh,pWrk : pComplex;
                       nnod :integer; Vsp1 : complex; var Ishort : complex);
{solves the current at short, when the no-fault voltage at the short is given
 pTwosc    pointer to the short (as a component)
 pGM       pointer to obj. for generators and motors
 pVrh      pointer to the right hand side (of pos.seq. net)
 pWrk      pointer to a working space
 nnod      number of nodes = dimension
 Vsp1      voltage at the short at no fault
 Ishort    the short circuit current}
var
  cpu,cpv   : complex;     {temporary}
  cpw,cpx   : complex;     {temporary}
  Ish1,Ish2 : complex;     {two defined short circuit currents}
  Jp,Jn     : complex;     {pos./neg. seq. injected fault current}
  Us1a,Us1b : Complex;     {phase voltages at fault}
  Us2a,Us2b : Complex;     {phase voltages at fault}
  Vsp2      : complex;     {pos seq. voltage at short}
  Vsn1,Vsn2 : complex;     {neg seq. voltage at short}
begin
  {first point = no fault => no short circuit current,
   neg.seq. voltage at fault = 0}
  Ish1.x := 0; Ish1.y := 0;                {no short circuit current, to start with}
  Vsn1.x := 0; Vsn1.y := 0;                {neg.seq. voltage at short is zero now !}
  {second point: define some short circuit current}
  Ish2 := Crmult(0.25,Vsp1);               {define some short circuit current}
  {calculate pos. and neg. sequence currents, from Ish2, -Ish2, 0 }
  cpu := Crmult(-1.0,Ish2);                {negative injected current, to phase b}
  PhaseToSeq(Ish2,cpu,czero,Jp,Jn,cpv);
  PosSeqNet(pTwosc,nnod,Jp,pVrh,pWrk);     {solution to pWrk^}
  GetVolt(pTwosc,pWrk,1,nnod,Vsp2);        {get pos.seq voltage at short}
(*  NegSeqNet(pTwosc, pGM, nnod, Jn, pWrk,apu);   {solve neg.seq. network}*)
  NegSeqNet1(pTwosc, nnod, Jn, pWrk);
  GetVolt(pTwosc,pWrk,1,nnod,Vsn2);           {get neg.seq voltage at short}
  {solve the fault current using condition that voltages at faulted phases must be equal}
  {convert to corresponding phase voltages, first at no fault current}
  SeqToPhase(Vsp1,Vsn1,czero,Us1a,Us1b,cpu);
  {phase voltages at short, when injecting a fault current}
  SeqToPhase(Vsp2,Vsn2,czero,Us2a,Us2b,cpu);
  {find short circuit current, at which voltages at phases a and b are equal}
  cpu := Csub(Us2b,Us2a);
  cpv := Csub(Us1a,Us1b);
  cpw := Cadd(Cmult(Ish1,cpu),Cmult(Ish2,cpv));
  cpx := Cadd(cpu,cpv);
  Ishort := Cdiv(cpw,cpx);                 {steady state fault current}
end;

procedure SolveFaultCurrent(pVrhs,pWrk : pComplex; pTwosc : TpComp; pGM : TpGenMot;
                            nnod : integer; var Ishort,Jp,Jn: complex);
{calculates the (steady state) short circuit current at the location of the fault,
 and decomposes it to pos and neg.seq currents
 when the voltages, i.e. the right hand side is given
 The result is in pWrk^
 ------
 pVrhs   pointer to the  right hand side = source voltages
 pWrk    pointer to a working space, the result is written here
 pTwosc  pointer to the short, as a component
 pGM     pointer to object for generators and motors
 nnod    number of nodes = dimension
 Ishort  the current at the location of the fault
 Jp,Jn   pos,neg seq. component of Ishort
}
var
  cpu,cpv : complex;    {temporary}
  Vsp1    : complex;    {prefault voltage at the location of fault}
begin
  {copy the rhs to working space, it must not be destroyed}
  copyrhs(pVrhs,pWrk,nnod);
  {solve with zero fault current}
  CLUbacksub(pAdmat,nnod,pIndex,pWrk);      {backsubstitute = solve}
  {start to calculate sc currents; first, get the nonfault voltages}
  GetVolt(pTwosc,pWrk,1,nnod,Vsp1);         {get pos.seq voltage at short}
  {next, set some fault current, solve pos, and neg. seq voltages,
   and, using the voltages, solve the current at short }
  {solve the (steady state) current at the short circuit}
  SolveCurrent(pTwosc, pGM, pVrhs, pWrk, nnod, Vsp1,Ishort);
  {use this to calculate the positive seq. net. The pos.seq
   currents are needed for the initial generator/motor voltages}
  cpu := Crmult(-1.0,Ishort);             {negative injected current, to phase b}
  PhaseToSeq(Ishort,cpu,czero,Jp,Jn,cpv);
end;

procedure  PhaseToPhaseShort(ipSet : longint; IsInitState : boolean);
{perform the dynamical 2-phase short circuit calculations
 ipSet pointer to the set of components etc, as integer
 IsInitState   if true, the precalculated initial state is used}
const
  Vmin = 0.01;             {minimum voltage for any fault current to flow}
var
  AP        : AsymPar;     {parameters of the asynch.motor}
  cNode     : integer;     {"node" for current}
  dt        : single;      {time step}
  err       : integer;     {error flag}
  errcom    : boolean;     {error flag}
  dodd,doddN: single;      {keep track of permutations}
  freq      : single;      {frequency}
  Icx       : complex;     {current}
  igm       : integer;     {index}
  it        : integer;     {index for time}
  Ishort    : complex;     {fault current, towards phase a}
  jc        : integer;     {current "node" of the fault}
  Jp,Jn     : complex;     {pos./neg. seq. injected fault current}
  ju        : integer;     {upstream node}
  nAsyMot   : integer;     {number of asynchronous motors}
  nCurrT    : integer;     {number of current trafos}
  nFault    : integer;     {number of short circuits (needed ?)}
  nGenMot   : integer;     {number of generators and motors}
  nPQrel    : integer;     {number of PGQ-relays}
  nRelay    : integer;     {number of relays}
  nSource   : integer;     {number of constant voltage sources}
  nnod      : integer;     {number of nodes}
  pAsMot    : TpComp;      {pointer to the asynch.motor}
  pComp     : TpComp;      {pointer to a component (relay)}
  pCurrT    : TpCurrT;     {pointer to objectg for current trafos}
  pGenMot   : TpGenMot;    {pointer to object for generators/motors}
  pRelay    : TpRelay;     {pointer to object for relays}
  pSet      : TpCompSet;   {pointer to the set of components, etc}
  pTwosc    : TpComp;      {pointer to the short circuit}
  pVrhs     : pComplex;    {temporary right hand side}
  Sngl,SnglN: Integer;     {flag for singular matrix}
  Tout,ToutN: Complex;     {test output from matrix decomposition}
  tt,tt0    : single;      {time, old time}
  Ucx       : complex;     {voltage at asm terminals}
  Vcx       : complex;     {voltage}
begin
pCT := nil;
  pRelay := nil;
  pGenMot := nil;
  pCurrT := nil;
  pSet := TpCompSet(ipSet);          {integer to pointer}
  freq := pSet^.appl_Hz;
  pTwosc := nil;                     {initialize pointer to short circuit}
  FindShort(pSet, pTwosc);           {find two phase short(s)}
(*nnod := pSet^.appl_nn;             {copy number of nodes} LATER*)
  {solve the network only, if there is a short !}
  if (pTwosc <> nil) then begin      {two phase short found}
    {first, a normal calculation, without fault. Actually needed for synch.mot only}
    if (not Imagoo.InitialStateBut.down) then
      Imagoo.AdmatOper(Imagoo.InitialStateBut.down)
    else Imagoo.NodeButclick(nil);
    nnod := pSet^.appl_nn;             {copy number of nodes}
    pSet^.GetMemForCurrTrAndRelays;    {memory for lists of curr.tr and relays (if exist)}
    {then, the calculations for the fault}
    {reserve and initialize memory for matrices}
    ReserveMat(nnod,pAdmat,pWs,pRhs,pIndex);
    {reserve memory for the neg.seq matrix}
    getmem(pNmat,nnod*nnod*SizeOf(complex));    {reserve matrix for neg seq.}
    clearCmat(pNmat,nnod);
    getmem(pIndexN,nnod*Sizeof(integer));       {for index array, neg seq.}
    clearIvec(pIndexN, nnod);
(*
    {reserve memory for the matrices for 3rd harmonic}
    getmem(p3mat,nnod*nnod*SizeOf(complex));    {reserve matrix for 3rd harmonic}
    clearCmat(p3mat,nnod);
    getmem(pIndex3,nnod*Sizeof(integer));       {for index array, 3rd harmonic}
    clearIvec(pIndex3, nnod);
    getmem(p3matN,nnod*nnod*SizeOf(complex));   {reserve matrix for 3rd harmonic}
    clearCmat(p3matN,nnod);
    getmem(pIndex3N,nnod*Sizeof(integer));      {for index array, 3rd harmonic}
    clearIvec(pIndex3N, nnod);
*)
    getmem(pVrhs,nnod*SizeOf(complex));         {for temporary right hand side}
    clrCrow(pVrhs,1,nnod);
(*
    {construct the extended admittance matrix (and rhs) for 3rd harmonics.}
    ConstrMatr(pSet, p3mat, pWs, nnod, freq, 3.0, {2}TwoPhaseShort,
               IsInitState, errcom);    {0 = construct for normal case}
*)
    {clear rhs, it is not (yet) needed}
    clrCrow(pWs,1,nnod);
(*
    {convert to matrix for neg.seq. of third harmonic}
    PosToNegMat(pSet, p3mat,p3matN, nnod, 3.0);
*)
    {construct the extended admittance matrix to pAdmat^, and to pRhs^
     0.0 = use nominal frequency}
    ConstrMatr(pSet, pAdmat, pRhs, nnod, freq, Steady, TwoPhaseShort,
               IsInitState, errcom);    {0 = construct for normal case}
    {copy the matrix to neg seq. matrix, convert to correspond to neg. seq}
    PosToNegMat(pSet, pAdmat,pNmat, nnod, 1.0);
    {count the number of generators, etc. Needed below}
    CountComp(ipSet,nGenMot,nRelay,nFault,nCurrT,nAsyMot,nSource,nPQrel);
    {solve voltages etc, but only if no unknown components}
    if (not(errcom)) then begin
      try
        CLUdecomp(pAdmat,pWs,nnod,pIndex,Dodd,Sngl,Tout);     {decompose, pos.seq}
        CLUdecomp(pNmat ,pWs,nnod,pIndexN,DoddN,SnglN,ToutN); {decompose, neg.seq}
(*
        CLUdecomp(p3mat ,pWs,nnod,pIndex3,Dodd3,Sngl3,Tout3); {decompose, 3rd harm.}
        CLUdecomp(p3matN,pWs,nnod,pIndex3N,Dodd3N,Sngl3N,Tout3N); {decompose, 3rd harm.neg seq.}
*)
        {create object for relays, if any exists (for display + checking of activation}
        CreateRelays(ipSet, nRelay, nPQrel, pRelay);
        {if there are current transformers, create object for operations with current trafos}
        CreateCurrT(ipSet, nCurrT, pSet^.nCalc, pCurrT);       {in shortcir.pas}
        {find the current trafos for the relays, if there are relays & curr.trafos}
        if (pRelay <>nil) then pRelay^.FindCurrTrafos(pCurrT);
        {create +initialize object for generators/motors, if any exist
        it is initialized with the currents & voltages calculated above}
        if (nGenMot > 0) or (nAsyMot > 0) then  begin
          CreateGenMot(ipSet, nGenMot, nAsyMot,nSource, freq, pGenMot);
          {calculate steady state solution, with fault}
          SolveFaultCurrent(pRhs, pWs, pTwosc, pGenMot, nnod, Ishort,Jp,Jn);
          PosSeqNet(pTwosc, nnod, Jp, pRhs,pWs);
          {save the steady pos.seq. state solution with fault}
          for igm := 1 to nGenMot+nAsyMot+nSource do begin
            pGenMot^.GetGMnode(igm,cNode);      {get current node for this gen.}
            getCvec(pWs ,cNode,nnod,Icx);       {get corresponding current}
           if (pGenMot^.IsGener(igm)) or (pGenMot^.IsSynchMot(igm)) then begin
             getCvec(pRhs,cNode,nnod,Vcx);             {get present int. voltage}
           end else if (pGenMot^.IsAsynchMot(igm)) then begin
             {asynchronous motor, calculate internal voltage}
             pGenMot^.GetAsmPar(igm, AP);              {get parameters}
             pGenMot^.GetGMpoint(igm,pAsMot);          {get pointer to the motor}
             pAsMot^.GetNode(1,ju,err);                {node of ext.voltage}
             getCvec(pWs,ju,nnod,Ucx);                 {upstream voltage}
             Vcx := Csub(Ucx,Cmult(Icx,AP.Zint));      {internal voltage}
           end else begin
             getCvec(pRhs,cNode,nnod,Vcx);             {source (or error ?)}
(*           Vcx := cplx(0,0);                         {error}  *)
           end;
            pGenMot^.putVolt(igm,Vcx);          {save the voltage}
(*          pGenMot^.putCurr(igm,Icx);          {save the current, for calculations}*)
            pGenMot^.PutSSCurr(igm,Icx);        {save as steady state curr.}
          end;
          {calculate the derivatives dI/dV for the generators and motors}
          {if there are asynch.motors, must reconstruct the adm.matrix}
          if (nAsyMot > 0) then begin
            clearCmat(pAdmat,nnod);
            clearCvec(pRhs,nnod);
            ConstrMatr(pSet, pAdmat, pRhs, nnod, freq, Derivates, TwoPhaseShort,
                       IsInitState,errcom);
            CLUdecomp(pAdmat,pWs,nnod,pIndex,Dodd,Sngl,Tout); {decompose}
          end;
          Calc_dIdV(pGenMot, pTwosc, pRhs, pVrhs, pWs, nnod,'two');
          pGenMot^.IsFaultFeltHere;    {mark gen, mot, etc, where fault is felt}
          pGenMot^.dIdVwhereFaultFelt; {copy dI/dV for comp. where fault felt}
          pGenMot^.Calc_dVdI;
          {solve the initial, transient generator voltages}
(*        pGenMot^.SolveDQVoltages;    {D-, Q- damping windings included} *)
          {new version}pGenMot^.InitialVoltagesAndCurrents;
        end else begin
          pGenMot := nil;
        end;
        {if there are asynch.motors, must reconstruct the adm.matrix once more}
        if (nAsyMot > 0) then begin
          clearCmat(pAdmat,nnod);
          clearCvec(pRhs,nnod);
          ConstrMatr(pSet, pAdmat, pRhs, nnod, freq, Transient, TwoPhaseShort,
                     IsInitState,errcom);
          CLUdecomp(pAdmat,pWs,nnod,pIndex,Dodd,Sngl,Tout); {decompose}
          {because the "source" of asynch.motors is the current, must calculate
           dI(all)/dI(as.mot) and dI(all)/dV(others)}
          Calc_dIdIV(pGenMot, pTwosc, pRhs, pVrhs, pWs, nnod, 'two');
        end;
        {solve the net with time}
        pTwosc^.GetNode(2,jc,err);       {get "node" of the fault current}
        tt := 0;                                 {initialize}
        for it := 1 to pSet^.nCalc do begin
          tt0 := tt;                             {old time, for time step}
          GetAndSaveTime(pSet, it, tt);          {calculate time, save it to pSet}
          {copy rhs to working space}
          copyCvec(pRhs,pVrhs,nnod);
          {if there are generators or motors, update the rhs}
          if (nGenMot > 0) or (nAsyMot > 0) then begin
            dt := tt-tt0;
            {calculate gener.voltage at this step, update the rhs}
            pGenMot^.VoltAtTt(it, dt, freq,pVrhs,nnod);
{if (it = 1) then showCmat1(pVrhs,nnod,1);}
          end;
         {solve}
          SolveFaultCurrent(pVrhs, pWs, pTwosc, pGenMot, nnod, Ishort,Jp,Jn);
(*        NegSeqNet(pTwosc, pGenMot, nnod, Jn, pWs,apu);{solve neg.seq. network}*)
(*          showmessage(floattostr(apu));*)
          NegSeqNet1(pTwosc, nnod, Jn, pWs);
//showCmat1(pWs,1,nnod);          
          {complete the solution with the fault current}
          putCvec(pWs,jc,nnod,{Jn}cplx(-Jn.x,-Jn.y));  {pos.direction is out 101202}
          {if there are relays, save the neg seq.current here, pos seq. later, but clear first}
          if (pCurrT <> nil) then begin
            pCurrT^.ClearTempVar;
            pCurrT^.SaveComplex(pWs, nnod, 2,it);   {save neg.seq. as set number 2}
          end;                                      {... in Shortcmp.pas}
          if (pSet^.nMeasZ > 0) then begin
            {if there are distance relays, save voltages}
            pSet^.SaveDistVoltTemp(pWs, nnod, 2);
          end;
          {save initial neg sec. currents etc for all components (pos.seq. later}
          if (it = 1{ncalcg}) then begin
            ClearAllVar(pSet);                        {clear initially}
            ResultsToComp(pSet, nnod, freq, pWs,2,{ForComp}ForBOth); {neg.seq to comp., as first set of var.}
            CopyAllVar(pSet,1,2);                   {copy to second set of var. in Elplex.pas}
          end;                                      {continues....}
          PosSeqNet(pTwosc, nnod, Jp, pVrhs,pWs);   {solve pos.seq. network}
          {complete the solution with the fault current}
          putCvec(pWs,jc,nnod,{Jp}cplx(-Jp.x,-Jp.y)); {pos.direction is out 101202}
          {if there are relays, complete the saving of currents here}
          if (pCurrT <> nil) then begin
            pCurrT^.SaveComplex(pWs, nnod, 1,it);   {save pos.seq. as set number 1}
            pCurrT^.PhaseMaxOrSum(it,pSet);         {save abs value of largest phase current,or sum}
          end;                                      {...in Shortcmp.pas}
          if (pSet^.nMeasZ > 0) then begin
            pSet^.SaveDistVoltTemp(pWs, nnod, 1);     {save voltages of distance relays}
            pSet^.SavePhaseVolt(it)
          end;
          {complete the saving of initial state for all components}
          if (it = 1{ncalcg}) then begin
            ResultsToComp(pSet, nnod, freq, pWs,1,{ForComp}ForBoth); {pos.seq to comp, as first set of var}
            AllVarSeqToPhase(pSet);                 {from seq to phase, all var, all comp.}
            {sum current trafos must display the sum current}
            if (pCurrT <> nil) then pCurrT^.SumToOutVar;  {in shortcmp.pas}
(* {poistettu 27.9.2003, koska jnnite vrin, vaikutus testattava...}
            {short circuit current to short circ.component}
            pTwosc^.putvar(3,-Ishort.x);            {-sign, because injected current}
            pTwosc^.putvar(4,-Ishort.y);
            {cpu := Crmult(-1.0,Ishort);            {negative injected current, to phase b}
            pTwosc^.putvar(7,Ishort.x{cpu.x});      {oltava 9, kun Ip ja Ib mukana}
            pTwosc^.putvar(8,Ishort.y{cpu.y});      {oltava 10, -"-}
*)
          end;
        end;
        {transfer currents from current trafos to relays, take ratio etc into account}
        AllRelayCurrFromCT(pSet);
        {display relay current using polar coordinates}
        PolarToRelaysAndBuses(pSet);

(*
        {short circuit current to short circ.component}
        pTwosc^.putvar(3,Ishort.x);
        pTwosc^.putvar(4,Ishort.y);
        cpu := Crmult(-1.0,Ishort);              {negative injected current, to phase b}
        pTwosc^.putvar(7,cpu.x);
        pTwosc^.putvar(8,cpu.y);
*)
        {update the eventual result boxes}
{later: pSet^.UpdateResultBoxes(3); }
        {show also the current through the current trafos, if allowed}
        ShowCurrOrNot(pSet, Imagoo.ShowCurrBut.down,Imagoo.ShowCurrBut.caption);
        ShowVoltagesOrNot(pSet, Imagoo.BusBut.down, Imagoo.BusBut.caption);   {in skemproc.pas}
        {show the measured impedances}
        ShowImpedances(pSet);  {in skemproc.pas}
        if (RelayCurr.visible)  then begin
          pComp := TpComp(RelayCharact.tag);   {pointer to the relay}
          Relay_Show(pComp,'real');
        end;
        {show also distance relay char. and impedance, if visible}
        if (DistRel.visible) then DistanceRelayShow;
        if (PolyRel.visible) then PolygonRelayShow;
        {check activation of relays, if there are any relays}
        if (pRelay <> nil) then pRelay^.GroupActivation {CheckActivation};
        {update the eventual result boxes}
        pSet^.UpdateResultBoxes(3);
      finally
        {destroy object for current trafos, if created}
        if (nCurrT > 0) then begin
          pCurrT^.Destr;                 {destroy object for current trafors}
          pCurrT^.Free;
          dispose(pCurrT);
          pCUrrT := nil;
        end;
        {destroy object for relays, if created}
        if (pRelay <> nil) then begin
          pRelay^.Destr;                 {destroy object for relays}
          pRelay^.Free;
          dispose(pRelay);
          pRelay := nil;
        end;
        {destroy object for machines, if created}
        if (pGenMot <> nil) then begin             {if there were gener/motors, free them}
          pGenMot^.Destr;                          {release memory}
          pGenMot^.Free;                           {release the object}
          dispose(pGenMot);
          pGenMot := nil;
        end;
      end;
    end else begin                            {there was an unknown component}
      show_message('unknown component');
    end;
    {free the reserved memory from matrices}
    FreeMat(nnod);                             {free pAdmat, pRhs, pWs, pIndex}
    Freemem(pNmat,nnod*nnod*SizeOf(complex));  {free matrix for zero seq.}
    Freemem(pIndexN,nnod*Sizeof(integer));     {free index array, zero seq}
    pSet^.FreeMemForCurrTrAndRelays;
(*
    Freemem(p3mat,nnod*nnod*SizeOf(complex));  {free matrix for 3rd harmonic}
    Freemem(pIndex3,nnod*Sizeof(integer));     {free index array, 3rd harmonic}
    Freemem(p3matN,nnod*nnod*SizeOf(complex)); {free matrix for 3rd harmonic}
    Freemem(pIndex3N,nnod*Sizeof(integer));    {free index array, 3rd harmonic}
*)
    Freemem(pVrhs,nnod*SizeOf(complex));
  end else begin
    show_message('no short circuit! ');
    Ishort.x := 0; Ishort.y := 0;
  end;
end;


end.

