{17.11.98 tss on viel joku virhe.... joku pointteri vrin ...}
{ - ainakin short-komponentille tulokset kaksi kertaa oliolle:
     Restocomp ja erikseen pEarth^...
  - tulosten indeksi parametrilla, ei numerolla (putvar...)
  - voisi kytt yhteisi osia ainakin twoshort'in kanssa
  - 3rd harmoninen pois, ei tarvita en !
  - jos vika ei kytketty minnekn, tulee floating overflow
  mik virta nytetn vika-komponentille 2 vaih. maasulussa ? olisiko summa ?}
{lopuksi poistettava vanha 2-vaihe-maasulku}
{ changes - - - - - - - - - - - - - - - - - - - - - }
{10.12.2002  when adding fault current to solution vector, change sign, because
             pos. injected current is in, but pos.direction for the current of the
             fault component is out}
unit Earthflt;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, StdCtrls,Compdef,Cmatmul,Skemadef,Utildef,
  Imagodef, Twoshort, Elplex, matmul, Skemproc, RelCurr, Shortcir,Shortcmp,
  distance,polygon;
//showcmat1(pzz,nn,nn);
procedure PosToZeroMat(ipSet : longint; paa,pzz : pComplex;
                       freq,fmult: single; nn : integer);
procedure EarthFault(ipSet : longint; IsInitState: boolean);
procedure LineZeroImped(pComp : TpComp; len : single; var Z0 : complex);
procedure AutoTrafozero(ipSet: longint; pComp: TpComp; paa,pbb: pComplex;
                        nn: integer; par, fmult: single; short: integer);
procedure Trafozero(ipSet: longint; pComp: TpComp; paa,pbb: pComplex;
                    nn: integer; par, fmult: single; short: integer);
procedure Feedzero (ipSet: longint; pComp: TpComp; paa,pbb: pComplex;
                    nn: integer; par, fmult: single; short: integer);
procedure Generzero(ipSet: longint; pComp: TpComp; paa,pbb: pComplex;
                    nn: integer; par, fmult: single; short: integer);
procedure Loadzero (ipSet: longint; pComp: TpComp; paa,pbb: pComplex;
                    nn: integer; par, fmult: single; short: integer);
procedure Smotzero (ipSet: longint; pComp: TpComp; paa,pbb: pComplex;
                    nn: integer; par, fmult: single; short: integer);
procedure ASmotzero(ipSet: longint; pComp: TpComp; paa,pbb: pComplex;
                    nn: integer; par, fmult: single; short: integer);
procedure Trlinzero(ipSet: longint; pComp: TpComp; paa,pbb: pComplex;
                    nn: integer; par, fmult: single; short: integer);
procedure TrfYDzero(ipSet: longint; pComp: TpComp; paa,pbb: pComplex;
                    nn: integer; par, fmult: single; short: integer);
procedure TrfDYzero(ipSet: longint; pComp: TpComp; paa,pbb: pComplex;
                    nn: integer; par, fmult: single; short: integer);
procedure TrfDDzero(ipSet: longint; pComp: TpComp; paa,pbb: pComplex;
                    nn: integer; par, fmult: single; short: integer);
procedure Trf3Wzero(ipSet: longint; pComp: TpComp; paa,pbb: pComplex;
                    nn: integer; par, fmult: single; short: integer);
procedure TrfYYYzero(ipSet: longint; pComp: TpComp; paa,pbb: pComplex;
                    nn: integer; par, fmult: single; short: integer);
procedure TrfYYDzero(ipSet: longint; pComp: TpComp; paa,pbb: pComplex;
                    nn: integer; par, fmult: single; short: integer);
procedure Starzero  (ipSet: longint; pComp: TpComp; paa,pbb: pComplex;
                    nn: integer; par, fmult: single; short: integer);
procedure Mutualzero(ipSet: longint; pComp: TpComp; paa,pbb: pComplex;
                     nn: integer; par, fmult: single; short: integer);
procedure Z012zero  (ipSet: longint; pComp: TpComp; paa,pbb: pComplex;
                     nn: integer; par, fmult: single; short: integer);
procedure IdealYDzero(ipSet:longint; pComp: TpComp; paa,pbb: pComplex;
                     nn: integer; par, fmult: single; short: integer);

procedure SolveEarthFaultCurrent(pVrhs,pWrk : pComplex; pEarthf : TpComp;
                                {pGM: TpGenMot;} nnod{, FaultType} : integer;
                                 var Ishort{,IshA,IshB},Jp,Jn,Jz: complex);
procedure SolveVoltageC(pVrhs,pWrk : pComplex; pEarthf : TpComp; nnod : integer;
                        var VoltC : complex);
procedure PosSeqNetLLE(pEarthf : TpComp; nnod : integer; VoltC : complex;
                       pVrh,pWrk : pComplex);
procedure FindZg(ipSet : longint; {nstar}xs,ys : integer; var pImped : TpComp);
procedure FindGrCurrT(ipSet : longint; nneutr : integer; var pCT : TpComp);

function ImpedMult(pComp: TpComp) : single;

implementation

uses
  Imagopas, AllShort, routines;

const
  czero : complex = (x : 0.0 ; y : 0.0);  {complex zero}
  XLRes = 1.0e6;         {a large resistance from D-trafo to ground}
var
  pZmat   : pComplex;    {pointer to the zero sequence matrix}
  pIndexZ : pInteger;    {pointer to array keeping track on row exchanges}

procedure R0X0Warning(pComp: TpComp; Rp,Xp,R0,X0: single);
{set warning, if pos seq. impedance = 0 but zero seq. impedance > 0
 pComp  pointer to the component (transformer)
 Rp,Xp  pos seq. resistance, reactance
 R0,X0  zero seq. resistance, reactance
 The warning is displayed in ShowWarnings in Imagopas.pas}
var
  ix,iy  : integer;   {coordinates}
  lbl    : string;    {label of the component}
  ll     : longint;   {temporary}
  pSet   : TpCompSet; {pointer to the common}
begin
  {set warning, if not correct R0 or X0}
  if ((Rp <= 0) and (R0 > 0)) or
     ((Xp <= 0) and (X0 > 0)) then begin
    pComp^.GetipSet(ll);
    pSet := TpCompSet(ll);
    pComp^.GetLabel(lbl,ix,iy);
    pSet^.RX0_warn := AppendTxtIf(lbl, pSet^.RX0_warn, ',');   {in routines.pas};
  end;
end;

procedure AutoTrafozero(ipSet: longint; pComp: TpComp; paa,pbb: pComplex;
                    nn: integer; par, fmult: single; short: integer);
{For an autotransformer,
 updates AN EXISTING, extended admittance matrix to the matrix
 of the zero sequence.
 pComp    pointer to the component (trafo)
 paa      pointer to the coefficient matrix
 pbb      pointer to the right hand side (not used ?)
 nn       dimension = number of nodes (excluding earth)
 par      a parameter (usually frequency, not used ?)
 fmult    frequency multiplier (harmonic)
 short    flag for a short circuit (not used ?)}
var
  cpu     : complex;        {temporary}
  Dflag   : single;         {flag for D-tertiary winding. 0 = Y,  <>  = D }
  er1,er2 : integer;
  er3,er4 : integer;        {error flag}
  er5,er7 : integer;        {error flag}
  er8,er9 : integer;
  er10,er6: integer;
  jcp,jcs : integer;        {prim, sec current node}
  jct     : integer;        {tert.current node}
  jn      : integer;
  jtw     : integer;        {"node" for circulating current in delta}
  jup,jus : integer;        {prim. sec. voltage nodes}
  jut     : integer;        {tert.voltage}
  jvp,jvs : integer;        {iternal voltage}
  Rg,Xg   : single;         {resistance, reactance to ground}
  zg      : complex;        {grouding impedance}
begin
  {get grounding impedance = read parameters}
  pComp^.GetPar(gATrafo_Rg,Rg);       {resistance to ground}
  pComp^.GetPar(gATrafo_Xg,Xg);       {reactance to ground}
  pComp^.GetPar(gATrafo_D,Dflag);     {flag for D-tertiary}
  if (Rg > 0) then zg.x := Rg         {real part of impedance to ground}
  else             zg.x := 0;
  zg.y := Xg;                         {imag. part of impedance to ground, can be < 0 !}
  {get nodes}
  pComp^.GetNode(1,jup,er1);
  pComp^.GetNode(2,jus,er2);
  pComp^.GetNode(3,jut,er3);
  pComp^.GetNode(4,jcp,er4);          {get "node" for primary current}
  pComp^.GetNode(5,jcs,er5);          {get "node" for sec. current}
  pComp^.GetNode(6,jvp,er6);
  pComp^.GetNode(7,jvs,er7);
  pComp^.GetNode(8,jn ,er8);           {neutral node}
  pComp^.GetNode(9,jct,er9);
  pComp^.GetNode(10,jtw,er10);

  {update matrix for grounding impedance}
  if (jn > 0) and (jn <= nn) and (er8 = 0) then begin  {reasonable neutral node}
    cpu.x := -1;
    cpu.y := 0;
    putCmat(paa,jn,jn,nn,nn,cpu);          {one to diagonal}
    if (jcs > 0) and (jcs <= nn) and (er5 = 0) then begin {reasonable current "node"}
      cpu := CRmult(-3.0,zg);              {(-?)3 * grounding impedance, pos current to trafo}
      putCmat(paa,jn,jcs,nn,nn,cpu);
    end;
    if (jcp > 0) and (jcp <= nn) then begin
      cpu := CRmult(3.0,zg);
      putCmat(paa,jn,jcp,nn,nn,cpu);
    end;
  end;
  { - - - - - - - - - - - - - - - - - - - - - - - }
  if (Dflag <> 0) then begin                       { Delta connected tertiary}
   {voltage in tertiary (delta) = 0}
    if (jut > 0) and (jut <= nn) then begin        {..some of this not needed?..}
      if (jct > 0) and (jct <= nn) then begin
{4}//   putCmat(paa,jut,jct,nn,nn,cplx(0,0));    {REMOVE!? clear eq. for pos.seq current balance}
{9}     putCmat(paa,jct,jut,nn,nn,Cxone);          {U3 = 0}

      end;
    end;
    {---}
    if (jct > 0) and (jct <= nn) then begin
      if (jus > 0) and (jus <= nn) then
        putCmat(paa,jct,jus,nn,nn,cplx(0,0));      {clear relation between U2 .. U3 }

    end;
    {I3 = 0}
    if (jtw > 0) and (jtw <= nn) then begin
{10}  putCmat(paa,jtw,jtw,nn,nn,cplx(0,0));
      if (jct > 0) and (jct <= nn) then
        putCmat(paa,jtw,jct,nn,nn,cplx(0,0));      {current to delta -> (or <- ) = 0}
      if (jvp > 0) and (jvp <= nn) then
        putCmat(paa,jtw,jvp,nn,nn,cxone);
    end;
    {---}
    if (jcp > 0) and (jcp <= nn) then begin        {voltage in prim. winding = 0}
      if (jvp > 0) and (jvp <= nn) then
{5}      putCmat(paa,jcp,jvp,nn,nn,cplx(0,0));
    end;
    {---}
    if (jcs > 0) and (jcs <= nn) then begin        {voltage in sec. winding = 0}
      if (jvs > 0) and (jvs <= nn) then
{6}     putCmat(paa,jcs,jvs,nn,nn,cplx(0,0));
    end;
    {---}

  end;
end;


(*
{testaillaan, kokeillaan...} {MELKEIN toimii 1.3.2016. Ei toimi kun feeder Zg iso}
procedure AutoTrafozero(ipSet: longint; pComp: TpComp; paa,pbb: pComplex;
                    nn: integer; par, fmult: single; short: integer);
{For an autotransformer,
 updates AN EXISTING, extended admittance matrix to the matrix
 of the zero sequence.
 pComp    pointer to the component (trafo)
 paa      pointer to the coefficient matrix
 pbb      pointer to the right hand side (not used ?)
 nn       dimension = number of nodes (excluding earth)
 par      a parameter (usually frequency, not used ?)
 fmult    frequency multiplier (harmonic)
 short    flag for a short circuit (not used ?)}
var
  cpu     : complex;        {temporary}
  Dflag   : single;         {flag for D-tertiary winding. 0 = Y,  <>  = D }
  er1,er2 : integer;
  er3,er4 : integer;        {error flag}
  er5,er7 : integer;        {error flag}
  er8,er9 : integer;
  er10,er6: integer;
  jcp,jcs : integer;        {prim, sec current node}
  jct     : integer;        {tert.current node}
  jn      : integer;
  jtw     : integer;        {"node" for circulating current in delta}
  jup,jus : integer;        {prim. sec. voltage nodes}
  jut     : integer;        {tert.voltage}
  jvp,jvs : integer;        {iternal voltage}
  Rg,Xg   : single;         {resistance, reactance to ground}
  zg      : complex;        {grouding impedance}
begin
  {get grounding impedance = read parameters}
  pComp^.GetPar(gATrafo_Rg,Rg);       {resistance to ground}
  pComp^.GetPar(gATrafo_Xg,Xg);       {reactance to ground}
  pComp^.GetPar(gATrafo_D,Dflag);     {flag for D-tertiary}
  if (Rg > 0) then zg.x := Rg         {real part of impedance to ground}
  else             zg.x := 0;
  zg.y := Xg;                         {imag. part of impedance to ground, can be < 0 !}
  {get nodes}
  pComp^.GetNode(4,jcp,er4);          {get "node" for primary current}
  pComp^.GetNode(5,jcs,er5);          {get "node" for sec. current}
  pComp^.GetNode(8,jn,er8);           {neutral node}
  {update matrix for grounding impedance}
  if (jn > 0) and (jn <= nn) and (er8 = 0) then begin  {reasonable neutral node}
    cpu.x := -1;
    cpu.y := 0;
    putCmat(paa,jn,jn,nn,nn,cpu);          {one to diagonal}
    if (jcs > 0) and (jcs <= nn) and (er5 = 0) then begin {reasonable current "node"}
      cpu := CRmult(-3.0,zg);              {(-?)3 * grounding impedance, pos current to trafo}
      putCmat(paa,jn,jcs,nn,nn,cpu);
    end;
    if (jcp > 0) and (jcp <= nn) then begin
      cpu := CRmult(3.0,zg);
      putCmat(paa,jn,jcp,nn,nn,cpu);
    end;
  end;

  {delta connected tertiary}
  if (Dflag <> 0) then begin
    {tert. current (to/from delta) = 0}
    pComp^.GetNode(10,jtw,er10);
    pComp^.GetNode(9,jct,er9);
    {singularinen...jos/kun}
    if (jtw > 0) and (jtw <= nn) then begin
{//}      putCmat(paa,jtw,jtw,nn,nn,cplx(0,0));     {ei sngl, jos toisinpin...}
      if (jct > 0) and (jct <= nn) then
{//}      putCmat(paa,jtw,jct,nn,nn,{cplx(0,0)}cxone);         {...siis 1,0 ja 0,0}
          {... mutta silloin vr tulos..}
    end;

    pComp^.GetNode(3,jut,er3);
    pComp^.GetNode(1,jup,er1);
    pComp^.GetNode(2,jus,er2);

{large impedance to ground, from secondary (?)}  {muuten singulaarinen, mutta onko hyv ratkaisu??}
//getCmat(paa,jus,jus,nn,nn,cpu);                  {...tai edes tarpeen ?}
//cpu := Cadd(cplx(0.01,0),cpu);
//putCmat(paa,jus,jus,nn,nn,cpu);

getCmat(paa,jut,jut,nn,nn,cpu);
cpu := Cadd(cplx(0.01,0),cpu);
putCmat(paa,jut,jut,nn,nn,cpu);


{even small current into delta causes large voltage}
    {first, clear pos.seq. equation}

//    if (jct > 0) and (jct <= nn) then begin
//      putCmat(paa,jct,jct,nn,nn,cplx(-10000,0));
//      if (jus > 0) and (jus <= nn) then
//        putCmat(paa,jct,jus,nn,nn,cplx(0,0));
//      if (jut > 0) and (jut <= nn) then
//        putCmat(paa,jct,jut,nn,nn,cplx(1,0));
//    end;


    {prim.voltage = neutral volt. ??? is it? why ??}
    pComp^.GetNode(6,jvp,er6);
    if (jcp > 0) and (jcp <= nn) then begin
      if (jup > 0) and (jup <= nn) then
        putCmat(paa,jcp,jup,nn,nn,cplx(1,0));
      if (jn > 0) and (jn <= nn) then
        putCmat(paa,jcp,jn,nn,nn,cplx(-1,0));
      if (jus > 0) and (jus <= nn) then
        putCmat(paa,jcp,jus,nn,nn,cplx(0,0));
      if (jvp > 0) and (jvp <= nn) then
        putCmat(paa,jcp,jvp,nn,nn,cplx(0,0));
    end;

    {sec. voltage ... neutral voltage ...??}
    pComp^.GetNode(7,jvs,er7);
    if (jcs > 0) and (jcs <= nn) then begin
      {first, clear equation for sec.voltage}
      putCmat(paa,jcs,jcs,nn,nn,cplx(0,0));
      if (jcp > 0) and (jcp <= nn) then
        putCmat(paa,jcs,jcp,nn,nn,cplx(0,0));
      if (jus > 0) and (jus <= nn) then
        putCmat(paa,jcs,jus,nn,nn,cplx(0,0));     {alkuperinen (0,0)}
      if (jn  > 0) and (jn  <= nn) then
        putCmat(paa,jcs,jn ,nn,nn,cplx(0,0));
      {then sec.voltage}
      if (jvs > 0) and (jvs <= nn) then
{singular, jos 0,0 ja jcs,jus = 1,0 }
        putCmat(paa,jcs,jvs,nn,nn,cplx(1,0));     {alkuperinen  (1,0)}
    end;
{mutta silti singulaarinen..??}

  end;
end;
*)

(* Toimiva . . . . . . . .
procedure AutoTrafozero(ipSet: longint; pComp: TpComp; paa,pbb: pComplex;
                    nn: integer; par, fmult: single; short: integer);
{For an autotransformer,
 updates AN EXISTING, extended admittance matrix to the matrix
 of the zero sequence.
 pComp    pointer to the component (trafo)
 paa      pointer to the coefficient matrix
 pbb      pointer to the right hand side (not used ?)
 nn       dimension = number of nodes (excluding earth)
 par      a parameter (usually frequency, not used ?)
 fmult    frequency multiplier (harmonic)
 short    flag for a short circuit (not used ?)}
var
  cpu     : complex;        {temporary}
  Dflag   : single;         {flag for D-tertiary winding. 0 = Y,  <>  = D }
  er1,er2 : integer;
  er3,er4 : integer;        {error flag}
  er5,er7 : integer;        {error flag}
  er8,er9 : integer;
  er10    : integer;
  jcp,jcs : integer;        {prim, sec current node}
  jct     : integer;        {tert.current node}
  jn      : integer;
  jtw     : integer;        {"node" for circulating current in delta}
  jup,jus : integer;        {prim. sec. voltage nodes}
  jut     : integer;        {tert.voltage}
  jvp,jvs : integer;        {iternal voltage}
  Rg,Xg   : single;         {resistance, reactance to ground}
  zg      : complex;        {grouding impedance}
begin
  {get grounding impedance = read parameters}
  pComp^.GetPar(gATrafo_Rg,Rg);       {resistance to ground}
  pComp^.GetPar(gATrafo_Xg,Xg);       {reactance to ground}
  pComp^.GetPar(gATrafo_D,Dflag);     {flag for D-tertiary}
  if (Rg > 0) then zg.x := Rg         {real part of impedance to ground}
  else             zg.x := 0;
  zg.y := Xg;                         {imag. part of impedance to ground, can be < 0 !}
  {get nodes}
  pComp^.GetNode(4,jcp,er4);          {get "node" for primary current}
  pComp^.GetNode(5,jcs,er5);          {get "node" for sec. current}
  pComp^.GetNode(8,jn,er8);           {neutral node}
  {update matrix for grounding impedance}
  if (jn > 0) and (jn <= nn) and (er8 = 0) then begin  {reasonable neutral node}
    cpu.x := -1;
    cpu.y := 0;
    putCmat(paa,jn,jn,nn,nn,cpu);          {one to diagonal}
    if (jcs > 0) and (jcs <= nn) and (er5 = 0) then begin {reasonable current "node"}
      cpu := CRmult(-3.0,zg);              {(-?)3 * grounding impedance, pos current to trafo}
      putCmat(paa,jn,jcs,nn,nn,cpu);
    end;
    if (jcp > 0) and (jcp <= nn) then begin
      cpu := CRmult(3.0,zg);
      putCmat(paa,jn,jcp,nn,nn,cpu);
    end;
  end;
  {delta connected tertiary}
  if (Dflag <> 0) then begin
    {tert. current (to/from delta) = 0}
    pComp^.GetNode(10,jtw,er10);
    pComp^.GetNode(9,jct,er9);
    if (jtw > 0) and (jtw <= nn) then begin
      putCmat(paa,jtw,jtw,nn,nn,cplx(0,0));
      if (jct > 0) and (jct <= nn) then
        putCmat(paa,jtw,jct,nn,nn,cxone);
    end;
    {even small current into delta causes large voltage}
    pComp^.GetNode(3,jut,er3);
    pComp^.GetNode(1,jup,er1);
    pComp^.GetNode(2,jus,er2);
    {also clear pos.seq. equation}
    if (jct > 0) and (jct <= nn) then begin
      putCmat(paa,jct,jct,nn,nn,cplx(-10000,0));
      if (jus > 0) and (jus <= nn) then
        putCmat(paa,jct,jus,nn,nn,cplx(0,0));
      if (jut > 0) and (jut <= nn) then
        putCmat(paa,jct,jut,nn,nn,cplx(1,0));
    end;
    {prim.voltage = neutral volt. ??? is it? why ??}
    pComp^.GetNode(7,jvp,er7);
    if (jcp > 0) and (jcp <= nn) then begin
      if (jup > 0) and (jup <= nn) then
        putCmat(paa,jcp,jup,nn,nn,cplx(1,0));
      if (jn > 0) and (jn <= nn) then
        putCmat(paa,jcp,jn,nn,nn,cplx(-1,0));
      if (jus > 0) and (jus <= nn) then
        putCmat(paa,jcp,jus,nn,nn,cplx(0,0));
      if (jvp > 0) and (jvp <= nn) then
        putCmat(paa,jcp,jvp,nn,nn,cplx(0,0));
    end;
    {sec. voltage ... neutral voltage ...??}
    pComp^.GetNode(7,jvs,er7);
    if (jcs > 0) and (jcs <= nn) then begin
      {first, clear eqation for sec.voltage}
      putCmat(paa,jcs,jcs,nn,nn,cplx(0,0));
      if (jcp > 0) and (jcp <= nn) then
        putCmat(paa,jcs,jcp,nn,nn,cplx(0,0));
      if (jus > 0) and (jus <= nn) then
        putCmat(paa,jcs,jus,nn,nn,cplx(0,0));
      if (jn  > 0) and (jn  <= nn) then
        putCmat(paa,jcs,jn ,nn,nn,cplx(0,0));
      {then sec.voltage}
      if (jvs > 0) and (jvs <= nn) then
        putCmat(paa,jcs,jvs,nn,nn,cplx(1,0));
    end;
  end;
end;
*)

procedure Trafozero(ipSet: longint; pComp: TpComp; paa,pbb: pComplex;
                    nn: integer; par, fmult: single; short: integer);
{For a Y-Y transformator,
 updates AN EXISTING, extended admittance matrix to the matrix
 of the zero sequence.
 pComp    pointer to the component (trafo)
 paa      pointer to the coefficient matrix
 pbb      pointer to the right hand side (not used ?)
 nn       dimension = number of nodes (excluding earth)
 par      a parameter (usually frequency, not used ?)
 fmult    frequency multiplier (harmonic)
 short    flag for a short circuit (not used ?)}
var
  apu     : single;    {temporary}
  cpu     : complex;   {temporary}
  jcp,jcs : integer;   {"nodes" for prim, sec. current}
  jnp,jns : integer;   {prim, sec neutral nodes}
{ js      : integer;   {sec.node}
  er1,er2 : integer;   {error flag}
  er3,er4 : integer;   {error flag}
  ix,iy   : integer;   {label coordinates}
  lbl     : string;    {label of the component}
  ll      : longint;   {temporary}
  nprl    : single;    {number of parallel trafos}
  pSet    : TpCompSet; {pointer to the common}
  r01,x01 : single;    {zero seq.imped./pos.seq.imped}
  Rp,R0   : single;    {pos.seq, zero seq. resistance}
  R1,R2   : single;    {grounding resistances}
  Xp,X0   : single;    {pos.seq, zero seq. reactance}
  X1,X2   : single;    {grounding reactances}
  zp,zs   : complex;   {prim, sec. grounding impedance}
begin
  {get grounding impedance = read parameters}
  pComp^.GetPar(gTrafo_R1g,R1);    {prim. resistance to ground}
  pComp^.GetPar(gTrafo_R2g,R2);    {sec.  resistance to ground}
  pComp^.GetPar(gTrafo_X1g,X1);    {prim. reactance to ground}
  pComp^.GetPar(gTrafo_X2g,X2);    {sec.  reactance to ground}
  {parallel trafos ?}
  pComp^.GetPar(gYY_parall,nprl);
  if (nprl > 0) then begin
    R1 := R1/nprl;
    R2 := R2/nprl;
    X1 := X1/nprl;
    X2 := X2/nprl;
  end;
  if (R1 > 0) then zp.x := R1      {real part of impedance to ground}
  else             zp.x := 0;
  zp.y := X1;                      {imag. part of impedance to ground, can be < 0 !}
  if (R2 > 0) then zs.x := R2      {real part of impedance to ground}
  else             zs.x := 0;
  {for reactance, must check frequency}
  if (fmult <= 0) then  begin
    zs.y := X2;                    {imag. part of sec. impedance to ground, can be < 0 !}
    zp.y := X1;                    {imag. part of prim impedance to ground, can be < 0 !}
  end else begin
    if (X2 < 0) then zs.y := X2/fmult
    else             zs.y := X2*fmult;
    if (X1 < 0) then zp.y := X1/fmult
    else             zp.y := X1*fmult;
  end;
  {get nodes}
  pComp^.GetNode(3,jcp,er1);       {get "node" for primary current}
  pComp^.GetNode(4,jcs,er2);       {get "node" for sec. current}
  pComp^.GetNode(5,jnp,er3);       {prim. neutral node}
  pComp^.getNode(6,jns,er4);       {sec. neutral node}
  {for an ideal transformer, zero seq. impedance = 0, only earthing impedance inclded}
  if (imagoo.IdealTrBut.down) then begin                 {ideal trafo}
    if (er1 = 0) and (er3 = 0) and
       (jnp > 0) and (jnp <= nn) and (jcp > 0) and (jcp <= nn) then begin
      cpu := Crmult(-3.,zp);                             {for prim. neutral point}
      putCmat(paa,jnp,jcp,nn,nn,cpu);                    {U = I*3Z}
    end;
    if (er2 = 0) and (er4 = 0) and
       (jns > 0) and (jns <= nn) and (jcs > 0) and (jcs <= nn) then begin
      cpu := Crmult(-3.,zs);                             {for sec. neutral point}
      putCmat(paa,jns,jcs,nn,nn,cpu);                    {U = I*3Z}
    end;
  end else begin                                         {normal trafo}
    {update matrix}
    if (jnp > 0) and (jnp <= nn) and (er3 = 0) then begin  {reasonable neutral node}
      cpu.x := 1;
      cpu.y := 0;
      putCmat(paa,jnp,jnp,nn,nn,cpu); {one to diagonal}
      if (jcp > 0) and (jcp <= nn) and (er1 = 0) then begin {reasonable current "node"}
        cpu := CRmult(-3.0,zp);       {-3 * grounding impedance, pos current to trafo}
        putCmat(paa,jnp,jcp,nn,nn,cpu);
      end;
    end;
    {same to secondary side}
    if (jns > 0) and (jns <= nn) and (er4 = 0) then begin  {reasonable neutral node}
      cpu.x := 1;
      cpu.y := 0;
      putCmat(paa,jns,jns,nn,nn,cpu); {one to diagonal}
      if (jcs > 0) and (jcs <= nn) and (er2 = 0) then begin {reasonable current "node"}
        cpu := CRmult(-3.0,zs);       {-3 * grounding impedance, pos current to trafo}
        putCmat(paa,jns,jcs,nn,nn,cpu);
      end;
    end;
    {zero seq.impedance - - - - - - - - - -}
    pComp^.GetPar(gTrafo_R1,Rp);     {pos. seq. resistance}
    pComp^.GetPar(gTrafo_X, Xp);     {pos. seq. reactance}
    pComp^.GetPar(gTrafo_R0,R0);     {zero seq. resistance}
    pComp^.GetPar(gTrafo_X0,X0);     {zero seq. reactance}
    {adjust impedances, if parallel trafos}
    if (nprl > 0) then begin
      Rp := {R1}Rp/nprl;           {corrected 5.2.11}
      R0 := {R2}R0/nprl;
      Xp := {X1}Xp/nprl;
      X0 := {X2}X0/nprl;
    end;
    if (Rp > 0) then r01 := R0/Rp else r01 := 1;
    if (Xp > 0) then x01 := X0/Xp else x01 := 1;
    {set warning, if not correct R0 or X0}
    R0X0Warning(pComp, Rp,Xp,R0,X0);
    {update matrix}
    getCmat(paa,jcs,jcs,nn,nn,cpu); {--- saved in putCmat(paa,jc,jc,nn,nn,cpu) in TrafoeqD of elplex}
    cpu.x := cpu.x*r01;
    cpu.y := cpu.y*x01;
    putCmat(paa,jcs,jcs,nn,nn,cpu);
    getCmat(paa,jcs,jcp,nn,nn,cpu); {--- saved in putCmat(paa,jc,jo,nn,nn,cpu) in TrafoeqD of elplex}
    cpu.x := cpu.x*r01;
    putCmat(paa,jcs,jcp,nn,nn,cpu);
  end;
end;

procedure Trf3Wzero(ipSet: longint; pComp: TpComp; paa,pbb: pComplex;
                    nn: integer; par, fmult: single; short: integer);
{For a YYY or a YYD transformer,
 updates AN EXISTING, extended admittance matrix to the matrix
 of the zero sequence}
var
  apu      : single;   {temporary}
  TrafoTyp : integer;  {type of the trafo , YYY, YYD, etc}
begin
  pComp^.GetPar(g3W_type,apu);    {type of the trafo}
  TrafoTyp := round(apu);
  if (TrafoTyp = 1) then begin    {YYY-trafo}
    TrfYYYzero(ipSet,pComp, paa,pbb,nn,par,fmult,short)
  end else begin                  {YYD-transformer}
    TrfYYDzero(ipSet,pComp, paa,pbb,nn,par,fmult,short)
  end;
end;

procedure TrfYYYzero(ipSet: longint; pComp: TpComp; paa,pbb: pComplex;
                    nn: integer; par, fmult: single; short: integer);
{For a Y-Y-Y transformator,
 updates AN EXISTING, extended admittance matrix to the matrix
 of the zero sequence.
 pComp    pointer to the component (trafo)
 paa      pointer to the coefficient matrix
 pbb      pointer to the right hand side (not used ?)
 nn       dimension = number of nodes (excluding earth)
 par      a parameter (usually frequency, not used ?)
 fmult    frequency multiplier (harmonic)
 short    flag for a short circuit (not used ?)}
var
  a1,a2,a3: single;    {temporary}
  cpu     : complex;   {temporary}
  ii,i1,i2: integer;   {indices}
  jc1,jc2 : integer;   {"nodes" for prim, sec. current}
  jc3     : integer;   {"node" for tert.current}
  jn1,jn2 : integer;   {prim, sec neutral nodes}
  jn3     : integer;   {tert. neutral node}
  er1,er2 : integer;   {error flag}
  er3,er4 : integer;   {error flag}
  er5,er6 : integer;   {error flag}
  R1,R2,R3: single;    {grounding resistances}
  X1,X2,X3: single;    {grounding reactances}
  z1,z2,z3: complex;   {grounding impedances}
begin
  {get grounding impedance = read parameters}
  pComp^.GetPar(g3W_R1g,R1);      {prim. resistance to ground}
  pComp^.GetPar(g3W_R2g,R2);      {sec.  resistance to ground}
  pComp^.GetPar(g3W_R3g,R3);      {tert.  resistance to ground}
  pComp^.GetPar(g3W_X1g,X1);      {prim. reactance to ground}
  pComp^.GetPar(g3W_X2g,X2);      {sec.  reactance to ground}
  pComp^.GetPar(g3W_X3g,X3);      {tert.  reactance to ground}
  if (R1 > 0) then z1.x := R1      {real part of impedance to ground}
  else             z1.x := 0;
  if (R2 > 0) then z2.x := R2      {real part of impedance to ground}
  else             z2.x := 0;
  if (R3 > 0) then z3.x := R3      {real part of impedance to ground}
  else             z3.x := 0;
  {reactance}
  z1.y := X1;                      {imag. part of prim. impedance to ground, can be < 0 !}
  z2.y := X2;                      {imag. part of sec. impedance to ground, can be < 0 !}
  z3.y := X3;
  {get nodes}
  pComp^.GetNode(4,jc1,er1);       {get "node" for primary current}
  pComp^.GetNode(5,jc2,er2);       {get "node" for sec. current}
  pComp^.GetNode(6,jc3,er3);
  pComp^.GetNode(7,jn1,er4);       {prim. neutral node}
  pComp^.getNode(8,jn2,er5);       {sec. neutral node}
  pComp^.getNode(9,jn3,er6);
  {update matrix}
  if (jn1 > 0) and (jn1 <= nn) and (er4 = 0) then begin   {reasonable neutral node}
    if (jc1 > 0) and (jc1 <= nn) and (er1 = 0) then begin {reasonable current "node"}
      cpu := CRmult(-3.0,z1);       {-3 * grounding impedance, pos current to trafo}
      putCmat(paa,jn1,jc1,nn,nn,cpu);
    end;
  end;
  {same to secondary side}
  if (jn2 > 0) and (jn2 <= nn) and (er5 = 0) then begin   {reasonable neutral node}
    if (jc2 > 0) and (jc2 <= nn) and (er2 = 0) then begin {reasonable current "node"}
      cpu := CRmult(-3.0,z2);       {-3 * grounding impedance, pos current to trafo}
      putCmat(paa,jn2,jc2,nn,nn,cpu);
    end;
  end;
  {and to the tertiary side}
  if (jn3 > 0) and (jn3 <= nn) and (er6 = 0) then begin   {reasonable neutral node}
    if (jc3 > 0) and (jc3 <= nn) and (er3 = 0) then begin {reasonable current "node"}
      cpu := CRmult(-3.0,z3);       {-3 * grounding impedance, pos current to trafo}
      putCmat(paa,jn3,jc3,nn,nn,cpu);
    end;
  end;
  {no zero seq. impedance for an ideal trafo}
  if (imagoo.IdealTrBut.down) then begin                  {ideal trafo}
    {do nothing}
  end else begin                                          {nonideal trafo}
    {zero sequence impedances, calculated in TrafoYYYmat, in Elplex.pas}
    for ii := 1 to 13 do begin
      pComp^.GetIntSing(ii,i1,i2,a1,a2,a3);
      if (i1 > 0) and (i1 <= nn) and (i2 > 0) and (i2 <= nn) then begin
        putCmat(paa,i1,i2,nn,nn,cplx(a1,a2));     {replace the pos.seq. coefficients}
      end;
    end;
  end;
end;

procedure TrfYYDzero(ipSet: longint; pComp: TpComp; paa,pbb: pComplex;
                    nn: integer; par, fmult: single; short: integer);
{For a Y-Y-D transformator,
 updates AN EXISTING, extended admittance matrix to the matrix
 of the zero sequence.
 pComp    pointer to the component (trafo)
 paa      pointer to the coefficient matrix
 pbb      pointer to the right hand side (not used ?)
 nn       dimension = number of nodes (excluding earth)
 par      a parameter (usually frequency, not used ?)
 fmult    frequency multiplier (harmonic)
 short    flag for a short circuit (not used ?)}
var
  a1,a2,a3: single;    {temporary}
  cpu     : complex;   {temporary}
  ii,i1,i2: integer;   {indices}
  jc1,jc2 : integer;   {"nodes" for prim, sec. current}
  jc3     : integer;   {"node" for tert.current}
  jn1,jn2 : integer;   {prim, sec neutral nodes}
  jn3     : integer;   {tert. winding current "node"}
  ju1,ju2 : integer;   {prim, sec. voltage nodes}
  ju3     : integer;   {tertiary voltage node}
  er,er0  : integer;   {error flag}
  er1,er2 : integer;   {error flag}
  er3,er4 : integer;   {error flag}
  er5,er6 : integer;   {error flag}
  R1,R2   : single;    {grounding resistances}
  X1,X2   : single;    {grounding reactances}
  z1,z2   : complex;   {grounding impedances}
begin
  {get grounding impedance = read parameters}
  pComp^.GetPar(g3W_R1g,R1);      {prim. resistance to ground}
  pComp^.GetPar(g3W_R2g,R2);      {sec.  resistance to ground}
  pComp^.GetPar(g3W_X1g,X1);      {prim. reactance to ground}
  pComp^.GetPar(g3W_X2g,X2);      {sec.  reactance to ground}
  if (R1 > 0) then z1.x := R1      {real part of impedance to ground}
  else             z1.x := 0;
  if (R2 > 0) then z2.x := R2      {real part of impedance to ground}
  else             z2.x := 0;
  {reactance}
  z1.y := X1;                      {imag. part of prim. impedance to ground, can be < 0 !}
  z2.y := X2;                      {imag. part of sec. impedance to ground, can be < 0 !}
  {get nodes}
  pComp^.GetNode(1,ju1,er);
  pComp^.GetNode(2,ju2,er);
  pComp^.GetNode(3,ju3,er0);       {tertiary voltage node}
  pComp^.GetNode(4,jc1,er1);       {get "node" for primary current}
  pComp^.GetNode(5,jc2,er2);       {get "node" for sec. current}
  pComp^.GetNode(6,jc3,er3);
  pComp^.GetNode(7,jn1,er4);       {prim. neutral node}
  pComp^.getNode(8,jn2,er5);       {sec. neutral node}
  pComp^.getNode(9,jn3,er6);
  {update matrix}
  if (jn1 > 0) and (jn1 <= nn) and (er4 = 0) then begin   {reasonable neutral node}
    if (jc1 > 0) and (jc1 <= nn) and (er1 = 0) then begin {reasonable current "node"}
      cpu := CRmult(-3.0,z1);       {-3 * grounding impedance, pos current to trafo}
      putCmat(paa,jn1,jc1,nn,nn,cpu);
    end;
  end;
  {same to secondary side}
  if (jn2 > 0) and (jn2 <= nn) and (er5 = 0) then begin   {reasonable neutral node}
    if (jc2 > 0) and (jc2 <= nn) and (er2 = 0) then begin {reasonable current "node"}
      cpu := CRmult(-3.0,z2);       {-3 * grounding impedance, pos current to trafo}
      putCmat(paa,jn2,jc2,nn,nn,cpu);
    end;
  end;
  {ideal transformer?}
  if (imagoo.IdealTrBut.down) then begin
    {tertiary zero seq. current is zero}
    putCmat(paa,jn3,jn3,nn,nn,cplx(0,0));
    {prim. and sec. voltages = neutral voltages (are they?)}
    if (ju1 >0) and (ju1 <= nn) and (ju2 > 0) and (ju2 <= nn) then begin
      {prim}
      putCmat(paa,jc1,ju2,nn,nn,cplx(0,0));    {clear, no sec.voltage here}
      putCmat(paa,jc1,ju1,nn,nn,cplx(1,0));
      putCmat(paa,jc1,jn2,nn,nn,cplx(0,0));
      putCmat(paa,jc1,jn1,nn,nn,cplx(-1,0));
      {sec}
      putCmat(paa,jc2,ju3,nn,nn,cplx(0,0));
      putCmat(paa,jc2,ju2,nn,nn,cplx(1,0));
      putCmat(paa,jc2,jn2,nn,nn,cplx(-1,0));
    end;
    {zero seq. tertiay current = 0}
    putCmat(paa,jn3,jc3,nn,nn,Cxone);
    putCmat(paa,jn3,jn3,nn,nn,cplx(0,0));

  end else begin                        {nonideal trafo}
    putCmat(paa,jc2,ju3,nn,nn,cplx(0,0)); {voltage over tert.winding = 0, cannot be in equation}
    {tertiary winding: two conditions: input current = very small; voltage over winding = 0}
    {on tertiary side, even a small current causes a large voltage}
    if (jc3 > 0) and (jc3 <= nn) and (er3 = 0) then begin  {reasonable sec. node}
      putCmat(paa,jc3,jn3,nn,nn,cplx(0,0));                {clear old equation}
      putCmat(paa,jc3,jc3,nn,nn,cplx(-XLRes,0));           {large resistance to diagonal}
      if (ju3 > 0) and (ju3 <= nn) and (er0 = 0) then begin
        putCmat(paa,jc3,ju3,nn,nn,cplx(1,0));              {one to voltage term}
      end;
    end;
    {voltage over D-winding = 0}
    putCmat(paa,jn3,ju3,nn,nn,cplx(0,0));
    {zero sequence impedances, calculated in TrafoYYDmat, in Elplex.pas}
    for ii := 1 to {6}{7}11 do begin
      pComp^.GetIntSing(ii,i1,i2,a1,a2,a3);
      if (i1 > 0) and (i1 <= nn) and (i2 > 0) and (i2 <= nn) then begin
        putCmat(paa,i1,i2,nn,nn,cplx(a1,a2));     {replace the pos.seq. coefficients}
      end;
    end;
  end;
end;

function ImpedMult(pComp: TpComp) : single;
{calculate the multiplier for the impedance, needed in IEC-calculations}
var
  ll   : longint;    {temporary}
  pSet : TpCompSet;  {pointer to the common}
  Vnom : Single;     {nominal voltage ("system voltage")}
begin
  pComp^.GetipSet(ll);
  pSet := TpCompSet(ll);
  {IEC-button down, but not IEC-calculation = Z012-calculation from toolbar or from Fault in all buses}
  if ((imagoo.IECBut.down) and not(pSet^.appl_but=15) and not (pSet^.Appl_but = 23)) or
     {IEC-calculation from Fault in all buses}
     ((pSet^.appl_op = 14) and (AllShortForm.IECBut.checked)) then begin
    pComp^.GetPar(gFeed_V,Vnom);            {nominal voltage}
    ImpedMult := VoltageFactor(Vnom);       {voltage factor = multiplier}
  end else begin
    ImpedMult := 1;
  end;
end;

procedure Feedzero(ipSet: longint; pComp: TpComp; paa,pbb: pComplex;
                   nn: integer; par, fmult: single; short: integer);
{For feeder,
 updates AN EXISTING, extended admittance matrix to the matrix
 of the zero sequence.
 pComp    pointer to the component (trafo)
 paa      pointer to the coefficient matrix
 pbb      pointer to the right hand side (not used ?)
 nn       dimension = number of nodes (excluding earth)
 par      a parameter (usually frequency, not used ?)
 fmult    frequency multiplier (harmonic)
 short    flag for a short circuit (not used ?)}
var
  apu     : single;    {temporary}
  cpu     : complex;   {temporary}
  jc      : integer;   {"node" for current}
  jd      : integer;   {downstream node = output}
  jn      : integer;   {neutral node}
  er1,er2 : integer;   {error flag}
  er3     : integer;   {error flag}
  pSet    : TpCompSet; {pointer to the common}
{  R,X     : single;    {"normal" (pos.seq.) impedance}
  R0,X0   : single;    {zero sequence impedance}
  Rg,Xg   : single;    {grounding impedance}
  Vnom    : single;    {nominal voltage}
  zn      : complex;   {grounding impedance}
  Z0      : complex;   {zero sequence impedance}
begin
  pSet := TpCompSet(ipSet);
  {get grounding impedance = read parameters}
  pComp^.GetPar(gFeed_Rg,Rg);      {grounding resistance}
  pComp^.GetPar(gFeed_Xg,Xg);      {grounding reactance}
{ pComp^.GetPar(gFeed_R,R);        {iternal resistance}
{ pComp^.GetPar(gFeed_X,X);        {internal reactance}
  if (Rg > 0) then zn.x := Rg      {real part of impedance to ground}
  else             zn.x := 0;
  {for reactance, must check frequency}
  if (fmult <= 0) then  begin
    zn.y := Xg;                    {imag. part of impedance to ground, can be < 0 !}
  end else begin
    if (Xg < 0) then zn.y := Xg/fmult
    else             zn.y := Xg*fmult;
  end;
  {zero sequence impedance}
  pComp^.GetPar(gFeed_R0,R0);      {resistance}
  pComp^.GetPar(gFeed_X0,X0);      {reactance}
(*
  if (R > 0) then begin                 {check that zero sequence impedance reasonable}
    if (R0 >= R) then Z0.x := R0
    else              Z0.x := R;
  end;
  if (X > 0) then begin                 {check that zero sequence impedance reasonable}
    if (X0 >= X) then Z0.y := X0
    else              Z0.y := X;
  end else begin
    if (X0 >= 0.00099) then Z0.y := X0
    else                    Z0.y := 0.00099;
  end;
*)
  if (R0 >= 0) then Z0.x := R0 else Z0.x := 0;      {can be smaller than R (?)...}
  if (X0 >= 0) then Z0.y := X0 else Z0.y := 0;      {... 5.11.2003}
  if (Z0.x = 0) and (Z0.y = 0) then Z0.x := 0.0001; {cannot be zero, or can it?}
  {get nodes}
  pComp^.GetNode(1,jd,er3);        {get downstream node (output)}
  pComp^.GetNode(2,jc,er1);        {get "node" for current}
  pComp^.GetNode(3,jn,er2);        {get neutral node}
  {update matrix}
  if (jn > 0) and (jn <= nn) and (er2 = 0) then begin  {reasonable neutral node}
    cpu.x := 1;
    cpu.y := 0;
    putCmat(paa,jn,jn,nn,nn,cpu);  {one to diagonal}
    if (jc > 0) and (jc <= nn) and (er1 = 0) then begin {reasonable current "node"}
      cpu := CRmult(3.0,zn);       {3 * grounding impedance, pos current to trafo}
      putCmat(paa,jn,jc,nn,nn,cpu);
    end;
  end;
  if (jc > 0) and (jc <= nn) and (er1 = 0) then begin
    if (jn > 0) and (jn <= nn) and (er2 = 0) then begin
      cpu.x := -1;
      cpu.y :=  0;
      putCmat(paa,jc,jn,nn,nn,cpu);  {voltage with respect to neutral}
    end;
    {check multiplication of impedance in IEC-calculation,..
     ..but no multiplication when calculating sequence impedances}
//    if ((imagoo.IECBut.down) and not(pSet^.appl_but=15) and not (pSet^.Appl_but = 23)) or
//       ((pSet^.appl_op = 14) and (AllShortForm.IECBut.checked)) then begin
//      pComp^.GetPar(gFeed_V,Vnom);      {nominal voltage}
//      apu := VoltageFactor(Vnom);       {voltage factor = multiplier}
//      cpu := Crmult(apu,Z0);
//      putCmat(paa,jc,jc,nn,nn,cpu);     {voltage drop, for zero seq.}
//    end else begin
//      putCmat(paa,jc,jc,nn,nn,Z0);      {voltage drop, for zero seq.}
//    end;
    cpu := Crmult(ImpedMult(pComp),Z0);
    putCmat(paa,jc,jc,nn,nn,cpu);
    if (jd > 0) and (jd <=nn) and (er3 = 0) then begin
      cpu.x := 1;
      cpu.y := 0;
      putCmat(paa,jc,jd,nn,nn,cpu);  {one to diagonal}
    end;
  end;
end;

procedure FindZg(ipSet : longint; {nstar}xs,ys : integer; var pImped : TpComp);
{find the grounding impedance connected to the star node
 ipSet    pointer to the set of components, etc, as integer
 (nstar)  (the node of the star point)
 xs,ys    coordinates of the star point
 pImped   pointer to the grounding impedance
}
var
  errc,er : integer;     {error flags}
  ii      : integer;     {temporary}
  ix,iy   : integer;     {node coordinates}
  jcomp   : integer;     {counts components}
  ModNam  : string;      {name (type) of the component}
  pSet    : TpCompSet;   {pointer to the set of components, etc.}
  pComp   : TpComp;      {pointer to components}
begin
  pImped := nil;              {initialize pointer to grounding impedance}
  pSet := TpCompSet(ipSet);   {integer to pointer}
  pComp := nil;               {initialize pointer to components}
  errc  := 0;                 {initialize error flag}
  jcomp := 0;
  while (errc = 0) do begin                     {scan all components}
    pSet^.NextComp(pComp,errc,jcomp,true);      {get pointer to next component}
    if (errc = 0) then begin                    {component found}
      pComp^.GetModName(ModNam);                {get the name (type) of the component}
      if (ModNam = gGrImped) then begin         {grounding impedance}
{       pComp^.GetNode(1,ii,er);                {get node}
{       if (ii = nstar) then begin              {connected to the star point}
        pComp^.getNxy(1,ix,iy);                 {node coordinates}
        if (ix = xs) and (iy = ys) then begin   {connected to the star point}
          pImped := pComp;
          break;
        end;
      end;
    end;
  end;
end;

procedure FindGrCurrT(ipSet : longint; nneutr : integer; var pCT : TpComp);
{find the wire ("Ground current trafo") connected to the given grounding impedance
 ipSet    pointer to the set of components, etc, as integer
 nneutr   neutral node of the given comp.
 pCT      pointer to the grounding curr.Trafo
}
var
  errc,er : integer;     {error flags}
  ii      : integer;     {temporary}
  jcomp   : integer;     {counts components}
  jn      : integer;     {neutral node}
  ModNam  : string;      {name (type) of the component}
  pSet    : TpCompSet;   {pointer to the set of components, etc.}
  pComp   : TpComp;      {pointer to components}
begin
  pCT := nil;                 {initialize pointer to grounding impedance}
  pSet := TpCompSet(ipSet);   {integer to pointer}
  pComp := nil;               {initialize pointer to components}
  errc  := 0;                 {initialize error flag}
  jcomp := 0;
  while (errc = 0) do begin                     {scan all components}
    pSet^.NextComp(pComp,errc,jcomp,true);      {get pointer to next component}
    if (errc = 0) then begin                    {component found}
      pComp^.GetModName(ModNam);                {get the name (type) of the component}
      if (ModNam = gGrcurrT) then begin         {grounding current Trafo}
        pComp^.getNode(2,jn,er);                {neutral node}
        if (jn = nneutr) then begin             {same node}
          pCT := pComp;
          break;
        end;
      end;
    end;
  end;
end;

procedure Generzero(ipSet: longint; pComp: TpComp; paa,pbb: pComplex;
                    nn: integer; par, fmult: single; short: integer);
{For a generator,
 updates AN EXISTING, extended admittance matrix to the matrix
 of the zero sequence.
 pComp    pointer to the component (trafo)
 paa      pointer to the coefficient matrix
 pbb      pointer to the right hand side (not used ?)
 nn       dimension = number of nodes (excluding earth)
 par      a parameter (usually frequency, not used ?)
 fmult    frequency multiplier (harmonic)
 short    flag for a short circuit (not used ?)}
const
  BigRes = 1.0e6;
var
  cpu     : complex;   {temporary}
  jc      : integer;   {"node" for current}
  jd      : integer;   {voltage ("downstream") node}
  jn      : integer;   {neutral node}
  er1,er2 : integer;   {error flag}
  er3,ern : integer;   {error flag}
  nneutr  : integer;   {neutral node}
  ngp     : single;    {number of parallel generators}
  pCT     : TpComp;    {pointer to the gr.current trafo}
  pImped  : TpComp;    {impedance from neutral to ground}
  pSet    : TpCompSet; {pointer to the common}
  Rg,Xg   : single;    {grounding impedance}
  Rs      : single;    {stator resistance}
  xs,ys   : integer;   {coordinates of the neutral point}
  X0      : single;    {zero seq. reactance}
  zn      : complex;   {grounding impedance}
begin
  pSet := TpCompSet(ipSet);
  {get nodes}
  pComp^.GetNode(1,jd,er1);        {get voltage node}
  pComp^.GetNode(2,jc,er2);        {get "node" for current}
  pComp^.GetNode(3,jn,er3);        {get neutral node}
  {get zero seq. impedance and grounding impedance = read parameters}
  ngp := nGenP(pComp);             {number of parallel generators, in elplex.pas}
  pComp^.GetPar(gGen_Rs,Rs);       {get stator resistance}
  Rs := Rs/ngp;
  pComp^.GetPar(gGen_X0,X0);       {get zero seq. reactance}
  X0 := X0/ngp;
  {find the impedance from neutral (star) to ground, if any}
  pComp^.getNxy(3,xs,ys);          {coordinates of neutral point}
  FindZg(ipSet, {jn} xs,ys, pImped);
  if (pImped <> nil) then begin    {impedance found}
    pImped^.GetPar(gGrImped_R,Rg); {grounding resistance}
    Rg := Rg/ngp;
    pImped^.GetPar(gGrImped_X,Xg); {grounding reactance}
    Xg := Xg/ngp;
    {save pointers}
    pComp^.PutipComp(longint(pImped));
    pImped^.PutipComp(longint(pComp));

    {find (if any) CT of grounding impedance (Ground current trafo)}
    pImped.GetNode(1,nneutr,ern);      {neutral node of gr.impedance}
    pCT := nil;
    FindGrCurrT(ipSet, nneutr, pCT);
    if (pCT <> nil) then begin
      {CT for gr.imped found}
      pCT^.PutipComp(longint(pImped));
      {no pointer to the opposite comp (not possible...)}
    end else begin                      {no gr.CT found = no connected comp}
      {...}
    end;

  end else begin
    Rg := BigRes;                  {must have some resistance}
    Xg := BigRes;
    pComp^.PutipComp(0);
  end;
  if (Rs < 0) then Rs := 0;        {reasonable resistance}
  if (Rg < 0) then Rg := 0;        {reasonable resistance}
  zn.x := Rg;                      {real part of impedance to ground}
  if (fmult <= 0) then begin
    zn.y := Xg;                    {imag. part of impedance to ground, can be < 0 !}
  end else begin                   {harmonic (or maybe ground freq.)}
    if (Xg < 0) then zn.y := Xg/fmult  {capacitive impedance}
    else             zn.y := Xg*fmult;
  end;
  {update matrix}
  if (jn > 0) and (jn <= nn) and (er3 = 0) then begin  {reasonable neutral node}
    {equation for neutral voltage}
    cpu.x := 1;
    cpu.y := 0;
    putCmat(paa,jn,jn,nn,nn,cpu);  {one to diagonal}
    if (jc > 0) and (jc <= nn) and (er2 = 0) then begin {reasonable current "node"}
      cpu := CRmult(3.0,zn);       {3 * grounding impedance}
      putCmat(paa,jn,jc,nn,nn,cpu);
    end;
    {equation at current node = eq. for voltage !}
    if (jc > 0) and (jc <= nn) and (er2 = 0) then begin
      cpu.x := Rs;                {zero sequence impedance}
      if (fmult <= 0) then begin
        cpu.y := X0;
      end else begin
        if (X0 < 0) then cpu.y := X0/fmult
        else             cpu.y := X0*fmult;
      end;
      {if IEC-calculation, multiply with the correction factor..
       but not when calculating sequence impedances}
      if ((Imagoo.IECBut.down) and not(pSet^.appl_op = 15)) or
         (pSet^.appl_op = 14) then
        cpu := Crmult(pComp^.var1_s,cpu);
      putCmat(paa,jc,jc,nn,nn,cpu); {voltage drop in stator, for zero seq.}
      if (jd > 0) and (jd <=nn) and (er1 = 0) then begin
        cpu.x := 1;
        cpu.y := 0;
        putCmat(paa,jc,jd,nn,nn,cpu); {one to diagonal}
        cpu.x := -1;
        cpu.y :=  0;
        putCmat(paa,jc,jn,nn,nn,cpu); {voltage relative to neutral}
      end;
    end;
  end;
end;

procedure Loadzero(ipSet: longint; pComp: TpComp; paa,pbb: pComplex;
                   nn: integer; par, fmult: single; short: integer);
{For a load, with ungrounded neutral,
 updates AN EXISTING, extended admittance matrix to the matrix
 of the zero sequence.
 pComp    pointer to the component (trafo)
 paa      pointer to the coefficient matrix
 pbb      pointer to the right hand side (not used ?)
 nn       dimension = number of nodes (excluding earth)
 par      a parameter (usually frequency, not used ?)
 fmult    frequency multiplier (harmonic)
 short    flag for a short circuit (not used ?)}
var
  cpu     : complex;   {temporary}
  ju      : integer;   {voltage (upstream) node}
  jn      : integer;   {neutral node}
  er1,er2 : integer;   {error flag}
begin
  {get nodes}
  pComp^.GetNode(1,ju,er1);        {get voltage node}
  pComp^.GetNode(3,jn,er2);        {get neutral node}
  {because not grounded, neutral voltage = upstream voltage}
  if (jn > 0) and (jn <= nn) and (er2 = 0) then begin  {reasonable neutral node}
    cpu.x := 1;
    cpu.y := 0;
    putCmat(paa,jn,jn,nn,nn,cpu);  {one to diagonal}
    if (ju > 0) and (ju <= nn) and (er1 = 0) then begin {reasonable voltage node}
      cpu.x := -1;
      cpu.y :=  0;
      putCmat(paa,jn,ju,nn,nn,cpu);
    end;
  end;
end;

procedure Smotzero(ipSet: longint; pComp: TpComp; paa,pbb: pComplex;
                   nn: integer; par, fmult: single; short: integer);
{For a synchronous motor, with ungrounded neutral,
 updates AN EXISTING, extended admittance matrix to the matrix
 of the zero sequence.
 pComp    pointer to the component (trafo)
 paa      pointer to the coefficient matrix
 pbb      pointer to the right hand side (not used ?)
 nn       dimension = number of nodes (excluding earth)
 par      a parameter (usually frequency, not used ?)
 fmult    frequency multiplier (harmonic)
 short    flag for a short circuit (not used ?)}
var
  cpu     : complex;   {temporary}
  ju      : integer;   {voltage (upstream) node}
  jn      : integer;   {neutral node}
  er1,er2 : integer;   {error flag}
begin
  {get nodes}
  pComp^.GetNode(1,ju,er1);        {get voltage node}
  pComp^.GetNode(3,jn,er2);        {get neutral node}
  {because not grounded, neutral (0-seq) voltage = upstream voltage}
  if (jn > 0) and (jn <= nn) and (er2 = 0) then begin  {reasonable neutral node}
    cpu.x := 1;
    cpu.y := 0;
    putCmat(paa,jn,jn,nn,nn,cpu);  {one to diagonal}
    if (ju > 0) and (ju <= nn) and (er1 = 0) then begin {reasonable voltage node}
      cpu.x := -1;
      cpu.y :=  0;
      putCmat(paa,jn,ju,nn,nn,cpu);
    end;
  end;
end;

procedure ASmotzero(ipSet: longint; pComp: TpComp; paa,pbb: pComplex;
                    nn: integer; par, fmult: single; short: integer);
{For an asynchronous motor,
 updates AN EXISTING, extended admittance matrix to the matrix
 of the zero sequence.
 pComp    pointer to the component (trafo)
 paa      pointer to the coefficient matrix
 pbb      pointer to the right hand side (not used ?)
 nn       dimension = number of nodes (excluding earth)
 par      a parameter (usually frequency, not used ?)
 fmult    frequency multiplier (harmonic)
 short    flag for a short circuit (not used ?)}
var
  cpu     : complex;   {temporary}
  jc      : integer;   {current "node"}
  ju      : integer;   {voltage (upstream) node}
  jn      : integer;   {neutral node}
  er1,er2 : integer;   {error flag}
begin
  {get nodes}
  pComp^.GetNode(1,ju,er1);        {get voltage node}
  pComp^.GetNode(2,jc,er1);        {get current node}
  pComp^.GetNode(3,jn,er2);        {get neutral node}
  {because not grounded, neutral (0-seq) voltage = upstream voltage}
  (*
  if (jn > 0) and (jn <= nn) and (er2 = 0) then begin  {reasonable neutral node}
    cpu.x := 1;
    cpu.y := 0;
    putCmat(paa,jn,jn,nn,nn,cpu);  {one to diagonal}
    if (ju > 0) and (ju <= nn) and (er1 = 0) then begin {reasonable voltage node}
      cpu.x := -1;
      cpu.y :=  0;
      putCmat(paa,jn,ju,nn,nn,cpu);
    end;
  end;
  *)
  if (jc > 0) and (jc <= nn) and (jn > 0) and (jn <= nn) and (ju > 0) and
     (ju <= nn) then begin
    cpu := cplx(1,0);
    putCmat(paa,jn,jn,nn,nn,cpu);
    cpu := cplx(0,0);
    putCmat(paa,jn,jc,nn,nn,cpu);
    cpu := cplx(-1,0);
    putCmat(paa,jn,ju,nn,nn,cpu);
  end;
end;

procedure Starzero(ipSet: longint; pComp: TpComp; paa,pbb: pComplex;
                    nn: integer; par, fmult: single; short: integer);
{For a star termination (phases connected to a wye),
 updates AN EXISTING, extended admittance matrix to the matrix
 of the zero sequence.
 pComp    pointer to the component (trafo)
 paa      pointer to the coefficient matrix
 pbb      pointer to the right hand side (not used ?)
 nn       dimension = number of nodes (excluding earth)
 par      a parameter (usually frequency, not used ?)
 fmult    frequency multiplier (harmonic)
 short    flag for a short circuit (not used ?)}
var
  cpu     : complex;
  jc      : integer;   {"node" for current}
  ju      : integer;   {voltage ("downstream") node}
  jn      : integer;   {neutral node}
  er1,er2 : integer;   {error flag}
  er3,ern : integer;   {error flag}
  nneutr  : integer;   {neutral node of gr.impedance}
  pCT     : TpComp;    {pointer to grounding imped.CT}
  pImped  : TpComp;    {impedance from neutral to ground}
  Rg,Xg   : single;    {earthing impedance}
  xs,ys   : integer;   {coordinates of the neutral point}
  zn      : complex;   {earthing impedance}
begin
  {get nodes}
  pComp^.GetNode(1,ju,er1);        {get voltage node}
  pComp^.GetNode(2,jc,er2);        {get "node" for current}
  pComp^.GetNode(3,jn,er3);        {get neutral node}
  {find the impedance from neutral (star) to ground, if any}
  pComp^.getNxy(3,xs,ys);          {coordinates of neutral point}
  FindZg(ipSet, {jn}xs,ys, pImped);
  {update matrix, depends on the earthing impedance}
  if (pImped <> nil) then begin        {impedance found}
    pImped^.GetPar(gGrImped_R,Rg);     {grounding resistance}
    pImped^.GetPar(gGrImped_X,Xg);     {grounding reactance}
    if (Rg > 0) or (Xg > 0) then begin {not solidly grounded}
      zn := cplx(3*Rg,3*Xg);           {3*, because in zero sequence}
      cpu := Crmult(-1,zn);
      putCmat(paa,jn,jc,nn,nn,cpu);
    end else begin                     {solidly grounded}
      {can use same matrix as for pos. and neg.seq ! (I think)}
    end;
    {save pointers}
    pComp^.PutipComp(longint(pImped));
    pImped^.PutipComp(longint(pComp));
    {find (if any) CT of grounding impedance (Ground current trafo)}
    pImped.GetNode(1,nneutr,ern);      {neutral node of gr.impedance}
    pCT := nil;
    FindGrCurrT(ipSet, nneutr, pCT);
    if (pCT <> nil) then begin
      {CT for gr.imped found}
      pCT^.PutipComp(longint(pImped));
      {no pointer to the opposite comp (not possible...)}
    end else begin                      {no gr.CT found = no connected comp}
      {...}
    end;
  end else begin                       {no impedance to earth}
    {not connected to ground, current is zero}
    cpu := cplx(0,0);
    putCmat(paa,jn,jn,nn,nn,cpu);      {reset the "voltage = zero"}
    cpu := cplx(1,0);
    putCmat(paa,jn,jc,nn,nn,cpu);      {current = zero}
  end;
end;


procedure LineZeroImped(pComp : TpComp; len : single; var Z0 : complex);
{reads and checks the zero sequence impedance of a transmission line
 pComp   pointer to the line as a component
 len     length of the line
 Z0      the zero seq. impedance}
var
  apu,apv : single; {temporary}
  par     : single; {number of parallel lines}
  R0,X0   : single; {zero seq. resistance, reactance / km }
begin
  pComp^.GetPar(gTrliS_R0,R0);    {zero seq. of resistor / km}
  pComp^.GetPar(gTrliS_X0,X0);    {zero seq. of reactance / km}
  pComp^.GetPar(gTrliS_paral,par);{number of parallel lines}
  if (par > 0) then begin
    R0 := R0/par;
    X0 := X0/par;
  end;
  if (R0  < 0.0) then R0  := 0;   {check values}
  if (X0  < 0.0) then X0  := 0;
  {check impedance}
  apu := R0*len;                  {resistance of line}
  apv := X0*len;                  {reactance of line}
  CheckImped(apu, apv, Z0);       {check that impedance not too small, in Elplex}
end;

procedure Trlinzero(ipSet: longint; pComp: TpComp; paa,pbb: pComplex;
                    nn: integer; par, fmult: single; short: integer);
{For a transmission line (with capacitance = susceptance)
 updates AN EXISTING, extended admittance matrix to the matrix
 of the zero sequence.
 pComp    pointer to the component (trafo)
 paa      pointer to the coefficient matrix
 pbb      pointer to the right hand side (not used ?)
 nn       dimension = number of nodes (excluding earth)
 par      a parameter (usually frequency, not used ?)
 fmult    frequency multiplier (harmonic)
 short    flag for a short circuit (not used ?)}
const
  czero : complex = (x : 0.0 ; y : 0.0);       {complex zero}
var
  cc       : complex;  {admittance of capacitors}
  cpu,cpv  : complex;  {temporary}
  cRL      : complex;  {admittance of the line itseld 1(R + jwL)}
  er1,er2  : integer;  {error flags}
  er3      : integer;  {error flags}
  jd,jm,ju : integer;  {downstream, umiddle,pstream nodes}
  len      : single;   {length of the line}
  nnod     : integer;  {number of nodes}
  ss       : single;   {relative length of the first section}
  Z0       : complex;  {checked zero seq. impedance}
  Y0       : complex;  {zero seq. admittance of the line}
  Y1       : complex;  {pos/neg seq. admittance of the line}
begin
  pComp^.GetPar(gTrliS_len, len); {length of the line (km)}
  if (len < 0)   then len := 0;
  {old, pos/neg seq. impedance}
  AdmTrl(pComp,1.0,len,cRL,cc);   {admittances, omega = 1 !}
  Y1 := cRL;
  LineZeroImped(pComp, len, Z0);  {get zero seq. impedance}
  Y0 := Cinv(Z0);                 {zero seq. admittance}
  pComp^.GetNnod(nnod);
  {must replace the pos/neg sequence impedance with the zero seq. impedance}
  if (nnod = 2) then begin        {no additional nodes}
    cpu := Csub(Y0,Y1);           {change in impedance}
    cpv := cplx(-cc.x,-cc.y);
    {update = replace old admittance with new}
    UpdateTwonode(pComp, paa, nn, cpu, czero);
  end else begin                  {additional node = component connected in the middle}
    pComp^.GetNode(1,ju,er1);     {get upstream node}
    pComp^.GetNode(2,jd,er2);     {get downstream node}
    pComp^.GetNode(3,jm,er3);     {the middle node}
    pComp^.GetPar(gTrliS_s1,ss);  {relative length of the first section}
    if (ss < gssmin) then ss := gssmin       {defined in elplex.pas}
    else if (ss > gssmax) then ss := gssmax;
    cpv := Csub(Y0,Y1);
    cpu := Crmult(1/ss,cpv);
    Twonode(pComp, paa, nn, ju, jm, cpu,czero);
    cpu := Crmult(1/(1-ss),cpv);
    Twonode(pComp, paa, nn, jm, jd, cpu,czero);
  end;
end;

procedure IdealYDzero(ipSet: longint; pComp: TpComp; paa,pbb: pComplex;
                    nn: integer; par, fmult: single; short: integer);
{For an ideal 1:1 Y-D transformer,
 updates AN EXISTING, extended admittance matrix to the matrix
 of the zero sequence.
 pComp    pointer to the component (trafo)
 paa      pointer to the coefficient matrix
 pbb      pointer to the right hand side (not used ?)
 nn       dimension = number of nodes (excluding earth)
 par      a parameter (usually frequency)
 fmult    frequency multiplier (harmonic)
 short    flag for a short circuit (not used ?)}
var
  er1,er2 : integer;   {error flag}
  er3,er4 : integer;   {error flag}
  er5,er6 : integer;   {error flag}
  grnd    : single;    {grounded/not}
  jcc     : integer;   {"node" for sec. circulating current}
  jcp,jcs : integer;   {"nodes" for prim, sec. current}
  jnp     : integer;   {prim neutral node}
  jp,js   : integer;   {prim, sec. secondary voltage node}
begin
  {get nodes}
  pComp^.GetNode(1,jp ,er1);       {node for prim.voltage}
  pComp^.GetNode(2,js ,er2);       {node for sec. voltage}
  pComp^.GetNode(3,jcp,er3);       {get "node" for primary current}
  pComp^.GetNode(4,jcs,er4);       {get "node" for sec. current}
  pComp^.GetNode(5,jnp,er5);       {prim. neutral node}
  pComp^.GetNode(6,jcc,er6);       {get "node" for sec. circulating current}
  {for an ideal ungrounded transformer, zero seq. current = 0}
  pComp^.GetPar(4,grnd);           {grounded, if not zero}
  if (grnd = 0) then begin
    {not grounded, current = 0}
    if (er3 = 0) and (er5 = 0) and
       (jnp > 0) and (jnp <= nn) and (jcp > 0) and (jcp <= nn) then begin
      putCmat(paa,jnp,jcp,nn,nn,cplx(1,0));         {I = 0}
      putCmat(paa,jnp,jnp,nn,nn,cplx(0,0));
    end;
  end;
  {secondary current is zero (I think...}
  if (er4 = 0) and (er6 = 0) then begin
    putCmat(paa,jcs,jcc,nn,nn,cplx(0,0));
  end;
  {primary voltage is equal to neutral voltage (I think, or is it? and why?}
  if (er3 = 0) and (er1 = 0) and (er2 = 0) and (er5 = 0) and
     (jcp > 0) and (jp > 0 ) and (js  > 0) and (jnp > 0) and
     (jcp<= nn)and (jp <= nn)and (js<= nn) and (jnp <=nn) then begin
    putCmat(paa,jcp,js,nn,nn,cplx(0,0));
    putCmat(paa,jcp,jp,nn,nn,cplx(1,0));
    putCmat(paa,jcp,jnp,nn,nn,cplx(-1,0));
  end;
end;


procedure TrfYDzero(ipSet: longint; pComp: TpComp; paa,pbb: pComplex;
                    nn: integer; par, fmult: single; short: integer);
{For a Y-D transformator,
 updates AN EXISTING, extended admittance matrix to the matrix
 of the zero sequence.
 pComp    pointer to the component (trafo)
 paa      pointer to the coefficient matrix
 pbb      pointer to the right hand side (not used ?)
 nn       dimension = number of nodes (excluding earth)
 par      a parameter (usually frequency)
 fmult    frequency multiplier (harmonic)
 short    flag for a short circuit (not used ?)}
var
  cpu     : complex;   {temporary}
  er1,er2 : integer;   {error flag}
  er3,er4 : integer;   {error flag}
  er5,er6 : integer;   {error flag}
  jcc     : integer;   {"node" for sec. circulating current}
  jcp,jcs : integer;   {"nodes" for prim, sec. current}
  jnp     : integer;   {prim neutral node}
  jp,js   : integer;   {prim, sec. secondary voltage node}
  nprl    : single;    {number of parallel trafos}
  r01,x01 : single;    {zero seq. imped / pos.seq.imped}
  R0,R1   : single;    {zero, pos.seq. resistance}
  R1g     : single;    {grounding resistances}
  X1g     : single;    {grounding reactances}
  X0,X1   : single;    {zero, pos.seq. reactance}
  zp      : complex;   {prim, sec. grounding impedance}
begin
  {get grounding impedance = read more parameters}
  pComp^.GetPar(gYDTrf_R1g,R1g);    {prim. resistance to ground}
  pComp^.GetPar(gYDTrf_X1g,X1g);    {prim. reactance to ground}
  {parallel trafos ?}
  pComp^.GetPar(gYD_parall,nprl);
  if (nprl > 0) then begin
    R1g := R1g/nprl;
    X1g := X1g/nprl;
  end;
  if (R1g > 0) then zp.x := R1g     {real part of impedance to ground}
  else              zp.x := 0;
  {for reactance, must check frequency}
  if (fmult <= 0) then  begin
    zp.y := X1g;                    {imag. part of impedance to ground, can be < 0 !}
  end else begin
    if (X1g < 0) then zp.y := X1g/fmult
    else              zp.y := X1g*fmult;
  end;
  {get nodes}
  pComp^.GetNode(1,jp ,er1);       {node for prim.voltage}
  pComp^.GetNode(2,js ,er2);       {node for sec. voltage}
  pComp^.GetNode(3,jcp,er3);       {get "node" for primary current}
  pComp^.GetNode(4,jcs,er4);       {get "node" for sec. current}
  pComp^.GetNode(5,jnp,er5);       {prim. neutral node}
  pComp^.GetNode(6,jcc,er6);       {get "node" for sec. circulating current}
  {for an ideal transformer, zero seq. impedance = 0, only earthing impedance included}
  if (imagoo.IdealTrBut.down) then begin                 {ideal trafo}
    if (er3 = 0) and (er5 = 0) and
       (jnp > 0) and (jnp <= nn) and (jcp > 0) and (jcp <= nn) then begin
      cpu := Crmult(-3.,zp);                             {for prim. neutral point}
      putCmat(paa,jnp,jcp,nn,nn,cpu);                    {U = I*3Z}
    end;
    {secondary current is zero (I think...}
    if (er4 = 0) and (er6 = 0) then begin
      putCmat(paa,jcs,jcc,nn,nn,cplx(0,0));
    end;
    {primary voltage is equal to neutral voltage (I think, or is it? and why?}
    if (er3 = 0) and (er1 = 0) and (er2 = 0) and (er5 = 0) and
       (jcp > 0) and (jp > 0 ) and (js  > 0) and (jnp > 0) and
       (jcp<= nn)and (jp <= nn)and (js<= nn) and (jnp <=nn) then begin
      putCmat(paa,jcp,js,nn,nn,cplx(0,0{1,0}));
      putCmat(paa,jcp,jp,nn,nn,cplx(1,0{0,0}));
      putCmat(paa,jcp,jnp,nn,nn,cplx(-1,0{0,0}));
    end;
  end else begin                              {normal, nonideal transformer}
    {update matrix}
    if (jcc > 0) and (jcc <= nn) and (js > 0) and (js <= nn) then begin
      cpu.x := 0; cpu.y := 0;
      putCmat(paa,jcc,js,nn,nn,cpu);  {voltage over D-branch is zero}
    end;
    {equation for neutral node}
    if (jnp > 0) and (jnp <= nn) and (er5 = 0) then begin  {reasonable neutral node}
      cpu.x := 1;
      cpu.y := 0;
      putCmat(paa,jnp,jnp,nn,nn,cpu); {one to diagonal}
      if (jcp > 0) and (jcp <= nn) and (er3 = 0) then begin {reasonable current "node"}
        cpu := CRmult(-3.0,zp);       {-3 * grounding impedance, pos current to trafo}
        putCmat(paa,jnp,jcp,nn,nn,cpu);
      end;
    end;
    {on secondary side, even a small current causes a large voltage}
    if (jcs > 0) and (jcs <= nn) and (er4 = 0) then begin  {reasonable sec. node}
      clrCrow(paa,jcs,nn);             {clear old equation}
      {add a large resistance to ground}
      cpu.x := -XLRes;
      cpu.y := 0;
      putCmat(paa,jcs,jcs,nn,nn,cpu);  {large resistance to diagonal}
      if (js > 0) and (js <= nn) and (er2 = 0) then begin
        cpu.x := 1;
        cpu.y := 0;
        putCmat(paa,jcs,js,nn,nn,cpu); {one to voltage term}
      end;
    end;
    {zero seq.impedance - - - - - - - - - -}
//  pComp^.GetPar(gTrafo_01,r01);    {zero seq. imped / pos.seq.imped}
//  if (r01 <= 0) then r01 := 1;
    pComp^.GetPar(gTrafo_R1,R1);
    pComp^.GetPar(gTrafo_R0,R0);
    pComp^.GetPar(gTrafo_X ,X1);
    pComp^.GetPar(gTrafo_X0,X0);
    {parallel trafos ?}
    if (nprl > 0) then begin
      R1 := R1/nprl;
      R0 := R0/nprl;
      X1 := X1/nprl;
      X0 := X0/nprl;
    end;
    if (R1 > 0) then r01 := R0/R1 else r01 := 1;
    if (X1 > 0) then x01 := X0/X1 else x01 := 1;
    {set warning, if not correct R0 or X0}
    R0X0Warning(pComp, R1,X1,R0,X0);
    {update matrix}
    getCmat(paa,jcc,jcp,nn,nn,cpu);
//  cpu := Crmult(r01,cpu);
    cpu.x := r01*cpu.x;
    cpu.y := x01*cpu.y;
    putCmat(paa,jcc,jcp,nn,nn,cpu);
//  getCmat(paa,jcc,js,nn,nn,cpu);  {this is not needed !? 28.5.2008}
//  cpu := Crmult(r01,cpu);
//  putCmat(paa,jcc,js,nn,nn,cpu);
  end;
end;

procedure TrfDYzero(ipSet: longint; pComp: TpComp; paa,pbb: pComplex;
                    nn: integer; par, fmult: single; short: integer);
{For a D-Y transformator,
 updates AN EXISTING, extended admittance matrix to the matrix
 of the zero sequence.
 pComp    pointer to the component (trafo)
 paa      pointer to the coefficient matrix
 pbb      pointer to the right hand side (not used ?)
 nn       dimension = number of nodes (excluding earth)
 par      a parameter (usually frequency)
 fmult    frequency multiplier (harmonic)
 short    flag for a short circuit (not used ?)}
var
  cpu     : complex;   {temporary}
  er1,er2 : integer;   {error flag}
  er3,er4 : integer;   {error flag}
  er5,er6 : integer;   {error flag}
  jcc     : integer;   {"node" for sec. circulating current}
  jcp,jcs : integer;   {"nodes" for prim, sec. current}
  jns     : integer;   {sec. neutral node}
  jp,js   : integer;   {prim, sec. secondary voltage node}
  nprl    : single;    {number of parallel trafos}
  R0,R1   : single;    {zero, pos.seq. resistance}
  r01,x01 : single;    {zero seq.imped/pos.seq.imped}
  R2g     : single;    {grounding resistance from sec.neutral}
  X2g     : single;    {grounding reactance}
  X0,X1   : single;    {zero, pos.seq. reactance}
  zp      : complex;   {prim, sec. grounding impedance}
begin
  {get grounding impedance = read more parameters}
  pComp^.GetPar(gDYTrf_R2g,R2g);    {sec. resistance to ground}
  pComp^.GetPar(gDYTrf_X2g,X2g);    {sec. reactance to ground}
  {parallel trafos ?}
  pComp^.GetPar(gDY_parall,nprl);
  if (nprl > 0) then begin
    R2g := R2g/nprl;
    X2g := X2g/nprl;
  end;
  if (R2g > 0) then zp.x := R2g     {real part of impedance to ground}
  else              zp.x := 0;
  {for reactance, must check frequency}
  if (fmult <= 0) then  begin
    zp.y := X2g;                    {imag. part of impedance to ground, can be < 0 !}
  end else begin
    if (X2g < 0) then zp.y := X2g/fmult
    else              zp.y := X2g*fmult;
  end;
  {get nodes}
  pComp^.GetNode(1,jp ,er1);       {node for prim.voltage}
  pComp^.GetNode(2,js ,er2);       {node for sec. voltage}
  pComp^.GetNode(3,jcp,er3);       {get "node" for primary current}
  pComp^.GetNode(4,jcs,er4);       {get "node" for sec. current}
  pComp^.GetNode(5,jns,er5);       {prim. neutral node}
  pComp^.GetNode(6,jcc,er6);       {get "node" for prim. circulating current}
  {for an ideal transformer, zero seq. impedance = 0, only earthing impedance included}
  if (imagoo.IdealTrBut.down) then begin                 {ideal trafo}
    if (er4 = 0) and (er5 = 0) and
       (jns > 0) and (jns <= nn) and (jcs > 0) and (jcs <= nn) then begin
      cpu := Crmult(-3.,zp);                             {for prim. neutral point}
      putCmat(paa,jns,jcs,nn,nn,cpu);                    {U = I*3Z}
    end;
    {primary current is zero (I think...}
    if (er3 = 0) and (er6 = 0) then begin
      putCmat(paa,jcp,jcc,nn,nn,cplx(0,0));
    end;
    {secondary voltage is equal to neutral voltage (I think, or is it? and why?}
    if (er4 = 0) and (er2 = 0) and (er1 = 0) and (er5 = 0) and
       (jcs > 0) and (js > 0 ) and (jp  > 0) and (jns > 0) and
       (jcs<= nn)and (js <= nn)and (jp<= nn) and (jns <=nn) then begin
      putCmat(paa,jcs,jp,nn,nn,cplx(0,0{1,0}));
      putCmat(paa,jcs,js,nn,nn,cplx(1,0{0,0}));
      putCmat(paa,jcs,jns,nn,nn,cplx(-1,0{0,0}));
    end;
  end else begin                              {normal, nonideal transformer}
    {update matrix}
     if (jcc > 0) and (jcc <= nn) and (jp > 0) and (jp <= nn) then begin
       cpu.x := 0; cpu.y := 0;
       putCmat(paa,jcc,jp,nn,nn,cpu);  {voltage over D-branch is zero}
     end;
    {equation for neutral node}
    if (jns > 0) and (jns <= nn) and (er5 = 0) then begin  {reasonable neutral node}
      cpu.x := 1;
      cpu.y := 0;
      putCmat(paa,jns,jns,nn,nn,cpu); {one to diagonal}
      if (jcs > 0) and (jcs <= nn) and (er4 = 0) then begin {reasonable current "node"}
        cpu := CRmult(-3.0,zp);       {-3 * grounding impedance, pos current to trafo}
        putCmat(paa,jns,jcs,nn,nn,cpu);
      end;
    end;
    {on prim side, even a small current causes a large voltage}
    if (jcp > 0) and (jcp <= nn) and (er3 = 0) then begin  {reasonable sec. node}
      clrCrow(paa,jcp,nn);              {clear old equation}
      {add a large resistance to ground}
      cpu.x := -XLRes;
      cpu.y := 0;
      putCmat(paa,jcp,jcp,nn,nn,cpu);   {large resistance to diagonal}
      if (jp > 0) and (jp <= nn) and (er1 = 0) then begin
        cpu.x := 1;
        cpu.y := 0;
        putCmat(paa,jcp,jp,nn,nn,cpu);  {one to prim.voltage term}
      end;
    end;
   {zero seq.impedance - - - - - - - - - -}
//  pComp^.GetPar(gTrafo_01,r01);    {zero seq. imped / pos.seq.imped}
//  if (r01 <= 0) then r01 := 1;
    pComp^.GetPar(gTrafo_R1,R1);
    pComp^.GetPar(gTrafo_R0,R0);
    pComp^.GetPar(gTrafo_X ,X1);
    pComp^.GetPar(gTrafo_X0,X0);
    {parallel trafos ?}
    if (nprl > 0) then begin
      R1 := R1/nprl;
      R0 := R0/nprl;
      X1 := X1/nprl;
      X0 := X0/nprl;
    end;
    if (R1 > 0) then r01 := R0/R1 else r01 := 1;
    if (X1 > 0) then x01 := X0/X1 else x01 := 1;
    {set warning, if not correct R0 or X0}
    R0X0Warning(pComp, R1,X1,R0,X0);
    {update matrix}
    getCmat(paa,jcc,jcs,nn,nn,cpu);
    cpu.x := r01*cpu.x;
    cpu.y := x01*cpu.y;
//  cpu := Crmult(r01,cpu);
    putCmat(paa,jcc,jcs,nn,nn,cpu);
//  getCmat(paa,jcc,jp,nn,nn,cpu); {not needed? 28.5.2008}
//  cpu := Crmult(r01,cpu);
//  putCmat(paa,jcc,jp,nn,nn,cpu);
//  getCmat(paa,jcs,jcs,nn,nn,cpu);
//  cpu.x := r01*cpu.x;
//  putCmat(paa,jcs,jcs,nn,nn,cpu);
  end;
end;

procedure TrfDDzero(ipSet: longint; pComp: TpComp; paa,pbb: pComplex;
                    nn: integer; par, fmult: single; short: integer);
{For a D-D transformator,
 updates AN EXISTING, extended admittance matrix to the matrix
 of the zero sequence.
 pComp    pointer to the component (trafo)
 paa      pointer to the coefficient matrix
 pbb      pointer to the right hand side (not used ?)
 nn       dimension = number of nodes (excluding earth)
 par      a parameter (usually frequency)
 fmult    frequency multiplier (harmonic)
 short    flag for a short circuit (not used ?)}
var
  cpu     : complex;   {temporary}
  er1,er2 : integer;   {error flag}
  er3,er4 : integer;   {error flag}
  er5,er6 : integer;   {error flag}
  jcc,jss : integer;   {"node" for sec. circulating current}
  jcp,jcs : integer;   {"nodes" for prim, sec. current}
  jp,js   : integer;   {prim, sec. secondary voltage node}
begin
  {get nodes}
  pComp^.GetNode(1,jp ,er1);       {node for prim.voltage}
  pComp^.GetNode(2,js ,er2);       {node for sec. voltage}
  pComp^.GetNode(3,jcp,er3);       {get "node" for primary current}
  pComp^.GetNode(4,jcs,er4);       {get "node" for sec. current}
  pComp^.GetNode(5,jcc,er5);       {prim. winding current}
  pComp^.GetNode(6,jss,er6);       {get "node" for sec. circulating current}
  {for an ideal DD-transformer, all zero seq. currents are zero}
  if (imagoo.IdealTrBut.down) then begin                 {ideal trafo}
    putCmat(paa,jcc,jcp,nn,nn,cplx(0,0));
    putCmat(paa,jss,jcc,nn,nn,cplx(0,0));
    putCmat(paa,jcs,jss,nn,nn,cplx(0,0));
    putCmat(paa,jcp,jcp,nn,nn,cplx(1,0));
    putCmat(paa,jcp,jp,nn,nn,cplx(0,0));
    putCmat(paa,jcp,js,nn,nn,cplx(0,0));
  end else begin                                         {normal, nonideal trafo}
    {zero seq. current must be zero in the prim. and sec. coils}
    cpu.x := 1; cpu.y := 0;
    if (jcc > 0) and (jcc <= nn) then begin
      clrCrow(paa,jcc,nn);
      putCmat(paa,jcc,jcc,nn,nn,cpu);
    end;
    if (jss > 0) and (jss <= nn) then begin
      clrCrow(paa,jss,nn);
      putCmat(paa,jss,jss,nn,nn,cpu);
    end;
    {on prim side, even a small current causes a large voltage}
    if (jcp > 0) and (jcp <= nn) and (er3 = 0) then begin  {reasonable sec. node}
      clrCrow(paa,jcp,nn);              {clear old equation}
      {add a large resistance to ground}
      cpu.x := -XLRes;
      cpu.y := 0;
      putCmat(paa,jcp,jcp,nn,nn,cpu);   {large resistance to diagonal}
      if (jp > 0) and (jp <= nn) and (er1 = 0) then begin
        cpu.x := 1;
        cpu.y := 0;
        putCmat(paa,jcp,jp,nn,nn,cpu);  {one to prim.voltage term}
      end;
    end;
    {similarly, on sec side, even a small current causes a large voltage}
    if (jcs > 0) and (jcs <= nn) and (er4 = 0) then begin  {reasonable sec. node}
      clrCrow(paa,jcs,nn);              {clear old equation}
      {add a large resistance to ground}
      cpu.x := -XLRes;
      cpu.y := 0;
      putCmat(paa,jcs,jcs,nn,nn,cpu);   {large resistance to diagonal}
      if (js > 0) and (js <= nn) and (er2 = 0) then begin
        cpu.x := 1;
        cpu.y := 0;
        putCmat(paa,jcs,js,nn,nn,cpu);  {one to prim.voltage term}
      end;
    end;
  end;
end;

procedure Mutualzero(ipSet: longint; pComp: TpComp; paa,pbb: pComplex;
                    nn: integer; par, fmult: single; short: integer);
{For a mutual impedance component (used with transmission lines),
 updates AN EXISTING, extended admittance matrix to the matrix
 of the zero sequence.
 pComp    pointer to the component (trafo)
 paa      pointer to the coefficient matrix
 pbb      pointer to the right hand side (not used ?)
 nn       dimension = number of nodes (excluding earth)
 par      a parameter (usually frequency, not used ?)
 fmult    frequency multiplier (harmonic)
 short    flag for a short circuit (not used ?)}
var
  apu     : single;   {temporary}
  Bb      : single;   {susceptance of capacitors}
  cpu     : complex;  {temporary}
  e1,e2   : integer;  {error flag}
  ii,jj   : integer;  {indices}
  j1,j2   : integer;  {current node}
  ini,inj : integer;  {index of current node}
  ip      : integer;  {index of parameter}
  j1d,j2d : integer;  {downstream "nodes" for current}
  j1u,j2u : integer;  {upstream "nodes" for current}
  kk      : integer;  {index}
  pos     : single;
  Rm0     : single;   {mutual resistance/length}
  Rr,Xx   : single;   {pos.seq. resistance, reactance}
  R0,X0   : single;   {zero seq. resistance, reactance}
  Len     : single;   {length of mutually connected part of line}
  lent    : single;   {total length of line}
  nline   : integer;  {number of lines}
  ss      : single;   {relative position of middle node}
  Xm0     : single;   {mutual reactance/length}
  Zmc     : complex;  {mutual impedance}
begin
  pComp^.GetPar(1,apu);              {number of lines}
  nline := round(apu);
  if (nline >= 2) and (nline <= gMutualMax) then begin {reasonable number of lines}
    pComp^.GetPar(gMutuStrt-1,ss);   {relative position of middle node}
    {first, replace pos.seq. impedances with zero seq. impedances}
    ip := gMutuStrt;
    for ii := 1 to nline do begin
      pComp^.GetNode((ii-1)*5+4,j1,e1);       {get first current node of line ii}
      pComp^.GetNode((ii-1)*5+5,j2,e2);       {get second current node of line ii}
      {get parameters, only Len, R0, X0 needed}
      GetMutualLinePar(pComp, ip, Len,Rr,Xx,R0,X0,Bb,Pos);
      {change to zero seq. impedances in eq. for voltage drop}
      {voltage drop in first section}
      if (e1 = 0) then begin
        cpu := cplx(-Ss*R0*Len,-Ss*X0*Len);       {s*Z*I1-term}
        putCmat(paa,j1,j1,nn,nn,cpu);
      end;
      {voltage drop in second section}
      if (e2 = 0) then begin
        cpu := cplx(-(1-Ss)*R0*Len,-(1-Ss)*X0*Len);  {(1-s)*Z*I2-term}
        putCmat(paa,j2,j2,nn,nn,cpu);
      end;
    end;
    {next, the mutual impedances between the lines}
    kk := 0;                                {index of mutual imped.parameter "group"}
    for ii := 2 to nline do begin           {all mutual impedances}
      pComp^.GetNode((ii-1)*5+4,j1u,e1);    {get first current node of line ii}
      pComp^.GetNode((ii-1)*5+5,j1d,e2);    {get second current node of line ii}
      {scan the other lines}
      for jj := 1 to ii-1 do begin
        inc(kk);
        pComp^.GetNode((jj-1)*5+4,j2u,e1);  {get first current node of line jj}
        pComp^.GetNode((jj-1)*5+5,j2d,e2);  {get second current node of line jj}
        if (e1 = 0) and (e2 = 0) then begin
          ip := (kk-1)*3+2;                 {index of length-param. (first param = no of lines)}
          pComp^.getPar(ip,Len);            {length}
          pComp^.GetPar(ip+1,Rm0);          {resistance/length}
          pComp^.getPar(ip+2,Xm0);          {reactance/length}
          Zmc := Cplx(-Rm0*len*ss,-Xm0*len*ss);           {mutual impedance, upstream sections}
          putCmat(paa,j1u,j2u,nn,nn,Zmc);   {V1u-V1d = Z*I2}
          putCmat(paa,j2u,j1u,nn,nn,Zmc);   {V2u-V2d = Z*I1}
          Zmc := Cplx(-Rm0*len*(1-ss),-Xm0*len*(1-ss));   {mutual impedance, downstream sections}
          putCmat(paa,j1d,j2d,nn,nn,Zmc);   {V1u-V1d = Z*I2}
          putCmat(paa,j2d,j1d,nn,nn,Zmc);   {V2u-V2d = Z*I1}
        end;
      end;
    end;
  end;
(*
  pComp^.GetPar(1,apu);           {number of lines}
  nline := round(apu);
  if (nline >= 2) and (nline <= gMutualMax) then begin {reasonable number of lines}
    kk := 0;                                           {index of mutual imped.parameter "group"}
    for ii := 2 to nline do begin                      {all mutual impedances}
      ini := ii*3;
      pComp^.GetNode(ini,j2c{j1c},e1);                      {current node}
      for jj := 1 to ii-1 do begin
        inc(kk);
        inj := jj*3;
        pComp^.GetNode(inj,j1c{j2c},e2);   {current node}
        if (e1 = 0) and (e2 = 0) then begin
          ip := (kk-1)*3+2;                 {index of length-param. (first param = no of lines)}
          pComp^.getPar(ip,Len);            {length}
//showmessage(inttostr(ii)+'  '+inttostr(jj)+'  '+floattostr(len));
          pComp^.GetPar(ip+1,Rm0);          {resistance/length}
          pComp^.getPar(ip+2,Xm0);          {reactance/length}
          Zmc := Cplx(-Rm0*len,-Xm0*len);   {mutual impedance}
          putCmat(paa,j1c,j2c,nn,nn,Zmc);   {V1u-V1d = Z*I2}
          putCmat(paa,j2c,j1c,nn,nn,Zmc);   {V2u-V2d = Z*I1}
        end;
      end;
    end;
  end;
*)
end;

(*
procedure Mutualzero(ipSet: longint; pComp: TpComp; paa,pbb: pComplex;
                    nn: integer; par, fmult: single; short: integer);
{For a mutual impedance component (used with transmission lines),
 updates AN EXISTING, extended admittance matrix to the matrix
 of the zero sequence.
 pComp    pointer to the component (trafo)
 paa      pointer to the coefficient matrix
 pbb      pointer to the right hand side (not used ?)
 nn       dimension = number of nodes (excluding earth)
 par      a parameter (usually frequency, not used ?)
 fmult    frequency multiplier (harmonic)
 short    flag for a short circuit (not used ?)}
var
  apu     : single;   {temporary}
  e1,e2   : integer;  {error flag}
  ii,jj   : integer;  {indices}
  ini,inj : integer;  {index of current node}
  ip      : integer;  {index of parameter}
  j1c,j2c : integer;  {"node" for current}
  kk      : integer;  {index}
  Rm0     : single;   {mutual resistance/length}
  Len     : single;   {length of line}
  nline   : integer;  {number of lines}
  Xm0     : single;   {mutual reactance/length}
  Zmc     : complex;  {mutual impedance}
begin
  pComp^.GetPar(1,apu);           {number of lines}
  nline := round(apu);
  if (nline >= 2) and (nline <= gMutualMax) then begin {reasonable number of lines}
    kk := 0;                                           {index of mutual imped.parameter "group"}
    for ii := 2 to nline do begin                      {all mutual impedances}
      ini := ii*3;
      pComp^.GetNode(ini,j2c{j1c},e1);                      {current node}
      for jj := 1 to ii-1 do begin
        inc(kk);
        inj := jj*3;
        pComp^.GetNode(inj,j1c{j2c},e2);   {current node}
        if (e1 = 0) and (e2 = 0) then begin
          ip := (kk-1)*3+2;                 {index of length-param. (first param = no of lines)}
          pComp^.getPar(ip,Len);            {length}
//showmessage(inttostr(ii)+'  '+inttostr(jj)+'  '+floattostr(len));
          pComp^.GetPar(ip+1,Rm0);          {resistance/length}
          pComp^.getPar(ip+2,Xm0);          {reactance/length}
          Zmc := Cplx(-Rm0*len,-Xm0*len);   {mutual impedance}
          putCmat(paa,j1c,j2c,nn,nn,Zmc);   {V1u-V1d = Z*I2}
          putCmat(paa,j2c,j1c,nn,nn,Zmc);   {V2u-V2d = Z*I1}
        end;
      end;
    end;
  end;
end;
*)
(*
procedure Mutualzero(ipSet: longint; pComp: TpComp; paa,pbb: pComplex;
                    nn: integer; par, fmult: single; short: integer);
{For a mutual impedance component (used with transmission lines),
 updates AN EXISTING, extended admittance matrix to the matrix
 of the zero sequence.
 pComp    pointer to the component (trafo)
 paa      pointer to the coefficient matrix
 pbb      pointer to the right hand side (not used ?)
 nn       dimension = number of nodes (excluding earth)
 par      a parameter (usually frequency, not used ?)
 fmult    frequency multiplier (harmonic)
 short    flag for a short circuit (not used ?)}
var
  e1,e2   : integer;  {error flag}
  j1c,j2c : integer;  {"node" for current}
  Rm0     : single;   {mutual resistance/length}
  Len     : single;   {length of line}
  Xm0     : single;   {mutual reactance/length}
  Zmc     : complex;  {mutual impedance}
begin
  pComp^.GetNode(5,j1c,e1);       {get current node of line 1}
  pComp^.GetNode(6,j2c,e2);       {get curent node of line 2}
  pComp^.GetPar(gMutu_Rm0,Rm0);   {mutual resistance}
  pComp^.GetPar(gMutu_Xm0,Xm0);   {mutual reactance}
  pComp^.GetPar(gMutu_L, Len);    {length of line}
  Zmc := Cplx(-Rm0*len,-Xm0*len);   {mutual impedance}
  if (e1 = 0) and (e2 = 0) then begin
    putCmat(paa,j1c,j2c,nn,nn,Zmc);  {V1u-V1d = Z*I2}
    putCmat(paa,j2c,j1c,nn,nn,Zmc);  {V2u-V2d = Z*I1}
  end;
end;
*)
procedure Z012Zero(ipSet: longint; pComp: TpComp; paa,pbb: pComplex;
                    nn: integer; par, fmult: single; short: integer);
{ For a sequence impedance (with different values in different seq.nets),
 updates AN EXISTING, extended admittance matrix to the matrix
 of the zero sequence.
 pComp    pointer to the component
 paa      pointer to the coefficient matrix
 pbb      pointer to the right hand side (not used ?)
 nn       dimension = number of nodes (excluding earth)
 par      a parameter (frequency)
 short    flag for a short circuit (not used ?)
 fmult    frequency muliplier }
var
  e3       : integer;   {error flag}
  jc       : integer;   {"node" for current}
  R0       : single;    {zero.seq. resistance}
  X0       : single;    {zero.seq. reactance}
  zc       : complex;   {-zero.seq. impedance}
begin
  pComp^.getNode(3,jc,e3);                  {get "node" for current}
  pComp^.getPar(5,R0);
  pComp^.getPar(6,X0);
  zc := cplx(-R0,-X0);
  if (e3 = 0) then
    PutCmat(paa,jc,jc,nn,nn,zc);            {replace pos.seq. impedance}
end;

procedure PosToZeroMat(ipSet : longint; paa,pzz : pComplex;
                       freq,fmult: single; nn : integer);
{copies and converts the extended matrix for pos. seq. to matrix for zero seq.
 ipSet   pointer to the set of components etc as integer
 paa     pointer to the matrix for pos.seq.
 pzz     pointer to the matrix
 freq    fundamental frequency
 fmult   frequency multiplier (for third harmonic)
 nn      dimension = number of nodes
}
var
  errc   : integer;     {error flag}
  jcomp  : integer;     {counts components}
  ModNam : string;      {component name}
  pComp  : TpComp;      {pointer to a component}
  prh    : pComplex;    {pointer to the right hand side, not used}
  pSet   : TpCompSet;   {pointer to the set of components etc}
  par    : single;      {parameter = frequency}
  short  : integer;     {flag for short circuit (not used ?)}
begin
  if (ipSet <> 0) and (nn > 0) then begin  {network defined ?}
    pSet := TpCompSet(ipSet);
    {start with copying the pos.seq.matrix to zero seq. matrix}
    copyCmat(paa,pzz,nn);         {copy aa to zz}
    prh := nil;                   {right hand side not in use}
    par := freq;                  {initialize frequency}
    short := 0;                   {initialize short circuit flag, not used ?}
    pComp := nil;                 {initialize pointer to component}
    errc := 0;                    {initialize error flag}
    jcomp := 0;
    while(errc = 0) do begin                    {scan all components}
      pSet^.NextComp(pComp,errc,jcomp,true);    {get pointer to next component}
      if (errc = 0) then begin
        pComp^.GetModName(ModNam);              {name of the component}
        {check those components that can have zero sequence components}
        if      (ModNam = gTrafoYY) then        {Y-Y transformer ?}
          Trafozero(ipSet,pComp, pzz,prh,nn,par,fmult,short)
        else if (ModNam = gTrafoYD) then        {Y-D transformer ?}
          TrfYDzero(ipSet,pComp, pzz,prh,nn,par,fmult,short)
        else if (ModNam = gTrafoDY) then        {D-Y transformer ?}
          TrfDYzero(ipSet,pComp, pzz,prh,nn,par,fmult,short)
        else if (ModNam = gTrafoDD) then        {D-D transformer ?}
          TrfDDzero(ipSet,pComp, pzz,prh,nn,par,fmult,short)
        else if (ModNam = gTrafo3W) then        {3-winding transformer ?}
          Trf3Wzero(ipSet,pComp, pzz,prh,nn,par,fmult,short)
        else if (ModNam = gIdealYD) then        {ideal 1:1 Y-D transformer ?}
          IdealYDzero(ipSet,pComp, pzz,prh,nn,par,fmult,short)
        else if (ModNam = gFeed) then           {feeder ?}
          Feedzero (ipSet,pComp, pzz,prh,nn,par,fmult,short)
        else if (ModNam = gGen ) then           {generator ?}
          Generzero(ipSet,pComp, pzz,prh,nn,par,fmult,short)
        else if (ModNam = gLoad) then           {load ?}
          Loadzero (ipSet,pComp, pzz,prh,nn,par,fmult,short)
        else if (ModNam = gSmot) then           {synchronous motor ?}
          Smotzero (ipSet,pComp, pzz,prh,nn,par,fmult,short)
        else if (ModNam = gTrliS) then          {transmission line ?}
          Trlinzero(ipSet,pComp, pzz,prh,nn,par,fmult,short)
        else if (ModNam = gASmot) then          {asynchronous motor ?}
          ASmotzero (ipSet,pComp, pzz,prh,nn,par,fmult,short)
        else if (ModNam = gStar)  then          {termination }
          Starzero (ipSet,pComp, pzz,prh,nn,par,fmult,short)
        else if (ModNam = gMutual)then          {mutual impedance }
          Mutualzero (ipSet,pComp, pzz,prh,nn,par,fmult,short)
        else if (ModNam = gZ012)  then          {sequence impedance }
          Z012zero   (ipSet,pComp, pzz,prh,nn,par,fmult,short)
        else if (ModNam = gAtrafo) then         {autotransformer}
          AutoTrafoZero(ipSet,pComp, pzz,prh,nn,par,fmult,short);
        {others do not (yet?) have zero seq. component}
      end;
    end;
  end;
//showcmat1(pzz,nn,nn);
end;

procedure NegSeqNet2(pFault : TpComp; nnod : integer; Jn : complex;
                    pWrk : pComplex);
{inject a current to the location of the fault, and solve the
 negative seq. net
 pFault   pointer to the short, as a component
 nnod     number of nodes = dimension
 Jn       the neg. seq. injected short circuit current
 pWrk     pointer to a working space, result is written here
 The solution is written to the array that pWrk is pointing to
 }
begin
  {for neg.seq. must clear rhs = no sources, other than the injected current}
  clearrhs(pWrk, nnod);
  {add the short circuit current = modify the rhs}
  InjSCcurr(pFault,pWrk,nnod,Jn);           {modify the rhs for the injected pos.seq current}
  CLUbacksub(pNmat,nnod,pIndexN,pWrk);      {backsubstitute = solve}
end;

procedure ZeroSeqNet(pFault : TpComp; nnod : integer; Jz : complex;
                    pWrk : pComplex);
{inject a current to the location of the fault, and solve the
 negative seq. net
 pFault   pointer to the short, as a component
 nnod     number of nodes = dimension
 Jz       the zero seq. injected short circuit current
 pWrk     pointer to a working space, result is written here
 The solution is written to the array that pWrk is pointing to
 }
begin
  clearrhs(pWrk, nnod);
  {inject zero seq. current to fault}
  InjSCcurr(pFault,pWrk,nnod,Jz);            {modify rhs for the injected neg.seq. current}
  CLUbacksub(pZmat,nnod,pIndexZ,pWrk);       {backsubstitute = solve}
end;

procedure SolveEarthCurrent(pEarthf: TpComp; pVrh,pWrk : pComplex;
                      nnod :integer; Vsp1 : complex;
                      var Ishort : complex);
{solves the current at short, when the no-fault voltage at the short is given
 pEarthf   pointer to the short (as a component)
 pVrh      pointer to the right hand side
 pWrk      pointer to a working space
 nnod      number of nodes = dimension
 Vsp1      voltage at the short at no fault
 Ishort    the short circuit current for the phase to earth fault}
var
  cpu,cpv     : complex;     {temporary}
  Ish1,Ish2   : complex;     {two defined short circuit currents}
  Jp,Jn,Jz    : complex;     {pos./neg./zero seq. injected fault current}
  Us1a,Us1b   : Complex;     {phase voltages at fault}
  Us2a,Us2b   : Complex;     {phase voltages at fault}
  Us1c,Us2c   : Complex;     {phase voltages at fault}
  Vsp2        : complex;     {pos seq. voltage at short}
  Vsn1,Vsn2   : complex;     {neg seq. voltage at short}
  Vsz1,Vsz2   : complex;     {zero seq. voltage at short}
begin
  Ish1.x := 0; Ish1.y := 0;                  {no short circuit current, to start with}
  Vsn1.x := 0; Vsn1.y := 0;                  {neg.seq. voltage at short is zero now !}
  Vsz1.x := 0; Vsz1.y := 0;                  {zero seq. voltage is also zero}
  {set some fault current, solve pos, neg. and zero seq. voltages }
  Ish2 := Crmult(0.025,Vsp1);                 {define some short circuit current}
  {calculate pos., neg. and zero sequence currents, from Ish2, 0, 0 }
  PhaseToSeq(Ish2,czero,czero,Jp,Jn,Jz);     {in compdef.pas}
  PosSeqNet(pEarthf,nnod,Jp,pVrh,pWrk);      {solution to pWrk^}
  GetVolt(pEarthf,pWrk,1,nnod,Vsp2);         {get pos.seq voltage at short}
  NegSeqNet2(pEarthf, nnod, Jn, pWrk);        {solve neg.seq. network}
  {for neg.seq voltages must set external voltages to zero (check!!!)}
  GetVolt(pEarthf,pWrk,1,nnod,Vsn2);         {get neg.seq voltage at short}
  {for zero seq. voltages, must set external voltages to zero}
  ZeroSeqNet(pEarthf, nnod, Jz, pWrk);       {solve neg.seq. network}
  GetVolt(pEarthf,pWrk,1,nnod,Vsz2);         {get neg.seq voltage at short}
  {solve the fault current using condition that voltage at fault = 0}
  {convert to corresponding phase voltages, first at no fault current}
  SeqToPhase(Vsp1,Vsn1,Vsz1,Us1a,Us1b,Us1c);
  {phase voltages at short, when injecting a fault current}
  SeqToPhase(Vsp2,Vsn2,Vsz2,Us2a,Us2b,Us2c);
  {find short circuit current, at which voltages at phase a = 0}
  cpu := Csub(Us1a,Us2a);
  cpv := Cmult(Ish2,Us1a);
  Ishort := Cdiv(cpv,cpu);
end;

procedure SolveEarthFaultCurrent(pVrhs,pWrk : pComplex; pEarthf : TpComp;
                                 nnod : integer;
                                 var Ishort,Jp,Jn,Jz: complex);
{calculates the (steady state) short circuit current at the location of the fault,
 and decomposes it to pos and neg.seq currents
 when voltages, i.e. the right hand side is given
 The result is in pWrk^
 ------
 pVrhs     pointer to the  right hand side = source voltages
 pWrk      pointer to a working space, the result is written here
 pEarthf   pointer to the short, as a component
 nnod      number of nodes = dimension
 Ishort    the current at the location of the fault for earth fault
 Jp,Jn,Jz  pos,neg,zero seq. component of Ishort}
var
  Vsp1    : complex;    {prefault voltage at the location of fault}
begin
  {copy the rhs to working space, it must not be destroyed}
  copyrhs(pVrhs,pWrk,nnod);
  {solve with zero fault current}
  CLUbacksub(pAdmat,nnod,pIndex,pWrk);      {backsubstitute = solve}
  {start to calculate sc currents; first, get the nonfault voltages}
  GetVolt(pEarthf,pWrk,1,nnod,Vsp1);         {get pos.seq voltage at short}
  {next, set some fault current, solve pos, and neg. seq voltages,
   and, using the voltages, solve the current at short }
  {solve the (steady state) current at the short circuit}
  SolveEarthCurrent(pEarthf, {pGM,} pVrhs, pWrk, nnod, Vsp1,Ishort{,IshA,IshB});
  {use this to calculate the positive seq. net. The pos.seq
   currents are needed for the initial generator/motor voltages}
   PhaseToSeq(Ishort,czero,czero,Jp,Jn,Jz); {for line to earth fault, in compdef.pas}
end;

procedure SolveVoltageC(pVrhs,pWrk : pComplex; pEarthf : TpComp; nnod : integer;
                        var VoltC : complex);
{solves the voltage at phase C, when therei is a 2 lline to earth fault at
 phases a and b
 Seeks for the voltage at phase C so that current = 0
 ------
 pVrhs     pointer to the  right hand side = source voltages, DO NOT DESTROY !
 pWrk      pointer to a working space, the result is written here
 pEarthf   pointer to the short, as a component
 nnod      number of nodes = dimension
 VoltC     voltage at phase C }
var
  cpu         : complex;    {temporary}
  er          : integer;    {error flag}
  Ia1,Ib1,Ic1 : complex;    {phase currents at fault}
  Ic0         : complex;    {c phase current at zero voltage}
  Ip1,In1,Iz1 : complex;    {seq. currents at fault}
  jc,ju       : integer;    {"node" for current, voltage}
  Vgs         : complex;    {some guessed voltage}
  Ua,Ub,Uc    : complex;    {voltages at phases a,b,c}
  Vp,Vn,Vz    : complex;    {sequence voltages}
begin
  {copy the rhs to working space, it must not be destroyed}
  copyrhs(pVrhs,pWrk,nnod);
  {find highest voltage, to be used as first guess}
  Vgs := maxCvec(pVrhs,nnod);               {find the largest source voltage}
  {solve with zero voltage at all phases}
  CLUbacksub(pAdmat,nnod,pIndex,pWrk);      {backsubstitute = solve}
  pEarthf^.getNode(2,jc,er);                {get "node" = equation number}
  pEarthf^.getNode(1,ju,er);
  if (jc > 0) and (jc <= nnod) and (Cabs(Vgs) > 0) then begin
    {zero voltage at all phases}
    getCvec(pWrk,jc,nnod,cpu);              {pos.seq. current at fault}
    Ic0 := Cmult(cpu,cplx(-0.5,0.8660254)); {current in phase C}
    {set voltages at phases a and b  to zero, nonzero at c}
    Ua := cplx(0.0,0.0);
    Ub := cplx(0.0,0.0);
    Uc := Vgs;
    PhaseToSeq(Ua,Ub,Uc,Vp,Vn,Vz);          {change to seq. voltages}
   {put voltage to rhs. of the networks}
    copyrhs(pVrhs,pWrk,nnod);               {copy for pos.seq.net}
    putCvec(pWrk,jc,nnod,Vp);               {pos.seq.voltage at fault}
    CLUbacksub(pAdmat,nnod,pIndex,pWrk);    {solve pos.seq. net}
    getCvec(pWrk,jc,nnod,Ip1);              {pos.seq. current at fault}
    clearRhs(pWrk,nnod);                    {no proper sources in neg.seq.net}
    putCvec(pWrk,jc,nnod,Vn);               {neg.seq.voltage}
    CLUbacksub(pNmat,nnod,pIndexN,pWrk);    {solve neg.seq.net}
    getCvec(pWrk,jc,nnod,In1);              {neg.seq. current at fault}
    clearRhs(pWrk,nnod);                    {no proper sources in zero.seq.net}
    putCvec(pWrk,jc,nnod,Vz);               {zero seq.voltage}
    CLUbacksub(pZmat,nnod,pIndexZ,pWrk);    {solve neg.seq.net}
    getCvec(pWrk,jc,nnod,Iz1);              {zero seq. current at fault}
    SeqToPhase(Ip1,In1,Iz1,Ia1,Ib1,Ic1);    {phase currents at fault}
    {calculate c phase voltage at which current = 0}
    cpu := Csub(Ic0,Ic1);
    if (Cabs(cpu) > 1.e-20) then begin
      VoltC := Cdiv(Cmult(Ic0,Uc),cpu);     {avoid division by zero}
    end else begin
      VoltC := cplx(0.0,0.0);               {just some value}
    end;
  end else begin                            {something wrong}
    VoltC := cplx(0.0,0.0);
  end;
end;

procedure PosSeqNetLLE(pEarthf : TpComp; nnod : integer; VoltC : complex;
                       pVrh,pWrk : pComplex);
{solve the positive seq. net in the case of line-line-earth fault, when
 the voltage at the unfaulted phase is given
 pEarthf   pointer to the fault, as a component
 nnod      no of nodes
 VoltC     the voltage at phase C
 pVrh      original right hand side (DO NOT DESTROY)
 pWrk      result}
var
  er        : integer;  {error flag}
  jc        : integer;  {"node" = index of the current}
  Ua,Ub,Uc  : complex;  {voltages at the phases}
  Vp,Vn,Vz  : complex;  {sequence voltages}
begin
  {solve the pos.seq.net}
  Ua := cplx(0.0,0.0);
  Ub := cplx(0.0,0.0);
  Uc := VoltC;
  PhaseToSeq(Ua,Ub,Uc,Vp,Vn,Vz);            {change to seq. voltages}
  {put voltage to rhs. of the networks}
  copyrhs(pVrh,pWrk,nnod);                  {copy for pos.seq.net}
  pEarthf^.getNode(2,jc,er);                {get "node" = equation number}
  if (jc > 0) and (jc <= nnod) then begin
    putCvec(pWrk,jc,nnod,Vp);               {pos.seq.voltage at fault}
    CLUbacksub(pAdmat,nnod,pIndex,pWrk);    {solve pos.seq. net}
  end else begin
    clearRhs(pWrk,nnod);                    {error, give zeroes}
  end;
end;

procedure ZeroSeqNetLLE(pEarthf : TpComp; nnod : integer; VoltC : complex;
                        pWrk : pComplex);
{solve the zero seq.net in the case of line-line-earth fault, when
 the voltage at the unfaulted phase is given
 pEarthf   pointer to the fault, as a component
 nnod      no of nodes
 VoltC     the voltage at phase C
 pWrk      result}
var
  er        : integer;  {error flag}
  jc        : integer;  {"node" = index of the current}
  Ua,Ub,Uc  : complex;  {voltages at the phases}
  Vp,Vn,Vz  : complex;  {sequence voltages}
begin
  {solve the zero.seq.net}
  Ua := cplx(0.0,0.0);
  Ub := cplx(0.0,0.0);
  Uc := VoltC;
  PhaseToSeq(Ua,Ub,Uc,Vp,Vn,Vz);            {change to seq. voltages}
  {put voltage to rhs. of the networks}
  ClearRhs(pWrk,nnod);                      {clear initially}
  pEarthf^.getNode(2,jc,er);                {get "node" = equation number}
  if (jc > 0) and (jc <= nnod) then begin
    putCvec(pWrk,jc,nnod,Vz);               {zero.seq.voltage at fault}
    CLUbacksub(pZmat,nnod,pIndexZ,pWrk);    {solve pos.seq. net}
  end else begin
    clearRhs(pWrk,nnod);                    {error, give zeroes}
  end;
end;

procedure NegSeqNetLLE(pEarthf : TpComp; nnod : integer; VoltC : complex;
                        pWrk : pComplex);
{solve the neg.seq. net in the case of line-line-earth fault, when
 the voltage at the unfaulted phase is given
 pEarthf   pointer to the fault, as a component
 nnod      no of nodes
 VoltC     the voltage at phase C
 pWrk      result}
var
  er        : integer;  {error flag}
  jc        : integer;  {"node" = index of the current}
  Ua,Ub,Uc  : complex;  {voltages at the phases}
  Vp,Vn,Vz  : complex;  {sequence voltages}
begin
  {solve the zero.seq.net}
  Ua := cplx(0.0,0.0);
  Ub := cplx(0.0,0.0);
  Uc := VoltC;
  PhaseToSeq(Ua,Ub,Uc,Vp,Vn,Vz);            {change to seq. voltages}
  {put voltage to rhs. of the networks}
  ClearRhs(pWrk,nnod);                      {clear initially}
  pEarthf^.getNode(2,jc,er);                {get "node" = equation number}
  if (jc > 0) and (jc <= nnod) then begin
    putCvec(pWrk,jc,nnod,Vn);               {zero.seq.voltage at fault}
    CLUbacksub(pNmat,nnod,pIndexN,pWrk);    {solve pos.seq. net}
  end else begin
    clearRhs(pWrk,nnod);                    {error, give zeroes}
  end;
end;

procedure EarthFault(ipSet : longint; IsInitState : boolean);
{solve the net (etc) in the case of a one phase to earth fault
 and a phase to phase to earth fault
 ipSet    pointer to the set of components, etc, as integer
 IsInitState   if true, the precalculated initial state is used}
const
  czero : complex = (x : 0.0 ; y : 0.0);       {complex zero}
var
  AP            : AsymPar;     {parameters of the asynch.motor}
  cNode         : integer;     {"node" for current}
  cpu,cpv,cpw   : complex;     {temporary}
  errcom        : boolean;     {error flag}
  err           : integer;     {error flag}
  ftype         : solve;       {type of fault}
  dodd,doddz    : single;      {keep track of permutations}
  doddn         : single;      {keep track of permutations}
  dt            : single;      {time step}
  freq          : single;      {the net frequency}
  Icx,Icn,Icz   : complex;     {current}
  igm           : integer;     {index for generators + motors}
  it            : integer;     {index}
  Ishort        : complex;     {fault current, towards phase a, earth fault}
  Jp,Jn,Jz      : complex;     {pos./neg./zero seq. injected fault current}
  jc            : integer;     {node}
  ju            : integer;     {upstream node of asynch.motor}
  nnod          : integer;     {number of nodes}
  nAsyMot       : integer;     {number of asynchronous motors}
  nCurrT        : integer;     {number of current trafos}
  nFault        : integer;     {number of short circuits (needed ?)}
  nGenMot       : integer;     {number of generators and motors}
  nPQrel        : integer;     {number of PQ-relays}
  nRelay        : integer;     {number of relays}
  nSource       : integer;     {number of constant voltage sources}
  pAsMot        : TpComp;      {pointer to asynch.motor}
  pComp         : TpComp;      {pointer to a component (relay)}
  pCurrT        : TpCurrT;     {pointer to object for current trafos}
  pEarthf       : TpComp;      {pointer to the earth fault}
  pGenMot       : TpGenMot;    {pointer to object for generators and motors}
  pRelay        : TpRelay;     {pointer to object for handling relays}
  pSet          : TpCompSet;   {pointer to the set of components, etc}
  pVrhs         : pComplex;    {pointer to working space}
  pWsn,pWsz     : pComplex;    {pointer to working space for neg.and zero seq}
  Sngl,Snglz    : Integer;     {flag for singular matrix}
  SnglN         : Integer;     {flag for singular matrix}
  text          : string;      {temporary text}
  Tout,Toutz    : Complex;     {test output from matrix decomposition}
  ToutN         : Complex;     {test output from matrix decomposition}
  tt,tt0        : single;      {time, old time}
  Ucx           : complex;     {voltage at the terminals of asynch.motor}
  Vcx           : Complex;     {voltage}
  VoltC         : complex;     {voltage of phase C at two phase earth fault}
begin
  pRelay := nil;
  pGenMot := nil;
  pCurrT := nil;
  pSet := TpCompSet(ipSet);          {integer to pointer}
  freq := pSet^.appl_Hz;             {net frequency}
  pEarthf := nil;                    {initialize pointer to earth fault}
  FindShort(pSet, pEarthf);          {find the fault(s)}
(*nnod := pSet^.appl_nn;             {copy number of nodes} *)
  {solve the network only, if there is a short !}
  if (pEarthf <> nil) {and (nnod > 0)} then begin {the short found}
    {solve the net as it is, without the fault. Actually needed only, if there...}
    if (not Imagoo.InitialStateBut.down) then
      Imagoo.AdmatOper(Imagoo.InitialStateBut.down){.... are motors in the net}
    else Imagoo.NodeButclick(nil);
    nnod := pSet^.appl_nn;             {copy number of nodes}
    pSet^.GetMemForCurrTrAndRelays;    {meory for curr.tr and relays (if needed)}
    {reserve and initialize memory for matrices}
    ReserveMat(nnod,pAdmat,pWs,pRhs,pIndex);    {reserve for pos seq.}
    getmem(pZmat,nnod*nnod*SizeOf(complex));    {reserve matrix for zero seq.}
    getmem(pNmat,nnod*nnod*SizeOf(complex));    {reserve matrix for neg. seq.}
    clearCmat(pZmat,nnod);
    clearCmat(pNmat,nnod);
    getmem(pIndexZ,nnod*Sizeof(integer));       {for index array, zero seq.}
    getmem(pIndexN,nnod*Sizeof(integer));       {for index array, neg. seq.}
    clearIvec(pIndexZ, nnod);
    clearIvec(pIndexN, nnod);
    {get mem. for working space (for steady state solution}
    getmem(pWsn,nnod*SizeOf(complex));
    getmem(pWsz,nnod*SizeOf(complex));
    {get memory for working space = temporary right hand side}
    getmem(pVrhs,nnod*SizeOf(complex));         {for temporary right hand side}
    {construct the extended admittance matrix. }
    if (pSet^.appl_op = 8) then begin           {line to earth fault}
      ConstrMatr(pSet, pAdmat, pRhs, nnod, freq, Steady, EarthShort,
                 IsInitState, errcom);    {0 = construct for normal case}
    end else begin                              {2 line to earth fault}
      ConstrMatr(pSet, pAdmat, pRhs, nnod, freq, Steady, TwoPhaseEarth,
                 IsInitState, errcom);    {0 = construct for normal case}
    end;
    {copy the matrix to neg. seq. matrix, convert to correspond to neg seq}
    PosToNegMat(pSet, pAdmat,pNmat, nnod, 1.0);
    {copy the matrix to zero seq. matrix, convert to correspond to zero seq}
    PosToZeroMat(ipSet, pAdmat,pZmat, freq, 0.0, nnod);
//showcmat1(pZmat,nnod,nnod);
    {count the number of generators, etc. Needed below}
    CountComp(ipSet,nGenMot,nRelay,nFault,nCurrT,nAsyMot,nSource,nPQRel);
    {solve voltages etc, but only if no unknown components}
    if (not(errcom)) then begin
      try
        CLUdecomp(pAdmat,pWs,nnod,pIndex,Dodd,Sngl,Tout); {decompose pos.seq matrix}
        CLUdecomp(pNmat,pWs,nnod,pIndexN,DoddN,SnglN,ToutN); {decompose neg.seq. matrix}
        CLUdecomp(pZmat,pWs,nnod,pIndexZ,DoddZ,SnglZ,ToutZ); {decompose zero seq.matrix}
//showmessage(inttostr(sngl)+'  '+inttostr(sngln)+'  '+inttostr(snglz));
//showmessage(inttostr(snglz));
        {for solution, copy Rhs to working space, Rhs must not be changed !}
        {create object for relays, if any exists (for display + checking of activation}
        CreateRelays(ipSet, nRelay, nPQrel, pRelay);
        {if there are current transformers, create object for operations with current trafos}
        CreateCurrT(ipSet, nCurrT, pSet^.nCalc, pCurrT);       {in shortcir.pas}
        {find the current trafos for the relays, if there are relays & curr.trafos}
        if (pRelay <>nil) then pRelay^.FindCurrTrafos(pCurrT);
        {create +initialize object for generators/motors, if any exist
        it is initialized with the currents & voltages calculated above}
        if (nGenMot > 0) or (nAsyMot > 0) then  begin
          CreateGenMot(ipSet, nGenMot, nAsyMot, nSource, freq, pGenMot);
          if (pSet^.appl_op = 8) then begin       {line to earth fault}
            {calculate steady state pos.seq. solution, with fault}
            SolveEarthFaultCurrent(pRhs, pWs, pEarthf, nnod,
                                  Ishort, Jp,Jn,Jz);
            PosSeqNet(pEarthf, nnod, Jp, pRhs,pWs);
            NegSeqNet2(pEarthf, nnod, Jn, pWsn);     {solve neg.seq. network}
            ZeroSeqNet(pEarthf,nnod,Jz,pWsz);
          end else begin                             {two line to earth fault}
            SolveVoltageC(pRhs,pWs,pEarthf,nnod,VoltC);
            PosSeqNetLLE(pEarthf,nnod,VoltC,pRhs,pWs);
            NegSeqNetLLE(pEarthf,nnod,VoltC,pWsn);
            ZeroSeqNetLLE(pEarthf,nnod,VoltC,pWsz);
          end;
          {save the steady pos.seq. state solution with fault}
          for igm := 1 to nGenMot+nAsyMot+nSource do begin
            pGenMot^.GetGMnode(igm,cNode);              {get current node for this gen.}
            getCvec(pWs ,cNode,nnod,Icx);               {get corresponding current}
            getCvec(pWsn,cNode,nnod,Icn);               {neg.seq.current}
            getCvec(pWsz,cNode,nnod,Icz);               {zero seq.current}
            SeqToPhase(Icx,Icn,Icz,cpu,cpv,cpw);        {to phase variables}
{showmessage(floattostr(Cabs(cpu))+'  '+floattostr(Cabs(cpv))+'  '+floattostr(Cabs(cpw)));}
            if (pGenMot^.IsGener(igm)) or (pGenMot^.IsSynchMot(igm)) then begin
              getCvec(pRhs,cNode,nnod,Vcx);             {get present int. voltage}
            end else if (pGenMot^.IsAsynchMot(igm)) then begin
              {asynchronous motor, calculate internal voltage}
              pGenMot^.GetAsmPar(igm, AP);              {get parameters}
              pGenMot^.GetGMpoint(igm,pAsMot);          {get pointer to the motor}
              pAsMot^.GetNode(1,ju,err);                {node of ext.voltage}
              getCvec(pWs,ju,nnod,Ucx);                 {upstream voltage}
              Vcx := Csub(Ucx,Cmult(Icx,AP.Zint));      {internal voltage}
            end else begin
              getCvec(pRhs,cNode,nnod,Vcx);             {source (or error)}
(*            Vcx := cplx(0,0);                         {error} *)
            end;
            pGenMot^.putVolt(igm,Vcx);                  {save the voltage}
(*          pGenMot^.putCurr(igm,Icx);                  {save the current, for calculations}*)
            pGenMot^.PutSSCurr(igm,Icx);                {save as steady state curr.}
          end;
          {calculate the derivatives dI/dV for the generators (and motors ??)}
          if (pSet^.appl_op = 8) then text := 'earth'
          else                        text := 'linelineearth';
          {must reconstruct the admit.matrix, if there are asynch.motors}
          if (nAsyMot > 0) then begin
            clearCmat(pAdmat,nnod);
            clearCvec(pRhs,nnod);
            if text = 'earth' then ftype := EarthShort else ftype := TwoPhaseEarth;
            ConstrMatr(pSet, pAdmat, pRhs, nnod, freq, Derivates, ftype,
                      IsInitState,errcom);
            CLUdecomp(pAdmat,pWs,nnod,pIndex,Dodd,Sngl,Tout); {decompose}
          end;
          Calc_dIdV(pGenMot, pEarthf, pRhs, pVrhs, pWs, nnod,text);
          pGenMot^.IsFaultFeltHere;    {mark gen, mot, etc, where fault is felt}
          pGenMot^.dIdVwhereFaultFelt; {copy dI/dV for comp. where fault felt}
          pGenMot^.Calc_dVdI;
          {solve the initial, transient generator voltages}
(*        pGenMot^.SolveDQVoltages;     {solve d- and q-voltages} *)
          {new version}pGenMot^.InitialVoltagesAndCurrents;
        end else begin
          pGenMot := nil;
        end;
        {solve the net with time}
        {must reconstruct the admit.matrix, if there are asynch.motors once more}
        if (nAsyMot > 0) then begin
          clearCmat(pAdmat,nnod);
          clearCvec(pRhs,nnod);
          if text = 'earth' then ftype := EarthShort else ftype := TwoPhaseEarth;
          ConstrMatr(pSet, pAdmat, pRhs, nnod, freq, Transient, ftype,
                    IsInitState,errcom);
          CLUdecomp(pAdmat,pWs,nnod,pIndex,Dodd,Sngl,Tout); {decompose}
          {because the "source" of asynch.motors is the current, must calculate
           dI(all)/dI(as.mot) and dI(all)/dV(others)}
          Calc_dIdIV(pGenMot, pEarthf, pRhs, pVrhs, pWs, nnod, text);
        end;
        pEarthf^.GetNode(2,jc,err);       {get "node" of the fault current}
        tt := 0;                                 {initialize}
        for it := 1 to pSet^.nCalc do begin
          tt0 := tt;                             {old time, for time step}
          GetAndSaveTime(pSet, it, tt);          {calculate time, save it to pSet}
          {copy rhs to working space}
          copyCvec(pRhs,pVrhs,nnod);
          {if there are generators or motors, update the rhs}
          if (nGenMot > 0) or (nAsyMot > 0) then begin
            dt := tt-tt0;
            {calculate gener.voltage at this step, update the rhs}
            pGenMot^.VoltAtTt(it, dt, freq,pVrhs,nnod);
          end;
          {solve}
          if (pSet^.appl_op = 8) then begin      {line to earth fault}
            SolveEarthFaultCurrent(pVrhs, pWs, pEarthf, nnod,
                                   Ishort, Jp,Jn,Jz);
            {solve zero seq. net}
            ZeroSeqNet(pEarthf,nnod,Jz,pWs);
//showCmat2(pWs,1,nnod);
            {complete the solution with the fault current. Minus, because injected in, but....}
            putCvec(pWs,jc,nnod,{Jz}cplx(-Jz.x,-Jz.y));    {...fault pos.dir out 101202}
          end else begin              {2 line to earth fault}
            SolveVoltageC(pVrhs,pWs,pEarthf,nnod,VoltC);
            ZeroSeqNetLLE(pEarthf,nnod,VoltC,pWs);
          end;
          {if there are relays, save the zero seq.current here, other seq. later}
          if (pCurrT <> nil) then begin
            pCurrT^.SaveComplex(pWs, nnod, 3,it);   {save zero.seq. as set number 3}
          end;
          if (pSet^.nMeasZ > 0) then begin
            {if there are distance relays, save voltages}
            pSet^.SaveDistVoltTemp(pWs, nnod, 3);
          end;
          {save initial zero sec. currents etc for all components (other seq. later}
          if (it = 1) then begin
            ClearAllVar(pSet);                      {clear initially}
            ResultsToComp(pSet, nnod, freq, pWs,3,{ForComp}ForBoth); {neg.seq to comp., as first set of var.}
            CopyAllVar(pSet,1,3);                   {copy to third set of var.}
          end;                                      {continues....}
          {solve neg.seq.net}
          if (pSet^.appl_op = 8) then begin         {line to earth fault}
            NegSeqNet2(pEarthf, nnod, Jn, pWs);     {solve neg.seq. network}
            {complete the solution with the fault current. Minus, because injected in, but....}
            putCvec(pWs,jc,nnod,{Jn}cplx(-Jn.x,-Jn.y));  {...fault pos.dir out 101202}
          end else begin                            {line-line-earth fault}
            NegSeqNetLLE(pEarthf,nnod,VoltC,pWs);
          end;
          {if there are relays, save the neg seq.current here, pos seq. later, but clear first}
          if (pCurrT <> nil) then begin
            pCurrT^.SaveComplex(pWs, nnod, 2,it);   {save neg.seq. as set number 2}
          end;
          if (pSet^.nMeasZ > 0) then begin
            {if there are distance relays, save voltages}
            pSet^.SaveDistVoltTemp(pWs, nnod, 2);
          end;
          {save initial neg sec. currents etc for all components (pos.seq. later}
          if (it = 1) then begin
            ResultsToComp(pSet, nnod, freq, pWs,2,{ForComp}ForBoth); {neg.seq to comp., as first set of var.}
            CopyAllVar(pSet,1,2);                   {copy to second set of var.}
          end;                                      {continues....}
          if (pSet^.appl_op = 8) then begin         {line to earth fault}
            PosSeqNet(pEarthf, nnod, Jp, pVrhs,pWs);{solve pos.seq. network}
            {complete the solution with the fault current. Minus, because injected in, but....}
            putCvec(pWs,jc,nnod,{Jp}cplx(-Jp.x,-Jp.y));  {...fault pos.dir out 101202}
//showCmat1(pWs,1,nnod);
          end else begin                            {line-line-earth fault}
            PosSeqNetLLE(pEarthf,nnod,VoltC,pVrhs,pWs);
          end;
          {if there are relays, complete the saving of currents here}
          if (pCurrT <> nil) then begin
            pCurrT^.SaveComplex(pWs, nnod, 1,it);   {save pos.seq. as set number 1}
            pCurrT^.PhaseMaxOrSum(it, pSet);        {save abs value of largest phase current,or sum}
          end;                                      {...in shortcmp.pas}
          if (pSet^.nMeasZ > 0) then begin
            {if there are distance relays, save voltages}
            pSet^.SaveDistVoltTemp(pWs, nnod, 1);
            pSet^.SavePhaseVolt(it)
          end;
          {complete the saving of initial state for all components}
          if (it = 1) then begin
            ResultsToComp(pSet, nnod, freq, pWs,1,{ForComp}ForBoth); {pos.seq to comp, as first set of var}
            AllVarSeqToPhase(pSet);                 {from seq to phase, all var, all comp.}
            {sum current trafos must display the sum current}
            if (pCurrT <> nil) then pCurrT^.SumToOutVar;      {in Shortcmp.pas}
(*  poistettu 27.9.2003, koska jnnite vrin}
            {short circuit current to short circ.component}
            if (pSet^.appl_op = 8) then begin  {line to earth fault}
              pEarthf^.putvar(3,-Ishort.x);      {- sign, because injected current }
              pEarthf^.putvar(4,-Ishort.y);
              pEarthf^.putvar(7,0);              {no fault current in other phases}
              pEarthf^.putvar(8,0);              {indeksi, kun Ip ja Ib ??}
              pEarthf^.putvar(11,0);
              pEarthf^.putvar(12,0);
            end else begin                     {2 line to earth fault}

            end;
*)
          end;
        end;
        {transfer currents from current trafos to relays, take ratio etc into account}
        AllRelayCurrFromCT(pSet);
        {display relay current using polar coordinates}
        PolarToRelaysAndBuses(pSet);
        {update the eventual result boxes}
{later: pSet^.UpdateResultBoxes(3); }
        {show also the current through the current trafos, if allowed}
        ShowCurrOrNot(pSet, Imagoo.ShowCurrBut.down,Imagoo.ShowCurrBut.caption);
        ShowVoltagesOrNot(pSet, Imagoo.BusBut.down, Imagoo.BusBut.caption);   {in skemproc.pas}
        {show the measured impedances}
        ShowImpedances(pSet);   {in skemproc.pas}
        if (RelayCurr.visible)  then begin
          pComp := TpComp(RelayCharact.tag);   {pointer to the relay}
          Relay_Show(pComp,'real');
        end;
        {show also distance relay char. and impedance, if visible}
        if (DistRel.visible) then DistanceRelayShow;
        if (PolyRel.visible) then PolygonRelayShow;
        {check activation of relays, if there are any relays...}
        {...but not, if impedance calculation}
        if not(pSet^.appl_but=15) then begin
          if (pRelay <> nil) then pRelay^.GroupActivation {CheckActivation};
        end;
        {update the eventual result boxes}
        pSet^.UpdateResultBoxes(3);
      finally
        {destroy object for current trafos, if created}
        if (nCurrT > 0) and (pCurrT <> nil) then begin
          pCurrT^.Destr;                 {destroy object for current trafors}
          pCurrT^.Free;
          dispose(pCurrT);
          pCurrT := nil;
        end;
        {destroy object for relays, if created}
        if (pRelay <> nil) then begin
          pRelay^.Destr;                 {destroy object for relays}
          pRelay^.Free;
          dispose(pRelay);
          pRelay := nil;
        end;
        {destroy object for relays, if created}
        if (pGenMot <> nil) then begin             {if there were gener/motors, free them}
          pGenMot^.Destr;                          {release memory}
          pGenMot^.Free;                           {release the object}
          dispose(pGenMot);
          pGenMot := nil;
        end;
      end;
    end else begin                            {there was an unknown component}
      show_message('unknown component');
    end;
    {free the reserved memory from matrices}
    FreeMat(nnod);
    Freemem(pZmat,nnod*nnod*SizeOf(complex));       {free matrix for zero seq.}
    Freemem(pNmat,nnod*nnod*SizeOf(complex));       {free matrix for neg. seq.}
    Freemem(pIndexZ,nnod*Sizeof(integer));          {free index array, zero seq}
    Freemem(pIndexN,nnod*Sizeof(integer));          {free index array, neg. seq}
    Freemem(pVrhs,nnod*SizeOf(complex));
    Freemem(pWsn,nnod*SizeOf(complex));
    Freemem(pWsz,nnod*SizeOf(complex));
    pSet^.FreeMemForCurrTrAndRelays;
  end else begin
    show_message('no short circuit! ');
    Ishort.x := 0; Ishort.y := 0;
  end;
end;
{----END OF UNIT---------END OF UNIT---------END OF UNIT---------END OF UNIT--}
end.
