unit search;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, ExtCtrls,Locate;

type
  TSearchForm = class(TForm)
    ImagePanel: TPanel;
    LocateImage: TImage;
    LocateGrid: TStringGrid;
    procedure FormCreate(Sender: TObject);
    procedure LocateGridSelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure FormHide(Sender: TObject);
    procedure LocateImageMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  SearchForm: TSearchForm;

implementation

{$R *.DFM}
uses
  Imagopas,find;

const
  srchx : integer = 290; {initial position of form for breaker-2's}
  srchy : integer = 0;

procedure TSearchForm.FormCreate(Sender: TObject);
var
  ll : longint;  {temporary}
begin
  SearchForm.tag := longint(@LocateGrid); {pointer to the grid is saved in tag}
  ll := longint(@LocateImage);
  SearchForm.hint := inttostr(ll);        {pointer to image is saved to hint !?}
  left := srchx;
  top := srchy;
  {add flag that form created}
  Imagoo.ReadyEdit.text := Imagoo.ReadyEdit.text+'s';
end;

procedure TSearchForm.LocateGridSelectCell(Sender: TObject; Col,
  Row: Longint; var CanSelect: Boolean);
begin
  SelectCell(@LocateGrid,Col,Row);
end;

procedure TSearchForm.FormHide(Sender: TObject);
begin
  {if listing open breakers, then as if clicking the BreakerBut in the main form}
  if (imagoo.BreakerBut.down) then begin
    if (LocateForm.visible = false) and (FindForm.visible = false) then begin
      imagoo.BreakerBut.down := false;
    end;
  end;
end;

procedure TSearchForm.LocateImageMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  srchx := left;
  srchy := top;
end;

end.
